/*   Copyright (C) 2009 Deino Software. */

#if !defined( _CLOG_UTIL )
#define _CLOG_UTIL

#include "clog_const.h"
#include "clog_inttypes.h"

void CLOG_Util_abort( int errorcode );

void CLOG_Util_set_tmpfilename( wchar_t *tmp_pathname );

void CLOG_Util_swap_bytes( void *bytes, int elem_sz, int Nelem );

char *CLOG_Util_strbuf_put(	   char *buf_ptr, const char *buf_tail,
							const char *val_str, const char *err_str );

char *CLOG_Util_strbuf_get(	   char *val_ptr, const char *val_tail,
							const char *buf_str, const char *err_str );

CLOG_BOOL_T CLOG_Util_is_MPIWtime_synchronized( void );

CLOG_BOOL_T CLOG_Util_is_runtime_bigendian( void );

int CLOG_File_open(wchar_t *filename, int flags, int mode, CLOG_FILE *fp);
int CLOG_File_close(CLOG_FILE fp);
int CLOG_File_fseek(CLOG_FILE fp, CLOG_int64_t offset, int whence, CLOG_int64_t *file_pos);
int CLOG_File_read(CLOG_FILE fp, void *buffer, CLOG_int64_t num_bytes);
int CLOG_File_write(CLOG_FILE fp, void *buffer, CLOG_int64_t num_bytes);

#endif  /* of _CLOG_UTIL */
