/*   Copyright (C) 2009 Deino Software. */

#include "mpe_logging_conf.h"
#include "clog_util.h"
#include "clog_inttypes.h"
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

int CLOG_File_open(wchar_t *filename, int flags, int mode, CLOG_FILE *fp)
{
	int err = 0;
	int cmode, amode, attrib;

	amode = 0;
	cmode = OPEN_EXISTING;
	attrib = FILE_ATTRIBUTE_NORMAL;

	if (flags & O_CREAT)
	{
		cmode = OPEN_ALWAYS;
	}
	if (flags & O_TRUNC)
	{
	}
	if (flags & O_RDONLY)
	{
		amode = GENERIC_READ;
	}
	if (flags & O_WRONLY)
	{
		amode = GENERIC_WRITE;
	}
	if (flags & O_RDWR)
	{
		amode = GENERIC_READ | GENERIC_WRITE;
	}

	*fp = CreateFile(filename, 
		amode,
		FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, 
		NULL, 
		cmode, 
		attrib, 
		NULL);

	if (*fp == INVALID_HANDLE_VALUE)
	{
		err = GetLastError();
	}
	return err;
}

int CLOG_File_close(CLOG_FILE fp)
{
	CloseHandle(fp);
	return 0;
}

int CLOG_File_fseek(CLOG_FILE fp, CLOG_int64_t offset, int whence, CLOG_int64_t *file_pos)
{
	LARGE_INTEGER loffset;
	DWORD move = FILE_BEGIN;
	DWORD result;

	switch (whence)
	{
	case SEEK_SET:
		move = FILE_BEGIN;
		break;
	case SEEK_CUR:
		move = FILE_CURRENT;
		break;
	case SEEK_END:
		move = FILE_END;
		break;
	}

	loffset.QuadPart = offset;
	result = SetFilePointer( fp, loffset.LowPart, &loffset.HighPart, whence );
	if (result != INVALID_SET_FILE_POINTER)
	{
		if (file_pos != NULL)
		{
			*file_pos = loffset.QuadPart;
		}
		return 0;
	}
	return -1;
	return 0;
}

int CLOG_File_read(CLOG_FILE fp, void *buffer, CLOG_int64_t num_bytes)
{
	DWORD num_to_read, num_read = 0;
	LARGE_INTEGER i;
	i.QuadPart = num_bytes;
	num_to_read = i.LowPart;
	ReadFile(fp, buffer, num_to_read, &num_read, NULL);
	return num_read;
}

int CLOG_File_write(CLOG_FILE fp, void *buffer, CLOG_int64_t num_bytes)
{
	DWORD num_to_write, num_written = 0;
	LARGE_INTEGER i;
	i.QuadPart = num_bytes;
	num_to_write = i.LowPart;
	WriteFile(fp, buffer, num_to_write, &num_written, NULL);
	return num_written;
}
