/* -*- Mode: C; c-basic-offset:4 ; -*- */
/* 
 *
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#ifndef AD_NTFS_INCLUDE
#define AD_NTFS_INCLUDE

#include <sys/types.h>
#include <fcntl.h>
/*
#include "adio.h"
*/
#include "mpiimpl.h"

#ifdef HAVE_INT64
#define DWORDLOW(x)		( (DWORD) ( x & (__int64) 0xFFFFFFFF ) )
#define DWORDHIGH(x)	   ( (DWORD) ( (x >> 32) & (__int64) 0xFFFFFFFF ) )
#define DWORDTOINT64(x,y)  ( (__int64) ( ( (__int64 x) << 32 ) + (__int64) y ) )
#else
#define DWORDLOW(x)		 x
#define DWORDHIGH(x)		0
#define DWORDTOINT64(x,y)   x
#endif

int ADIOI_NTFS_aio(MPID_File_ptr fd, void *buf, int len, MPI_Offset offset, int wr, void *handle);

int ADIOI_NTFS_Open(MPID_File_ptr fderror_code);
int ADIOI_NTFS_Close(MPID_File_ptr fd);
int ADIOI_NTFS_ReadContig(MPID_File_ptr fd, void *buf, int count, MPI_Datatype datatype, int file_ptr_type, MPI_Offset offset, MPI_Status *status);
int ADIOI_NTFS_WriteContig(MPID_File_ptr fd, void *buf, int count, MPI_Datatype datatype, int file_ptr_type, MPI_Offset offset, MPI_Status *status);
int ADIOI_NTFS_IwriteContig(MPID_File_ptr fd, void *buf, int count, MPI_Datatype datatype, int file_ptr_type, MPI_Offset offset, ADIO_Request *request);
int ADIOI_NTFS_IreadContig(MPID_File_ptr fd, void *buf, int count, MPI_Datatype datatype, int file_ptr_type, MPI_Offset offset, ADIO_Request *request);
int ADIOI_NTFS_ReadDone(ADIO_Request *request, MPI_Status *status, int *flag);
int ADIOI_NTFS_WriteDone(ADIO_Request *request, MPI_Status *status, int *flag);
int ADIOI_NTFS_ReadComplete(ADIO_Request *request, MPI_Status *status);
int ADIOI_NTFS_WriteComplete(ADIO_Request *request, MPI_Status *status);
int ADIOI_NTFS_Fcntl(MPID_File_ptr fd, int flag, ADIO_Fcntl_t *fcntl_struct);
int ADIOI_NTFS_IwriteStrided(MPID_File_ptr fd, void *buf, int count, MPI_Datatype datatype, int file_ptr_type, MPI_Offset offset, ADIO_Request *request);
int ADIOI_NTFS_Flush(MPID_File_ptr fd);
int ADIOI_NTFS_Resize(MPID_File_ptr fd, MPI_Offset size);

const wchar_t * ADIOI_NTFS_Strerror(int error);

#endif
