// DeinoLP.h
#pragma once

#include <winsock2.h>
#include <windows.h>

using namespace System;

namespace DeinoLP
{
    public class BufferNode
    {
    public:
	int curpos, length;
	wchar_t *buffer;
	BufferNode *next;
    };

    public ref class ProcessCreation
    {
    private:
	HANDLE hProcess, hThread;
	static HANDLE hLPLock = NULL;
	HANDLE hRead, hWrite;

    public:
	ProcessCreation();
	~ProcessCreation();

	void DeinoLaunchProcess(System::String ^cmd, System::String ^domain, System::String ^user, System::String ^password);
	void DeinoWaitForExit();
	void Kill();
	System::String^ DeinoLPReadLine();
	void DeinoLPWriteLine(System::String ^str);
	System::String^ DeinoLPReadLine(System::String^ read_handle);
	void DeinoLPWriteLine(System::String^ write_handle, System::String ^str);

    private:
	int launch_process(wchar_t *cmd, wchar_t *domain, wchar_t *user, wchar_t *password);
	void lock();
	void unlock();
	BufferNode *output_list;
	bool ReadNextBuffer();
    };

    public ref class DriveMapping
    {
    public:
	static int MapDrive(System::Char drive_letter, System::String ^mapping, System::String ^username, System::String ^password);
	static int UnMapDrive(System::Char drive_letter);
    };
}
