using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DeinoMPIwin
{
    public partial class SelectLocation : Form
    {
        public string FileName
        {
            get
            {
                return file_textBox.Text;
            }
        }

        public bool UseRegistry
        {
            get
            {
                return registry_radioButton.Checked;
            }
        }

        public SelectLocation()
        {
            InitializeComponent();
        }

        private void ok_button_Click(object sender, EventArgs e)
        {
            if (file_radioButton.Checked)
            {
                if (!File.Exists(file_textBox.Text))
                {
                    MessageBox.Show("Please enter a valid file name into the dialog", "Error");
                    file_textBox.Focus();
                    return;
                }
            }
            DialogResult = DialogResult.OK;
            Close();
        }

        private void browse_button_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Filter = "Credential Store files (*.xml)|*.xml|All files (*.*)|*.*";
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                file_textBox.Text = dlg.FileName;
            }
        }
    }
}