using System.Collections.Generic;
using System.ServiceProcess;
using System.Text;
using System;
using System.IO;

namespace DeinoPM
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main(string[] args)
        {
            try
            {
                ServiceBase[] ServicesToRun;

                if (args.Length > 0 && args[0] == "/start")
                {
                    DeinoPM pm = new DeinoPM();
                    pm.OnDebugStart(args);
                    return;
                }

                if (args.Length > 0 && args[0] == "/stop")
                {
                    DeinoPM pm = new DeinoPM();
                    pm.OnDebugStop();
                    return;
                }

                if (args.Length > 0 && args[0] == "/public_key")
                {
                    DeinoPM pm = new DeinoPM();
                    if (args.Length > 1)
                    {
                        pm.RunManager(args[1], args[2]);
                    }
                    else
                    {
                        string public_key = Encoding.Unicode.GetString(Convert.FromBase64String(Console.In.ReadLine().Trim()));
                        pm.RunManager(public_key);
                    }
                    return;
                }

                // More than one user Service may run within the same process. To add
                // another service to this process, change the following line to
                // create a second service object. For example,
                //
                //   ServicesToRun = new ServiceBase[] {new Service1(), new MySecondUserService()};
                //
                ServicesToRun = new ServiceBase[] { new DeinoPM() };

                ServiceBase.Run(ServicesToRun);
            }
            catch (Exception e)
            {
                Console.WriteLine("Exception caught: {0}", e.Message);
            }
        }
    }
}