/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*
 *  (C) 2006 by Deino Software.
 *  (C) 2001 by Argonne National Laboratory.
 *	  See COPYRIGHT in top-level directory.
 */
#ifndef SMPD_DATABASE_H
#define SMPD_DATABASE_H

#define SMPD_DBS_SUCCESS		  0
#define SMPD_DBS_FAIL			-1
#define SMPD_MAX_DBS_NAME_LEN	 256
#define SMPD_MAX_DBS_KEY_LEN	  256
#define SMPD_MAX_DBS_VALUE_LEN	4096

#if defined(__cplusplus)
extern "C" {
#endif

int smpd_dbs_init();
int smpd_dbs_finalize();
int smpd_dbs_create(wchar_t *name, size_t maxlen);
int smpd_dbs_create_name_in(wchar_t *name);
int smpd_dbs_destroy(const wchar_t *name);
int smpd_dbs_get(const wchar_t *name, const wchar_t *key, wchar_t *value, size_t maxlen);
int smpd_dbs_put(const wchar_t *name, const wchar_t *key, const wchar_t *value);
int smpd_dbs_delete(const wchar_t *name, const wchar_t *key);
int smpd_dbs_first(const wchar_t *name, wchar_t *key, size_t maxlen1, wchar_t *value, size_t maxlen2);
int smpd_dbs_next(const wchar_t *name, wchar_t *key, size_t maxlen1, wchar_t *value, size_t maxlen2);
int smpd_dbs_firstdb(wchar_t *name, size_t maxlen);
int smpd_dbs_nextdb(wchar_t *name, size_t maxlen);

#if defined(__cplusplus)
}
#endif

#endif
