/*   Copyright (C) 2009 Deino Software. */

#include <stdio.h>
#include "smpd.h"

int smpd_restart()
{
	int error;
	wchar_t szExe[1024];
	wchar_t pszStr[2048];
	STARTUPINFO sInfo;
	PROCESS_INFORMATION pInfo;

	if (!GetModuleFileName(NULL, szExe, 1024))
	{
		smpd_translate_win_error(GetLastError(), pszStr, 2048, L"GetModuleFileName failed.\nError: ");
		return SMPD_FAIL;
	}

	/* Warning: This function can raise an exception */
	GetStartupInfo(&sInfo);

	_snwprintf_s(pszStr, 2048, _TRUNCATE, L"\"%s\" -restart", szExe);

	if (!CreateProcess(NULL, 
			pszStr,
			NULL, NULL, FALSE, 
			DETACHED_PROCESS,
			NULL, NULL, 
			&sInfo, &pInfo))
	{
		error = GetLastError();
		wprintf(L"CreateProcess failed for '%s'\n", pszStr);
		smpd_translate_win_error(error, pszStr, 2048, L"Error: ");
		return SMPD_FAIL;
	}
	CloseHandle(pInfo.hProcess);
	CloseHandle(pInfo.hThread);
	return SMPD_SUCCESS;
}
