/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*
 *  (C) 2006 by Deino Software.
 *  (C) 2001 by Argonne National Laboratory.
 *	  See COPYRIGHT in top-level directory.
 */

#ifndef SMPD_SERVICE_H
#define SMPD_SERVICE_H

#include "smpd.h"

/* name of the service */
#define SMPD_SERVICE_NAME		 "deino_smpd"
#define SMPD_SERVICE_NAMEW	   L"deino_smpd"
/* displayed name of the service */
#define SMPD_SERVICE_DISPLAY_NAME   "Deino SMPD Process Manager"
#define SMPD_SERVICE_DISPLAY_NAMEW L"Deino SMPD Process Manager"
/* guid to represent the service */
#define SMPD_SERVICE_GUID   "f5e3c95b-7a1f-49c1-b518-25cbf0796936"
#define SMPD_SERVICE_GUIDW L"f5e3c95b-7a1f-49c1-b518-25cbf0796936"
/* guid to represent the service vendor */
#define SMPD_SERVICE_VENDOR_GUID   "e86ee83a-a584-4710-9621-e592d754acad"
#define SMPD_SERVICE_VENDOR_GUIDW L"e86ee83a-a584-4710-9621-e592d754acad"
/* vendor */
#define SMPD_PRODUCT_VENDOR   "Deino Software"
#define SMPD_PRODUCT_VENDORW L"Deino Software"
/* product */
#define SMPD_PRODUCT   "deino_smpd"
#define SMPD_PRODUCTW L"deino_smpd"
/* registry key */
#define SMPD_SERVICE_REGISTRY_KEY "Software\\Deino\\MPICH2\\SMPD"

void smpd_install_service(SMPD_BOOL interact, SMPD_BOOL bSetupRestart, SMPD_BOOL bSetupScp);
SMPD_BOOL smpd_remove_service(SMPD_BOOL bErrorOnNotInstalled);
void smpd_stop_service();
void smpd_start_service();
void smpd_service_main(int argc, LPTSTR argv[]);
void smpd_service_stop();
void smpd_add_error_to_message_log(LPCTSTR msg);
SMPD_BOOL smpd_report_status_to_sc_mgr(DWORD dwCurrentState, DWORD dwWin32ExitCode, DWORD dwWaitHint);

#endif
