/*  (C) 2009 by Deino Software. */

#include "mpi_fortimpl.h"
/* mpierrs.h and mpierror.h for the error code creation */
#include "mpierrs.h"
#include <stdio.h>
#include "mpierror.h"
#include "mpichconf.h"
#include "mpichtimer.h"

#ifndef MPICH_MPI_FROM_PMPI

#ifdef F77_NAME_UPPER
#define mpi_abort_ PMPI_ABORT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_abort_ pmpi_abort__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_abort_ pmpi_abort
#else
#define mpi_abort_ pmpi_abort_
#endif
#define MPI_Abort PMPI_Abort

#ifdef F77_NAME_UPPER
#define mpi_accumulate_ PMPI_ACCUMULATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_accumulate_ pmpi_accumulate__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_accumulate_ pmpi_accumulate
#else
#define mpi_accumulate_ pmpi_accumulate_
#endif
#define MPI_Accumulate PMPI_Accumulate

#ifdef F77_NAME_UPPER
#define mpi_accumulate_ PMPI_ACCUMULATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_accumulate_ pmpi_accumulate__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_accumulate_ pmpi_accumulate
#else
#define mpi_accumulate_ pmpi_accumulate_
#endif
#define MPI_Accumulate PMPI_Accumulate

#ifdef F77_NAME_UPPER
#define mpi_add_error_class_ PMPI_ADD_ERROR_CLASS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_add_error_class_ pmpi_add_error_class__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_add_error_class_ pmpi_add_error_class
#else
#define mpi_add_error_class_ pmpi_add_error_class_
#endif
#define MPI_Add_error_class PMPI_Add_error_class

#ifdef F77_NAME_UPPER
#define mpi_add_error_code_ PMPI_ADD_ERROR_CODE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_add_error_code_ pmpi_add_error_code__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_add_error_code_ pmpi_add_error_code
#else
#define mpi_add_error_code_ pmpi_add_error_code_
#endif
#define MPI_Add_error_code PMPI_Add_error_code

#ifdef F77_NAME_UPPER
#define mpi_add_error_string_ PMPI_ADD_ERROR_STRING
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_add_error_string_ pmpi_add_error_string__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_add_error_string_ pmpi_add_error_string
#else
#define mpi_add_error_string_ pmpi_add_error_string_
#endif
#undef MPI_Add_error_string
#define MPI_Add_error_string PMPI_Add_error_string

#ifdef F77_NAME_UPPER
#define mpi_address_ PMPI_ADDRESS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_address_ pmpi_address__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_address_ pmpi_address
#else
#define mpi_address_ pmpi_address_
#endif
#define MPI_Allgather PMPI_Allgather

#ifdef F77_NAME_UPPER
#define mpi_allgather_ PMPI_ALLGATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgather_ pmpi_allgather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgather_ pmpi_allgather
#else
#define mpi_allgather_ pmpi_allgather_
#endif
#define MPI_Allgather PMPI_Allgather

#ifdef F77_NAME_UPPER
#define mpi_allgatherv_ PMPI_ALLGATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgatherv_ pmpi_allgatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgatherv_ pmpi_allgatherv
#else
#define mpi_allgatherv_ pmpi_allgatherv_
#endif
#define MPI_Allgatherv PMPI_Allgatherv

#ifdef F77_NAME_UPPER
#define mpi_allgatherv_ PMPI_ALLGATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgatherv_ pmpi_allgatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgatherv_ pmpi_allgatherv
#else
#define mpi_allgatherv_ pmpi_allgatherv_
#endif
#define MPI_Allgatherv PMPI_Allgatherv

#ifdef F77_NAME_UPPER
#define mpi_alloc_mem_ PMPI_ALLOC_MEM
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alloc_mem_ pmpi_alloc_mem__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alloc_mem_ pmpi_alloc_mem
#else
#define mpi_alloc_mem_ pmpi_alloc_mem_
#endif
#define MPI_Alloc_mem PMPI_Alloc_mem

#ifdef F77_NAME_UPPER
#define mpi_allreduce_ PMPI_ALLREDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allreduce_ pmpi_allreduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allreduce_ pmpi_allreduce
#else
#define mpi_allreduce_ pmpi_allreduce_
#endif
#define MPI_Allreduce PMPI_Allreduce

#ifdef F77_NAME_UPPER
#define mpi_allreduce_ PMPI_ALLREDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allreduce_ pmpi_allreduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allreduce_ pmpi_allreduce
#else
#define mpi_allreduce_ pmpi_allreduce_
#endif
#define MPI_Allreduce PMPI_Allreduce

#ifdef F77_NAME_UPPER
#define mpi_alltoall_ PMPI_ALLTOALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoall_ pmpi_alltoall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoall_ pmpi_alltoall
#else
#define mpi_alltoall_ pmpi_alltoall_
#endif
#define MPI_Alltoall PMPI_Alltoall

#ifdef F77_NAME_UPPER
#define mpi_alltoall_ PMPI_ALLTOALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoall_ pmpi_alltoall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoall_ pmpi_alltoall
#else
#define mpi_alltoall_ pmpi_alltoall_
#endif
#define MPI_Alltoall PMPI_Alltoall

#ifdef F77_NAME_UPPER
#define mpi_alltoallv_ PMPI_ALLTOALLV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallv_ pmpi_alltoallv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallv_ pmpi_alltoallv
#else
#define mpi_alltoallv_ pmpi_alltoallv_
#endif
#define MPI_Alltoallv PMPI_Alltoallv

#ifdef F77_NAME_UPPER
#define mpi_alltoallv_ PMPI_ALLTOALLV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallv_ pmpi_alltoallv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallv_ pmpi_alltoallv
#else
#define mpi_alltoallv_ pmpi_alltoallv_
#endif
#define MPI_Alltoallv PMPI_Alltoallv

#ifdef F77_NAME_UPPER
#define mpi_alltoallw_ PMPI_ALLTOALLW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallw_ pmpi_alltoallw__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallw_ pmpi_alltoallw
#else
#define mpi_alltoallw_ pmpi_alltoallw_
#endif
#define MPI_Alltoallw PMPI_Alltoallw

#ifdef F77_NAME_UPPER
#define mpi_alltoallw_ PMPI_ALLTOALLW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallw_ pmpi_alltoallw__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallw_ pmpi_alltoallw
#else
#define mpi_alltoallw_ pmpi_alltoallw_
#endif
#define MPI_Alltoallw PMPI_Alltoallw

#ifdef F77_NAME_UPPER
#define mpi_attr_delete_ PMPI_ATTR_DELETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_attr_delete_ pmpi_attr_delete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_attr_delete_ pmpi_attr_delete
#else
#define mpi_attr_delete_ pmpi_attr_delete_
#endif
#define MPI_Attr_delete PMPI_Attr_delete

#ifdef F77_NAME_UPPER
#define mpi_attr_get_ PMPI_ATTR_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_attr_get_ pmpi_attr_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_attr_get_ pmpi_attr_get
#else
#define mpi_attr_get_ pmpi_attr_get_
#endif
#define MPI_Attr_get PMPI_Attr_get

#ifdef F77_NAME_UPPER
#define mpi_attr_put_ PMPI_ATTR_PUT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_attr_put_ pmpi_attr_put__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_attr_put_ pmpi_attr_put
#else
#define mpi_attr_put_ pmpi_attr_put_
#endif
#define MPI_Attr_put PMPI_Attr_put

#ifdef F77_NAME_UPPER
#define mpi_barrier_ PMPI_BARRIER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_barrier_ pmpi_barrier__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_barrier_ pmpi_barrier
#else
#define mpi_barrier_ pmpi_barrier_
#endif
#define MPI_Barrier PMPI_Barrier

#ifdef F77_NAME_UPPER
#define mpi_bcast_ PMPI_BCAST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bcast_ pmpi_bcast__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bcast_ pmpi_bcast
#else
#define mpi_bcast_ pmpi_bcast_
#endif
#define MPI_Bcast PMPI_Bcast

#ifdef F77_NAME_UPPER
#define mpi_bcast_ PMPI_BCAST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bcast_ pmpi_bcast__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bcast_ pmpi_bcast
#else
#define mpi_bcast_ pmpi_bcast_
#endif
#define MPI_Bcast PMPI_Bcast

#ifdef F77_NAME_UPPER
#define mpi_bsend_init_ PMPI_BSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_init_ pmpi_bsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_init_ pmpi_bsend_init
#else
#define mpi_bsend_init_ pmpi_bsend_init_
#endif
#define MPI_Bsend_init PMPI_Bsend_init

#ifdef F77_NAME_UPPER
#define mpi_bsend_init_ PMPI_BSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_init_ pmpi_bsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_init_ pmpi_bsend_init
#else
#define mpi_bsend_init_ pmpi_bsend_init_
#endif
#define MPI_Bsend_init PMPI_Bsend_init

#ifdef F77_NAME_UPPER
#define mpi_bsend_ PMPI_BSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_ pmpi_bsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_ pmpi_bsend
#else
#define mpi_bsend_ pmpi_bsend_
#endif
#define MPI_Bsend PMPI_Bsend

#ifdef F77_NAME_UPPER
#define mpi_bsend_ PMPI_BSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_ pmpi_bsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_ pmpi_bsend
#else
#define mpi_bsend_ pmpi_bsend_
#endif
#define MPI_Bsend PMPI_Bsend

#ifdef F77_NAME_UPPER
#define mpi_buffer_attach_ PMPI_BUFFER_ATTACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_attach_ pmpi_buffer_attach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_attach_ pmpi_buffer_attach
#else
#define mpi_buffer_attach_ pmpi_buffer_attach_
#endif
#define MPI_Buffer_attach PMPI_Buffer_attach

#ifdef F77_NAME_UPPER
#define mpi_buffer_attach_ PMPI_BUFFER_ATTACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_attach_ pmpi_buffer_attach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_attach_ pmpi_buffer_attach
#else
#define mpi_buffer_attach_ pmpi_buffer_attach_
#endif
#define MPI_Buffer_attach PMPI_Buffer_attach

#ifdef F77_NAME_UPPER
#define mpi_buffer_detach_ PMPI_BUFFER_DETACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_detach_ pmpi_buffer_detach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_detach_ pmpi_buffer_detach
#else
#define mpi_buffer_detach_ pmpi_buffer_detach_
#endif
#define MPI_Buffer_detach PMPI_Buffer_detach

#ifdef F77_NAME_UPPER
#define mpi_buffer_detach_ PMPI_BUFFER_DETACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_detach_ pmpi_buffer_detach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_detach_ pmpi_buffer_detach
#else
#define mpi_buffer_detach_ pmpi_buffer_detach_
#endif
#define MPI_Buffer_detach PMPI_Buffer_detach

#ifdef F77_NAME_UPPER
#define mpi_cancel_ PMPI_CANCEL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cancel_ pmpi_cancel__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cancel_ pmpi_cancel
#else
#define mpi_cancel_ pmpi_cancel_
#endif
#define MPI_Cancel PMPI_Cancel

#ifdef F77_NAME_UPPER
#define mpi_cart_coords_ PMPI_CART_COORDS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_coords_ pmpi_cart_coords__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_coords_ pmpi_cart_coords
#else
#define mpi_cart_coords_ pmpi_cart_coords_
#endif
#define MPI_Cart_coords PMPI_Cart_coords

#ifdef F77_NAME_UPPER
#define mpi_cart_create_ PMPI_CART_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_create_ pmpi_cart_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_create_ pmpi_cart_create
#else
#define mpi_cart_create_ pmpi_cart_create_
#endif
#define MPI_Cart_create PMPI_Cart_create

#ifdef F77_NAME_UPPER
#define mpi_cart_get_ PMPI_CART_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_get_ pmpi_cart_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_get_ pmpi_cart_get
#else
#define mpi_cart_get_ pmpi_cart_get_
#endif
#define MPI_Cart_get PMPI_Cart_get

#ifdef F77_NAME_UPPER
#define mpi_cart_map_ PMPI_CART_MAP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_map_ pmpi_cart_map__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_map_ pmpi_cart_map
#else
#define mpi_cart_map_ pmpi_cart_map_
#endif
#define MPI_Cart_map PMPI_Cart_map

#ifdef F77_NAME_UPPER
#define mpi_cart_rank_ PMPI_CART_RANK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_rank_ pmpi_cart_rank__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_rank_ pmpi_cart_rank
#else
#define mpi_cart_rank_ pmpi_cart_rank_
#endif
#define MPI_Cart_rank PMPI_Cart_rank

#ifdef F77_NAME_UPPER
#define mpi_cart_shift_ PMPI_CART_SHIFT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_shift_ pmpi_cart_shift__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_shift_ pmpi_cart_shift
#else
#define mpi_cart_shift_ pmpi_cart_shift_
#endif
#define MPI_Cart_shift PMPI_Cart_shift

#ifdef F77_NAME_UPPER
#define mpi_cart_sub_ PMPI_CART_SUB
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_sub_ pmpi_cart_sub__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_sub_ pmpi_cart_sub
#else
#define mpi_cart_sub_ pmpi_cart_sub_
#endif
#define MPI_Cart_sub PMPI_Cart_sub

#ifdef F77_NAME_UPPER
#define mpi_cartdim_get_ PMPI_CARTDIM_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cartdim_get_ pmpi_cartdim_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cartdim_get_ pmpi_cartdim_get
#else
#define mpi_cartdim_get_ pmpi_cartdim_get_
#endif
#define MPI_Cartdim_get PMPI_Cartdim_get

#ifdef F77_NAME_UPPER
#define mpi_close_port_ PMPI_CLOSE_PORT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_close_port_ pmpi_close_port__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_close_port_ pmpi_close_port
#else
#define mpi_close_port_ pmpi_close_port_
#endif
#undef MPI_Close_port
#define MPI_Close_port PMPI_Close_port

#ifdef F77_NAME_UPPER
#define mpi_comm_accept_ PMPI_COMM_ACCEPT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_accept_ pmpi_comm_accept__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_accept_ pmpi_comm_accept
#else
#define mpi_comm_accept_ pmpi_comm_accept_
#endif
#undef MPI_Comm_accept
#define MPI_Comm_accept PMPI_Comm_accept

#ifdef F77_NAME_UPPER
#define mpi_comm_compare_ PMPI_COMM_COMPARE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_compare_ pmpi_comm_compare__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_compare_ pmpi_comm_compare
#else
#define mpi_comm_compare_ pmpi_comm_compare_
#endif
#define MPI_Comm_compare PMPI_Comm_compare

#ifdef F77_NAME_UPPER
#define mpi_comm_connect_ PMPI_COMM_CONNECT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_connect_ pmpi_comm_connect__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_connect_ pmpi_comm_connect
#else
#define mpi_comm_connect_ pmpi_comm_connect_
#endif
#undef MPI_Comm_connect
#define MPI_Comm_connect PMPI_Comm_connect

#ifdef F77_NAME_UPPER
#define mpi_comm_create_ PMPI_COMM_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_create_ pmpi_comm_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_create_ pmpi_comm_create
#else
#define mpi_comm_create_ pmpi_comm_create_
#endif
#define MPI_Comm_create PMPI_Comm_create

#ifdef F77_NAME_UPPER
#define mpi_comm_dup_ PMPI_COMM_DUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_dup_ pmpi_comm_dup__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_dup_ pmpi_comm_dup
#else
#define mpi_comm_dup_ pmpi_comm_dup_
#endif
#define MPI_Comm_dup PMPI_Comm_dup

#ifdef F77_NAME_UPPER
#define mpi_comm_free_ PMPI_COMM_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_free_ pmpi_comm_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_free_ pmpi_comm_free
#else
#define mpi_comm_free_ pmpi_comm_free_
#endif
#define MPI_Comm_free PMPI_Comm_free

#ifdef F77_NAME_UPPER
#define mpi_comm_get_attr_ PMPI_COMM_GET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_attr_ pmpi_comm_get_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_attr_ pmpi_comm_get_attr
#else
#define mpi_comm_get_attr_ pmpi_comm_get_attr_
#endif
#define MPI_Comm_get_attr PMPI_Comm_get_attr

#ifdef F77_NAME_UPPER
#define mpi_comm_group_ PMPI_COMM_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_group_ pmpi_comm_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_group_ pmpi_comm_group
#else
#define mpi_comm_group_ pmpi_comm_group_
#endif
#define MPI_Comm_group PMPI_Comm_group

#ifdef F77_NAME_UPPER
#define mpi_comm_join_ PMPI_COMM_JOIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_join_ pmpi_comm_join__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_join_ pmpi_comm_join
#else
#define mpi_comm_join_ pmpi_comm_join_
#endif
#define MPI_Comm_join PMPI_Comm_join

#ifdef F77_NAME_UPPER
#define mpi_comm_rank_ PMPI_COMM_RANK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_rank_ pmpi_comm_rank__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_rank_ pmpi_comm_rank
#else
#define mpi_comm_rank_ pmpi_comm_rank_
#endif
#define MPI_Comm_rank PMPI_Comm_rank

#ifdef F77_NAME_UPPER
#define mpi_comm_set_attr_ PMPI_COMM_SET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_set_attr_ pmpi_comm_set_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_set_attr_ pmpi_comm_set_attr
#else
#define mpi_comm_set_attr_ pmpi_comm_set_attr_
#endif
#define MPI_Comm_set_attr PMPI_Comm_set_attr

#ifdef F77_NAME_UPPER
#define mpi_comm_set_name_ PMPI_COMM_SET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_set_name_ pmpi_comm_set_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_set_name_ pmpi_comm_set_name
#else
#define mpi_comm_set_name_ pmpi_comm_set_name_
#endif
#undef MPI_Comm_set_name
#define MPI_Comm_set_name PMPI_Comm_set_name

#ifdef F77_NAME_UPPER
#define mpi_comm_size_ PMPI_COMM_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_size_ pmpi_comm_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_size_ pmpi_comm_size
#else
#define mpi_comm_size_ pmpi_comm_size_
#endif
#define MPI_Comm_size PMPI_Comm_size

#ifdef F77_NAME_UPPER
#define mpi_comm_spawn_ PMPI_COMM_SPAWN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_spawn_ pmpi_comm_spawn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_spawn_ pmpi_comm_spawn
#else
#define mpi_comm_spawn_ pmpi_comm_spawn_
#endif
#undef MPI_Comm_spawn
#define MPI_Comm_spawn PMPI_Comm_spawn

#ifdef F77_NAME_UPPER
#define mpi_comm_split_ PMPI_COMM_SPLIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_split_ pmpi_comm_split__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_split_ pmpi_comm_split
#else
#define mpi_comm_split_ pmpi_comm_split_
#endif
#define MPI_Comm_split PMPI_Comm_split

#ifdef F77_NAME_UPPER
#define mpi_comm_call_errhandler_ PMPI_COMM_CALL_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_call_errhandler_ pmpi_comm_call_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_call_errhandler_ pmpi_comm_call_errhandler
#else
#define mpi_comm_call_errhandler_ pmpi_comm_call_errhandler_
#endif
#define MPI_Comm_call_errhandler PMPI_Comm_call_errhandler

#ifdef F77_NAME_UPPER
#define mpi_comm_create_errhandler_ PMPI_COMM_CREATE_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_create_errhandler_ pmpi_comm_create_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_create_errhandler_ pmpi_comm_create_errhandler
#else
#define mpi_comm_create_errhandler_ pmpi_comm_create_errhandler_
#endif
#define MPI_Comm_create_errhandler PMPI_Comm_create_errhandler

#ifdef F77_NAME_UPPER
#define mpi_comm_delete_attr_ PMPI_COMM_DELETE_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_delete_attr_ pmpi_comm_delete_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_delete_attr_ pmpi_comm_delete_attr
#else
#define mpi_comm_delete_attr_ pmpi_comm_delete_attr_
#endif
#define MPI_Comm_delete_attr PMPI_Comm_delete_attr

#ifdef F77_NAME_UPPER
#define mpi_comm_disconnect_ PMPI_COMM_DISCONNECT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_disconnect_ pmpi_comm_disconnect__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_disconnect_ pmpi_comm_disconnect
#else
#define mpi_comm_disconnect_ pmpi_comm_disconnect_
#endif
#define MPI_Comm_disconnect PMPI_Comm_disconnect

#ifdef F77_NAME_UPPER
#define mpi_comm_free_keyval_ PMPI_COMM_FREE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_free_keyval_ pmpi_comm_free_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_free_keyval_ pmpi_comm_free_keyval
#else
#define mpi_comm_free_keyval_ pmpi_comm_free_keyval_
#endif
#define MPI_Comm_free_keyval PMPI_Comm_free_keyval

#ifdef F77_NAME_UPPER
#define mpi_comm_get_errhandler_ PMPI_COMM_GET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_errhandler_ pmpi_comm_get_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_errhandler_ pmpi_comm_get_errhandler
#else
#define mpi_comm_get_errhandler_ pmpi_comm_get_errhandler_
#endif
#define MPI_Comm_get_errhandler PMPI_Comm_get_errhandler

#ifdef F77_NAME_UPPER
#define mpi_comm_get_name_ PMPI_COMM_GET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_name_ pmpi_comm_get_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_name_ pmpi_comm_get_name
#else
#define mpi_comm_get_name_ pmpi_comm_get_name_
#endif
#undef MPI_Comm_get_name
#define MPI_Comm_get_name PMPI_Comm_get_name

#ifdef F77_NAME_UPPER
#define mpi_comm_create_keyval_ PMPI_COMM_CREATE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_create_keyval_ pmpi_comm_create_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_create_keyval_ pmpi_comm_create_keyval
#else
#define mpi_comm_create_keyval_ pmpi_comm_create_keyval_
#endif
#define MPI_Comm_create_keyval PMPI_Comm_create_keyval

#ifdef F77_NAME_UPPER
#define mpi_comm_get_parent_ PMPI_COMM_GET_PARENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_parent_ pmpi_comm_get_parent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_parent_ pmpi_comm_get_parent
#else
#define mpi_comm_get_parent_ pmpi_comm_get_parent_
#endif
#define MPI_Comm_get_parent PMPI_Comm_get_parent

#ifdef F77_NAME_UPPER
#define mpi_comm_remote_group_ PMPI_COMM_REMOTE_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_remote_group_ pmpi_comm_remote_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_remote_group_ pmpi_comm_remote_group
#else
#define mpi_comm_remote_group_ pmpi_comm_remote_group_
#endif
#define MPI_Comm_remote_group PMPI_Comm_remote_group

#ifdef F77_NAME_UPPER
#define mpi_comm_remote_size_ PMPI_COMM_REMOTE_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_remote_size_ pmpi_comm_remote_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_remote_size_ pmpi_comm_remote_size
#else
#define mpi_comm_remote_size_ pmpi_comm_remote_size_
#endif
#define MPI_Comm_remote_size PMPI_Comm_remote_size

#ifdef F77_NAME_UPPER
#define mpi_comm_set_errhandler_ PMPI_COMM_SET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_set_errhandler_ pmpi_comm_set_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_set_errhandler_ pmpi_comm_set_errhandler
#else
#define mpi_comm_set_errhandler_ pmpi_comm_set_errhandler_
#endif
#define MPI_Comm_set_errhandler PMPI_Comm_set_errhandler

#ifdef F77_NAME_UPPER
#define mpi_comm_test_inter_ PMPI_COMM_TEST_INTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_test_inter_ pmpi_comm_test_inter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_test_inter_ pmpi_comm_test_inter
#else
#define mpi_comm_test_inter_ pmpi_comm_test_inter_
#endif
#define MPI_Comm_test_inter PMPI_Comm_test_inter

#ifdef F77_NAME_UPPER
#define mpi_dims_create_ PMPI_DIMS_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_dims_create_ pmpi_dims_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_dims_create_ pmpi_dims_create
#else
#define mpi_dims_create_ pmpi_dims_create_
#endif
#define MPI_Dims_create PMPI_Dims_create

#ifdef MPI_COMM_DUP_FN
#undef MPI_COMM_DUP_FN
#endif

#ifdef F77_NAME_UPPER
#define mpi_errhandler_create_ PMPI_ERRHANDLER_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_create_ pmpi_errhandler_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_create_ pmpi_errhandler_create
#else
#define mpi_errhandler_create_ pmpi_errhandler_create_
#endif
/* This defines the routine that we call, which must be the PMPI version
   since we're renameing the Fortran entry as the pmpi version */
#define MPI_Errhandler_create PMPI_Errhandler_create 

#ifdef F77_NAME_UPPER
#define mpi_errhandler_free_ PMPI_ERRHANDLER_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_free_ pmpi_errhandler_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_free_ pmpi_errhandler_free
#else
#define mpi_errhandler_free_ pmpi_errhandler_free_
#endif
#define MPI_Errhandler_free PMPI_Errhandler_free

#ifdef F77_NAME_UPPER
#define mpi_errhandler_get_ PMPI_ERRHANDLER_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_get_ pmpi_errhandler_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_get_ pmpi_errhandler_get
#else
#define mpi_errhandler_get_ pmpi_errhandler_get_
#endif
#define MPI_Errhandler_get PMPI_Errhandler_get

#ifdef F77_NAME_UPPER
#define mpi_errhandler_set_ PMPI_ERRHANDLER_SET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_set_ pmpi_errhandler_set__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_set_ pmpi_errhandler_set
#else
#define mpi_errhandler_set_ pmpi_errhandler_set_
#endif
#define MPI_Errhandler_set PMPI_Errhandler_set

#ifdef F77_NAME_UPPER
#define mpi_error_class_ PMPI_ERROR_CLASS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_error_class_ pmpi_error_class__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_error_class_ pmpi_error_class
#else
#define mpi_error_class_ pmpi_error_class_
#endif
#define MPI_Error_class PMPI_Error_class

#ifdef F77_NAME_UPPER
#define mpi_error_string_ PMPI_ERROR_STRING
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_error_string_ pmpi_error_string__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_error_string_ pmpi_error_string
#else
#define mpi_error_string_ pmpi_error_string_
#endif
#undef MPI_Error_string
#define MPI_Error_string PMPI_Error_string

#ifdef F77_NAME_UPPER
#define mpi_exscan_ PMPI_EXSCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_exscan_ pmpi_exscan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_exscan_ pmpi_exscan
#else
#define mpi_exscan_ pmpi_exscan_
#endif
#define MPI_Exscan PMPI_Exscan

#ifdef F77_NAME_UPPER
#define mpi_exscan_ PMPI_EXSCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_exscan_ pmpi_exscan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_exscan_ pmpi_exscan
#else
#define mpi_exscan_ pmpi_exscan_
#endif
#define MPI_Exscan PMPI_Exscan

#ifdef F77_NAME_UPPER
#define mpi_file_call_errhandler_ PMPI_FILE_CALL_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_call_errhandler_ pmpi_file_call_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_call_errhandler_ pmpi_file_call_errhandler
#else
#define mpi_file_call_errhandler_ pmpi_file_call_errhandler_
#endif
#define MPI_File_call_errhandler PMPI_File_call_errhandler 

#ifdef F77_NAME_UPPER
#define mpi_file_create_errhandler_ PMPI_FILE_CREATE_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_create_errhandler_ pmpi_file_create_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_create_errhandler_ pmpi_file_create_errhandler
#else
#define mpi_file_create_errhandler_ pmpi_file_create_errhandler_
#endif
#define MPI_File_create_errhandler PMPI_File_create_errhandler

#ifdef F77_NAME_UPPER
#define mpi_file_get_errhandler_ PMPI_FILE_GET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_errhandler_ pmpi_file_get_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_errhandler_ pmpi_file_get_errhandler
#else
#define mpi_file_get_errhandler_ pmpi_file_get_errhandler_
#endif
#define MPI_File_get_errhandler PMPI_File_get_errhandler

#ifdef F77_NAME_UPPER
#define mpi_file_set_errhandler_ PMPI_FILE_SET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_errhandler_ pmpi_file_set_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_errhandler_ pmpi_file_set_errhandler
#else
#define mpi_file_set_errhandler_ pmpi_file_set_errhandler_
#endif
#define MPI_File_set_errhandler PMPI_File_set_errhandler

#ifdef F77_NAME_UPPER
#define mpi_finalized_ PMPI_FINALIZED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_finalized_ pmpi_finalized__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_finalized_ pmpi_finalized
#else
#define mpi_finalized_ pmpi_finalized_
#endif
#define MPI_Finalized PMPI_Finalized

#ifdef F77_NAME_UPPER
#define mpi_finalize_ PMPI_FINALIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_finalize_ pmpi_finalize__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_finalize_ pmpi_finalize
#else
#define mpi_finalize_ pmpi_finalize_
#endif
#define MPI_Finalize PMPI_Finalize

#ifdef F77_NAME_UPPER
#define mpi_free_mem_ PMPI_FREE_MEM
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_free_mem_ pmpi_free_mem__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_free_mem_ pmpi_free_mem
#else
#define mpi_free_mem_ pmpi_free_mem_
#endif
#define MPI_Free_mem PMPI_Free_mem

#ifdef F77_NAME_UPPER
#define mpi_gather_ PMPI_GATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gather_ pmpi_gather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gather_ pmpi_gather
#else
#define mpi_gather_ pmpi_gather_
#endif
#define MPI_Gather PMPI_Gather

#ifdef F77_NAME_UPPER
#define mpi_gather_ PMPI_GATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gather_ pmpi_gather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gather_ pmpi_gather
#else
#define mpi_gather_ pmpi_gather_
#endif
#define MPI_Gather PMPI_Gather

#ifdef F77_NAME_UPPER
#define mpi_gatherv_ PMPI_GATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gatherv_ pmpi_gatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gatherv_ pmpi_gatherv
#else
#define mpi_gatherv_ pmpi_gatherv_
#endif
#define MPI_Gatherv PMPI_Gatherv

#ifdef F77_NAME_UPPER
#define mpi_gatherv_ PMPI_GATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gatherv_ pmpi_gatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gatherv_ pmpi_gatherv
#else
#define mpi_gatherv_ pmpi_gatherv_
#endif
#define MPI_Gatherv PMPI_Gatherv

#ifdef F77_NAME_UPPER
#define mpi_get_count_ PMPI_GET_COUNT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_count_ pmpi_get_count__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_count_ pmpi_get_count
#else
#define mpi_get_count_ pmpi_get_count_
#endif
#define MPI_Get_count PMPI_Get_count

#ifdef F77_NAME_UPPER
#define mpi_get_elements_ PMPI_GET_ELEMENTS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_elements_ pmpi_get_elements__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_elements_ pmpi_get_elements
#else
#define mpi_get_elements_ pmpi_get_elements_
#endif
#define MPI_Get_elements PMPI_Get_elements

#ifdef F77_NAME_UPPER
#define mpi_get_version_ PMPI_GET_VERSION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_version_ pmpi_get_version__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_version_ pmpi_get_version
#else
#define mpi_get_version_ pmpi_get_version_
#endif
#define MPI_Get_version PMPI_Get_version

#ifdef F77_NAME_UPPER
#define mpi_get_address_ PMPI_GET_ADDRESS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_address_ pmpi_get_address__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_address_ pmpi_get_address
#else
#define mpi_get_address_ pmpi_get_address_
#endif
#define MPI_Get PMPI_Get

#ifdef F77_NAME_UPPER
#define mpi_get_ PMPI_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_ pmpi_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_ pmpi_get
#else
#define mpi_get_ pmpi_get_
#endif
#define MPI_Get PMPI_Get

#ifdef F77_NAME_UPPER
#define mpi_get_processor_name_ PMPI_GET_PROCESSOR_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_processor_name_ pmpi_get_processor_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_processor_name_ pmpi_get_processor_name
#else
#define mpi_get_processor_name_ pmpi_get_processor_name_
#endif
#undef MPI_Get_processor_name
#define MPI_Get_processor_name PMPI_Get_processor_name

#ifdef F77_NAME_UPPER
#define mpi_graph_create_ PMPI_GRAPH_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_create_ pmpi_graph_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_create_ pmpi_graph_create
#else
#define mpi_graph_create_ pmpi_graph_create_
#endif
#define MPI_Graph_create PMPI_Graph_create

#ifdef F77_NAME_UPPER
#define mpi_graph_get_ PMPI_GRAPH_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_get_ pmpi_graph_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_get_ pmpi_graph_get
#else
#define mpi_graph_get_ pmpi_graph_get_
#endif
#define MPI_Graph_get PMPI_Graph_get

#ifdef F77_NAME_UPPER
#define mpi_graph_map_ PMPI_GRAPH_MAP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_map_ pmpi_graph_map__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_map_ pmpi_graph_map
#else
#define mpi_graph_map_ pmpi_graph_map_
#endif
#define MPI_Graph_map PMPI_Graph_map

#ifdef F77_NAME_UPPER
#define mpi_graphdims_get_ PMPI_GRAPHDIMS_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graphdims_get_ pmpi_graphdims_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graphdims_get_ pmpi_graphdims_get
#else
#define mpi_graphdims_get_ pmpi_graphdims_get_
#endif
#define MPI_Graphdims_get PMPI_Graphdims_get

#ifdef F77_NAME_UPPER
#define mpi_grequest_complete_ PMPI_GREQUEST_COMPLETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_grequest_complete_ pmpi_grequest_complete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_grequest_complete_ pmpi_grequest_complete
#else
#define mpi_grequest_complete_ pmpi_grequest_complete_
#endif
#define MPI_Grequest_complete PMPI_Grequest_complete

#ifdef F77_NAME_UPPER
#define mpi_grequest_start_ PMPI_GREQUEST_START
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_grequest_start_ pmpi_grequest_start__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_grequest_start_ pmpi_grequest_start
#else
#define mpi_grequest_start_ pmpi_grequest_start_
#endif
#define MPI_Grequest_start PMPI_Grequest_start

#ifdef F77_NAME_UPPER
#define mpi_graph_neighbors_count_ PMPI_GRAPH_NEIGHBORS_COUNT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_neighbors_count_ pmpi_graph_neighbors_count__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_neighbors_count_ pmpi_graph_neighbors_count
#else
#define mpi_graph_neighbors_count_ pmpi_graph_neighbors_count_
#endif
#define MPI_Graph_neighbors_count PMPI_Graph_neighbors_count

#ifdef F77_NAME_UPPER
#define mpi_graph_neighbors_ PMPI_GRAPH_NEIGHBORS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_neighbors_ pmpi_graph_neighbors__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_neighbors_ pmpi_graph_neighbors
#else
#define mpi_graph_neighbors_ pmpi_graph_neighbors_
#endif
#define MPI_Graph_neighbors PMPI_Graph_neighbors

#ifdef F77_NAME_UPPER
#define mpi_group_compare_ PMPI_GROUP_COMPARE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_compare_ pmpi_group_compare__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_compare_ pmpi_group_compare
#else
#define mpi_group_compare_ pmpi_group_compare_
#endif
#define MPI_Group_compare PMPI_Group_compare

#ifdef F77_NAME_UPPER
#define mpi_group_excl_ PMPI_GROUP_EXCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_excl_ pmpi_group_excl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_excl_ pmpi_group_excl
#else
#define mpi_group_excl_ pmpi_group_excl_
#endif
#define MPI_Group_excl PMPI_Group_excl

#ifdef F77_NAME_UPPER
#define mpi_group_free_ PMPI_GROUP_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_free_ pmpi_group_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_free_ pmpi_group_free
#else
#define mpi_group_free_ pmpi_group_free_
#endif
#define MPI_Group_free PMPI_Group_free

#ifdef F77_NAME_UPPER
#define mpi_group_incl_ PMPI_GROUP_INCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_incl_ pmpi_group_incl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_incl_ pmpi_group_incl
#else
#define mpi_group_incl_ pmpi_group_incl_
#endif
#define MPI_Group_incl PMPI_Group_incl

#ifdef F77_NAME_UPPER
#define mpi_group_rank_ PMPI_GROUP_RANK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_rank_ pmpi_group_rank__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_rank_ pmpi_group_rank
#else
#define mpi_group_rank_ pmpi_group_rank_
#endif
#define MPI_Group_rank PMPI_Group_rank

#ifdef F77_NAME_UPPER
#define mpi_group_size_ PMPI_GROUP_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_size_ pmpi_group_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_size_ pmpi_group_size
#else
#define mpi_group_size_ pmpi_group_size_
#endif
#define MPI_Group_size PMPI_Group_size

#ifdef F77_NAME_UPPER
#define mpi_group_union_ PMPI_GROUP_UNION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_union_ pmpi_group_union__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_union_ pmpi_group_union
#else
#define mpi_group_union_ pmpi_group_union_
#endif
#define MPI_Group_union PMPI_Group_union

#ifdef F77_NAME_UPPER
#define mpi_group_difference_ PMPI_GROUP_DIFFERENCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_difference_ pmpi_group_difference__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_difference_ pmpi_group_difference
#else
#define mpi_group_difference_ pmpi_group_difference_
#endif
#define MPI_Group_difference PMPI_Group_difference

#ifdef F77_NAME_UPPER
#define mpi_group_intersection_ PMPI_GROUP_INTERSECTION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_intersection_ pmpi_group_intersection__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_intersection_ pmpi_group_intersection
#else
#define mpi_group_intersection_ pmpi_group_intersection_
#endif
#define MPI_Group_intersection PMPI_Group_intersection

#ifdef F77_NAME_UPPER
#define mpi_group_range_excl_ PMPI_GROUP_RANGE_EXCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_range_excl_ pmpi_group_range_excl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_range_excl_ pmpi_group_range_excl
#else
#define mpi_group_range_excl_ pmpi_group_range_excl_
#endif
#define MPI_Group_range_excl PMPI_Group_range_excl

#ifdef F77_NAME_UPPER
#define mpi_group_range_incl_ PMPI_GROUP_RANGE_INCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_range_incl_ pmpi_group_range_incl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_range_incl_ pmpi_group_range_incl
#else
#define mpi_group_range_incl_ pmpi_group_range_incl_
#endif
#define MPI_Group_range_incl PMPI_Group_range_incl

#ifdef F77_NAME_UPPER
#define mpi_group_translate_ranks_ PMPI_GROUP_TRANSLATE_RANKS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_translate_ranks_ pmpi_group_translate_ranks__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_translate_ranks_ pmpi_group_translate_ranks
#else
#define mpi_group_translate_ranks_ pmpi_group_translate_ranks_
#endif
#define MPI_Group_translate_ranks PMPI_Group_translate_ranks

#ifdef F77_NAME_UPPER
#define mpi_ibsend_ PMPI_IBSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ibsend_ pmpi_ibsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ibsend_ pmpi_ibsend
#else
#define mpi_ibsend_ pmpi_ibsend_
#endif
#define MPI_Ibsend PMPI_Ibsend

#ifdef F77_NAME_UPPER
#define mpi_ibsend_ PMPI_IBSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ibsend_ pmpi_ibsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ibsend_ pmpi_ibsend
#else
#define mpi_ibsend_ pmpi_ibsend_
#endif
#define MPI_Ibsend PMPI_Ibsend

#ifdef F77_NAME_UPPER
#define mpi_intercomm_create_ PMPI_INTERCOMM_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_intercomm_create_ pmpi_intercomm_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_intercomm_create_ pmpi_intercomm_create
#else
#define mpi_intercomm_create_ pmpi_intercomm_create_
#endif
#define MPI_Intercomm_create PMPI_Intercomm_create

#ifdef F77_NAME_UPPER
#define mpi_intercomm_merge_ PMPI_INTERCOMM_MERGE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_intercomm_merge_ pmpi_intercomm_merge__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_intercomm_merge_ pmpi_intercomm_merge
#else
#define mpi_intercomm_merge_ pmpi_intercomm_merge_
#endif
#define MPI_Intercomm_merge PMPI_Intercomm_merge

#ifdef F77_NAME_UPPER
#define mpi_info_create_ PMPI_INFO_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_create_ pmpi_info_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_create_ pmpi_info_create
#else
#define mpi_info_create_ pmpi_info_create_
#endif
#define MPI_Info_create PMPI_Info_create

#ifdef F77_NAME_UPPER
#define mpi_info_delete_ PMPI_INFO_DELETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_delete_ pmpi_info_delete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_delete_ pmpi_info_delete
#else
#define mpi_info_delete_ pmpi_info_delete_
#endif
#undef MPI_Info_delete
#define MPI_Info_delete PMPI_Info_delete

#ifdef F77_NAME_UPPER
#define mpi_info_dup_ PMPI_INFO_DUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_dup_ pmpi_info_dup__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_dup_ pmpi_info_dup
#else
#define mpi_info_dup_ pmpi_info_dup_
#endif
#define MPI_Info_dup PMPI_Info_dup

#ifdef F77_NAME_UPPER
#define mpi_info_free_ PMPI_INFO_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_free_ pmpi_info_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_free_ pmpi_info_free
#else
#define mpi_info_free_ pmpi_info_free_
#endif
#define MPI_Info_free PMPI_Info_free

#ifdef F77_NAME_UPPER
#define mpi_info_get_ PMPI_INFO_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_ pmpi_info_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_ pmpi_info_get
#else
#define mpi_info_get_ pmpi_info_get_
#endif
#undef MPI_Info_get
#define MPI_Info_get PMPI_Info_get

#ifdef F77_NAME_UPPER
#define mpi_info_set_ PMPI_INFO_SET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_set_ pmpi_info_set__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_set_ pmpi_info_set
#else
#define mpi_info_set_ pmpi_info_set_
#endif
#undef MPI_Info_set
#define MPI_Info_set PMPI_Info_set

#ifdef F77_NAME_UPPER
#define mpi_info_get_nkeys_ PMPI_INFO_GET_NKEYS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_nkeys_ pmpi_info_get_nkeys__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_nkeys_ pmpi_info_get_nkeys
#else
#define mpi_info_get_nkeys_ pmpi_info_get_nkeys_
#endif
#define MPI_Info_get_nkeys PMPI_Info_get_nkeys

#ifdef F77_NAME_UPPER
#define mpi_info_get_nthkey_ PMPI_INFO_GET_NTHKEY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_nthkey_ pmpi_info_get_nthkey__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_nthkey_ pmpi_info_get_nthkey
#else
#define mpi_info_get_nthkey_ pmpi_info_get_nthkey_
#endif
#undef MPI_Info_get_nthkey
#define MPI_Info_get_nthkey PMPI_Info_get_nthkey

#ifdef F77_NAME_UPPER
#define mpi_info_get_valuelen_ PMPI_INFO_GET_VALUELEN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_valuelen_ pmpi_info_get_valuelen__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_valuelen_ pmpi_info_get_valuelen
#else
#define mpi_info_get_valuelen_ pmpi_info_get_valuelen_
#endif
#undef MPI_Info_get_valuelen
#define MPI_Info_get_valuelen PMPI_Info_get_valuelen

#ifdef F77_NAME_UPPER
#define mpi_initialized_ PMPI_INITIALIZED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_initialized_ pmpi_initialized__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_initialized_ pmpi_initialized
#else
#define mpi_initialized_ pmpi_initialized_
#endif
#define MPI_Initialized PMPI_Initialized 

#ifdef F77_NAME_UPPER
#define mpi_iprobe_ PMPI_IPROBE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_iprobe_ pmpi_iprobe__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_iprobe_ pmpi_iprobe
#else
#define mpi_iprobe_ pmpi_iprobe_
#endif
#define MPI_Iprobe PMPI_Iprobe 

#ifdef F77_NAME_UPPER
#define mpi_irecv_ PMPI_IRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irecv_ pmpi_irecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irecv_ pmpi_irecv
#else
#define mpi_irecv_ pmpi_irecv_
#endif
#define MPI_Irecv PMPI_Irecv

#ifdef F77_NAME_UPPER
#define mpi_irecv_ PMPI_IRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irecv_ pmpi_irecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irecv_ pmpi_irecv
#else
#define mpi_irecv_ pmpi_irecv_
#endif
#define MPI_Irecv PMPI_Irecv

#ifdef F77_NAME_UPPER
#define mpi_irsend_ PMPI_IRSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irsend_ pmpi_irsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irsend_ pmpi_irsend
#else
#define mpi_irsend_ pmpi_irsend_
#endif
#define MPI_Irsend PMPI_Irsend

#ifdef F77_NAME_UPPER
#define mpi_irsend_ PMPI_IRSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irsend_ pmpi_irsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irsend_ pmpi_irsend
#else
#define mpi_irsend_ pmpi_irsend_
#endif
#define MPI_Irsend PMPI_Irsend

#ifdef F77_NAME_UPPER
#define mpi_isend_ PMPI_ISEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_isend_ pmpi_isend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_isend_ pmpi_isend
#else
#define mpi_isend_ pmpi_isend_
#endif
#define MPI_Isend PMPI_Isend

#ifdef F77_NAME_UPPER
#define mpi_isend_ PMPI_ISEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_isend_ pmpi_isend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_isend_ pmpi_isend
#else
#define mpi_isend_ pmpi_isend_
#endif
#define MPI_Isend PMPI_Isend

#ifdef F77_NAME_UPPER
#define mpi_issend_ PMPI_ISSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_issend_ pmpi_issend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_issend_ pmpi_issend
#else
#define mpi_issend_ pmpi_issend_
#endif
#define MPI_Issend PMPI_Issend

#ifdef F77_NAME_UPPER
#define mpi_issend_ PMPI_ISSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_issend_ pmpi_issend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_issend_ pmpi_issend
#else
#define mpi_issend_ pmpi_issend_
#endif
#define MPI_Issend PMPI_Issend

#ifdef F77_NAME_UPPER
#define mpi_is_thread_main_ PMPI_IS_THREAD_MAIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_is_thread_main_ pmpi_is_thread_main__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_is_thread_main_ pmpi_is_thread_main
#else
#define mpi_is_thread_main_ pmpi_is_thread_main_
#endif
#define MPI_Is_thread_main PMPI_Is_thread_main

#ifdef F77_NAME_UPPER
#define mpi_keyval_free_ PMPI_KEYVAL_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_keyval_free_ pmpi_keyval_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_keyval_free_ pmpi_keyval_free
#else
#define mpi_keyval_free_ pmpi_keyval_free_
#endif
#define MPI_Keyval_free PMPI_Keyval_free 

#ifdef F77_NAME_UPPER
#define mpi_lookup_name_ PMPI_LOOKUP_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_lookup_name_ pmpi_lookup_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_lookup_name_ pmpi_lookup_name
#else
#define mpi_lookup_name_ pmpi_lookup_name_
#endif
#undef MPI_Lookup_name
#define MPI_Lookup_name PMPI_Lookup_name

#ifdef MPI_COMM_NULL_COPY_FN
#undef MPI_COMM_NULL_COPY_FN
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_null_copy_fn_ PMPI_COMM_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_null_copy_fn_ pmpi_comm_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_null_copy_fn_ pmpi_comm_null_copy_fn
#else
#define mpi_comm_null_copy_fn_ pmpi_comm_null_copy_fn_
#endif
#undef MPI_mpi_comm_null_copy_fn
#define MPI_mpi_comm_null_copy_fn PMPI_mpi_comm_null_copy_fn 

#ifdef F77_NAME_UPPER
#define mpi_op_create_ PMPI_OP_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_op_create_ pmpi_op_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_op_create_ pmpi_op_create
#else
#define mpi_op_create_ pmpi_op_create_
#endif
#define MPI_Op_create PMPI_Op_create 

#ifdef F77_NAME_UPPER
#define mpi_op_free_ PMPI_OP_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_op_free_ pmpi_op_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_op_free_ pmpi_op_free
#else
#define mpi_op_free_ pmpi_op_free_
#endif
#define MPI_Op_free PMPI_Op_free

#ifdef F77_NAME_UPPER
#define mpi_open_port_ PMPI_OPEN_PORT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_open_port_ pmpi_open_port__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_open_port_ pmpi_open_port
#else
#define mpi_open_port_ pmpi_open_port_
#endif
#undef MPI_Open_port
#define MPI_Open_port PMPI_Open_port

#ifdef F77_NAME_UPPER
#define mpi_pack_external_ PMPI_PACK_EXTERNAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_external_ pmpi_pack_external__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_external_ pmpi_pack_external
#else
#define mpi_pack_external_ pmpi_pack_external_
#endif
#undef MPI_Pack_external
#define MPI_Pack_external PMPI_Pack_external

#ifdef F77_NAME_UPPER
#define mpi_pack_size_ PMPI_PACK_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_size_ pmpi_pack_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_size_ pmpi_pack_size
#else
#define mpi_pack_size_ pmpi_pack_size_
#endif
#define MPI_Pack_size PMPI_Pack_size

#ifdef F77_NAME_UPPER
#define mpi_pack_external_size_ PMPI_PACK_EXTERNAL_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_external_size_ pmpi_pack_external_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_external_size_ pmpi_pack_external_size
#else
#define mpi_pack_external_size_ pmpi_pack_external_size_
#endif
#undef MPI_Pack_external_size
#define MPI_Pack_external_size PMPI_Pack_external_size

#ifdef F77_NAME_UPPER
#define mpi_pack_ PMPI_PACK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_ pmpi_pack__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_ pmpi_pack
#else
#define mpi_pack_ pmpi_pack_
#endif
#define MPI_Pack PMPI_Pack

#ifdef F77_NAME_UPPER
#define mpi_probe_ PMPI_PROBE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_probe_ pmpi_probe__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_probe_ pmpi_probe
#else
#define mpi_probe_ pmpi_probe_
#endif
#define MPI_Probe PMPI_Probe 

#ifdef F77_NAME_UPPER
#define mpi_publish_name_ PMPI_PUBLISH_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_publish_name_ pmpi_publish_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_publish_name_ pmpi_publish_name
#else
#define mpi_publish_name_ pmpi_publish_name_
#endif
#undef MPI_Publish_name
#define MPI_Publish_name PMPI_Publish_name

#ifdef F77_NAME_UPPER
#define mpi_put_ PMPI_PUT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_put_ pmpi_put__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_put_ pmpi_put
#else
#define mpi_put_ pmpi_put_
#endif
#define MPI_Put PMPI_Put

#ifdef F77_NAME_UPPER
#define mpi_query_thread_ PMPI_QUERY_THREAD
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_query_thread_ pmpi_query_thread__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_query_thread_ pmpi_query_thread
#else
#define mpi_query_thread_ pmpi_query_thread_
#endif
#define MPI_Query_thread PMPI_Query_thread

#ifdef F77_NAME_UPPER
#define mpi_recv_init_ PMPI_RECV_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_init_ pmpi_recv_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_init_ pmpi_recv_init
#else
#define mpi_recv_init_ pmpi_recv_init_
#endif
#define MPI_Recv_init PMPI_Recv_init

#ifdef F77_NAME_UPPER
#define mpi_recv_init_ PMPI_RECV_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_init_ pmpi_recv_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_init_ pmpi_recv_init
#else
#define mpi_recv_init_ pmpi_recv_init_
#endif
#define MPI_Recv_init PMPI_Recv_init

#ifdef F77_NAME_UPPER
#define mpi_recv_ PMPI_RECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_ pmpi_recv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_ pmpi_recv
#else
#define mpi_recv_ pmpi_recv_
#endif
#define MPI_Recv PMPI_Recv

#ifdef F77_NAME_UPPER
#define mpi_recv_ PMPI_RECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_ pmpi_recv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_ pmpi_recv
#else
#define mpi_recv_ pmpi_recv_
#endif
#define MPI_Recv PMPI_Recv

#ifdef F77_NAME_UPPER
#define mpi_reduce_scatter_ PMPI_REDUCE_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_scatter_ pmpi_reduce_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_scatter_ pmpi_reduce_scatter
#else
#define mpi_reduce_scatter_ pmpi_reduce_scatter_
#endif
#define MPI_Reduce_scatter PMPI_Reduce_scatter

#ifdef F77_NAME_UPPER
#define mpi_reduce_scatter_ PMPI_REDUCE_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_scatter_ pmpi_reduce_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_scatter_ pmpi_reduce_scatter
#else
#define mpi_reduce_scatter_ pmpi_reduce_scatter_
#endif
#define MPI_Reduce_scatter PMPI_Reduce_scatter

#ifdef F77_NAME_UPPER
#define mpi_reduce_ PMPI_REDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_ pmpi_reduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_ pmpi_reduce
#else
#define mpi_reduce_ pmpi_reduce_
#endif
#define MPI_Reduce PMPI_Reduce

#ifdef F77_NAME_UPPER
#define mpi_reduce_ PMPI_REDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_ pmpi_reduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_ pmpi_reduce
#else
#define mpi_reduce_ pmpi_reduce_
#endif
#define MPI_Reduce PMPI_Reduce

#ifdef F77_NAME_UPPER
#define mpi_request_get_status_ PMPI_REQUEST_GET_STATUS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_request_get_status_ pmpi_request_get_status__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_request_get_status_ pmpi_request_get_status
#else
#define mpi_request_get_status_ pmpi_request_get_status_
#endif
#define MPI_Request_get_status PMPI_Request_get_status 

#ifdef F77_NAME_UPPER
#define mpi_request_free_ PMPI_REQUEST_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_request_free_ pmpi_request_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_request_free_ pmpi_request_free
#else
#define mpi_request_free_ pmpi_request_free_
#endif
#define MPI_Request_free PMPI_Request_free

#ifdef F77_NAME_UPPER
#define mpi_rsend_init_ PMPI_RSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_init_ pmpi_rsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_init_ pmpi_rsend_init
#else
#define mpi_rsend_init_ pmpi_rsend_init_
#endif
#define MPI_Rsend_init PMPI_Rsend_init

#ifdef F77_NAME_UPPER
#define mpi_rsend_init_ PMPI_RSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_init_ pmpi_rsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_init_ pmpi_rsend_init
#else
#define mpi_rsend_init_ pmpi_rsend_init_
#endif
#define MPI_Rsend_init PMPI_Rsend_init

#ifdef F77_NAME_UPPER
#define mpi_rsend_ PMPI_RSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_ pmpi_rsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_ pmpi_rsend
#else
#define mpi_rsend_ pmpi_rsend_
#endif
#define MPI_Rsend PMPI_Rsend

#ifdef F77_NAME_UPPER
#define mpi_rsend_ PMPI_RSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_ pmpi_rsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_ pmpi_rsend
#else
#define mpi_rsend_ pmpi_rsend_
#endif
#define MPI_Rsend PMPI_Rsend

#ifdef F77_NAME_UPPER
#define mpi_scan_ PMPI_SCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scan_ pmpi_scan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scan_ pmpi_scan
#else
#define mpi_scan_ pmpi_scan_
#endif
#define MPI_Scan PMPI_Scan

#ifdef F77_NAME_UPPER
#define mpi_scan_ PMPI_SCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scan_ pmpi_scan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scan_ pmpi_scan
#else
#define mpi_scan_ pmpi_scan_
#endif
#define MPI_Scan PMPI_Scan

#ifdef F77_NAME_UPPER
#define mpi_scatter_ PMPI_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatter_ pmpi_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatter_ pmpi_scatter
#else
#define mpi_scatter_ pmpi_scatter_
#endif
#define MPI_Scatter PMPI_Scatter

#ifdef F77_NAME_UPPER
#define mpi_scatter_ PMPI_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatter_ pmpi_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatter_ pmpi_scatter
#else
#define mpi_scatter_ pmpi_scatter_
#endif
#define MPI_Scatter PMPI_Scatter

#ifdef F77_NAME_UPPER
#define mpi_scatterv_ PMPI_SCATTERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatterv_ pmpi_scatterv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatterv_ pmpi_scatterv
#else
#define mpi_scatterv_ pmpi_scatterv_
#endif
#define MPI_Scatterv PMPI_Scatterv

#ifdef F77_NAME_UPPER
#define mpi_scatterv_ PMPI_SCATTERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatterv_ pmpi_scatterv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatterv_ pmpi_scatterv
#else
#define mpi_scatterv_ pmpi_scatterv_
#endif
#define MPI_Scatterv PMPI_Scatterv

#ifdef F77_NAME_UPPER
#define mpi_send_init_ PMPI_SEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_init_ pmpi_send_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_init_ pmpi_send_init
#else
#define mpi_send_init_ pmpi_send_init_
#endif
#define MPI_Send_init PMPI_Send_init

#ifdef F77_NAME_UPPER
#define mpi_send_init_ PMPI_SEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_init_ pmpi_send_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_init_ pmpi_send_init
#else
#define mpi_send_init_ pmpi_send_init_
#endif
#define MPI_Send_init PMPI_Send_init

#ifdef F77_NAME_UPPER
#define mpi_send_ PMPI_SEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_ pmpi_send__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_ pmpi_send
#else
#define mpi_send_ pmpi_send_
#endif
#define MPI_Send PMPI_Send

#ifdef F77_NAME_UPPER
#define mpi_send_ PMPI_SEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_ pmpi_send__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_ pmpi_send
#else
#define mpi_send_ pmpi_send_
#endif
#define MPI_Send PMPI_Send

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_ PMPI_SENDRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_ pmpi_sendrecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_ pmpi_sendrecv
#else
#define mpi_sendrecv_ pmpi_sendrecv_
#endif
#define MPI_Sendrecv PMPI_Sendrecv

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_ PMPI_SENDRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_ pmpi_sendrecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_ pmpi_sendrecv
#else
#define mpi_sendrecv_ pmpi_sendrecv_
#endif
#define MPI_Sendrecv PMPI_Sendrecv

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_replace_ PMPI_SENDRECV_REPLACE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_replace_ pmpi_sendrecv_replace__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_replace_ pmpi_sendrecv_replace
#else
#define mpi_sendrecv_replace_ pmpi_sendrecv_replace_
#endif
#define MPI_Sendrecv_replace PMPI_Sendrecv_replace

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_replace_ PMPI_SENDRECV_REPLACE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_replace_ pmpi_sendrecv_replace__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_replace_ pmpi_sendrecv_replace
#else
#define mpi_sendrecv_replace_ pmpi_sendrecv_replace_
#endif
#define MPI_Sendrecv_replace PMPI_Sendrecv_replace

#ifdef F77_NAME_UPPER
#define mpi_comm_spawn_multiple_ PMPI_COMM_SPAWN_MULTIPLE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_spawn_multiple_ pmpi_comm_spawn_multiple__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_spawn_multiple_ pmpi_comm_spawn_multiple
#else
#define mpi_comm_spawn_multiple_ pmpi_comm_spawn_multiple_
#endif
#undef MPI_Comm_spawn_multiple
#define MPI_Comm_spawn_multiple PMPI_Comm_spawn_multiple

#ifdef F77_NAME_UPPER
#define mpi_ssend_init_ PMPI_SSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_init_ pmpi_ssend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_init_ pmpi_ssend_init
#else
#define mpi_ssend_init_ pmpi_ssend_init_
#endif
#define MPI_Ssend_init PMPI_Ssend_init

#ifdef F77_NAME_UPPER
#define mpi_ssend_init_ PMPI_SSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_init_ pmpi_ssend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_init_ pmpi_ssend_init
#else
#define mpi_ssend_init_ pmpi_ssend_init_
#endif
#define MPI_Ssend_init PMPI_Ssend_init

#ifdef F77_NAME_UPPER
#define mpi_ssend_ PMPI_SSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_ pmpi_ssend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_ pmpi_ssend
#else
#define mpi_ssend_ pmpi_ssend_
#endif
#define MPI_Ssend PMPI_Ssend

#ifdef F77_NAME_UPPER
#define mpi_ssend_ PMPI_SSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_ pmpi_ssend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_ pmpi_ssend
#else
#define mpi_ssend_ pmpi_ssend_
#endif
#define MPI_Ssend PMPI_Ssend

#ifdef F77_NAME_UPPER
#define mpi_startall_ PMPI_STARTALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_startall_ pmpi_startall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_startall_ pmpi_startall
#else
#define mpi_startall_ pmpi_startall_
#endif
#define MPI_Startall PMPI_Startall

#ifdef F77_NAME_UPPER
#define mpi_start_ PMPI_START
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_start_ pmpi_start__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_start_ pmpi_start
#else
#define mpi_start_ pmpi_start_
#endif
#define MPI_Start PMPI_Start

#ifdef F77_NAME_UPPER
#define mpi_status_set_cancelled_ PMPI_STATUS_SET_CANCELLED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_status_set_cancelled_ pmpi_status_set_cancelled__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_status_set_cancelled_ pmpi_status_set_cancelled
#else
#define mpi_status_set_cancelled_ pmpi_status_set_cancelled_
#endif
#define MPI_Status_set_cancelled PMPI_Status_set_cancelled

#ifdef F77_NAME_UPPER
#define mpi_status_set_elements_ PMPI_STATUS_SET_ELEMENTS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_status_set_elements_ pmpi_status_set_elements__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_status_set_elements_ pmpi_status_set_elements
#else
#define mpi_status_set_elements_ pmpi_status_set_elements_
#endif
#define MPI_Status_set_elements PMPI_Status_set_elements

#undef MPI_Status_c2f
#define MPI_Status_c2f PMPI_Status_c2f

#undef MPI_Status_f2c
#define MPI_Status_f2c PMPI_Status_f2c

#ifdef F77_NAME_UPPER
#define mpi_testall_ PMPI_TESTALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_testall_ pmpi_testall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_testall_ pmpi_testall
#else
#define mpi_testall_ pmpi_testall_
#endif
#define MPI_Testall PMPI_Testall

#ifdef F77_NAME_UPPER
#define mpi_testany_ PMPI_TESTANY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_testany_ pmpi_testany__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_testany_ pmpi_testany
#else
#define mpi_testany_ pmpi_testany_
#endif
#define MPI_Testany PMPI_Testany

#ifdef F77_NAME_UPPER
#define mpi_test_cancelled_ PMPI_TEST_CANCELLED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_test_cancelled_ pmpi_test_cancelled__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_test_cancelled_ pmpi_test_cancelled
#else
#define mpi_test_cancelled_ pmpi_test_cancelled_
#endif
#define MPI_Test_cancelled PMPI_Test_cancelled

#ifdef F77_NAME_UPPER
#define mpi_test_ PMPI_TEST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_test_ pmpi_test__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_test_ pmpi_test
#else
#define mpi_test_ pmpi_test_
#endif
#define MPI_Test PMPI_Test

#ifdef F77_NAME_UPPER
#define mpi_testsome_ PMPI_TESTSOME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_testsome_ pmpi_testsome__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_testsome_ pmpi_testsome
#else
#define mpi_testsome_ pmpi_testsome_
#endif
#define MPI_Testsome PMPI_Testsome

#ifdef F77_NAME_UPPER
#define mpi_topo_test_ PMPI_TOPO_TEST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_topo_test_ pmpi_topo_test__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_topo_test_ pmpi_topo_test
#else
#define mpi_topo_test_ pmpi_topo_test_
#endif
#define MPI_Topo_test PMPI_Topo_test

#ifdef F77_NAME_UPPER
#define mpi_type_commit_ PMPI_TYPE_COMMIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_commit_ pmpi_type_commit__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_commit_ pmpi_type_commit
#else
#define mpi_type_commit_ pmpi_type_commit_
#endif
#define MPI_Type_commit PMPI_Type_commit

#ifdef F77_NAME_UPPER
#define mpi_type_dup_ PMPI_TYPE_DUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_dup_ pmpi_type_dup__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_dup_ pmpi_type_dup
#else
#define mpi_type_dup_ pmpi_type_dup_
#endif
#define MPI_Type_dup PMPI_Type_dup

#ifdef F77_NAME_UPPER
#define mpi_type_extent_ PMPI_TYPE_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_extent_ pmpi_type_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_extent_ pmpi_type_extent
#else
#define mpi_type_extent_ pmpi_type_extent_
#endif
#define MPI_Type_extent PMPI_Type_extent

#ifdef F77_NAME_UPPER
#define mpi_type_free_ PMPI_TYPE_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_free_ pmpi_type_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_free_ pmpi_type_free
#else
#define mpi_type_free_ pmpi_type_free_
#endif
#define MPI_Type_free PMPI_Type_free

#ifdef F77_NAME_UPPER
#define mpi_type_get_attr_ PMPI_TYPE_GET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_attr_ pmpi_type_get_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_attr_ pmpi_type_get_attr
#else
#define mpi_type_get_attr_ pmpi_type_get_attr_
#endif
#define MPI_Type_get_attr PMPI_Type_get_attr

#ifdef F77_NAME_UPPER
#define mpi_type_hindexed_ PMPI_TYPE_HINDEXED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_hindexed_ pmpi_type_hindexed__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_hindexed_ pmpi_type_hindexed
#else
#define mpi_type_hindexed_ pmpi_type_hindexed_
#endif
#define MPI_Type_hindexed PMPI_Type_hindexed

#ifdef F77_NAME_UPPER
#define mpi_type_hvector_ PMPI_TYPE_HVECTOR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_hvector_ pmpi_type_hvector__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_hvector_ pmpi_type_hvector
#else
#define mpi_type_hvector_ pmpi_type_hvector_
#endif
#define MPI_Type_hvector PMPI_Type_hvector

#ifdef F77_NAME_UPPER
#define mpi_type_indexed_ PMPI_TYPE_INDEXED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_indexed_ pmpi_type_indexed__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_indexed_ pmpi_type_indexed
#else
#define mpi_type_indexed_ pmpi_type_indexed_
#endif
#define MPI_Type_indexed PMPI_Type_indexed

#ifdef F77_NAME_UPPER
#define mpi_type_lb_ PMPI_TYPE_LB
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_lb_ pmpi_type_lb__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_lb_ pmpi_type_lb
#else
#define mpi_type_lb_ pmpi_type_lb_
#endif
#define MPI_Type_lb PMPI_Type_lb

#ifdef F77_NAME_UPPER
#define mpi_type_match_size_ PMPI_TYPE_MATCH_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_match_size_ pmpi_type_match_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_match_size_ pmpi_type_match_size
#else
#define mpi_type_match_size_ pmpi_type_match_size_
#endif
#define MPI_Type_match_size PMPI_Type_match_size

#ifdef F77_NAME_UPPER
#define mpi_type_size_ PMPI_TYPE_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_size_ pmpi_type_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_size_ pmpi_type_size
#else
#define mpi_type_size_ pmpi_type_size_
#endif
#define MPI_Type_size PMPI_Type_size

#ifdef F77_NAME_UPPER
#define mpi_type_struct_ PMPI_TYPE_STRUCT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_struct_ pmpi_type_struct__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_struct_ pmpi_type_struct
#else
#define mpi_type_struct_ pmpi_type_struct_
#endif
#define MPI_Type_struct PMPI_Type_struct

#ifdef F77_NAME_UPPER
#define mpi_type_ub_ PMPI_TYPE_UB
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_ub_ pmpi_type_ub__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_ub_ pmpi_type_ub
#else
#define mpi_type_ub_ pmpi_type_ub_
#endif
#define MPI_Type_ub PMPI_Type_ub

#ifdef F77_NAME_UPPER
#define mpi_type_vector_ PMPI_TYPE_VECTOR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_vector_ pmpi_type_vector__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_vector_ pmpi_type_vector
#else
#define mpi_type_vector_ pmpi_type_vector_
#endif
#define MPI_Type_vector PMPI_Type_vector

#ifdef F77_NAME_UPPER
#define mpi_type_create_hindexed_ PMPI_TYPE_CREATE_HINDEXED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_hindexed_ pmpi_type_create_hindexed__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_hindexed_ pmpi_type_create_hindexed
#else
#define mpi_type_create_hindexed_ pmpi_type_create_hindexed_
#endif
#define MPI_Type_create_hindexed PMPI_Type_create_hindexed

#ifdef F77_NAME_UPPER
#define mpi_type_create_hvector_ PMPI_TYPE_CREATE_HVECTOR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_hvector_ pmpi_type_create_hvector__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_hvector_ pmpi_type_create_hvector
#else
#define mpi_type_create_hvector_ pmpi_type_create_hvector_
#endif
#define MPI_Type_create_hvector PMPI_Type_create_hvector

#ifdef F77_NAME_UPPER
#define mpi_type_create_indexed_block_ PMPI_TYPE_CREATE_INDEXED_BLOCK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_indexed_block_ pmpi_type_create_indexed_block__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_indexed_block_ pmpi_type_create_indexed_block
#else
#define mpi_type_create_indexed_block_ pmpi_type_create_indexed_block_
#endif
#define MPI_Type_create_indexed_block PMPI_Type_create_indexed_block

#ifdef F77_NAME_UPPER
#define mpi_type_contiguous_ PMPI_TYPE_CONTIGUOUS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_contiguous_ pmpi_type_contiguous__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_contiguous_ pmpi_type_contiguous
#else
#define mpi_type_contiguous_ pmpi_type_contiguous_
#endif
#define MPI_Type_contiguous PMPI_Type_contiguous

#ifdef F77_NAME_UPPER
#define mpi_type_create_resized_ PMPI_TYPE_CREATE_RESIZED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_resized_ pmpi_type_create_resized__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_resized_ pmpi_type_create_resized
#else
#define mpi_type_create_resized_ pmpi_type_create_resized_
#endif
#define MPI_Type_create_resized PMPI_Type_create_resized

#ifdef F77_NAME_UPPER
#define mpi_type_create_struct_ PMPI_TYPE_CREATE_STRUCT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_struct_ pmpi_type_create_struct__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_struct_ pmpi_type_create_struct
#else
#define mpi_type_create_struct_ pmpi_type_create_struct_
#endif
#define MPI_Type_create_struct PMPI_Type_create_struct

#ifdef F77_NAME_UPPER
#define mpi_type_create_subarray_ PMPI_TYPE_CREATE_SUBARRAY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_subarray_ pmpi_type_create_subarray__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_subarray_ pmpi_type_create_subarray
#else
#define mpi_type_create_subarray_ pmpi_type_create_subarray_
#endif
#define MPI_Type_create_subarray PMPI_Type_create_subarray

#ifdef F77_NAME_UPPER
#define mpi_type_create_darray_ PMPI_TYPE_CREATE_DARRAY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_darray_ pmpi_type_create_darray__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_darray_ pmpi_type_create_darray
#else
#define mpi_type_create_darray_ pmpi_type_create_darray_
#endif
#define MPI_Type_create_darray PMPI_Type_create_darray

#ifdef F77_NAME_UPPER
#define mpi_type_delete_attr_ PMPI_TYPE_DELETE_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_delete_attr_ pmpi_type_delete_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_delete_attr_ pmpi_type_delete_attr
#else
#define mpi_type_delete_attr_ pmpi_type_delete_attr_
#endif
#define MPI_Type_delete_attr PMPI_Type_delete_attr

#ifdef F77_NAME_UPPER
#define mpi_type_free_keyval_ PMPI_TYPE_FREE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_free_keyval_ pmpi_type_free_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_free_keyval_ pmpi_type_free_keyval
#else
#define mpi_type_free_keyval_ pmpi_type_free_keyval_
#endif
#define MPI_Type_free_keyval PMPI_Type_free_keyval

#ifdef F77_NAME_UPPER
#define mpi_type_get_contents_ PMPI_TYPE_GET_CONTENTS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_contents_ pmpi_type_get_contents__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_contents_ pmpi_type_get_contents
#else
#define mpi_type_get_contents_ pmpi_type_get_contents_
#endif
#define MPI_Type_get_contents PMPI_Type_get_contents

#ifdef F77_NAME_UPPER
#define mpi_type_get_envelope_ PMPI_TYPE_GET_ENVELOPE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_envelope_ pmpi_type_get_envelope__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_envelope_ pmpi_type_get_envelope
#else
#define mpi_type_get_envelope_ pmpi_type_get_envelope_
#endif
#define MPI_Type_get_envelope PMPI_Type_get_envelope

#ifdef F77_NAME_UPPER
#define mpi_type_get_extent_ PMPI_TYPE_GET_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_extent_ pmpi_type_get_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_extent_ pmpi_type_get_extent
#else
#define mpi_type_get_extent_ pmpi_type_get_extent_
#endif
#define MPI_Type_get_extent PMPI_Type_get_extent

#ifdef F77_NAME_UPPER
#define mpi_type_get_name_ PMPI_TYPE_GET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_name_ pmpi_type_get_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_name_ pmpi_type_get_name
#else
#define mpi_type_get_name_ pmpi_type_get_name_
#endif
#undef MPI_Type_get_name
#define MPI_Type_get_name PMPI_Type_get_name

#ifdef F77_NAME_UPPER
#define mpi_type_get_true_extent_ PMPI_TYPE_GET_TRUE_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_true_extent_ pmpi_type_get_true_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_true_extent_ pmpi_type_get_true_extent
#else
#define mpi_type_get_true_extent_ pmpi_type_get_true_extent_
#endif
#define MPI_Type_get_true_extent PMPI_Type_get_true_extent

#ifdef F77_NAME_UPPER
#define mpi_type_create_keyval_ PMPI_TYPE_CREATE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_keyval_ pmpi_type_create_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_keyval_ pmpi_type_create_keyval
#else
#define mpi_type_create_keyval_ pmpi_type_create_keyval_
#endif
#define MPI_Type_create_keyval PMPI_Type_create_keyval

#ifdef F77_NAME_UPPER
#define mpi_type_set_attr_ PMPI_TYPE_SET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_set_attr_ pmpi_type_set_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_set_attr_ pmpi_type_set_attr
#else
#define mpi_type_set_attr_ pmpi_type_set_attr_
#endif
#define MPI_Type_set_attr PMPI_Type_set_attr

#ifdef F77_NAME_UPPER
#define mpi_type_set_name_ PMPI_TYPE_SET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_set_name_ pmpi_type_set_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_set_name_ pmpi_type_set_name
#else
#define mpi_type_set_name_ pmpi_type_set_name_
#endif
#undef MPI_Type_set_name
#define MPI_Type_set_name PMPI_Type_set_name

#ifdef F77_NAME_UPPER
#define mpi_unpack_external_ PMPI_UNPACK_EXTERNAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_unpack_external_ pmpi_unpack_external__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_unpack_external_ pmpi_unpack_external
#else
#define mpi_unpack_external_ pmpi_unpack_external_
#endif
#undef MPI_Unpack_external
#define MPI_Unpack_external PMPI_Unpack_external

#ifdef F77_NAME_UPPER
#define mpi_unpack_ PMPI_UNPACK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_unpack_ pmpi_unpack__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_unpack_ pmpi_unpack
#else
#define mpi_unpack_ pmpi_unpack_
#endif
#define MPI_Unpack PMPI_Unpack

#ifdef F77_NAME_UPPER
#define mpi_unpublish_name_ PMPI_UNPUBLISH_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_unpublish_name_ pmpi_unpublish_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_unpublish_name_ pmpi_unpublish_name
#else
#define mpi_unpublish_name_ pmpi_unpublish_name_
#endif
#undef MPI_Unpublish_name
#define MPI_Unpublish_name PMPI_Unpublish_name

#ifdef F77_NAME_UPPER
#define mpi_waitall_ PMPI_WAITALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_waitall_ pmpi_waitall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_waitall_ pmpi_waitall
#else
#define mpi_waitall_ pmpi_waitall_
#endif
#define MPI_Waitall PMPI_Waitall

#ifdef F77_NAME_UPPER
#define mpi_waitany_ PMPI_WAITANY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_waitany_ pmpi_waitany__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_waitany_ pmpi_waitany
#else
#define mpi_waitany_ pmpi_waitany_
#endif
#define MPI_Waitany PMPI_Waitany

#ifdef F77_NAME_UPPER
#define mpi_wait_ PMPI_WAIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wait_ pmpi_wait__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wait_ pmpi_wait
#else
#define mpi_wait_ pmpi_wait_
#endif
#define MPI_Wait PMPI_Wait

#ifdef F77_NAME_UPPER
#define mpi_waitsome_ PMPI_WAITSOME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_waitsome_ pmpi_waitsome__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_waitsome_ pmpi_waitsome
#else
#define mpi_waitsome_ pmpi_waitsome_
#endif
#define MPI_Waitsome PMPI_Waitsome

#ifdef F77_NAME_UPPER
#define mpi_win_complete_ PMPI_WIN_COMPLETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_complete_ pmpi_win_complete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_complete_ pmpi_win_complete
#else
#define mpi_win_complete_ pmpi_win_complete_
#endif
#define MPI_Win_complete PMPI_Win_complete

#ifdef F77_NAME_UPPER
#define mpi_win_create_ PMPI_WIN_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_ pmpi_win_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_ pmpi_win_create
#else
#define mpi_win_create_ pmpi_win_create_
#endif
#define MPI_Win_create PMPI_Win_create

#ifdef F77_NAME_UPPER
#define mpi_win_create_ PMPI_WIN_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_ pmpi_win_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_ pmpi_win_create
#else
#define mpi_win_create_ pmpi_win_create_
#endif
#define MPI_Win_create PMPI_Win_create

#ifdef F77_NAME_UPPER
#define mpi_win_fence_ PMPI_WIN_FENCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_fence_ pmpi_win_fence__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_fence_ pmpi_win_fence
#else
#define mpi_win_fence_ pmpi_win_fence_
#endif
#define MPI_Win_fence PMPI_Win_fence

#ifdef F77_NAME_UPPER
#define mpi_win_free_ PMPI_WIN_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_free_ pmpi_win_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_free_ pmpi_win_free
#else
#define mpi_win_free_ pmpi_win_free_
#endif
#define MPI_Win_free PMPI_Win_free

#ifdef F77_NAME_UPPER
#define mpi_win_get_attr_ PMPI_WIN_GET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_attr_ pmpi_win_get_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_attr_ pmpi_win_get_attr
#else
#define mpi_win_get_attr_ pmpi_win_get_attr_
#endif
#define MPI_Win_get_attr PMPI_Win_get_attr

#ifdef F77_NAME_UPPER
#define mpi_win_get_group_ PMPI_WIN_GET_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_group_ pmpi_win_get_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_group_ pmpi_win_get_group
#else
#define mpi_win_get_group_ pmpi_win_get_group_
#endif
#define MPI_Win_get_group PMPI_Win_get_group

#ifdef F77_NAME_UPPER
#define mpi_win_get_name_ PMPI_WIN_GET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_name_ pmpi_win_get_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_name_ pmpi_win_get_name
#else
#define mpi_win_get_name_ pmpi_win_get_name_
#endif
#undef MPI_Win_get_name
#define MPI_Win_get_name PMPI_Win_get_name

#ifdef F77_NAME_UPPER
#define mpi_win_lock_ PMPI_WIN_LOCK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_lock_ pmpi_win_lock__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_lock_ pmpi_win_lock
#else
#define mpi_win_lock_ pmpi_win_lock_
#endif
#define MPI_Win_lock PMPI_Win_lock

#ifdef F77_NAME_UPPER
#define mpi_win_post_ PMPI_WIN_POST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_post_ pmpi_win_post__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_post_ pmpi_win_post
#else
#define mpi_win_post_ pmpi_win_post_
#endif
#define MPI_Win_post PMPI_Win_post

#ifdef F77_NAME_UPPER
#define mpi_win_set_attr_ PMPI_WIN_SET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_set_attr_ pmpi_win_set_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_set_attr_ pmpi_win_set_attr
#else
#define mpi_win_set_attr_ pmpi_win_set_attr_
#endif
#define MPI_Win_set_attr PMPI_Win_set_attr

#ifdef F77_NAME_UPPER
#define mpi_win_set_name_ PMPI_WIN_SET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_set_name_ pmpi_win_set_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_set_name_ pmpi_win_set_name
#else
#define mpi_win_set_name_ pmpi_win_set_name_
#endif
#undef MPI_Win_set_name
#define MPI_Win_set_name PMPI_Win_set_name

#ifdef F77_NAME_UPPER
#define mpi_win_start_ PMPI_WIN_START
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_start_ pmpi_win_start__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_start_ pmpi_win_start
#else
#define mpi_win_start_ pmpi_win_start_
#endif
#define MPI_Win_start PMPI_Win_start

#ifdef F77_NAME_UPPER
#define mpi_win_test_ PMPI_WIN_TEST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_test_ pmpi_win_test__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_test_ pmpi_win_test
#else
#define mpi_win_test_ pmpi_win_test_
#endif
#define MPI_Win_test PMPI_Win_test

#ifdef F77_NAME_UPPER
#define mpi_win_unlock_ PMPI_WIN_UNLOCK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_unlock_ pmpi_win_unlock__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_unlock_ pmpi_win_unlock
#else
#define mpi_win_unlock_ pmpi_win_unlock_
#endif
#define MPI_Win_unlock PMPI_Win_unlock

#ifdef F77_NAME_UPPER
#define mpi_win_wait_ PMPI_WIN_WAIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_wait_ pmpi_win_wait__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_wait_ pmpi_win_wait
#else
#define mpi_win_wait_ pmpi_win_wait_
#endif
#define MPI_Win_wait PMPI_Win_wait

#ifdef F77_NAME_UPPER
#define mpi_win_call_errhandler_ PMPI_WIN_CALL_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_call_errhandler_ pmpi_win_call_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_call_errhandler_ pmpi_win_call_errhandler
#else
#define mpi_win_call_errhandler_ pmpi_win_call_errhandler_
#endif
#define MPI_Win_call_errhandler PMPI_Win_call_errhandler

#ifdef F77_NAME_UPPER
#define mpi_win_create_errhandler_ PMPI_WIN_CREATE_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_errhandler_ pmpi_win_create_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_errhandler_ pmpi_win_create_errhandler
#else
#define mpi_win_create_errhandler_ pmpi_win_create_errhandler_
#endif
#define MPI_Win_create_errhandler PMPI_Win_create_errhandler

#ifdef F77_NAME_UPPER
#define mpi_win_delete_attr_ PMPI_WIN_DELETE_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_delete_attr_ pmpi_win_delete_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_delete_attr_ pmpi_win_delete_attr
#else
#define mpi_win_delete_attr_ pmpi_win_delete_attr_
#endif
#define MPI_Win_delete_attr PMPI_Win_delete_attr

#ifdef F77_NAME_UPPER
#define mpi_win_free_keyval_ PMPI_WIN_FREE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_free_keyval_ pmpi_win_free_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_free_keyval_ pmpi_win_free_keyval
#else
#define mpi_win_free_keyval_ pmpi_win_free_keyval_
#endif
#define MPI_Win_free_keyval PMPI_Win_free_keyval

#ifdef F77_NAME_UPPER
#define mpi_win_get_errhandler_ PMPI_WIN_GET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_errhandler_ pmpi_win_get_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_errhandler_ pmpi_win_get_errhandler
#else
#define mpi_win_get_errhandler_ pmpi_win_get_errhandler_
#endif
#define MPI_Win_get_errhandler PMPI_Win_get_errhandler

#ifdef F77_NAME_UPPER
#define mpi_win_create_keyval_ PMPI_WIN_CREATE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_keyval_ pmpi_win_create_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_keyval_ pmpi_win_create_keyval
#else
#define mpi_win_create_keyval_ pmpi_win_create_keyval_
#endif
#define MPI_Win_create_keyval PMPI_Win_create_keyval

#ifdef F77_NAME_UPPER
#define mpi_win_set_errhandler_ PMPI_WIN_SET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_set_errhandler_ pmpi_win_set_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_set_errhandler_ pmpi_win_set_errhandler
#else
#define mpi_win_set_errhandler_ pmpi_win_set_errhandler_
#endif
#define MPI_Win_set_errhandler PMPI_Win_set_errhandler

#ifdef F77_NAME_UPPER
#define mpi_wtick_ PMPI_WTICK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wtick_ pmpi_wtick__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wtick_ pmpi_wtick
#else
#define mpi_wtick_ pmpi_wtick_
#endif
#define MPI_Wtick PMPI_Wtick

#ifdef F77_NAME_UPPER
#define mpi_init_ PMPI_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_init_ pmpi_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_init_ pmpi_init
#else
#define mpi_init_ pmpi_init_
#endif
#undef MPI_Init
#define MPI_Init PMPI_Init 

#ifdef F77_NAME_UPPER
#define mpi_address_ PMPI_ADDRESS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_address_ pmpi_address__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_address_ pmpi_address
#else
#define mpi_address_ pmpi_address_
#endif
#undef MPI_Address
#define MPI_Address PMPI_Address 

#ifdef F77_NAME_UPPER
#define mpi_file_close_ PMPI_FILE_CLOSE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_close_ pmpi_file_close__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_close_ pmpi_file_close
#else
#define mpi_file_close_ pmpi_file_close_
#endif
#undef MPI_File_close
#define MPI_File_close PMPI_File_close 

#ifdef F77_NAME_UPPER
#define mpi_file_delete_ PMPI_FILE_DELETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_delete_ pmpi_file_delete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_delete_ pmpi_file_delete
#else
#define mpi_file_delete_ pmpi_file_delete_
#endif
#undef MPI_File_delete
#define MPI_File_delete PMPI_File_delete 

#ifdef F77_NAME_UPPER
#define mpi_file_get_amode_ PMPI_FILE_GET_AMODE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_amode_ pmpi_file_get_amode__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_amode_ pmpi_file_get_amode
#else
#define mpi_file_get_amode_ pmpi_file_get_amode_
#endif
#undef MPI_File_get_amode
#define MPI_File_get_amode PMPI_File_get_amode 

#ifdef F77_NAME_UPPER
#define mpi_file_get_atomicity_ PMPI_FILE_GET_ATOMICITY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_atomicity_ pmpi_file_get_atomicity__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_atomicity_ pmpi_file_get_atomicity
#else
#define mpi_file_get_atomicity_ pmpi_file_get_atomicity_
#endif
#undef MPI_File_get_atomicity
#define MPI_File_get_atomicity PMPI_File_get_atomicity 

#ifdef F77_NAME_UPPER
#define mpi_file_get_byte_offset_ PMPI_FILE_GET_BYTE_OFFSET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_byte_offset_ pmpi_file_get_byte_offset__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_byte_offset_ pmpi_file_get_byte_offset
#else
#define mpi_file_get_byte_offset_ pmpi_file_get_byte_offset_
#endif
#undef MPI_File_get_byte_offset
#define MPI_File_get_byte_offset PMPI_File_get_byte_offset 

#ifdef F77_NAME_UPPER
#define mpi_file_get_group_ PMPI_FILE_GET_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_group_ pmpi_file_get_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_group_ pmpi_file_get_group
#else
#define mpi_file_get_group_ pmpi_file_get_group_
#endif
#undef MPI_File_get_group
#define MPI_File_get_group PMPI_File_get_group 

#ifdef F77_NAME_UPPER
#define mpi_file_get_info_ PMPI_FILE_GET_INFO
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_info_ pmpi_file_get_info__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_info_ pmpi_file_get_info
#else
#define mpi_file_get_info_ pmpi_file_get_info_
#endif
#undef MPI_File_get_info
#define MPI_File_get_info PMPI_File_get_info 

#ifdef F77_NAME_UPPER
#define mpi_file_get_position_ PMPI_FILE_GET_POSITION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_position_ pmpi_file_get_position__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_position_ pmpi_file_get_position
#else
#define mpi_file_get_position_ pmpi_file_get_position_
#endif
#undef MPI_File_get_position
#define MPI_File_get_position PMPI_File_get_position 

#ifdef F77_NAME_UPPER
#define mpi_file_get_position_shared_ PMPI_FILE_GET_POSITION_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_position_shared_ pmpi_file_get_position_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_position_shared_ pmpi_file_get_position_shared
#else
#define mpi_file_get_position_shared_ pmpi_file_get_position_shared_
#endif
#undef MPI_File_get_position_shared
#define MPI_File_get_position_shared PMPI_File_get_position_shared 

#ifdef F77_NAME_UPPER
#define mpi_file_get_size_ PMPI_FILE_GET_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_size_ pmpi_file_get_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_size_ pmpi_file_get_size
#else
#define mpi_file_get_size_ pmpi_file_get_size_
#endif
#undef MPI_File_get_size
#define MPI_File_get_size PMPI_File_get_size 

#ifdef F77_NAME_UPPER
#define mpi_file_get_type_extent_ PMPI_FILE_GET_TYPE_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_type_extent_ pmpi_file_get_type_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_type_extent_ pmpi_file_get_type_extent
#else
#define mpi_file_get_type_extent_ pmpi_file_get_type_extent_
#endif
#undef MPI_File_get_type_extent
#define MPI_File_get_type_extent PMPI_File_get_type_extent 

#ifdef F77_NAME_UPPER
#define mpi_file_get_view_ PMPI_FILE_GET_VIEW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_view_ pmpi_file_get_view__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_view_ pmpi_file_get_view
#else
#define mpi_file_get_view_ pmpi_file_get_view_
#endif
#undef MPI_File_get_view
#define MPI_File_get_view PMPI_File_get_view 

#ifdef F77_NAME_UPPER
#define mpi_file_iread_ PMPI_FILE_IREAD
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iread_ pmpi_file_iread__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iread_ pmpi_file_iread
#else
#define mpi_file_iread_ pmpi_file_iread_
#endif
#undef MPI_File_iread
#define MPI_File_iread PMPI_File_iread 

#ifdef F77_NAME_UPPER
#define mpi_file_iread_at_ PMPI_FILE_IREAD_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iread_at_ pmpi_file_iread_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iread_at_ pmpi_file_iread_at
#else
#define mpi_file_iread_at_ pmpi_file_iread_at_
#endif
#undef MPI_File_iread_at
#define MPI_File_iread_at PMPI_File_iread_at 

#ifdef F77_NAME_UPPER
#define mpi_file_iread_shared_ PMPI_FILE_IREAD_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iread_shared_ pmpi_file_iread_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iread_shared_ pmpi_file_iread_shared
#else
#define mpi_file_iread_shared_ pmpi_file_iread_shared_
#endif
#undef MPI_File_iread_shared
#define MPI_File_iread_shared PMPI_File_iread_shared 

#ifdef F77_NAME_UPPER
#define mpi_file_open_ PMPI_FILE_OPEN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_open_ pmpi_file_open__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_open_ pmpi_file_open
#else
#define mpi_file_open_ pmpi_file_open_
#endif
#undef MPI_File_open
#define MPI_File_open PMPI_File_open 

#ifdef F77_NAME_UPPER
#define mpi_file_preallocate_ PMPI_FILE_PREALLOCATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_preallocate_ pmpi_file_preallocate__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_preallocate_ pmpi_file_preallocate
#else
#define mpi_file_preallocate_ pmpi_file_preallocate_
#endif
#undef MPI_File_preallocate
#define MPI_File_preallocate PMPI_File_preallocate 

#ifdef F77_NAME_UPPER
#define mpi_file_read_ PMPI_FILE_READ
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ pmpi_file_read__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ pmpi_file_read
#else
#define mpi_file_read_ pmpi_file_read_
#endif
#undef MPI_File_read
#define MPI_File_read PMPI_File_read 

#ifdef F77_NAME_UPPER
#define mpi_file_read_all_ PMPI_FILE_READ_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_all_ pmpi_file_read_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_all_ pmpi_file_read_all
#else
#define mpi_file_read_all_ pmpi_file_read_all_
#endif
#undef MPI_File_read_all
#define MPI_File_read_all PMPI_File_read_all 

#ifdef F77_NAME_UPPER
#define mpi_file_read_all_begin_ PMPI_FILE_READ_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_all_begin_ pmpi_file_read_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_all_begin_ pmpi_file_read_all_begin
#else
#define mpi_file_read_all_begin_ pmpi_file_read_all_begin_
#endif
#undef MPI_File_read_all_begin
#define MPI_File_read_all_begin PMPI_File_read_all_begin 

#ifdef F77_NAME_UPPER
#define mpi_file_read_all_end_ PMPI_FILE_READ_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_all_end_ pmpi_file_read_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_all_end_ pmpi_file_read_all_end
#else
#define mpi_file_read_all_end_ pmpi_file_read_all_end_
#endif
#undef MPI_File_read_all_end
#define MPI_File_read_all_end PMPI_File_read_all_end 

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_ PMPI_FILE_READ_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_ pmpi_file_read_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_ pmpi_file_read_at
#else
#define mpi_file_read_at_ pmpi_file_read_at_
#endif
#undef MPI_File_read_at
#define MPI_File_read_at PMPI_File_read_at 

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_all_ PMPI_FILE_READ_AT_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_all_ pmpi_file_read_at_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_all_ pmpi_file_read_at_all
#else
#define mpi_file_read_at_all_ pmpi_file_read_at_all_
#endif
#undef MPI_File_read_at_all
#define MPI_File_read_at_all PMPI_File_read_at_all 

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_all_begin_ PMPI_FILE_READ_AT_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_all_begin_ pmpi_file_read_at_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_all_begin_ pmpi_file_read_at_all_begin
#else
#define mpi_file_read_at_all_begin_ pmpi_file_read_at_all_begin_
#endif
#undef MPI_File_read_at_all_begin
#define MPI_File_read_at_all_begin PMPI_File_read_at_all_begin 

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_all_end_ PMPI_FILE_READ_AT_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_all_end_ pmpi_file_read_at_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_all_end_ pmpi_file_read_at_all_end
#else
#define mpi_file_read_at_all_end_ pmpi_file_read_at_all_end_
#endif
#undef MPI_File_read_at_all_end
#define MPI_File_read_at_all_end PMPI_File_read_at_all_end 

#ifdef F77_NAME_UPPER
#define mpi_file_read_ordered_ PMPI_FILE_READ_ORDERED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ordered_ pmpi_file_read_ordered__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ordered_ pmpi_file_read_ordered
#else
#define mpi_file_read_ordered_ pmpi_file_read_ordered_
#endif
#undef MPI_File_read_ordered
#define MPI_File_read_ordered PMPI_File_read_ordered 

#ifdef F77_NAME_UPPER
#define mpi_file_read_ordered_begin_ PMPI_FILE_READ_ORDERED_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ordered_begin_ pmpi_file_read_ordered_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ordered_begin_ pmpi_file_read_ordered_begin
#else
#define mpi_file_read_ordered_begin_ pmpi_file_read_ordered_begin_
#endif
#undef MPI_File_read_ordered_begin
#define MPI_File_read_ordered_begin PMPI_File_read_ordered_begin 

#ifdef F77_NAME_UPPER
#define mpi_file_read_ordered_end_ PMPI_FILE_READ_ORDERED_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ordered_end_ pmpi_file_read_ordered_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ordered_end_ pmpi_file_read_ordered_end
#else
#define mpi_file_read_ordered_end_ pmpi_file_read_ordered_end_
#endif
#undef MPI_File_read_ordered_end
#define MPI_File_read_ordered_end PMPI_File_read_ordered_end 

#ifdef F77_NAME_UPPER
#define mpi_file_read_shared_ PMPI_FILE_READ_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_shared_ pmpi_file_read_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_shared_ pmpi_file_read_shared
#else
#define mpi_file_read_shared_ pmpi_file_read_shared_
#endif
#undef MPI_File_read_shared
#define MPI_File_read_shared PMPI_File_read_shared 

#ifdef F77_NAME_UPPER
#define mpi_file_set_atomicity_ PMPI_FILE_SET_ATOMICITY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_atomicity_ pmpi_file_set_atomicity__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_atomicity_ pmpi_file_set_atomicity
#else
#define mpi_file_set_atomicity_ pmpi_file_set_atomicity_
#endif
#undef MPI_File_set_atomicity
#define MPI_File_set_atomicity PMPI_File_set_atomicity 

#ifdef F77_NAME_UPPER
#define mpi_file_set_info_ PMPI_FILE_SET_INFO
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_info_ pmpi_file_set_info__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_info_ pmpi_file_set_info
#else
#define mpi_file_set_info_ pmpi_file_set_info_
#endif
#undef MPI_File_set_info
#define MPI_File_set_info PMPI_File_set_info 

#ifdef F77_NAME_UPPER
#define mpi_file_set_size_ PMPI_FILE_SET_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_size_ pmpi_file_set_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_size_ pmpi_file_set_size
#else
#define mpi_file_set_size_ pmpi_file_set_size_
#endif
#undef MPI_File_set_size
#define MPI_File_set_size PMPI_File_set_size 

#ifdef F77_NAME_UPPER
#define mpi_file_set_view_ PMPI_FILE_SET_VIEW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_view_ pmpi_file_set_view__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_view_ pmpi_file_set_view
#else
#define mpi_file_set_view_ pmpi_file_set_view_
#endif
#undef MPI_File_set_view
#define MPI_File_set_view PMPI_File_set_view 

#ifdef F77_NAME_UPPER
#define mpi_file_sync_ PMPI_FILE_SYNC
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_sync_ pmpi_file_sync__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_sync_ pmpi_file_sync
#else
#define mpi_file_sync_ pmpi_file_sync_
#endif
#undef MPI_File_sync
#define MPI_File_sync PMPI_File_sync 

#ifdef F77_NAME_UPPER
#define mpi_file_write_ PMPI_FILE_WRITE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ pmpi_file_write__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ pmpi_file_write
#else
#define mpi_file_write_ pmpi_file_write_
#endif
#undef MPI_File_write
#define MPI_File_write PMPI_File_write 

#ifdef F77_NAME_UPPER
#define mpi_file_write_all_ PMPI_FILE_WRITE_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_all_ pmpi_file_write_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_all_ pmpi_file_write_all
#else
#define mpi_file_write_all_ pmpi_file_write_all_
#endif
#undef MPI_File_write_all
#define MPI_File_write_all PMPI_File_write_all 

#ifdef F77_NAME_UPPER
#define mpi_file_write_all_begin_ PMPI_FILE_WRITE_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_all_begin_ pmpi_file_write_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_all_begin_ pmpi_file_write_all_begin
#else
#define mpi_file_write_all_begin_ pmpi_file_write_all_begin_
#endif
#undef MPI_File_write_all_begin
#define MPI_File_write_all_begin PMPI_File_write_all_begin 

#ifdef F77_NAME_UPPER
#define mpi_file_write_all_end_ PMPI_FILE_WRITE_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_all_end_ pmpi_file_write_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_all_end_ pmpi_file_write_all_end
#else
#define mpi_file_write_all_end_ pmpi_file_write_all_end_
#endif
#undef MPI_File_write_all_end
#define MPI_File_write_all_end PMPI_File_write_all_end 

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_ PMPI_FILE_WRITE_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_ pmpi_file_write_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_ pmpi_file_write_at
#else
#define mpi_file_write_at_ pmpi_file_write_at_
#endif
#undef MPI_File_write_at
#define MPI_File_write_at PMPI_File_write_at 

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_all_ PMPI_FILE_WRITE_AT_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_all_ pmpi_file_write_at_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_all_ pmpi_file_write_at_all
#else
#define mpi_file_write_at_all_ pmpi_file_write_at_all_
#endif
#undef MPI_File_write_at_all
#define MPI_File_write_at_all PMPI_File_write_at_all 

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_all_begin_ PMPI_FILE_WRITE_AT_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_all_begin_ pmpi_file_write_at_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_all_begin_ pmpi_file_write_at_all_begin
#else
#define mpi_file_write_at_all_begin_ pmpi_file_write_at_all_begin_
#endif
#undef MPI_File_write_at_all_begin
#define MPI_File_write_at_all_begin PMPI_File_write_at_all_begin 

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_all_end_ PMPI_FILE_WRITE_AT_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_all_end_ pmpi_file_write_at_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_all_end_ pmpi_file_write_at_all_end
#else
#define mpi_file_write_at_all_end_ pmpi_file_write_at_all_end_
#endif
#undef MPI_File_write_at_all_end
#define MPI_File_write_at_all_end PMPI_File_write_at_all_end 

#ifdef F77_NAME_UPPER
#define mpi_file_write_ordered_ PMPI_FILE_WRITE_ORDERED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ordered_ pmpi_file_write_ordered__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ordered_ pmpi_file_write_ordered
#else
#define mpi_file_write_ordered_ pmpi_file_write_ordered_
#endif
#undef MPI_File_write_ordered
#define MPI_File_write_ordered PMPI_File_write_ordered 

#ifdef F77_NAME_UPPER
#define mpi_file_write_ordered_begin_ PMPI_FILE_WRITE_ORDERED_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ordered_begin_ pmpi_file_write_ordered_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ordered_begin_ pmpi_file_write_ordered_begin
#else
#define mpi_file_write_ordered_begin_ pmpi_file_write_ordered_begin_
#endif
#undef MPI_File_write_ordered_begin
#define MPI_File_write_ordered_begin PMPI_File_write_ordered_begin 

#ifdef F77_NAME_UPPER
#define mpi_file_write_ordered_end_ PMPI_FILE_WRITE_ORDERED_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ordered_end_ pmpi_file_write_ordered_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ordered_end_ pmpi_file_write_ordered_end
#else
#define mpi_file_write_ordered_end_ pmpi_file_write_ordered_end_
#endif
#undef MPI_File_write_ordered_end
#define MPI_File_write_ordered_end PMPI_File_write_ordered_end 

#ifdef F77_NAME_UPPER
#define mpi_file_write_shared_ PMPI_FILE_WRITE_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_shared_ pmpi_file_write_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_shared_ pmpi_file_write_shared
#else
#define mpi_file_write_shared_ pmpi_file_write_shared_
#endif
#undef MPI_File_write_shared
#define MPI_File_write_shared PMPI_File_write_shared 

#ifdef F77_NAME_UPPER
#define mpi_get_address_ PMPI_GET_ADDRESS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_address_ pmpi_get_address__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_address_ pmpi_get_address
#else
#define mpi_get_address_ pmpi_get_address_
#endif
#undef MPI_Get_address
#define MPI_Get_address PMPI_Get_address 

#ifdef F77_NAME_UPPER
#define mpi_init_thread_ PMPI_INIT_THREAD
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_init_thread_ pmpi_init_thread__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_init_thread_ pmpi_init_thread
#else
#define mpi_init_thread_ pmpi_init_thread_
#endif
#undef MPI_Init_thread
#define MPI_Init_thread PMPI_Init_thread 

#ifdef F77_NAME_UPPER
#define mpi_keyval_create_ PMPI_KEYVAL_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_keyval_create_ pmpi_keyval_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_keyval_create_ pmpi_keyval_create
#else
#define mpi_keyval_create_ pmpi_keyval_create_
#endif
#undef MPI_Keyval_create
#define MPI_Keyval_create PMPI_Keyval_create 

#undef MPI_Comm_create_keyval
#define MPI_Comm_create_keyval PMPI_Comm_create_keyval

#ifdef F77_NAME_UPPER
#define mpi_null_copy_fn_ PMPI_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_null_copy_fn_ pmpi_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_null_copy_fn_ pmpi_null_copy_fn
#else
#define mpi_null_copy_fn_ pmpi_null_copy_fn_
#endif
#undef MPI_mpi_null_copy_fn
#define MPI_mpi_null_copy_fn PMPI_mpi_null_copy_fn 

#ifdef F77_NAME_UPPER
#define mpi_null_delete_fn_ PMPI_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_null_delete_fn_ pmpi_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_null_delete_fn_ pmpi_null_delete_fn
#else
#define mpi_null_delete_fn_ pmpi_null_delete_fn_
#endif
#undef MPI_mpi_null_delete_fn
#define MPI_mpi_null_delete_fn PMPI_mpi_null_delete_fn 

#ifdef F77_NAME_UPPER
#define mpi_pcontrol_ PMPI_PCONTROL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pcontrol_ pmpi_pcontrol__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pcontrol_ pmpi_pcontrol
#else
#define mpi_pcontrol_ pmpi_pcontrol_
#endif
#undef MPI_Pcontrol
#define MPI_Pcontrol PMPI_Pcontrol 

#ifdef F77_NAME_UPPER
#define mpi_register_datarep_ PMPI_REGISTER_DATAREP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_register_datarep_ pmpi_register_datarep__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_register_datarep_ pmpi_register_datarep
#else
#define mpi_register_datarep_ pmpi_register_datarep_
#endif
#undef MPI_Register_datarep
#define MPI_Register_datarep PMPI_Register_datarep 

#ifdef F77_NAME_UPPER
#define mpi_conversion_fn_null_ MPI_CONVERSION_FN_NULL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_conversion_fn_null_ mpi_conversion_fn_null__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_conversion_fn_null_ mpi_conversion_fn_null
/* Else leave name alone */
#endif

/* Add the prototype so the routine knows what this is */
extern FORT_DLL_SPEC int FORT_CALL mpi_conversion_fn_null_ ( void*v1, MPI_Fint*v2, MPI_Fint*v3, void*v4, MPI_Offset*v5, MPI_Fint *v6, MPI_Fint*v7, MPI_Fint *ierr );

#ifdef F77_NAME_UPPER
#define mpi_wtick_ PMPI_WTICK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wtick_ pmpi_wtick__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wtick_ pmpi_wtick
#else
#define mpi_wtick_ pmpi_wtick_
#endif
#undef MPI_Wtick
#define MPI_Wtick PMPI_Wtick 

#ifdef F77_NAME_UPPER
#define mpi_wtime_ PMPI_WTIME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wtime_ pmpi_wtime__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wtime_ pmpi_wtime
#else
#define mpi_wtime_ pmpi_wtime_
#endif
#undef MPI_Wtime
#define MPI_Wtime PMPI_Wtime 

#ifdef F77_NAME_UPPER
#define mpi_file_iwrite_ PMPI_FILE_IWRITE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iwrite_ pmpi_file_iwrite__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iwrite_ pmpi_file_iwrite
#else
#define mpi_file_iwrite_ pmpi_file_iwrite_
#endif
#undef MPI_File_iwrite
#define MPI_File_iwrite PMPI_File_iwrite 

#ifdef F77_NAME_UPPER
#define mpi_file_iwrite_at_ PMPI_FILE_IWRITE_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iwrite_at_ pmpi_file_iwrite_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iwrite_at_ pmpi_file_iwrite_at
#else
#define mpi_file_iwrite_at_ pmpi_file_iwrite_at_
#endif
#undef MPI_File_iwrite_at
#define MPI_File_iwrite_at PMPI_File_iwrite_at 

#ifdef F77_NAME_UPPER
#define mpi_file_iwrite_shared_ PMPI_FILE_IWRITE_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iwrite_shared_ pmpi_file_iwrite_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iwrite_shared_ pmpi_file_iwrite_shared
#else
#define mpi_file_iwrite_shared_ pmpi_file_iwrite_shared_
#endif
#undef MPI_File_iwrite_shared
#define MPI_File_iwrite_shared PMPI_File_iwrite_shared 

#ifdef F77_NAME_UPPER
#define mpi_file_seek_ PMPI_FILE_SEEK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_seek_ pmpi_file_seek__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_seek_ pmpi_file_seek
#else
#define mpi_file_seek_ pmpi_file_seek_
#endif
#undef MPI_File_seek
#define MPI_File_seek PMPI_File_seek 

#ifdef F77_NAME_UPPER
#define mpi_file_seek_shared_ PMPI_FILE_SEEK_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_seek_shared_ pmpi_file_seek_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_seek_shared_ pmpi_file_seek_shared
#else
#define mpi_file_seek_shared_ pmpi_file_seek_shared_
#endif
#undef MPI_File_seek_shared
#define MPI_File_seek_shared PMPI_File_seek_shared 

#ifdef F77_NAME_UPPER
#define mpi_comm_dup_fn_ PMPI_COMM_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_dup_fn_ pmpi_comm_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_dup_fn_ pmpi_comm_dup_fn
#else
#define mpi_comm_dup_fn_ pmpi_comm_dup_fn_
#endif
#undef MPI_mpi_comm_dup_fn
#define MPI_mpi_comm_dup_fn PMPI_mpi_comm_dup_fn 

#ifdef F77_NAME_UPPER
#define mpi_type_dup_fn_ PMPI_TYPE_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_dup_fn_ pmpi_type_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_dup_fn_ pmpi_type_dup_fn
#else
#define mpi_type_dup_fn_ pmpi_type_dup_fn_
#endif
#undef MPI_mpi_type_dup_fn
#define MPI_mpi_type_dup_fn PMPI_mpi_type_dup_fn 

#ifdef F77_NAME_UPPER
#define mpi_win_dup_fn_ PMPI_WIN_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_dup_fn_ pmpi_win_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_dup_fn_ pmpi_win_dup_fn
#else
#define mpi_win_dup_fn_ pmpi_win_dup_fn_
#endif
#undef MPI_mpi_win_dup_fn
#define MPI_mpi_win_dup_fn PMPI_mpi_win_dup_fn 

#ifdef F77_NAME_UPPER
#define mpi_dup_fn_ PMPI_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_dup_fn_ pmpi_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_dup_fn_ pmpi_dup_fn
#else
#define mpi_dup_fn_ pmpi_dup_fn_
#endif
#undef MPI_mpi_dup_fn
#define MPI_mpi_dup_fn PMPI_mpi_dup_fn 

#ifdef F77_NAME_UPPER
#define mpi_comm_null_delete_fn_ PMPI_COMM_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_null_delete_fn_ pmpi_comm_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_null_delete_fn_ pmpi_comm_null_delete_fn
#else
#define mpi_comm_null_delete_fn_ pmpi_comm_null_delete_fn_
#endif
#undef MPI_mpi_comm_null_delete_fn
#define MPI_mpi_comm_null_delete_fn PMPI_mpi_comm_null_delete_fn 

#ifdef F77_NAME_UPPER
#define mpi_type_null_copy_fn_ PMPI_TYPE_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_null_copy_fn_ pmpi_type_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_null_copy_fn_ pmpi_type_null_copy_fn
#else
#define mpi_type_null_copy_fn_ pmpi_type_null_copy_fn_
#endif
#undef MPI_mpi_type_null_copy_fn
#define MPI_mpi_type_null_copy_fn PMPI_mpi_type_null_copy_fn 

#ifdef F77_NAME_UPPER
#define mpi_type_null_delete_fn_ PMPI_TYPE_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_null_delete_fn_ pmpi_type_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_null_delete_fn_ pmpi_type_null_delete_fn
#else
#define mpi_type_null_delete_fn_ pmpi_type_null_delete_fn_
#endif
#undef MPI_mpi_type_null_delete_fn
#define MPI_mpi_type_null_delete_fn PMPI_mpi_type_null_delete_fn 

#ifdef F77_NAME_UPPER
#define mpi_win_null_copy_fn_ PMPI_WIN_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_null_copy_fn_ pmpi_win_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_null_copy_fn_ pmpi_win_null_copy_fn
#else
#define mpi_win_null_copy_fn_ pmpi_win_null_copy_fn_
#endif
#undef MPI_mpi_win_null_copy_fn
#define MPI_mpi_win_null_copy_fn PMPI_mpi_win_null_copy_fn 

#ifdef F77_NAME_UPPER
#define mpi_win_null_delete_fn_ PMPI_WIN_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_null_delete_fn_ pmpi_win_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_null_delete_fn_ pmpi_win_null_delete_fn
#else
#define mpi_win_null_delete_fn_ pmpi_win_null_delete_fn_
#endif
#undef MPI_mpi_win_null_delete_fn
#define MPI_mpi_win_null_delete_fn PMPI_mpi_win_null_delete_fn 



#else /* MPICH_MPI_FROM_PMPI */




#ifdef F77_NAME_UPPER
#define mpi_abort_ MPI_ABORT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_abort_ mpi_abort__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_abort_ mpi_abort
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_accumulate_ MPI_ACCUMULATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_accumulate_ mpi_accumulate__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_accumulate_ mpi_accumulate
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_accumulate_ MPI_ACCUMULATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_accumulate_ mpi_accumulate__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_accumulate_ mpi_accumulate
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_add_error_class_ MPI_ADD_ERROR_CLASS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_add_error_class_ mpi_add_error_class__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_add_error_class_ mpi_add_error_class
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_add_error_code_ MPI_ADD_ERROR_CODE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_add_error_code_ mpi_add_error_code__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_add_error_code_ mpi_add_error_code
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_add_error_string_ MPI_ADD_ERROR_STRING
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_add_error_string_ mpi_add_error_string__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_add_error_string_ mpi_add_error_string
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_allgather_ MPI_ALLGATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgather_ mpi_allgather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgather_ mpi_allgather
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_allgather_ MPI_ALLGATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgather_ mpi_allgather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgather_ mpi_allgather
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_allgatherv_ MPI_ALLGATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgatherv_ mpi_allgatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgatherv_ mpi_allgatherv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_allgatherv_ MPI_ALLGATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allgatherv_ mpi_allgatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allgatherv_ mpi_allgatherv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alloc_mem_ MPI_ALLOC_MEM
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alloc_mem_ mpi_alloc_mem__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alloc_mem_ mpi_alloc_mem
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_allreduce_ MPI_ALLREDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allreduce_ mpi_allreduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allreduce_ mpi_allreduce
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_allreduce_ MPI_ALLREDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_allreduce_ mpi_allreduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_allreduce_ mpi_allreduce
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alltoall_ MPI_ALLTOALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoall_ mpi_alltoall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoall_ mpi_alltoall
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alltoall_ MPI_ALLTOALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoall_ mpi_alltoall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoall_ mpi_alltoall
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alltoallv_ MPI_ALLTOALLV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallv_ mpi_alltoallv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallv_ mpi_alltoallv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alltoallv_ MPI_ALLTOALLV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallv_ mpi_alltoallv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallv_ mpi_alltoallv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alltoallw_ MPI_ALLTOALLW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallw_ mpi_alltoallw__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallw_ mpi_alltoallw
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_alltoallw_ MPI_ALLTOALLW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_alltoallw_ mpi_alltoallw__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_alltoallw_ mpi_alltoallw
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_attr_delete_ MPI_ATTR_DELETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_attr_delete_ mpi_attr_delete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_attr_delete_ mpi_attr_delete
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_attr_get_ MPI_ATTR_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_attr_get_ mpi_attr_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_attr_get_ mpi_attr_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_attr_put_ MPI_ATTR_PUT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_attr_put_ mpi_attr_put__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_attr_put_ mpi_attr_put
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_barrier_ MPI_BARRIER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_barrier_ mpi_barrier__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_barrier_ mpi_barrier
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_bcast_ MPI_BCAST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bcast_ mpi_bcast__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bcast_ mpi_bcast
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_bcast_ MPI_BCAST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bcast_ mpi_bcast__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bcast_ mpi_bcast
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_bsend_init_ MPI_BSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_init_ mpi_bsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_init_ mpi_bsend_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_bsend_init_ MPI_BSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_init_ mpi_bsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_init_ mpi_bsend_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_bsend_ MPI_BSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_ mpi_bsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_ mpi_bsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_bsend_ MPI_BSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_bsend_ mpi_bsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_bsend_ mpi_bsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_buffer_attach_ MPI_BUFFER_ATTACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_attach_ mpi_buffer_attach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_attach_ mpi_buffer_attach
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_buffer_attach_ MPI_BUFFER_ATTACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_attach_ mpi_buffer_attach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_attach_ mpi_buffer_attach
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_buffer_detach_ MPI_BUFFER_DETACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_detach_ mpi_buffer_detach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_detach_ mpi_buffer_detach
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_buffer_detach_ MPI_BUFFER_DETACH
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_buffer_detach_ mpi_buffer_detach__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_buffer_detach_ mpi_buffer_detach
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cancel_ MPI_CANCEL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cancel_ mpi_cancel__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cancel_ mpi_cancel
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_coords_ MPI_CART_COORDS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_coords_ mpi_cart_coords__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_coords_ mpi_cart_coords
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_create_ MPI_CART_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_create_ mpi_cart_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_create_ mpi_cart_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_get_ MPI_CART_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_get_ mpi_cart_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_get_ mpi_cart_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_map_ MPI_CART_MAP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_map_ mpi_cart_map__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_map_ mpi_cart_map
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_rank_ MPI_CART_RANK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_rank_ mpi_cart_rank__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_rank_ mpi_cart_rank
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_shift_ MPI_CART_SHIFT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_shift_ mpi_cart_shift__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_shift_ mpi_cart_shift
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cart_sub_ MPI_CART_SUB
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cart_sub_ mpi_cart_sub__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cart_sub_ mpi_cart_sub
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_cartdim_get_ MPI_CARTDIM_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_cartdim_get_ mpi_cartdim_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_cartdim_get_ mpi_cartdim_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_close_port_ MPI_CLOSE_PORT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_close_port_ mpi_close_port__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_close_port_ mpi_close_port
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_accept_ MPI_COMM_ACCEPT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_accept_ mpi_comm_accept__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_accept_ mpi_comm_accept
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_compare_ MPI_COMM_COMPARE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_compare_ mpi_comm_compare__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_compare_ mpi_comm_compare
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_connect_ MPI_COMM_CONNECT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_connect_ mpi_comm_connect__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_connect_ mpi_comm_connect
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_create_ MPI_COMM_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_create_ mpi_comm_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_create_ mpi_comm_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_dup_ MPI_COMM_DUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_dup_ mpi_comm_dup__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_dup_ mpi_comm_dup
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_free_ MPI_COMM_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_free_ mpi_comm_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_free_ mpi_comm_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_get_attr_ MPI_COMM_GET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_attr_ mpi_comm_get_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_attr_ mpi_comm_get_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_group_ MPI_COMM_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_group_ mpi_comm_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_group_ mpi_comm_group
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_join_ MPI_COMM_JOIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_join_ mpi_comm_join__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_join_ mpi_comm_join
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_rank_ MPI_COMM_RANK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_rank_ mpi_comm_rank__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_rank_ mpi_comm_rank
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_set_attr_ MPI_COMM_SET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_set_attr_ mpi_comm_set_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_set_attr_ mpi_comm_set_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_set_name_ MPI_COMM_SET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_set_name_ mpi_comm_set_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_set_name_ mpi_comm_set_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_size_ MPI_COMM_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_size_ mpi_comm_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_size_ mpi_comm_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_spawn_ MPI_COMM_SPAWN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_spawn_ mpi_comm_spawn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_spawn_ mpi_comm_spawn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_split_ MPI_COMM_SPLIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_split_ mpi_comm_split__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_split_ mpi_comm_split
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_call_errhandler_ MPI_COMM_CALL_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_call_errhandler_ mpi_comm_call_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_call_errhandler_ mpi_comm_call_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_create_errhandler_ MPI_COMM_CREATE_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_create_errhandler_ mpi_comm_create_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_create_errhandler_ mpi_comm_create_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_delete_attr_ MPI_COMM_DELETE_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_delete_attr_ mpi_comm_delete_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_delete_attr_ mpi_comm_delete_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_disconnect_ MPI_COMM_DISCONNECT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_disconnect_ mpi_comm_disconnect__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_disconnect_ mpi_comm_disconnect
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_free_keyval_ MPI_COMM_FREE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_free_keyval_ mpi_comm_free_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_free_keyval_ mpi_comm_free_keyval
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_get_errhandler_ MPI_COMM_GET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_errhandler_ mpi_comm_get_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_errhandler_ mpi_comm_get_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_get_name_ MPI_COMM_GET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_name_ mpi_comm_get_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_name_ mpi_comm_get_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_create_keyval_ MPI_COMM_CREATE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_create_keyval_ mpi_comm_create_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_create_keyval_ mpi_comm_create_keyval
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_get_parent_ MPI_COMM_GET_PARENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_get_parent_ mpi_comm_get_parent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_get_parent_ mpi_comm_get_parent
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_remote_group_ MPI_COMM_REMOTE_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_remote_group_ mpi_comm_remote_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_remote_group_ mpi_comm_remote_group
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_remote_size_ MPI_COMM_REMOTE_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_remote_size_ mpi_comm_remote_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_remote_size_ mpi_comm_remote_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_set_errhandler_ MPI_COMM_SET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_set_errhandler_ mpi_comm_set_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_set_errhandler_ mpi_comm_set_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_test_inter_ MPI_COMM_TEST_INTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_test_inter_ mpi_comm_test_inter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_test_inter_ mpi_comm_test_inter
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_dims_create_ MPI_DIMS_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_dims_create_ mpi_dims_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_dims_create_ mpi_dims_create
/* Else leave name alone */
#endif

#ifdef MPI_COMM_DUP_FN
#undef MPI_COMM_DUP_FN
#endif

#ifdef F77_NAME_UPPER
#define mpi_errhandler_create_ MPI_ERRHANDLER_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_create_ mpi_errhandler_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_create_ mpi_errhandler_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_errhandler_free_ MPI_ERRHANDLER_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_free_ mpi_errhandler_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_free_ mpi_errhandler_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_errhandler_get_ MPI_ERRHANDLER_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_get_ mpi_errhandler_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_get_ mpi_errhandler_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_errhandler_set_ MPI_ERRHANDLER_SET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_errhandler_set_ mpi_errhandler_set__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_errhandler_set_ mpi_errhandler_set
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_error_class_ MPI_ERROR_CLASS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_error_class_ mpi_error_class__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_error_class_ mpi_error_class
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_error_string_ MPI_ERROR_STRING
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_error_string_ mpi_error_string__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_error_string_ mpi_error_string
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_exscan_ MPI_EXSCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_exscan_ mpi_exscan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_exscan_ mpi_exscan
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_exscan_ MPI_EXSCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_exscan_ mpi_exscan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_exscan_ mpi_exscan
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_call_errhandler_ MPI_FILE_CALL_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_call_errhandler_ mpi_file_call_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_call_errhandler_ mpi_file_call_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_create_errhandler_ MPI_FILE_CREATE_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_create_errhandler_ mpi_file_create_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_create_errhandler_ mpi_file_create_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_errhandler_ MPI_FILE_GET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_errhandler_ mpi_file_get_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_errhandler_ mpi_file_get_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_set_errhandler_ MPI_FILE_SET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_errhandler_ mpi_file_set_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_errhandler_ mpi_file_set_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_finalized_ MPI_FINALIZED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_finalized_ mpi_finalized__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_finalized_ mpi_finalized
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_finalize_ MPI_FINALIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_finalize_ mpi_finalize__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_finalize_ mpi_finalize
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_free_mem_ MPI_FREE_MEM
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_free_mem_ mpi_free_mem__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_free_mem_ mpi_free_mem
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_gather_ MPI_GATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gather_ mpi_gather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gather_ mpi_gather
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_gather_ MPI_GATHER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gather_ mpi_gather__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gather_ mpi_gather
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_gatherv_ MPI_GATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gatherv_ mpi_gatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gatherv_ mpi_gatherv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_gatherv_ MPI_GATHERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_gatherv_ mpi_gatherv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_gatherv_ mpi_gatherv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_count_ MPI_GET_COUNT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_count_ mpi_get_count__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_count_ mpi_get_count
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_elements_ MPI_GET_ELEMENTS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_elements_ mpi_get_elements__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_elements_ mpi_get_elements
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_version_ MPI_GET_VERSION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_version_ mpi_get_version__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_version_ mpi_get_version
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_ MPI_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_ mpi_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_ mpi_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_ MPI_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_ mpi_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_ mpi_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_processor_name_ MPI_GET_PROCESSOR_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_processor_name_ mpi_get_processor_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_processor_name_ mpi_get_processor_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_graph_create_ MPI_GRAPH_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_create_ mpi_graph_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_create_ mpi_graph_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_graph_get_ MPI_GRAPH_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_get_ mpi_graph_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_get_ mpi_graph_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_graph_map_ MPI_GRAPH_MAP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_map_ mpi_graph_map__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_map_ mpi_graph_map
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_graphdims_get_ MPI_GRAPHDIMS_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graphdims_get_ mpi_graphdims_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graphdims_get_ mpi_graphdims_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_grequest_complete_ MPI_GREQUEST_COMPLETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_grequest_complete_ mpi_grequest_complete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_grequest_complete_ mpi_grequest_complete
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_grequest_start_ MPI_GREQUEST_START
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_grequest_start_ mpi_grequest_start__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_grequest_start_ mpi_grequest_start
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_graph_neighbors_count_ MPI_GRAPH_NEIGHBORS_COUNT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_neighbors_count_ mpi_graph_neighbors_count__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_neighbors_count_ mpi_graph_neighbors_count
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_graph_neighbors_ MPI_GRAPH_NEIGHBORS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_graph_neighbors_ mpi_graph_neighbors__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_graph_neighbors_ mpi_graph_neighbors
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_compare_ MPI_GROUP_COMPARE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_compare_ mpi_group_compare__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_compare_ mpi_group_compare
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_excl_ MPI_GROUP_EXCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_excl_ mpi_group_excl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_excl_ mpi_group_excl
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_free_ MPI_GROUP_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_free_ mpi_group_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_free_ mpi_group_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_incl_ MPI_GROUP_INCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_incl_ mpi_group_incl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_incl_ mpi_group_incl
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_rank_ MPI_GROUP_RANK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_rank_ mpi_group_rank__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_rank_ mpi_group_rank
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_size_ MPI_GROUP_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_size_ mpi_group_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_size_ mpi_group_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_union_ MPI_GROUP_UNION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_union_ mpi_group_union__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_union_ mpi_group_union
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_difference_ MPI_GROUP_DIFFERENCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_difference_ mpi_group_difference__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_difference_ mpi_group_difference
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_intersection_ MPI_GROUP_INTERSECTION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_intersection_ mpi_group_intersection__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_intersection_ mpi_group_intersection
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_range_excl_ MPI_GROUP_RANGE_EXCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_range_excl_ mpi_group_range_excl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_range_excl_ mpi_group_range_excl
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_range_incl_ MPI_GROUP_RANGE_INCL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_range_incl_ mpi_group_range_incl__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_range_incl_ mpi_group_range_incl
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_group_translate_ranks_ MPI_GROUP_TRANSLATE_RANKS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_group_translate_ranks_ mpi_group_translate_ranks__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_group_translate_ranks_ mpi_group_translate_ranks
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_ibsend_ MPI_IBSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ibsend_ mpi_ibsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ibsend_ mpi_ibsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_ibsend_ MPI_IBSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ibsend_ mpi_ibsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ibsend_ mpi_ibsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_intercomm_create_ MPI_INTERCOMM_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_intercomm_create_ mpi_intercomm_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_intercomm_create_ mpi_intercomm_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_intercomm_merge_ MPI_INTERCOMM_MERGE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_intercomm_merge_ mpi_intercomm_merge__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_intercomm_merge_ mpi_intercomm_merge
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_create_ MPI_INFO_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_create_ mpi_info_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_create_ mpi_info_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_delete_ MPI_INFO_DELETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_delete_ mpi_info_delete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_delete_ mpi_info_delete
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_dup_ MPI_INFO_DUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_dup_ mpi_info_dup__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_dup_ mpi_info_dup
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_free_ MPI_INFO_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_free_ mpi_info_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_free_ mpi_info_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_get_ MPI_INFO_GET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_ mpi_info_get__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_ mpi_info_get
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_set_ MPI_INFO_SET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_set_ mpi_info_set__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_set_ mpi_info_set
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_get_nkeys_ MPI_INFO_GET_NKEYS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_nkeys_ mpi_info_get_nkeys__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_nkeys_ mpi_info_get_nkeys
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_get_nthkey_ MPI_INFO_GET_NTHKEY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_nthkey_ mpi_info_get_nthkey__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_nthkey_ mpi_info_get_nthkey
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_info_get_valuelen_ MPI_INFO_GET_VALUELEN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_info_get_valuelen_ mpi_info_get_valuelen__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_info_get_valuelen_ mpi_info_get_valuelen
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_initialized_ MPI_INITIALIZED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_initialized_ mpi_initialized__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_initialized_ mpi_initialized
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_iprobe_ MPI_IPROBE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_iprobe_ mpi_iprobe__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_iprobe_ mpi_iprobe
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_irecv_ MPI_IRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irecv_ mpi_irecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irecv_ mpi_irecv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_irecv_ MPI_IRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irecv_ mpi_irecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irecv_ mpi_irecv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_irsend_ MPI_IRSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irsend_ mpi_irsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irsend_ mpi_irsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_irsend_ MPI_IRSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_irsend_ mpi_irsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_irsend_ mpi_irsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_isend_ MPI_ISEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_isend_ mpi_isend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_isend_ mpi_isend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_isend_ MPI_ISEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_isend_ mpi_isend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_isend_ mpi_isend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_issend_ MPI_ISSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_issend_ mpi_issend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_issend_ mpi_issend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_issend_ MPI_ISSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_issend_ mpi_issend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_issend_ mpi_issend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_is_thread_main_ MPI_IS_THREAD_MAIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_is_thread_main_ mpi_is_thread_main__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_is_thread_main_ mpi_is_thread_main
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_keyval_free_ MPI_KEYVAL_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_keyval_free_ mpi_keyval_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_keyval_free_ mpi_keyval_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_lookup_name_ MPI_LOOKUP_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_lookup_name_ mpi_lookup_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_lookup_name_ mpi_lookup_name
/* Else leave name alone */
#endif

#ifdef MPI_COMM_NULL_COPY_FN
#undef MPI_COMM_NULL_COPY_FN
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_null_copy_fn_ MPI_COMM_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_null_copy_fn_ mpi_comm_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_null_copy_fn_ mpi_comm_null_copy_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_op_create_ MPI_OP_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_op_create_ mpi_op_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_op_create_ mpi_op_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_op_free_ MPI_OP_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_op_free_ mpi_op_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_op_free_ mpi_op_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_open_port_ MPI_OPEN_PORT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_open_port_ mpi_open_port__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_open_port_ mpi_open_port
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_pack_external_ MPI_PACK_EXTERNAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_external_ mpi_pack_external__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_external_ mpi_pack_external
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_pack_size_ MPI_PACK_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_size_ mpi_pack_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_size_ mpi_pack_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_pack_external_size_ MPI_PACK_EXTERNAL_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_external_size_ mpi_pack_external_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_external_size_ mpi_pack_external_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_pack_ MPI_PACK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pack_ mpi_pack__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pack_ mpi_pack
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_probe_ MPI_PROBE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_probe_ mpi_probe__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_probe_ mpi_probe
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_publish_name_ MPI_PUBLISH_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_publish_name_ mpi_publish_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_publish_name_ mpi_publish_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_put_ MPI_PUT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_put_ mpi_put__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_put_ mpi_put
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_query_thread_ MPI_QUERY_THREAD
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_query_thread_ mpi_query_thread__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_query_thread_ mpi_query_thread
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_recv_init_ MPI_RECV_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_init_ mpi_recv_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_init_ mpi_recv_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_recv_init_ MPI_RECV_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_init_ mpi_recv_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_init_ mpi_recv_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_recv_ MPI_RECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_ mpi_recv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_ mpi_recv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_recv_ MPI_RECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_recv_ mpi_recv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_recv_ mpi_recv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_reduce_scatter_ MPI_REDUCE_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_scatter_ mpi_reduce_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_scatter_ mpi_reduce_scatter
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_reduce_scatter_ MPI_REDUCE_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_scatter_ mpi_reduce_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_scatter_ mpi_reduce_scatter
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_reduce_ MPI_REDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_ mpi_reduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_ mpi_reduce
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_reduce_ MPI_REDUCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_reduce_ mpi_reduce__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_reduce_ mpi_reduce
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_request_get_status_ MPI_REQUEST_GET_STATUS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_request_get_status_ mpi_request_get_status__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_request_get_status_ mpi_request_get_status
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_request_free_ MPI_REQUEST_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_request_free_ mpi_request_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_request_free_ mpi_request_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_rsend_init_ MPI_RSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_init_ mpi_rsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_init_ mpi_rsend_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_rsend_init_ MPI_RSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_init_ mpi_rsend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_init_ mpi_rsend_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_rsend_ MPI_RSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_ mpi_rsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_ mpi_rsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_rsend_ MPI_RSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_rsend_ mpi_rsend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_rsend_ mpi_rsend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_scan_ MPI_SCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scan_ mpi_scan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scan_ mpi_scan
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_scan_ MPI_SCAN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scan_ mpi_scan__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scan_ mpi_scan
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_scatter_ MPI_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatter_ mpi_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatter_ mpi_scatter
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_scatter_ MPI_SCATTER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatter_ mpi_scatter__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatter_ mpi_scatter
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_scatterv_ MPI_SCATTERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatterv_ mpi_scatterv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatterv_ mpi_scatterv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_scatterv_ MPI_SCATTERV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_scatterv_ mpi_scatterv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_scatterv_ mpi_scatterv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_send_init_ MPI_SEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_init_ mpi_send_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_init_ mpi_send_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_send_init_ MPI_SEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_init_ mpi_send_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_init_ mpi_send_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_send_ MPI_SEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_ mpi_send__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_ mpi_send
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_send_ MPI_SEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_send_ mpi_send__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_send_ mpi_send
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_ MPI_SENDRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_ mpi_sendrecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_ mpi_sendrecv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_ MPI_SENDRECV
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_ mpi_sendrecv__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_ mpi_sendrecv
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_replace_ MPI_SENDRECV_REPLACE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_replace_ mpi_sendrecv_replace__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_replace_ mpi_sendrecv_replace
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_sendrecv_replace_ MPI_SENDRECV_REPLACE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_sendrecv_replace_ mpi_sendrecv_replace__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_sendrecv_replace_ mpi_sendrecv_replace
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_spawn_multiple_ MPI_COMM_SPAWN_MULTIPLE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_spawn_multiple_ mpi_comm_spawn_multiple__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_spawn_multiple_ mpi_comm_spawn_multiple
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_ssend_init_ MPI_SSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_init_ mpi_ssend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_init_ mpi_ssend_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_ssend_init_ MPI_SSEND_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_init_ mpi_ssend_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_init_ mpi_ssend_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_ssend_ MPI_SSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_ mpi_ssend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_ mpi_ssend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_ssend_ MPI_SSEND
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_ssend_ mpi_ssend__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_ssend_ mpi_ssend
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_startall_ MPI_STARTALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_startall_ mpi_startall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_startall_ mpi_startall
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_start_ MPI_START
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_start_ mpi_start__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_start_ mpi_start
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_status_set_cancelled_ MPI_STATUS_SET_CANCELLED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_status_set_cancelled_ mpi_status_set_cancelled__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_status_set_cancelled_ mpi_status_set_cancelled
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_status_set_elements_ MPI_STATUS_SET_ELEMENTS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_status_set_elements_ mpi_status_set_elements__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_status_set_elements_ mpi_status_set_elements
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_testall_ MPI_TESTALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_testall_ mpi_testall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_testall_ mpi_testall
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_testany_ MPI_TESTANY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_testany_ mpi_testany__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_testany_ mpi_testany
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_test_cancelled_ MPI_TEST_CANCELLED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_test_cancelled_ mpi_test_cancelled__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_test_cancelled_ mpi_test_cancelled
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_test_ MPI_TEST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_test_ mpi_test__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_test_ mpi_test
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_testsome_ MPI_TESTSOME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_testsome_ mpi_testsome__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_testsome_ mpi_testsome
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_topo_test_ MPI_TOPO_TEST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_topo_test_ mpi_topo_test__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_topo_test_ mpi_topo_test
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_commit_ MPI_TYPE_COMMIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_commit_ mpi_type_commit__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_commit_ mpi_type_commit
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_dup_ MPI_TYPE_DUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_dup_ mpi_type_dup__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_dup_ mpi_type_dup
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_extent_ MPI_TYPE_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_extent_ mpi_type_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_extent_ mpi_type_extent
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_free_ MPI_TYPE_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_free_ mpi_type_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_free_ mpi_type_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_get_attr_ MPI_TYPE_GET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_attr_ mpi_type_get_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_attr_ mpi_type_get_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_hindexed_ MPI_TYPE_HINDEXED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_hindexed_ mpi_type_hindexed__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_hindexed_ mpi_type_hindexed
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_hvector_ MPI_TYPE_HVECTOR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_hvector_ mpi_type_hvector__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_hvector_ mpi_type_hvector
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_indexed_ MPI_TYPE_INDEXED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_indexed_ mpi_type_indexed__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_indexed_ mpi_type_indexed
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_lb_ MPI_TYPE_LB
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_lb_ mpi_type_lb__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_lb_ mpi_type_lb
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_match_size_ MPI_TYPE_MATCH_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_match_size_ mpi_type_match_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_match_size_ mpi_type_match_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_size_ MPI_TYPE_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_size_ mpi_type_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_size_ mpi_type_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_struct_ MPI_TYPE_STRUCT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_struct_ mpi_type_struct__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_struct_ mpi_type_struct
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_ub_ MPI_TYPE_UB
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_ub_ mpi_type_ub__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_ub_ mpi_type_ub
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_vector_ MPI_TYPE_VECTOR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_vector_ mpi_type_vector__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_vector_ mpi_type_vector
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_hindexed_ MPI_TYPE_CREATE_HINDEXED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_hindexed_ mpi_type_create_hindexed__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_hindexed_ mpi_type_create_hindexed
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_hvector_ MPI_TYPE_CREATE_HVECTOR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_hvector_ mpi_type_create_hvector__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_hvector_ mpi_type_create_hvector
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_indexed_block_ MPI_TYPE_CREATE_INDEXED_BLOCK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_indexed_block_ mpi_type_create_indexed_block__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_indexed_block_ mpi_type_create_indexed_block
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_contiguous_ MPI_TYPE_CONTIGUOUS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_contiguous_ mpi_type_contiguous__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_contiguous_ mpi_type_contiguous
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_resized_ MPI_TYPE_CREATE_RESIZED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_resized_ mpi_type_create_resized__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_resized_ mpi_type_create_resized
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_struct_ MPI_TYPE_CREATE_STRUCT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_struct_ mpi_type_create_struct__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_struct_ mpi_type_create_struct
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_subarray_ MPI_TYPE_CREATE_SUBARRAY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_subarray_ mpi_type_create_subarray__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_subarray_ mpi_type_create_subarray
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_darray_ MPI_TYPE_CREATE_DARRAY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_darray_ mpi_type_create_darray__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_darray_ mpi_type_create_darray
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_delete_attr_ MPI_TYPE_DELETE_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_delete_attr_ mpi_type_delete_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_delete_attr_ mpi_type_delete_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_free_keyval_ MPI_TYPE_FREE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_free_keyval_ mpi_type_free_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_free_keyval_ mpi_type_free_keyval
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_get_contents_ MPI_TYPE_GET_CONTENTS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_contents_ mpi_type_get_contents__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_contents_ mpi_type_get_contents
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_get_envelope_ MPI_TYPE_GET_ENVELOPE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_envelope_ mpi_type_get_envelope__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_envelope_ mpi_type_get_envelope
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_get_extent_ MPI_TYPE_GET_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_extent_ mpi_type_get_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_extent_ mpi_type_get_extent
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_get_name_ MPI_TYPE_GET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_name_ mpi_type_get_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_name_ mpi_type_get_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_get_true_extent_ MPI_TYPE_GET_TRUE_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_get_true_extent_ mpi_type_get_true_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_get_true_extent_ mpi_type_get_true_extent
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_create_keyval_ MPI_TYPE_CREATE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_create_keyval_ mpi_type_create_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_create_keyval_ mpi_type_create_keyval
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_set_attr_ MPI_TYPE_SET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_set_attr_ mpi_type_set_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_set_attr_ mpi_type_set_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_set_name_ MPI_TYPE_SET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_set_name_ mpi_type_set_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_set_name_ mpi_type_set_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_unpack_external_ MPI_UNPACK_EXTERNAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_unpack_external_ mpi_unpack_external__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_unpack_external_ mpi_unpack_external
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_unpack_ MPI_UNPACK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_unpack_ mpi_unpack__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_unpack_ mpi_unpack
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_unpublish_name_ MPI_UNPUBLISH_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_unpublish_name_ mpi_unpublish_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_unpublish_name_ mpi_unpublish_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_waitall_ MPI_WAITALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_waitall_ mpi_waitall__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_waitall_ mpi_waitall
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_waitany_ MPI_WAITANY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_waitany_ mpi_waitany__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_waitany_ mpi_waitany
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_wait_ MPI_WAIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wait_ mpi_wait__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wait_ mpi_wait
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_waitsome_ MPI_WAITSOME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_waitsome_ mpi_waitsome__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_waitsome_ mpi_waitsome
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_complete_ MPI_WIN_COMPLETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_complete_ mpi_win_complete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_complete_ mpi_win_complete
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_create_ MPI_WIN_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_ mpi_win_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_ mpi_win_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_create_ MPI_WIN_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_ mpi_win_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_ mpi_win_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_fence_ MPI_WIN_FENCE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_fence_ mpi_win_fence__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_fence_ mpi_win_fence
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_free_ MPI_WIN_FREE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_free_ mpi_win_free__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_free_ mpi_win_free
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_get_attr_ MPI_WIN_GET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_attr_ mpi_win_get_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_attr_ mpi_win_get_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_get_group_ MPI_WIN_GET_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_group_ mpi_win_get_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_group_ mpi_win_get_group
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_get_name_ MPI_WIN_GET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_name_ mpi_win_get_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_name_ mpi_win_get_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_lock_ MPI_WIN_LOCK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_lock_ mpi_win_lock__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_lock_ mpi_win_lock
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_post_ MPI_WIN_POST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_post_ mpi_win_post__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_post_ mpi_win_post
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_set_attr_ MPI_WIN_SET_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_set_attr_ mpi_win_set_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_set_attr_ mpi_win_set_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_set_name_ MPI_WIN_SET_NAME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_set_name_ mpi_win_set_name__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_set_name_ mpi_win_set_name
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_start_ MPI_WIN_START
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_start_ mpi_win_start__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_start_ mpi_win_start
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_test_ MPI_WIN_TEST
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_test_ mpi_win_test__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_test_ mpi_win_test
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_unlock_ MPI_WIN_UNLOCK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_unlock_ mpi_win_unlock__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_unlock_ mpi_win_unlock
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_wait_ MPI_WIN_WAIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_wait_ mpi_win_wait__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_wait_ mpi_win_wait
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_call_errhandler_ MPI_WIN_CALL_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_call_errhandler_ mpi_win_call_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_call_errhandler_ mpi_win_call_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_create_errhandler_ MPI_WIN_CREATE_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_errhandler_ mpi_win_create_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_errhandler_ mpi_win_create_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_delete_attr_ MPI_WIN_DELETE_ATTR
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_delete_attr_ mpi_win_delete_attr__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_delete_attr_ mpi_win_delete_attr
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_free_keyval_ MPI_WIN_FREE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_free_keyval_ mpi_win_free_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_free_keyval_ mpi_win_free_keyval
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_get_errhandler_ MPI_WIN_GET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_get_errhandler_ mpi_win_get_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_get_errhandler_ mpi_win_get_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_create_keyval_ MPI_WIN_CREATE_KEYVAL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_create_keyval_ mpi_win_create_keyval__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_create_keyval_ mpi_win_create_keyval
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_set_errhandler_ MPI_WIN_SET_ERRHANDLER
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_set_errhandler_ mpi_win_set_errhandler__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_set_errhandler_ mpi_win_set_errhandler
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_wtick_ MPI_WTICK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wtick_ mpi_wtick__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wtick_ mpi_wtick
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_init_ MPI_INIT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_init_ mpi_init__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_init_ mpi_init
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_address_ MPI_ADDRESS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_address_ mpi_address__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_address_ mpi_address
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_close_ MPI_FILE_CLOSE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_close_ mpi_file_close__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_close_ mpi_file_close
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_delete_ MPI_FILE_DELETE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_delete_ mpi_file_delete__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_delete_ mpi_file_delete
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_amode_ MPI_FILE_GET_AMODE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_amode_ mpi_file_get_amode__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_amode_ mpi_file_get_amode
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_atomicity_ MPI_FILE_GET_ATOMICITY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_atomicity_ mpi_file_get_atomicity__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_atomicity_ mpi_file_get_atomicity
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_byte_offset_ MPI_FILE_GET_BYTE_OFFSET
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_byte_offset_ mpi_file_get_byte_offset__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_byte_offset_ mpi_file_get_byte_offset
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_group_ MPI_FILE_GET_GROUP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_group_ mpi_file_get_group__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_group_ mpi_file_get_group
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_info_ MPI_FILE_GET_INFO
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_info_ mpi_file_get_info__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_info_ mpi_file_get_info
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_position_ MPI_FILE_GET_POSITION
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_position_ mpi_file_get_position__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_position_ mpi_file_get_position
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_position_shared_ MPI_FILE_GET_POSITION_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_position_shared_ mpi_file_get_position_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_position_shared_ mpi_file_get_position_shared
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_size_ MPI_FILE_GET_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_size_ mpi_file_get_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_size_ mpi_file_get_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_type_extent_ MPI_FILE_GET_TYPE_EXTENT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_type_extent_ mpi_file_get_type_extent__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_type_extent_ mpi_file_get_type_extent
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_get_view_ MPI_FILE_GET_VIEW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_get_view_ mpi_file_get_view__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_get_view_ mpi_file_get_view
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_iread_ MPI_FILE_IREAD
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iread_ mpi_file_iread__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iread_ mpi_file_iread
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_iread_at_ MPI_FILE_IREAD_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iread_at_ mpi_file_iread_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iread_at_ mpi_file_iread_at
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_iread_shared_ MPI_FILE_IREAD_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iread_shared_ mpi_file_iread_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iread_shared_ mpi_file_iread_shared
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_open_ MPI_FILE_OPEN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_open_ mpi_file_open__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_open_ mpi_file_open
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_preallocate_ MPI_FILE_PREALLOCATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_preallocate_ mpi_file_preallocate__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_preallocate_ mpi_file_preallocate
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_ MPI_FILE_READ
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ mpi_file_read__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ mpi_file_read
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_all_ MPI_FILE_READ_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_all_ mpi_file_read_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_all_ mpi_file_read_all
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_all_begin_ MPI_FILE_READ_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_all_begin_ mpi_file_read_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_all_begin_ mpi_file_read_all_begin
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_all_end_ MPI_FILE_READ_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_all_end_ mpi_file_read_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_all_end_ mpi_file_read_all_end
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_ MPI_FILE_READ_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_ mpi_file_read_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_ mpi_file_read_at
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_all_ MPI_FILE_READ_AT_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_all_ mpi_file_read_at_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_all_ mpi_file_read_at_all
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_all_begin_ MPI_FILE_READ_AT_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_all_begin_ mpi_file_read_at_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_all_begin_ mpi_file_read_at_all_begin
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_at_all_end_ MPI_FILE_READ_AT_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_at_all_end_ mpi_file_read_at_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_at_all_end_ mpi_file_read_at_all_end
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_ordered_ MPI_FILE_READ_ORDERED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ordered_ mpi_file_read_ordered__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ordered_ mpi_file_read_ordered
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_ordered_begin_ MPI_FILE_READ_ORDERED_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ordered_begin_ mpi_file_read_ordered_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ordered_begin_ mpi_file_read_ordered_begin
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_ordered_end_ MPI_FILE_READ_ORDERED_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_ordered_end_ mpi_file_read_ordered_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_ordered_end_ mpi_file_read_ordered_end
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_read_shared_ MPI_FILE_READ_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_read_shared_ mpi_file_read_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_read_shared_ mpi_file_read_shared
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_set_atomicity_ MPI_FILE_SET_ATOMICITY
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_atomicity_ mpi_file_set_atomicity__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_atomicity_ mpi_file_set_atomicity
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_set_info_ MPI_FILE_SET_INFO
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_info_ mpi_file_set_info__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_info_ mpi_file_set_info
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_set_size_ MPI_FILE_SET_SIZE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_size_ mpi_file_set_size__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_size_ mpi_file_set_size
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_set_view_ MPI_FILE_SET_VIEW
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_set_view_ mpi_file_set_view__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_set_view_ mpi_file_set_view
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_sync_ MPI_FILE_SYNC
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_sync_ mpi_file_sync__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_sync_ mpi_file_sync
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_ MPI_FILE_WRITE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ mpi_file_write__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ mpi_file_write
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_all_ MPI_FILE_WRITE_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_all_ mpi_file_write_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_all_ mpi_file_write_all
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_all_begin_ MPI_FILE_WRITE_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_all_begin_ mpi_file_write_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_all_begin_ mpi_file_write_all_begin
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_all_end_ MPI_FILE_WRITE_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_all_end_ mpi_file_write_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_all_end_ mpi_file_write_all_end
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_ MPI_FILE_WRITE_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_ mpi_file_write_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_ mpi_file_write_at
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_all_ MPI_FILE_WRITE_AT_ALL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_all_ mpi_file_write_at_all__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_all_ mpi_file_write_at_all
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_all_begin_ MPI_FILE_WRITE_AT_ALL_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_all_begin_ mpi_file_write_at_all_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_all_begin_ mpi_file_write_at_all_begin
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_at_all_end_ MPI_FILE_WRITE_AT_ALL_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_at_all_end_ mpi_file_write_at_all_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_at_all_end_ mpi_file_write_at_all_end
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_ordered_ MPI_FILE_WRITE_ORDERED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ordered_ mpi_file_write_ordered__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ordered_ mpi_file_write_ordered
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_ordered_begin_ MPI_FILE_WRITE_ORDERED_BEGIN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ordered_begin_ mpi_file_write_ordered_begin__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ordered_begin_ mpi_file_write_ordered_begin
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_ordered_end_ MPI_FILE_WRITE_ORDERED_END
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_ordered_end_ mpi_file_write_ordered_end__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_ordered_end_ mpi_file_write_ordered_end
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_write_shared_ MPI_FILE_WRITE_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_write_shared_ mpi_file_write_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_write_shared_ mpi_file_write_shared
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_get_address_ MPI_GET_ADDRESS
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_get_address_ mpi_get_address__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_get_address_ mpi_get_address
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_init_thread_ MPI_INIT_THREAD
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_init_thread_ mpi_init_thread__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_init_thread_ mpi_init_thread
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_keyval_create_ MPI_KEYVAL_CREATE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_keyval_create_ mpi_keyval_create__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_keyval_create_ mpi_keyval_create
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_null_copy_fn_ MPI_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_null_copy_fn_ mpi_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_null_copy_fn_ mpi_null_copy_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_null_delete_fn_ MPI_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_null_delete_fn_ mpi_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_null_delete_fn_ mpi_null_delete_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_pcontrol_ MPI_PCONTROL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_pcontrol_ mpi_pcontrol__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_pcontrol_ mpi_pcontrol
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_register_datarep_ MPI_REGISTER_DATAREP
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_register_datarep_ mpi_register_datarep__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_register_datarep_ mpi_register_datarep
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_conversion_fn_null_ MPI_CONVERSION_FN_NULL
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_conversion_fn_null_ mpi_conversion_fn_null__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_conversion_fn_null_ mpi_conversion_fn_null
/* Else leave name alone */
#endif

/* Add the prototype so the routine knows what this is */
extern FORT_DLL_SPEC int FORT_CALL mpi_conversion_fn_null_ ( void*v1, MPI_Fint*v2, MPI_Fint*v3, void*v4, MPI_Offset*v5, MPI_Fint *v6, MPI_Fint*v7, MPI_Fint *ierr );

#ifdef F77_NAME_UPPER
#define mpi_wtick_ MPI_WTICK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wtick_ mpi_wtick__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wtick_ mpi_wtick
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_wtime_ MPI_WTIME
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_wtime_ mpi_wtime__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_wtime_ mpi_wtime
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_iwrite_ MPI_FILE_IWRITE
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iwrite_ mpi_file_iwrite__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iwrite_ mpi_file_iwrite
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_iwrite_at_ MPI_FILE_IWRITE_AT
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iwrite_at_ mpi_file_iwrite_at__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iwrite_at_ mpi_file_iwrite_at
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_iwrite_shared_ MPI_FILE_IWRITE_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_iwrite_shared_ mpi_file_iwrite_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_iwrite_shared_ mpi_file_iwrite_shared
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_seek_ MPI_FILE_SEEK
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_seek_ mpi_file_seek__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_seek_ mpi_file_seek
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_file_seek_shared_ MPI_FILE_SEEK_SHARED
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_file_seek_shared_ mpi_file_seek_shared__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_file_seek_shared_ mpi_file_seek_shared
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_dup_fn_ MPI_COMM_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_dup_fn_ mpi_comm_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_dup_fn_ mpi_comm_dup_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_dup_fn_ MPI_TYPE_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_dup_fn_ mpi_type_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_dup_fn_ mpi_type_dup_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_dup_fn_ MPI_WIN_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_dup_fn_ mpi_win_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_dup_fn_ mpi_win_dup_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_dup_fn_ MPI_DUP_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_dup_fn_ mpi_dup_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_dup_fn_ mpi_dup_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_comm_null_delete_fn_ MPI_COMM_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_comm_null_delete_fn_ mpi_comm_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_comm_null_delete_fn_ mpi_comm_null_delete_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_null_copy_fn_ MPI_TYPE_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_null_copy_fn_ mpi_type_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_null_copy_fn_ mpi_type_null_copy_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_type_null_delete_fn_ MPI_TYPE_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_type_null_delete_fn_ mpi_type_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_type_null_delete_fn_ mpi_type_null_delete_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_null_copy_fn_ MPI_WIN_NULL_COPY_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_null_copy_fn_ mpi_win_null_copy_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_null_copy_fn_ mpi_win_null_copy_fn
/* Else leave name alone */
#endif

#ifdef F77_NAME_UPPER
#define mpi_win_null_delete_fn_ MPI_WIN_NULL_DELETE_FN
#elif defined(F77_NAME_LOWER_2USCORE)
#define mpi_win_null_delete_fn_ mpi_win_null_delete_fn__
#elif !defined(F77_NAME_LOWER_USCORE)
#define mpi_win_null_delete_fn_ mpi_win_null_delete_fn
/* Else leave name alone */
#endif


#endif /* MPICH_MPI_FROM_PMPI */

#include "fproto.h"

FORT_DLL_SPEC void FORT_CALL mpi_abort_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Abort( (MPI_Comm)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_accumulate_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *ierr ){
	*ierr = MPI_Accumulate( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, *v6, (MPI_Datatype)(*v7), *v8, *v9 );
}

FORT_DLL_SPEC void FORT_CALL mpi_add_error_class_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Add_error_class( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_add_error_code_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Add_error_code( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_add_error_string_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Add_error_string( *v1, p2 );
	MPIU_Free( p2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_allgather_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Allgather( v1, *v2, (MPI_Datatype)(*v3), v4, *v5, (MPI_Datatype)(*v6), (MPI_Comm)(*v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_allgatherv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Allgatherv( v1, *v2, (MPI_Datatype)(*v3), v4, v5, v6, (MPI_Datatype)(*v7), (MPI_Comm)(*v8) );
}

FORT_DLL_SPEC void FORT_CALL mpi_alloc_mem_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *ierr ){
	*ierr = MPI_Alloc_mem( *v1, (MPI_Info)(*v2), v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_allreduce_ ( void*v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Allreduce( v1, v2, *v3, (MPI_Datatype)(*v4), *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_alltoall_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Alltoall( v1, *v2, (MPI_Datatype)(*v3), v4, *v5, (MPI_Datatype)(*v6), (MPI_Comm)(*v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_alltoallv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, void*v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *ierr ){
	*ierr = MPI_Alltoallv( v1, v2, v3, (MPI_Datatype)(*v4), v5, v6, v7, (MPI_Datatype)(*v8), (MPI_Comm)(*v9) );
}

FORT_DLL_SPEC void FORT_CALL mpi_alltoallw_ ( void*v1, MPI_Fint v2[], MPI_Fint v3[], MPI_Fint v4[], void*v5, MPI_Fint v6[], MPI_Fint v7[], MPI_Fint v8[], MPI_Fint *v9, MPI_Fint *ierr ){
	*ierr = MPI_Alltoallw( v1, v2, v3, v4, v5, v6, v7, v8, (MPI_Comm)(*v9) );
}

FORT_DLL_SPEC void FORT_CALL mpi_attr_delete_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Attr_delete( (MPI_Comm)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_attr_get_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *v4, MPI_Fint *ierr ){
	void *attrv3;
	int l4;
	*ierr = MPI_Attr_get( (MPI_Comm)(*v1), *v2, &attrv3, &l4 );

	if ((int)*ierr || !l4) {
		*(MPI_Fint*)v3 = 0;
	}
	else {
		*(MPI_Fint*)v3 = (MPI_Fint)MPIU_PtrToAint(attrv3);
	}
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_attr_put_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *ierr ){
	*ierr = MPI_Attr_put( (MPI_Comm)(*v1), *v2, MPIU_IntToPtr(*(MPI_Fint*)v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_barrier_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Barrier( (MPI_Comm)(*v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_bcast_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Bcast( v1, *v2, (MPI_Datatype)(*v3), *v4, (MPI_Comm)(*v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_bsend_init_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Bsend_init( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_bsend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Bsend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_buffer_attach_ ( void*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Buffer_attach( v1, *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_buffer_detach_ ( void*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	void *t1 = v1;
	*ierr = MPI_Buffer_detach( &t1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_cancel_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Cancel( (MPI_Request *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_coords_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Cart_coords( (MPI_Comm)(*v1), *v2, *v3, v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_create_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	int *l4 = (int *)MPIU_Malloc(*v2 * sizeof(int));
	int l5;

	{int li;
	 for (li=0; li<*v2; li++) {
		l4[li] = MPIR_FROM_FLOG(v4[li]);
	 }
	}
	l5 = MPIR_FROM_FLOG(*v5);
	*ierr = MPI_Cart_create( (MPI_Comm)(*v1), *v2, v3, l4, l5, (MPI_Comm *)(v6) );
	MPIU_Free( l4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_get_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Cart_get( (MPI_Comm)(*v1), *v2, v3, v4, v5 );

	{int li;
	 for (li=0; li<*v2; li++) {
		v4[li] = MPIR_TO_FLOG(v4[li]);
	 }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_map_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Cart_map( (MPI_Comm)(*v1), *v2, v3, v4, v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_rank_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Cart_rank( (MPI_Comm)(*v1), v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_shift_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Cart_shift( (MPI_Comm)(*v1), *v2, *v3, v4, v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_cart_sub_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Cart_sub( (MPI_Comm)(*v1), v2, (MPI_Comm *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_cartdim_get_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Cartdim_get( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_close_port_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Close_port( p1 );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_accept_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Comm_accept( p1, (MPI_Info)(*v2), *v3, (MPI_Comm)(*v4), (MPI_Comm *)(v5) );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_compare_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Comm_compare( (MPI_Comm)(*v1), (MPI_Comm)(*v2), v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_connect_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Comm_connect( p1, (MPI_Info)(*v2), *v3, (MPI_Comm)(*v4), (MPI_Comm *)(v5) );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_create_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Comm_create( (MPI_Comm)(*v1), *v2, (MPI_Comm *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_dup_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_dup( (MPI_Comm)(*v1), (MPI_Comm *)(v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Comm_free( (MPI_Comm *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_get_attr_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *v4, MPI_Fint *ierr ){
	void *attrv3;
	int l4;
	*ierr = MPI_Comm_get_attr( (MPI_Comm)(*v1), *v2, &attrv3, &l4 );

	if ((int)*ierr || !l4) {
		*(MPI_Aint*)v3 = 0;
	}
	else {
		*(MPI_Aint*)v3 = MPIU_PtrToAint(attrv3);
	}
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_group_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_group( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_join_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_join( *v1, (MPI_Comm *)(v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_rank_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_rank( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_set_attr_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *ierr ){
	*ierr = MPI_Comm_set_attr( (MPI_Comm)(*v1), *v2, *(void **)v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_set_name_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Comm_set_name( (MPI_Comm)(*v1), p2 );
	MPIU_Free( p2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_size_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_size( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_spawn_ ( TCHAR *v1 FORT_MIXED_LEN(d1), TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint v8[], MPI_Fint *ierr FORT_END_LEN(d1) FORT_END_LEN(d2) ){
	TCHAR *p1;
	TCHAR **p2;
	TCHAR *pcpy2;
	int  asize2=0;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	{ int i;
	  TCHAR *ptmp;

	  /* Compute the size of the array by looking for an all-blank line */
	  pcpy2 = v2;
	  for (asize2=1; 1; asize2++) {
		  TCHAR *pt = pcpy2 + d2 - 1;
		  while (*pt == _TEXT(' ') && pt > pcpy2) pt--;
		  if (*pt == _TEXT(' ')) break;
		  pcpy2 += d2;
	  }

	  p2 = (TCHAR **)MPIU_Malloc( asize2 * sizeof(TCHAR *) );
	  ptmp	= (TCHAR *)MPIU_Malloc( asize2 * (d2 + 1)*sizeof(TCHAR) );
	  for (i=0; i<asize2-1; i++) {
		  TCHAR *p = v2 + i * d2, *pin, *pdest;
		  int j;

		  pdest = ptmp + i * (d2 + 1);
		  p2[i] = pdest;
		  /* Move to the end and work back */
		  pin = p + d2 - 1;
		  while (*pin == _TEXT(' ') && pin > p) pin--;
		  /* Copy and then null terminate */
		  for (j=0; j<(pin-p)+1; j++) { pdest[j] = p[j]; }
		  pdest[j] = 0;
		  }
	/* Null terminate the array */
	p2[asize2-1] = 0;
	}

	if (v8 == MPI_F_ERRCODES_IGNORE) { v8 = MPI_ERRCODES_IGNORE; }
	*ierr = MPI_Comm_spawn( p1, p2, *v3, (MPI_Info)(*v4), *v5, (MPI_Comm)(*v6), (MPI_Comm *)(v7), (int *)v8 );
	MPIU_Free( p1 );
	MPIU_Free( p2[0] ); MPIU_Free( p2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_split_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Comm_split( (MPI_Comm)(*v1), *v2, *v3, (MPI_Comm *)(v4) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_call_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_call_errhandler( (MPI_Comm)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_create_errhandler_ ( MPI_Comm_errhandler_fn*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_create_errhandler( v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_delete_attr_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_delete_attr( (MPI_Comm)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_disconnect_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Comm_disconnect( (MPI_Comm *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_free_keyval_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Comm_free_keyval( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_get_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_get_errhandler( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_get_name_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *ierr FORT_END_LEN(d2) ){
	*ierr = MPI_Comm_get_name( (MPI_Comm)(*v1), v2, v3 );

	{TCHAR *p = v2;
		while (*p) p++;
		while ((p-v2) < d2) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_create_keyval_ ( MPI_Comm_copy_attr_function*v1, MPI_Comm_delete_attr_function*v2, MPI_Fint *v3, void*v4, MPI_Fint *ierr ){
	*ierr = MPI_Comm_create_keyval( v1, v2, v3, v4 );

	if (*ierr == MPI_SUCCESS) {
		 MPIR_Keyval_set_fortran90( *v3 );
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_get_parent_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Comm_get_parent( (MPI_Comm *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_remote_group_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_remote_group( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_remote_size_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_remote_size( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_set_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Comm_set_errhandler( (MPI_Comm)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_test_inter_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	int l2;
	*ierr = MPI_Comm_test_inter( (MPI_Comm)(*v1), &l2 );
	*v2 = MPIR_TO_FLOG(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_dims_create_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Dims_create( *v1, *v2, v3 );
}

#ifdef MPI_COMM_DUP_FN
#undef MPI_COMM_DUP_FN
#endif

FORT_DLL_SPEC void FORT_CALL mpi_errhandler_create_ ( MPI_Handler_function*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Errhandler_create( v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_errhandler_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Errhandler_free( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_errhandler_get_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Errhandler_get( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_errhandler_set_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Errhandler_set( (MPI_Comm)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_error_class_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Error_class( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_error_string_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *ierr FORT_END_LEN(d2) ){
	*ierr = MPI_Error_string( *v1, v2, v3 );

	{TCHAR *p = v2;
		while (*p) p++;
		while ((p-v2) < d2) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_exscan_ ( void*v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Exscan( v1, v2, *v3, (MPI_Datatype)(*v4), *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_call_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_call_errhandler( MPI_File_f2c(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_create_errhandler_ ( MPI_File_errhandler_fn*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_create_errhandler( v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_errhandler( MPI_File_f2c(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_set_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_set_errhandler( MPI_File_f2c(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_finalized_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Finalized( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_finalize_ ( MPI_Fint *ierr ){
	*ierr = MPI_Finalize(  );
}

FORT_DLL_SPEC void FORT_CALL mpi_free_mem_ ( void*v1, MPI_Fint *ierr ){
	*ierr = MPI_Free_mem( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_gather_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Gather( v1, *v2, (MPI_Datatype)(*v3), v4, *v5, (MPI_Datatype)(*v6), *v7, (MPI_Comm)(*v8) );
}

FORT_DLL_SPEC void FORT_CALL mpi_gatherv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Gatherv( v1, *v2, (MPI_Datatype)(*v3), v4, v5, v6, (MPI_Datatype)(*v7), *v8, (MPI_Comm)(*v9) );
}

FORT_DLL_SPEC void FORT_CALL mpi_get_count_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Get_count( (MPI_Status *)(v1), (MPI_Datatype)(*v2), v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_get_elements_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Get_elements( (MPI_Status *)(v1), (MPI_Datatype)(*v2), v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_get_version_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Get_version( v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_get_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *ierr ){
	*ierr = MPI_Get( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, *v6, (MPI_Datatype)(*v7), *v8 );
}

FORT_DLL_SPEC void FORT_CALL mpi_get_processor_name_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, MPI_Fint *ierr FORT_END_LEN(d1) ){
	*ierr = MPI_Get_processor_name( v1, v2 );

	{TCHAR *p = v1;
		while (*p) p++;
		while ((p-v1) < d1) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_graph_create_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Graph_create( (MPI_Comm)(*v1), *v2, v3, v4, *v5, (MPI_Comm *)(v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_graph_get_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Graph_get( (MPI_Comm)(*v1), *v2, *v3, v4, v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_graph_map_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Graph_map( (MPI_Comm)(*v1), *v2, v3, v4, v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_graphdims_get_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Graphdims_get( (MPI_Comm)(*v1), v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_grequest_complete_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Grequest_complete( *v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_grequest_start_ ( MPI_Grequest_query_function*v1, MPI_Grequest_free_function*v2, MPI_Grequest_cancel_function*v3, void*v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Grequest_start( v1, v2, v3, v4, (MPI_Request *)(v5) );

	if (*ierr == MPI_SUCCESS) {
		 MPIR_Grequest_set_lang_f77( *v5 );
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_graph_neighbors_count_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Graph_neighbors_count( (MPI_Comm)(*v1), *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_graph_neighbors_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Graph_neighbors( (MPI_Comm)(*v1), *v2, *v3, v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_compare_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Group_compare( *v1, *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_excl_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Group_excl( *v1, *v2, v3, v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Group_free( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_incl_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Group_incl( *v1, *v2, v3, v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_rank_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Group_rank( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_size_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Group_size( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_union_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Group_union( *v1, *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_difference_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Group_difference( *v1, *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_intersection_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Group_intersection( *v1, *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_range_excl_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint v3[], MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Group_range_excl( *v1, *v2, (int (*)[3])(v3), v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_range_incl_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint v3[], MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Group_range_incl( *v1, *v2, (int (*)[3])(v3), v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_group_translate_ranks_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Group_translate_ranks( *v1, *v2, v3, *v4, v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_ibsend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Ibsend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_intercomm_create_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Intercomm_create( (MPI_Comm)(*v1), *v2, (MPI_Comm)(*v3), *v4, *v5, (MPI_Comm *)(v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_intercomm_merge_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	int l2;
	l2 = MPIR_FROM_FLOG(*v2);
	*ierr = MPI_Intercomm_merge( (MPI_Comm)(*v1), l2, (MPI_Comm *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_create_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Info_create( (MPI_Info *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_delete_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Info_delete( (MPI_Info)(*v1), p2 );
	MPIU_Free( p2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_dup_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Info_dup( (MPI_Info)(*v1), (MPI_Info *)(v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Info_free( (MPI_Info *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_get_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, TCHAR *v4 FORT_MIXED_LEN(d4), MPI_Fint *v5, MPI_Fint *ierr FORT_END_LEN(d2) FORT_END_LEN(d4) ){
	TCHAR *p2;
	int l5;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Info_get( (MPI_Info)(*v1), p2, *v3, v4, &l5 );
	MPIU_Free( p2 );

	{TCHAR *p = v4;
		while (*p) p++;
		while ((p-v4) < d4) { *p++ = _TEXT(' '); }
	}
	*v5 = MPIR_TO_FLOG(l5);
}

FORT_DLL_SPEC void FORT_CALL mpi_info_set_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), TCHAR *v3 FORT_MIXED_LEN(d3), MPI_Fint *ierr FORT_END_LEN(d2) FORT_END_LEN(d3) ){
	TCHAR *p2;
	TCHAR *p3;

	{TCHAR *p = v2 + d2 - 1;
	 TCHAR *pin = v2;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		while (*pin == _TEXT(' ') && pin < p) pin++;
		p2 = (TCHAR *)MPIU_Malloc( (p-pin + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-pin); li++) { p2[li] = pin[li]; }
		p2[li] = 0;
	}

	{TCHAR *p = v3 + d3 - 1;
	 TCHAR *pin = v3;
	 int  li;
		while (*p == _TEXT(' ') && p > v3) p--;
		p++;
		while (*pin == _TEXT(' ') && pin < p) pin++;
		p3 = (TCHAR *)MPIU_Malloc( (p-pin + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-pin); li++) { p3[li] = pin[li]; }
		p3[li] = 0;
	}
	*ierr = MPI_Info_set( (MPI_Info)(*v1), p2, p3 );
	MPIU_Free( p2 );
	MPIU_Free( p3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_get_nkeys_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Info_get_nkeys( (MPI_Info)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_info_get_nthkey_ ( MPI_Fint *v1, MPI_Fint *v2, TCHAR *v3 FORT_MIXED_LEN(d3), MPI_Fint *ierr FORT_END_LEN(d3) ){
	*ierr = MPI_Info_get_nthkey( (MPI_Info)(*v1), *v2, v3 );

	{TCHAR *p = v3;
		while (*p) p++;
		while ((p-v3) < d3) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_info_get_valuelen_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;
	int l4;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Info_get_valuelen( (MPI_Info)(*v1), p2, v3, &l4 );
	MPIU_Free( p2 );
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_initialized_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	int l1;
	*ierr = MPI_Initialized( &l1 );
	*v1 = MPIR_TO_FLOG(l1);
}

FORT_DLL_SPEC void FORT_CALL mpi_iprobe_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	int l4;

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v5 == MPI_F_STATUS_IGNORE) { v5 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Iprobe( *v1, *v2, (MPI_Comm)(*v3), &l4, (MPI_Status *)v5 );
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_irecv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Irecv( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_irsend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Irsend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_isend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Isend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_issend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Issend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_is_thread_main_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Is_thread_main( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_keyval_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Keyval_free( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_lookup_name_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, TCHAR *v3 FORT_MIXED_LEN(d3), MPI_Fint *ierr FORT_END_LEN(d1) FORT_END_LEN(d3) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Lookup_name( p1, (MPI_Info)(*v2), v3 );
	MPIU_Free( p1 );

	{TCHAR *p = v3;
		while (*p) p++;
		while ((p-v3) < d3) { *p++ = _TEXT(' '); }
	}
}

#ifdef MPI_COMM_NULL_COPY_FN
#undef MPI_COMM_NULL_COPY_FN
#endif

FORT_DLL_SPEC int FORT_CALL mpi_conversion_fn_null_ ( void*v1, MPI_Fint*v2, MPI_Fint*v3, void*v4, MPI_Offset*v5, MPI_Fint *v6, MPI_Fint*v7, MPI_Fint *ierr )
{
   return MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_op_create_ ( MPI_User_function*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Op_create( v1, *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_op_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Op_free( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_open_port_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *ierr FORT_END_LEN(d2) ){
	*ierr = MPI_Open_port( (MPI_Info)(*v1), v2 );

	{TCHAR *p = v2;
		while (*p) p++;
		while ((p-v2) < d2) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_pack_external_ ( TCHAR *v1 FORT_MIXED_LEN(d1), void*v2, MPI_Fint *v3, MPI_Fint *v4, void*v5, MPI_Aint * v6, MPI_Aint * v7, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Pack_external( p1, v2, *v3, (MPI_Datatype)(*v4), v5, *v6, v7 );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_pack_size_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Pack_size( *v1, (MPI_Datatype)(*v2), (MPI_Comm)(*v3), v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_pack_external_size_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, MPI_Fint *v3, MPI_Aint * v4, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Pack_external_size( p1, *v2, (MPI_Datatype)(*v3), v4 );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_pack_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Pack( v1, *v2, (MPI_Datatype)(*v3), v4, *v5, v6, (MPI_Comm)(*v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_probe_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v4 == MPI_F_STATUS_IGNORE) { v4 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Probe( *v1, *v2, (MPI_Comm)(*v3), (MPI_Status *)v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_publish_name_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, TCHAR *v3 FORT_MIXED_LEN(d3), MPI_Fint *ierr FORT_END_LEN(d1) FORT_END_LEN(d3) ){
	TCHAR *p1;
	TCHAR *p3;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}

	{TCHAR *p = v3 + d3 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v3) p--;
		p++;
		p3 = (TCHAR *)MPIU_Malloc( (p-v3 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v3); li++) { p3[li] = v3[li]; }
		p3[li] = 0;
	}
	*ierr = MPI_Publish_name( p1, (MPI_Info)(*v2), p3 );
	MPIU_Free( p1 );
	MPIU_Free( p3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_put_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *ierr ){
	*ierr = MPI_Put( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, *v6, (MPI_Datatype)(*v7), *v8 );
}

FORT_DLL_SPEC void FORT_CALL mpi_query_thread_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Query_thread( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_recv_init_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Recv_init( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_recv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v7 == MPI_F_STATUS_IGNORE) { v7 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Recv( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Status *)v7 );
}

FORT_DLL_SPEC void FORT_CALL mpi_reduce_scatter_ ( void*v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Reduce_scatter( v1, v2, v3, (MPI_Datatype)(*v4), *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_reduce_ ( void*v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Reduce( v1, v2, *v3, (MPI_Datatype)(*v4), *v5, *v6, (MPI_Comm)(*v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_request_get_status_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Request_get_status( *v1, v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_request_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Request_free( (MPI_Request *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_rsend_init_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Rsend_init( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_rsend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Rsend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_scan_ ( void*v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v1 == MPIR_F_MPI_IN_PLACE) v1 = MPI_IN_PLACE;
	*ierr = MPI_Scan( v1, v2, *v3, (MPI_Datatype)(*v4), *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_scatter_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v4 == MPIR_F_MPI_IN_PLACE) v4 = MPI_IN_PLACE;
	*ierr = MPI_Scatter( v1, *v2, (MPI_Datatype)(*v3), v4, *v5, (MPI_Datatype)(*v6), *v7, (MPI_Comm)(*v8) );
}

FORT_DLL_SPEC void FORT_CALL mpi_scatterv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, void*v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }
	if (v5 == MPIR_F_MPI_IN_PLACE) v5 = MPI_IN_PLACE;
	*ierr = MPI_Scatterv( v1, v2, v3, (MPI_Datatype)(*v4), v5, *v6, (MPI_Datatype)(*v7), *v8, (MPI_Comm)(*v9) );
}

FORT_DLL_SPEC void FORT_CALL mpi_send_init_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Send_init( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_send_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Send( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_sendrecv_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, void*v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *v10, MPI_Fint *v11, MPI_Fint *v12, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v12 == MPI_F_STATUS_IGNORE) { v12 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Sendrecv( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, v6, *v7, (MPI_Datatype)(*v8), *v9, *v10, (MPI_Comm)(*v11), (MPI_Status *)v12 );
}

FORT_DLL_SPEC void FORT_CALL mpi_sendrecv_replace_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v9 == MPI_F_STATUS_IGNORE) { v9 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Sendrecv_replace( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, *v6, *v7, (MPI_Comm)(*v8), (MPI_Status *)v9 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_spawn_multiple_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), TCHAR *v3 FORT_MIXED_LEN(d3), MPI_Fint v4[], MPI_Info v5[], MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *v8, MPI_Fint v9[], MPI_Fint *ierr FORT_END_LEN(d2) FORT_END_LEN(d3) ){
	TCHAR **p2;
	int  asize2=0;
	TCHAR ***p3=0;

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	{ int i;
	  TCHAR *ptmp;

	  asize2 = *v1 + 1;

	  p2 = (TCHAR **)MPIU_Malloc( asize2 * sizeof(TCHAR *) );
	  ptmp	= (TCHAR *)MPIU_Malloc( (asize2 * (d2 + 1))*sizeof(TCHAR) );
	  for (i=0; i<asize2-1; i++) {
		  TCHAR *p = v2 + i * d2, *pin, *pdest;
		  int j;

		  pdest = ptmp + i * (d2 + 1);
		  p2[i] = pdest;
		  /* Move to the end and work back */
		  pin = p + d2 - 1;
		  while (*pin == _TEXT(' ') && pin > p) pin--;
		  /* Copy and then null terminate */
		  for (j=0; j<(pin-p)+1; j++) { pdest[j] = p[j]; }
		  pdest[j] = 0;
		  }
	/* Null terminate the array */
	p2[asize2-1] = 0;
	}

	/* Check for the special case of a the null args case. */
	if (v3 == MPI_F_ARGVS_NULL) { v3 = (TCHAR *)MPI_ARGVS_NULL; }
	else {
		/* We must convert from the 2-dimensional Fortran array of
		   fixed length strings to a C variable-sized array (really an
		   array of pointers for each command of pointers to each
		   argument, which is null terminated.*/

	  int k;

	  /* Allocate the array of pointers for the commands */
	  p3 = (TCHAR ***)MPIU_Malloc( *v1 * sizeof(TCHAR **) );

	  for (k=0; k<*v1; k++) {
		/* For each command, find the number of command-line arguments.
		   They are terminated by an empty entry. */
		/* Find the first entry in the Fortran array for this row */
		TCHAR *p = v3 + k * d3;
		int arglen = 0, argcnt=0, i;
		TCHAR **pargs, *pdata;
		for (argcnt=0; 1; argcnt ++) {
			TCHAR *pin = p + d3 - 1; /* Move to the end of the
											current Fortran string */
			while (*pin == _TEXT(' ') && pin > p) pin--; /* Move backwards until
													we find a non-blank
													(Fortran is blank padded)*/
			if (pin == p && *pin == _TEXT(' ')) {
				/* found the terminating empty arg */
				break;
			}
			/* Keep track of the amount of space needed */
			arglen += (int)(pin - p) + 2;   /* add 1 for the null */
			/* Advance to the next entry in the array */
			p += (*v1) * d3;
		}

		/* argcnt is the number of provided arguments.
		   Allocate the necessary elements and copy, null terminating copies */
		pargs = (TCHAR **)MPIU_Malloc( (argcnt+1)*sizeof(TCHAR *) );
		pdata = (TCHAR *)MPIU_Malloc( arglen*sizeof(TCHAR) );
		p3[k] = pargs;
		pargs[argcnt] = 0;  /* Null terminate end */
		/* Copy each argument to consequtive locations in pdata,
		   and set the corresponding pointer entry */
		p = v3 + k * d3;
		for (i=0; i<argcnt; i++) {
			int j;
			TCHAR *pin;
			p3[k][i] = pdata;
			/* Move to the end and work back */
			pin = p + d3 - 1;
			while (*pin == _TEXT(' ') && pin > p) pin--;
			/* Copy and then null terminate */
			for (j=0; j<(pin-p)+1; j++) { *pdata++ = p[j]; }
			*pdata++ = 0;
			/* Advance to the next entry in the array */
			p += (*v1) * d3;
		}
		/* Set the terminator */
		p3[k][i] = 0;
	   }
	}

	if (v9 == MPI_F_ERRCODES_IGNORE) { v9 = MPI_ERRCODES_IGNORE; }
	*ierr = MPI_Comm_spawn_multiple( *v1, p2, p3, v4, v5, *v6, (MPI_Comm)(*v7), (MPI_Comm *)(v8), (int *)v9 );
	MPIU_Free( p2[0] ); MPIU_Free( p2 );
	if (v3 != (TCHAR *)MPI_ARGVS_NULL) {
		int i;
		for (i=0; i <*v1; i++) {
			MPIU_Free( p3[i][0] );  /* Free space allocated to args */
			MPIU_Free( p3[i] );	   /* Free space allocated to arg array */
		}
		/* Free the array of arrays */
		MPIU_Free( p3 );
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_ssend_init_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Ssend_init( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6), (MPI_Request *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_ssend_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Ssend( v1, *v2, (MPI_Datatype)(*v3), *v4, *v5, (MPI_Comm)(*v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_startall_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Startall( *v1, (MPI_Request *)(v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_start_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Start( (MPI_Request *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_status_set_cancelled_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Status_set_cancelled( (MPI_Status *)(v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_status_set_elements_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Status_set_elements( (MPI_Status *)(v1), (MPI_Datatype)(*v2), *v3 );
}

/* mpierrs.h and mpierror.h for the error code creation */
#include "mpierrs.h"
#include <stdio.h>
#include "mpierror.h"

/* -- Begin Profiling Symbol Block for routine MPI_Status_c2f */
#if defined(USE_WEAK_SYMBOLS) && !defined(USE_ONLY_MPI_NAMES)
#if defined(HAVE_PRAGMA_WEAK)
#pragma weak MPI_Status_c2f = PMPI_Status_c2f
#elif defined(HAVE_PRAGMA_HP_SEC_DEF)
#pragma _HP_SECONDARY_DEF PMPI_Status_c2f MPI_Status_c2f
#elif defined(HAVE_PRAGMA_CRI_DUP)
#pragma _CRI duplicate MPI_Status_c2f as PMPI_Status_c2f
#endif
#endif
/* -- End Profiling Symbol Block */

/* Define MPICH_MPI_FROM_PMPI if weak symbols are not supported to build
   the MPI routines */
FORT_DLL_SPEC void FORT_CALL mpi_testall_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	int l3;

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v4 == MPI_F_STATUSES_IGNORE) { v4 = (MPI_Fint *)MPI_STATUSES_IGNORE; }
	*ierr = MPI_Testall( *v1, (MPI_Request *)(v2), &l3, (MPI_Status *)v4 );
	*v3 = MPIR_TO_FLOG(l3);
}

FORT_DLL_SPEC void FORT_CALL mpi_testany_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	int l3;
	int l4;

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v5 == MPI_F_STATUS_IGNORE) { v5 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Testany( *v1, (MPI_Request *)(v2),  &l3, &l4, (MPI_Status *)v5 );
	*v3 = (MPI_Fint)l3;
	if (l3 >= 0) *v3 = *v3 + 1;
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_test_cancelled_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	int l2;
	*ierr = MPI_Test_cancelled( (MPI_Status *)(v1), &l2 );
	*v2 = MPIR_TO_FLOG(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_test_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	int l2;

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v3 == MPI_F_STATUS_IGNORE) { v3 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Test( (MPI_Request *)(v1), &l2, (MPI_Status *)v3 );
	*v2 = MPIR_TO_FLOG(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_testsome_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v5 == MPI_F_STATUSES_IGNORE) { v5 = (MPI_Fint *)MPI_STATUSES_IGNORE; }
	*ierr = MPI_Testsome( *v1, (MPI_Request *)(v2), v3, v4, (MPI_Status *)v5 );

	{int li;
	 for (li=0; li<*v3; li++) {
		if (v4[li] >= 0) v4[li] += 1;
	 }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_topo_test_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Topo_test( (MPI_Comm)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_commit_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Type_commit( (MPI_Datatype *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_dup_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Type_dup( (MPI_Datatype)(*v1), (MPI_Datatype *)(v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_extent_ ( MPI_Fint *v1, MPI_Fint * v2, MPI_Fint *ierr ){
	MPI_Aint l2;
	*ierr = MPI_Type_extent( (MPI_Datatype)(*v1), &l2 );
	*v2 = (MPI_Fint)(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_type_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Type_free( (MPI_Datatype *)(v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_get_attr_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *v4, MPI_Fint *ierr ){
	void *attrv3;
	int l4;
	*ierr = MPI_Type_get_attr( (MPI_Datatype)(*v1), *v2, &attrv3, &l4 );

	if ((int)*ierr || !l4) {
		*(MPI_Aint*)v3 = 0;
	}
	else {
		*(MPI_Aint*)v3 = MPIU_PtrToAint(attrv3);
	}
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_type_hindexed_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint * v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	MPI_Aint *l3;

#ifdef HAVE_AINT_LARGER_THAN_FINT
	if (*v1 > 0) {
		int li;
		l3 = (MPI_Aint *)MPIU_Malloc( *v1 * sizeof(MPI_Aint) );
		for (li=0; li<*v1; li++)
			l3[li] = v3[li];
	}
	else l3 = 0;
#else
	l3 = v3;
#endif
	*ierr = MPI_Type_hindexed( *v1, v2, l3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );

#ifdef HAVE_AINT_LARGER_THAN_FINT
	if (l3) { MPIU_Free(l3); }
#endif
}

FORT_DLL_SPEC void FORT_CALL mpi_type_hvector_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint * v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	MPI_Aint l3;
	l3 = (MPI_Aint)*v3;
	*ierr = MPI_Type_hvector( *v1, *v2, l3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_indexed_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_indexed( *v1, v2, v3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_lb_ ( MPI_Fint *v1, MPI_Fint * v2, MPI_Fint *ierr ){
	MPI_Aint l2;
	*ierr = MPI_Type_lb( (MPI_Datatype)(*v1), &l2 );
	*v2 = (MPI_Fint)(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_type_match_size_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Type_match_size( *v1, *v2, (MPI_Datatype *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_size_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Type_size( (MPI_Datatype)(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_struct_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint * v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	MPI_Aint *l3;

#ifdef HAVE_AINT_LARGER_THAN_FINT
	if (*v1 > 0) {
		int li;
		l3 = (MPI_Aint *)MPIU_Malloc( *v1 * sizeof(MPI_Aint) );
		for (li=0; li<*v1; li++)
			l3[li] = v3[li];
	}
	else l3 = 0;
#else
	l3 = v3;
#endif
	*ierr = MPI_Type_struct( *v1, v2, l3, (MPI_Datatype *)(v4), (MPI_Datatype *)(v5) );

#ifdef HAVE_AINT_LARGER_THAN_FINT
	if (l3) { MPIU_Free(l3); }
#endif
}

FORT_DLL_SPEC void FORT_CALL mpi_type_ub_ ( MPI_Fint *v1, MPI_Fint * v2, MPI_Fint *ierr ){
	MPI_Aint l2;
	*ierr = MPI_Type_ub( (MPI_Datatype)(*v1), &l2 );
	*v2 = (MPI_Fint)(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_type_vector_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_vector( *v1, *v2, *v3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_hindexed_ ( MPI_Fint *v1, MPI_Fint v2[], MPI_Aint * v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_hindexed( *v1, v2, v3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_hvector_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Aint * v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_hvector( *v1, *v2, *v3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_indexed_block_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint v3[], MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_indexed_block( *v1, *v2, v3, (MPI_Datatype)(*v4), (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_contiguous_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Type_contiguous( *v1, (MPI_Datatype)(*v2), (MPI_Datatype *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_resized_ ( MPI_Fint *v1, MPI_Aint * v2, MPI_Aint * v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_resized( (MPI_Datatype)(*v1), *v2, *v3, (MPI_Datatype *)(v4) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_struct_ ( MPI_Fint *v1, MPI_Fint v2[], MPI_Aint * v3, MPI_Fint v4[], MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_struct( *v1, v2, v3, v4, (MPI_Datatype *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_subarray_ ( MPI_Fint *v1, MPI_Fint v2[], MPI_Fint v3[], MPI_Fint v4[], MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_subarray( *v1, v2, v3, v4, *v5, (MPI_Datatype)(*v6), (MPI_Datatype *)(v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_darray_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint v4[], MPI_Fint v5[], MPI_Fint v6[], MPI_Fint v7[], MPI_Fint *v8, MPI_Fint *v9, MPI_Fint *v10, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_darray( *v1, *v2, *v3, v4, v5, v6, v7, *v8, (MPI_Datatype)(*v9), (MPI_Datatype *)(v10) );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_delete_attr_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Type_delete_attr( (MPI_Datatype)(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_free_keyval_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Type_free_keyval( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_get_contents_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint v5[], MPI_Aint * v6, MPI_Fint v7[], MPI_Fint *ierr ){
	*ierr = MPI_Type_get_contents( (MPI_Datatype)(*v1), *v2, *v3, *v4, v5, v6, v7 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_get_envelope_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_Type_get_envelope( (MPI_Datatype)(*v1), v2, v3, v4, v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_get_extent_ ( MPI_Fint *v1, MPI_Aint * v2, MPI_Aint * v3, MPI_Fint *ierr ){
	*ierr = MPI_Type_get_extent( (MPI_Datatype)(*v1), v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_get_name_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *ierr FORT_END_LEN(d2) ){
	*ierr = MPI_Type_get_name( (MPI_Datatype)(*v1), v2, v3 );

	{TCHAR *p = v2;
		while (*p) p++;
		while ((p-v2) < d2) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_type_get_true_extent_ ( MPI_Fint *v1, MPI_Aint * v2, MPI_Aint * v3, MPI_Fint *ierr ){
	*ierr = MPI_Type_get_true_extent( (MPI_Datatype)(*v1), v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_create_keyval_ ( MPI_Type_copy_attr_function*v1, MPI_Type_delete_attr_function*v2, MPI_Fint *v3, void*v4, MPI_Fint *ierr ){
	*ierr = MPI_Type_create_keyval( v1, v2, v3, v4 );

	if (*ierr == MPI_SUCCESS) {
		 MPIR_Keyval_set_fortran90( *v3 );
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_type_set_attr_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *ierr ){
	*ierr = MPI_Type_set_attr( (MPI_Datatype)(*v1), *v2, *(void **)v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_type_set_name_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Type_set_name( (MPI_Datatype)(*v1), p2 );
	MPIU_Free( p2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_unpack_external_ ( TCHAR *v1 FORT_MIXED_LEN(d1), void*v2, MPI_Aint * v3, MPI_Aint * v4, void*v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}
	*ierr = MPI_Unpack_external( p1, v2, *v3, v4, v5, *v6, (MPI_Datatype)(*v7) );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_unpack_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, void*v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *v7, MPI_Fint *ierr ){
	*ierr = MPI_Unpack( v1, *v2, v3, v4, *v5, (MPI_Datatype)(*v6), (MPI_Comm)(*v7) );
}

FORT_DLL_SPEC void FORT_CALL mpi_unpublish_name_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, TCHAR *v3 FORT_MIXED_LEN(d3), MPI_Fint *ierr FORT_END_LEN(d1) FORT_END_LEN(d3) ){
	TCHAR *p1;
	TCHAR *p3;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0;
	}

	{TCHAR *p = v3 + d3 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v3) p--;
		p++;
		p3 = (TCHAR *)MPIU_Malloc( (p-v3 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v3); li++) { p3[li] = v3[li]; }
		p3[li] = 0;
	}
	*ierr = MPI_Unpublish_name( p1, (MPI_Info)(*v2), p3 );
	MPIU_Free( p1 );
	MPIU_Free( p3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_waitall_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v3 == MPI_F_STATUSES_IGNORE) { v3 = (MPI_Fint *)MPI_STATUSES_IGNORE; }
	*ierr = MPI_Waitall( *v1, (MPI_Request *)(v2), (MPI_Status *)v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_waitany_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	int l3;

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v4 == MPI_F_STATUS_IGNORE) { v4 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Waitany( *v1, (MPI_Request *)(v2),  &l3, (MPI_Status *)v4 );
	*v3 = (MPI_Fint)l3;
	if (l3 >= 0) *v3 = *v3 + 1;
}

FORT_DLL_SPEC void FORT_CALL mpi_wait_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v2 == MPI_F_STATUS_IGNORE) { v2 = (MPI_Fint*)MPI_STATUS_IGNORE; }
	*ierr = MPI_Wait( (MPI_Request *)(v1), (MPI_Status *)v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_waitsome_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

	if (v5 == MPI_F_STATUSES_IGNORE) { v5 = (MPI_Fint *)MPI_STATUSES_IGNORE; }
	*ierr = MPI_Waitsome( *v1, (MPI_Request *)(v2), v3, v4, (MPI_Status *)v5 );

	{int li;
	 for (li=0; li<*v3; li++) {
		if (v4[li] >= 0) v4[li] += 1;
	 }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_win_complete_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Win_complete( *v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_create_ ( void*v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_Win_create( v1, *v2, *v3, (MPI_Info)(*v4), (MPI_Comm)(*v5), v6 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_fence_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_fence( *v1, *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_free_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Win_free( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_get_attr_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *v4, MPI_Fint *ierr ){
	void *attrv3;
	int l4;
	*ierr = MPI_Win_get_attr( *v1, *v2, &attrv3, &l4 );

	if ((int)*ierr || !l4) {
		*(MPI_Aint*)v3 = 0;
	}
	else {
		*(MPI_Aint*)v3 = MPIU_PtrToAint(attrv3);
	}
	*v4 = MPIR_TO_FLOG(l4);
}

FORT_DLL_SPEC void FORT_CALL mpi_win_get_group_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_get_group( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_get_name_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *ierr FORT_END_LEN(d2) ){
	*ierr = MPI_Win_get_name( *v1, v2, v3 );

	{TCHAR *p = v2;
		while (*p) p++;
		while ((p-v2) < d2) { *p++ = _TEXT(' '); }
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_win_lock_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_Win_lock( *v1, *v2, *v3, *v4 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_post_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Win_post( *v1, *v2, *v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_set_attr_ ( MPI_Fint *v1, MPI_Fint *v2, void*v3, MPI_Fint *ierr ){
	*ierr = MPI_Win_set_attr( *v1, *v2, *(void**)v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_set_name_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == _TEXT(' ') && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0;
	}
	*ierr = MPI_Win_set_name( *v1, p2 );
	MPIU_Free( p2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_start_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_Win_start( *v1, *v2, *v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_test_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_test( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_unlock_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_unlock( *v1, *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_wait_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Win_wait( *v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_call_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_call_errhandler( *v1, *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_create_errhandler_ ( MPI_Win_errhandler_fn*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_create_errhandler( v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_delete_attr_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_delete_attr( *v1, *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_free_keyval_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Win_free_keyval( v1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_get_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_get_errhandler( *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_win_create_keyval_ ( MPI_Win_copy_attr_function*v1, MPI_Win_delete_attr_function*v2, MPI_Fint *v3, void*v4, MPI_Fint *ierr ){
	*ierr = MPI_Win_create_keyval( v1, v2, v3, v4 );

	if (*ierr == MPI_SUCCESS) {
		 MPIR_Keyval_set_fortran90( *v3 );
	}
}

FORT_DLL_SPEC void FORT_CALL mpi_win_set_errhandler_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_Win_set_errhandler( *v1, *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_init_ ( MPI_Fint *ierr ){
#ifndef F77_RUNTIME_VALUES
	/* any compile/link time values go here */
#else
#   error "Fortran values must be determined at configure time"
#endif
	mpirinitf_(); MPIR_F_NeedInit = 0;
	*ierr = MPI_Init( 0, 0 );
}

FORT_DLL_SPEC void FORT_CALL mpi_address_ ( void*v1, MPI_Fint *v2, MPI_Fint *ierr ){
	MPI_Aint a, b;
	*ierr = MPI_Address( v1, &a );

	if (MPIR_F_NeedInit){ mpirinitf_(); MPIR_F_NeedInit = 0; }

#ifdef USE_POINTER_FOR_BOTTOM
	b = a;
#else
	//b = a - (MPI_Aint) MPIR_F_MPI_BOTTOM;
	b = a - MPIU_PtrToAint(MPIR_F_MPI_BOTTOM);
#endif
	*v2 = (MPI_Fint)( b );
#ifdef HAVE_AINT_LARGER_THAN_FINT
	/* Check for truncation */
	if ((MPI_Aint)*v2 - b != 0) {
		*ierr = MPIR_Err_create_code( MPI_SUCCESS, MPIR_ERR_RECOVERABLE, 
						  L"MPI_Address", __LINE__, MPI_ERR_ARG, L"**inttoosmall", 0 );
		(void)MPIR_Err_return_comm( 0, L"MPI_Address",  *ierr );
	}
#endif
}

FORT_DLL_SPEC void FORT_CALL mpi_file_close_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	MPI_File l1 = MPI_File_f2c(*v1);
	*ierr = MPI_File_close( &l1 );
	*v1 = MPI_File_c2f(l1);
}

FORT_DLL_SPEC void FORT_CALL mpi_file_delete_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Fint *v2, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == ' ' && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0; 
	}
	*ierr = MPI_File_delete( p1, (MPI_Info)(*v2) );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_amode_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_amode( MPI_File_f2c(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_atomicity_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	int l2;
	*ierr = MPI_File_get_atomicity( MPI_File_f2c(*v1), &l2 );
	*v2 = MPIR_TO_FLOG(l2);
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_byte_offset_ ( MPI_Fint *v1, MPI_Offset *v2, MPI_Offset*v3, MPI_Fint *ierr ){
	*ierr = MPI_File_get_byte_offset( MPI_File_f2c(*v1), *v2, v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_group_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_group( MPI_File_f2c(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_info_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_info( MPI_File_f2c(*v1), (MPI_Info *)(v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_position_ ( MPI_Fint *v1, MPI_Offset*v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_position( MPI_File_f2c(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_position_shared_ ( MPI_Fint *v1, MPI_Offset*v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_position_shared( MPI_File_f2c(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_size_ ( MPI_Fint *v1, MPI_Offset*v2, MPI_Fint *ierr ){
	*ierr = MPI_File_get_size( MPI_File_f2c(*v1), v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_type_extent_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_FAint * v3, MPI_Fint *ierr ){
	*ierr = MPI_File_get_type_extent( MPI_File_f2c(*v1), (MPI_Datatype)(*v2), v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_get_view_ ( MPI_Fint *v1, MPI_Offset*v2, MPI_Fint *v3, MPI_Fint *v4, TCHAR *v5 FORT_MIXED_LEN(d5), MPI_Fint *ierr FORT_END_LEN(d5) ){
	TCHAR *p5;
	p5 = (TCHAR *)MPIU_Malloc( (d5 + 1)*sizeof(TCHAR) );
	*ierr = MPI_File_get_view( MPI_File_f2c(*v1), v2, (MPI_Datatype *)(v3), (MPI_Datatype *)(v4), p5 );

	{TCHAR *p = v5, *pc=p5;
		while (*pc) {*p++ = *pc++;}
		while ((p-v5) < d5) { *p++ = ' '; }
	}
	MPIU_Free( p5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_iread_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPIO_Request*v5, MPI_Fint *ierr ){
	*ierr = MPI_File_iread( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_iread_at_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPIO_Request*v6, MPI_Fint *ierr ){
	*ierr = MPI_File_iread_at( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5), v6 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_iread_shared_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPIO_Request*v5, MPI_Fint *ierr ){
	*ierr = MPI_File_iread_shared( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_open_ ( MPI_Fint *v1, TCHAR *v2 FORT_MIXED_LEN(d2), MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr FORT_END_LEN(d2) ){
	TCHAR *p2;
	MPI_File l5;

	{TCHAR *p = v2 + d2 - 1;
	 int  li;
		while (*p == ' ' && p > v2) p--;
		p++;
		p2 = (TCHAR *)MPIU_Malloc( (p-v2 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v2); li++) { p2[li] = v2[li]; }
		p2[li] = 0; 
	}
	*ierr = MPI_File_open( (MPI_Comm)(*v1), p2, *v3, (MPI_Info)(*v4), &l5 );
	MPIU_Free( p2 );
	*v5 = MPI_File_c2f(l5);
}

FORT_DLL_SPEC void FORT_CALL mpi_file_preallocate_ ( MPI_Fint *v1, MPI_Offset *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_preallocate( MPI_File_f2c(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_read( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_all_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_read_all( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_all_begin_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_File_read_all_begin( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_all_end_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_read_all_end( MPI_File_f2c(*v1), v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_at_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_File_read_at( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5), (MPI_Status *)(v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_at_all_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_File_read_at_all( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5), (MPI_Status *)(v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_at_all_begin_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_read_at_all_begin( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_at_all_end_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_read_at_all_end( MPI_File_f2c(*v1), v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_ordered_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_read_ordered( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_ordered_begin_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_File_read_ordered_begin( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_ordered_end_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_read_ordered_end( MPI_File_f2c(*v1), v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_read_shared_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_read_shared( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_set_atomicity_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	int l2;
	l2 = MPIR_FROM_FLOG(*v2);
	*ierr = MPI_File_set_atomicity( MPI_File_f2c(*v1), l2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_set_info_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_set_info( MPI_File_f2c(*v1), (MPI_Info)(*v2) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_set_size_ ( MPI_Fint *v1, MPI_Offset *v2, MPI_Fint *ierr ){
	*ierr = MPI_File_set_size( MPI_File_f2c(*v1), *v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_set_view_ ( MPI_Fint *v1, MPI_Offset *v2, MPI_Fint *v3, MPI_Fint *v4, TCHAR *v5 FORT_MIXED_LEN(d5), MPI_Fint *v6, MPI_Fint *ierr FORT_END_LEN(d5) ){
	TCHAR *p5;

	{TCHAR *p = v5 + d5 - 1;
	 int  li;
		while (*p == ' ' && p > v5) p--;
		p++;
		p5 = (TCHAR *)MPIU_Malloc( (p-v5 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v5); li++) { p5[li] = v5[li]; }
		p5[li] = 0; 
	}
	*ierr = MPI_File_set_view( MPI_File_f2c(*v1), *v2, (MPI_Datatype)(*v3), (MPI_Datatype)(*v4), p5, (MPI_Info)(*v6) );
	MPIU_Free( p5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_sync_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_File_sync( MPI_File_f2c(*v1) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_write( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_all_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_write_all( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_all_begin_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_File_write_all_begin( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_all_end_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_write_all_end( MPI_File_f2c(*v1), v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_at_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_File_write_at( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5), (MPI_Status *)(v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_at_all_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *v6, MPI_Fint *ierr ){
	*ierr = MPI_File_write_at_all( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5), (MPI_Status *)(v6) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_at_all_begin_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_write_at_all_begin( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_at_all_end_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_write_at_all_end( MPI_File_f2c(*v1), v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_ordered_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_write_ordered( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_ordered_begin_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *ierr ){
	*ierr = MPI_File_write_ordered_begin( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_ordered_end_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_write_ordered_end( MPI_File_f2c(*v1), v2, (MPI_Status *)(v3) );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_write_shared_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPI_Fint *v5, MPI_Fint *ierr ){
	*ierr = MPI_File_write_shared( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), (MPI_Status *)(v5) );
}

FORT_DLL_SPEC void FORT_CALL mpi_get_address_ ( void*v1, MPI_Aint*v2, MPI_Fint *ierr ){
	MPI_Aint a;
	*ierr = MPI_Get_address( v1, &a );

#ifndef USE_POINTER_FOR_BOTTOM
	//a = a - (MPI_Aint) MPIR_F_MPI_BOTTOM;
	a = a - MPIU_PtrToAint(MPIR_F_MPI_BOTTOM);
#endif
	*v2 =  a;
}

FORT_DLL_SPEC void FORT_CALL mpi_init_thread_ ( MPI_Fint *v1, MPI_Fint *v2, MPI_Fint *ierr ){
	mpirinitf_(); MPIR_F_NeedInit = 0;
	*ierr = MPI_Init_thread( 0, 0, *v1, v2 );
}

FORT_DLL_SPEC void FORT_CALL mpi_keyval_create_ ( MPI_Copy_function v1, MPI_Delete_function v2, MPI_Fint *v3, void*v4, MPI_Fint *ierr ){
		*ierr = MPI_Comm_create_keyval( v1, v2, v3, v4 );
		if (!*ierr) {
			MPIR_Keyval_set_fortran( *v3 );
		}
}

FORT_DLL_SPEC void FORT_CALL mpi_null_copy_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, void*v5, MPI_Fint *v6, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
		*v6 = MPIR_TO_FLOG(0);
}

FORT_DLL_SPEC void FORT_CALL mpi_null_delete_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_pcontrol_ ( MPI_Fint *v1, MPI_Fint *ierr ){
	*ierr = MPI_Pcontrol( (int)*v1 );
}

#ifndef MPICH_MPI_FROM_PMPI
/* This isn't a callable function */
FORT_DLL_SPEC int FORT_CALL mpi_conversion_fn_null_ ( void*v1, MPI_Fint*v2, MPI_Fint*v3, void*v4, MPI_Offset*v5, MPI_Fint *v6, MPI_Fint*v7, MPI_Fint *ierr ) {
	return 0;
}
#endif

FORT_DLL_SPEC void FORT_CALL mpi_register_datarep_ ( TCHAR *v1 FORT_MIXED_LEN(d1), MPI_Datarep_conversion_function*v2, MPI_Datarep_conversion_function*v3, MPI_Datarep_extent_function*v4, void*v5, MPI_Fint *ierr FORT_END_LEN(d1) ){
	TCHAR *p1;

	{TCHAR *p = v1 + d1 - 1;
	 int  li;
		while (*p == ' ' && p > v1) p--;
		p++;
		p1 = (TCHAR *)MPIU_Malloc( (p-v1 + 1)*sizeof(TCHAR) );
		for (li=0; li<(p-v1); li++) { p1[li] = v1[li]; }
		p1[li] = 0; 
	}

	if (v2 == (MPI_Datarep_conversion_function *)mpi_conversion_fn_null_){
		 v2 = 0;
	}

	if (v3 == (MPI_Datarep_conversion_function *)mpi_conversion_fn_null_){
		 v3 = 0;
	}
	*ierr = MPI_Register_datarep( p1, v2, v3, v4, v5 );
	MPIU_Free( p1 );
}

FORT_DLL_SPEC double FORT_CALL mpi_wtick_ ( void ) {
	double d; 
	d = MPID_Wtick( );
	return d;
}

FORT_DLL_SPEC double FORT_CALL mpi_wtime_ ( void ) {
	double d; MPID_Time_t t;

	MPID_Wtime( &t );
	MPID_Wtime_todouble( &t, &d );
	return d;
}

FORT_DLL_SPEC void FORT_CALL mpi_file_iwrite_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPIO_Request*v5, MPI_Fint *ierr ){
	*ierr = MPI_File_iwrite( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_iwrite_at_ ( MPI_Fint *v1, MPI_Offset *v2, void*v3, MPI_Fint *v4, MPI_Fint *v5, MPIO_Request*v6, MPI_Fint *ierr ){
	*ierr = MPI_File_iwrite_at( MPI_File_f2c(*v1), *v2, v3, *v4, (MPI_Datatype)(*v5), v6 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_iwrite_shared_ ( MPI_Fint *v1, void*v2, MPI_Fint *v3, MPI_Fint *v4, MPIO_Request*v5, MPI_Fint *ierr ){
	*ierr = MPI_File_iwrite_shared( MPI_File_f2c(*v1), v2, *v3, (MPI_Datatype)(*v4), v5 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_seek_ ( MPI_Fint *v1, MPI_Offset *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_seek( MPI_File_f2c(*v1), *v2, *v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_file_seek_shared_ ( MPI_Fint *v1, MPI_Offset *v2, MPI_Fint *v3, MPI_Fint *ierr ){
	*ierr = MPI_File_seek_shared( MPI_File_f2c(*v1), *v2, *v3 );
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_dup_fn_ ( MPI_Fint v1, MPI_Fint*v2, void*v3, void**v4, void**v5, MPI_Fint*v6, MPI_Fint *ierr ){
		*v5 = *v4;
		*v6 = MPIR_TO_FLOG(1);
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_type_dup_fn_ ( MPI_Fint v1, MPI_Fint*v2, void*v3, void**v4, void**v5, MPI_Fint*v6, MPI_Fint *ierr ){
		*v5 = *v4;
		*v6 = MPIR_TO_FLOG(1);
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_win_dup_fn_ ( MPI_Fint v1, MPI_Fint*v2, void*v3, void**v4, void**v5, MPI_Fint*v6, MPI_Fint *ierr ){
		*v5 = *v4;
		*v6 = MPIR_TO_FLOG(1);
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_dup_fn_ ( MPI_Fint v1, MPI_Fint*v2, void*v3, void**v4, void**v5, MPI_Fint*v6, MPI_Fint *ierr ){
		*v5 = *v4;
		*v6 = MPIR_TO_FLOG(1);
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_null_copy_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, void*v5, MPI_Fint *v6, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
		*v6 = MPIR_TO_FLOG(0);
}

FORT_DLL_SPEC void FORT_CALL mpi_comm_null_delete_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_type_null_copy_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, void*v5, MPI_Fint *v6, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
		*v6 = MPIR_TO_FLOG(0);
}

FORT_DLL_SPEC void FORT_CALL mpi_type_null_delete_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
}

FORT_DLL_SPEC void FORT_CALL mpi_win_null_copy_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, void*v5, MPI_Fint *v6, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
		*v6 = MPIR_TO_FLOG(0);
}

FORT_DLL_SPEC void FORT_CALL mpi_win_null_delete_fn_ ( MPI_Fint*v1, MPI_Fint*v2, void*v3, void*v4, MPI_Fint *ierr ){
		*ierr = MPI_SUCCESS;
}
