/*   Copyright (C) 2009 Deino Software. */

typedef struct msgpair {
		const unsigned int sentinal1;
		const wchar_t *short_name, *long_name; 
		const unsigned int sentinal2; } msgpair;
#if MPICH_ERROR_MSG_LEVEL > MPICH_ERROR_MSG_NONE
/* The names are in sorted order, allowing the use of a simple
  linear search or bisection algorithm to find the message corresponding to
  a particular message */
static const wchar_t short_gen0[] = L"**CreateFileMapping";
static const wchar_t long_gen0[]  = L"CreateFileMapping failed";
static const wchar_t short_gen1[] = L"**CreateThread";
static const wchar_t long_gen1[]  = L"CreateThread failed";
static const wchar_t short_gen2[] = L"**FindWindowEx";
static const wchar_t long_gen2[]  = L"FindWindowEx failed";
static const wchar_t short_gen3[] = L"**MPIDI_CH3I_SHM_Attach_to_mem";
static const wchar_t long_gen3[]  = L"MPIDI_CH3I_SHM_Attach_to_mem failed";
static const wchar_t short_gen4[] = L"**MPIU_Strdup";
static const wchar_t long_gen4[]  = L"MPIU_Strdup failed";
static const wchar_t short_gen5[] = L"**MPIU_Wcsncpy";
static const wchar_t long_gen5[]  = L"wide string copy failed";
static const wchar_t short_gen6[] = L"**MapViewOfFileEx";
static const wchar_t long_gen6[]  = L"MapViewOfFileEx failed";
static const wchar_t short_gen7[] = L"**OpenProcess";
static const wchar_t long_gen7[]  = L"OpenProcess failed";
static const wchar_t short_gen8[] = L"**_snwprintf";
static const wchar_t long_gen8[]  = L"wide string printf failed";
static const wchar_t short_gen9[] = L"**afinetinvalid";
static const wchar_t long_gen9[]  = L"Network type AF_INET invalid in call to inet_pton";
static const wchar_t short_gen10[] = L"**allocmem";
static const wchar_t long_gen10[]  = L"Unable to allocate memory for MPI_Alloc_mem";
static const wchar_t short_gen11[] = L"**arg";
static const wchar_t long_gen11[]  = L"Invalid argument";
static const wchar_t short_gen12[] = L"**argarray";
static const wchar_t long_gen12[]  = L"Invalid value in array";
static const wchar_t short_gen13[] = L"**argarrayneg";
static const wchar_t long_gen13[]  = L"Negative value in array ";
static const wchar_t short_gen14[] = L"**argerrcode";
static const wchar_t long_gen14[]  = L"Invalid error code";
static const wchar_t short_gen15[] = L"**argneg";
static const wchar_t long_gen15[]  = L"Invalid argument; must be non-negative";
static const wchar_t short_gen16[] = L"**argnonpos";
static const wchar_t long_gen16[]  = L"Invalid argument; must be positive";
static const wchar_t short_gen17[] = L"**argrange";
static const wchar_t long_gen17[]  = L"Argument is not within valid range";
static const wchar_t short_gen18[] = L"**argstr_hostd";
static const wchar_t long_gen18[]  = L"no space for the host description";
static const wchar_t short_gen19[] = L"**argstr_missinghost";
static const wchar_t long_gen19[]  = L"Missing hostname or invalid host/port description in business card";
static const wchar_t short_gen20[] = L"**argstr_missingport";
static const wchar_t long_gen20[]  = L"Missing port or invalid host/port description in business card";
static const wchar_t short_gen21[] = L"**argstr_port";
static const wchar_t long_gen21[]  = L"no space for the listener port";
static const wchar_t short_gen22[] = L"**argstr_port_name_tag";
static const wchar_t long_gen22[]  = L"no space for port_name tag";
static const wchar_t short_gen23[] = L"**argstr_shmhost";
static const wchar_t long_gen23[]  = L"no space for the host name";
static const wchar_t short_gen24[] = L"**argstr_shmpid";
static const wchar_t long_gen24[]  = L"no process id in the business card";
static const wchar_t short_gen25[] = L"**argstr_shmq";
static const wchar_t long_gen25[]  = L"no space for the shared memory queue name";
static const wchar_t short_gen26[] = L"**assert";
static const wchar_t long_gen26[]  = L"Invalid assert argument";
static const wchar_t short_gen27[] = L"**attach_to_mem";
static const wchar_t long_gen27[]  = L"attach to shared memory segment failed";
static const wchar_t short_gen28[] = L"**attrnotptr";
static const wchar_t long_gen28[]  = L"The attribute value is not the address of a pointer or pointer-sized integer.  A common error is to pass the address of an integer to any of the MPI_Xxx_get_attr routines on systems where the size of a pointer is larger than the size of an integer.";
static const wchar_t short_gen29[] = L"**attrsentinal";
static const wchar_t long_gen29[]  = L"Internal fields in an attribute have been overwritten; possible errors in using the attribute value in user code.";
static const wchar_t short_gen30[] = L"**bad_listenersock";
static const wchar_t long_gen30[]  = L"bad listener sock";
static const wchar_t short_gen31[] = L"**bad_set";
static const wchar_t long_gen31[]  = L"bad set parameter";
static const wchar_t short_gen32[] = L"**bad_sock";
static const wchar_t long_gen32[]  = L"bad sock";
static const wchar_t short_gen33[] = L"**badcase";
static const wchar_t long_gen33[]  = L"INTERNAL ERROR: unexpected value in case statement";
static const wchar_t short_gen34[] = L"**base";
static const wchar_t long_gen34[]  = L"Invalid base address";
static const wchar_t short_gen35[] = L"**boot_create";
static const wchar_t long_gen35[]  = L"unable to create a bootstrap message queue";
static const wchar_t short_gen36[] = L"**boot_detach";
static const wchar_t long_gen36[]  = L"detaching from message queue failed";
static const wchar_t short_gen37[] = L"**boot_recv";
static const wchar_t long_gen37[]  = L"receiving bootstrap message failed";
static const wchar_t short_gen38[] = L"**boot_send";
static const wchar_t long_gen38[]  = L"sending bootstrap message failed";
static const wchar_t short_gen39[] = L"**boot_unlink";
static const wchar_t long_gen39[]  = L"unable to unlink the shared memory message queue";
static const wchar_t short_gen40[] = L"**bootqmsg";
static const wchar_t long_gen40[]  = L"invalid bootstrap queue message size";
static const wchar_t short_gen41[] = L"**bsendbufsmall";
static const wchar_t long_gen41[]  = L"Buffer size is smaller than MPI_BSEND_OVERHEAD";
static const wchar_t short_gen42[] = L"**bsendnobuf";
static const wchar_t long_gen42[]  = L"No buffer to detach. ";
static const wchar_t short_gen43[] = L"**buf_inplace";
static const wchar_t long_gen43[]  = L"buffer cannot be MPI_IN_PLACE";
static const wchar_t short_gen44[] = L"**bufalias";
static const wchar_t long_gen44[]  = L"Buffers must not be aliased";
static const wchar_t short_gen45[] = L"**bufbsend";
static const wchar_t long_gen45[]  = L"Insufficient space in Bsend buffer";
static const wchar_t short_gen46[] = L"**bufexists";
static const wchar_t long_gen46[]  = L"Buffer already attached with MPI_BUFFER_ATTACH.";
static const wchar_t short_gen47[] = L"**buffer";
static const wchar_t long_gen47[]  = L"Invalid buffer pointer";
static const wchar_t short_gen48[] = L"**bufnull";
static const wchar_t long_gen48[]  = L"Null buffer pointer";
static const wchar_t short_gen49[] = L"**buscard";
static const wchar_t long_gen49[]  = L"unable to create a business card";
static const wchar_t short_gen50[] = L"**buscard_len";
static const wchar_t long_gen50[]  = L"no space left in the business card to add a parameter";
static const wchar_t short_gen51[] = L"**business_card";
static const wchar_t long_gen51[]  = L"Invalid business card";
static const wchar_t short_gen52[] = L"**ca_guids";
static const wchar_t long_gen52[]  = L"unable to get the guids from the infiniband access layer";
static const wchar_t short_gen53[] = L"**cancelunknown";
static const wchar_t long_gen53[]  = L"Attempt to cancel an unknown type of request";
static const wchar_t short_gen54[] = L"**cartcoordinvalid";
static const wchar_t long_gen54[]  = L"Cartesian coordinate is invalid (not in range)";
static const wchar_t short_gen55[] = L"**cartdim";
static const wchar_t long_gen55[]  = L"Size of Cartesian grid is larger than the size of the communicator";
static const wchar_t short_gen56[] = L"**ch3|badca";
static const wchar_t long_gen56[]  = L"specified completion action in not known";
static const wchar_t short_gen57[] = L"**ch3|badmsgtype";
static const wchar_t long_gen57[]  = L"request contained an invalid message type";
static const wchar_t short_gen58[] = L"**ch3|badreqtype";
static const wchar_t long_gen58[]  = L"request contained an invalid request type";
static const wchar_t short_gen59[] = L"**ch3|canceleager";
static const wchar_t long_gen59[]  = L"failure occurred while performing local cancellation of a eager message";
static const wchar_t short_gen60[] = L"**ch3|cancelreq";
static const wchar_t long_gen60[]  = L"failure occurred while sending remote cancellation request packet";
static const wchar_t short_gen61[] = L"**ch3|cancelresp";
static const wchar_t long_gen61[]  = L"failure occurred while attempting to send cancel response packet";
static const wchar_t short_gen62[] = L"**ch3|cancelrndv";
static const wchar_t long_gen62[]  = L"failure occurred while performing local cancellation of a rendezvous message";
static const wchar_t short_gen63[] = L"**ch3|ch3_init";
static const wchar_t long_gen63[]  = L"channel initialization failed";
static const wchar_t short_gen64[] = L"**ch3|close_progress";
static const wchar_t long_gen64[]  = L"an error occurred while the device was waiting for all open connections to close";
static const wchar_t short_gen65[] = L"**ch3|conn_parent";
static const wchar_t long_gen65[]  = L"spawned process group was unable to connect back to the parent";
static const wchar_t short_gen66[] = L"**ch3|ctspkt";
static const wchar_t long_gen66[]  = L"failure occurred while attempting to send CTS packet";
static const wchar_t short_gen67[] = L"**ch3|eagermsg";
static const wchar_t long_gen67[]  = L"failure occurred while attempting to send an eager message";
static const wchar_t short_gen68[] = L"**ch3|flowcntlpkt";
static const wchar_t long_gen68[]  = L"UNIMPLEMENTED: unable to handle flow control packets";
static const wchar_t short_gen69[] = L"**ch3|get_parent_port";
static const wchar_t long_gen69[]  = L"spawn process group was unable to obtain parent port name from the channel";
static const wchar_t short_gen70[] = L"**ch3|loadrecviov";
static const wchar_t long_gen70[]  = L"failure occurred while loading the receive I/O vector";
static const wchar_t short_gen71[] = L"**ch3|loadsendiov";
static const wchar_t long_gen71[]  = L"failure occurred while loading the send I/O vector";
static const wchar_t short_gen72[] = L"**ch3|nopktcontainermem";
static const wchar_t long_gen72[]  = L"failed to allocate memory for a packet reorder container";
static const wchar_t short_gen73[] = L"**ch3|ooocancelreq";
static const wchar_t long_gen73[]  = L"UNIMPLEMENTED: unable to process out-of-order cancellation requests";
static const wchar_t short_gen74[] = L"**ch3|pktordered";
static const wchar_t long_gen74[]  = L"failure occurred while processing a reordered packet";
static const wchar_t short_gen75[] = L"**ch3|postrecv";
static const wchar_t long_gen75[]  = L"failure occurred while posting a receive for message data";
static const wchar_t short_gen76[] = L"**ch3|rmamsg";
static const wchar_t long_gen76[]  = L"failure occurred while attempting to send an RMA message";
static const wchar_t short_gen77[] = L"**ch3|rtspkt";
static const wchar_t long_gen77[]  = L"failure occurred while attempting to send RTS packet";
static const wchar_t short_gen78[] = L"**ch3|send_close_ack";
static const wchar_t long_gen78[]  = L"an error occurred when the device attempted to acknowledge the closing of a connection";
static const wchar_t short_gen79[] = L"**ch3|senddata";
static const wchar_t long_gen79[]  = L"failure occurred while attempting to send message data";
static const wchar_t short_gen80[] = L"**ch3|sock|accept";
static const wchar_t long_gen80[]  = L"[ch3:sock] accepting a new connection failed";
static const wchar_t short_gen81[] = L"**ch3|sock|addrinuse";
static const wchar_t long_gen81[]  = L"[ch3:sock] tcp port already in use";
static const wchar_t short_gen82[] = L"**ch3|sock|badhost";
static const wchar_t long_gen82[]  = L"[ch3:soc] invalid host description";
static const wchar_t short_gen83[] = L"**ch3|sock|badpacket";
static const wchar_t long_gen83[]  = L"[ch3:sock] received packet of unknow type";
static const wchar_t short_gen84[] = L"**ch3|sock|badsock";
static const wchar_t long_gen84[]  = L"[ch3:sock] internal error - bad sock";
static const wchar_t short_gen85[] = L"**ch3|sock|connalloc";
static const wchar_t long_gen85[]  = L"[ch3:sock] unable to allocate an internal connection structure";
static const wchar_t short_gen86[] = L"**ch3|sock|connclose";
static const wchar_t long_gen86[]  = L"[ch3:sock] active connection unexpectedly closed";
static const wchar_t short_gen87[] = L"**ch3|sock|connfailed";
static const wchar_t long_gen87[]  = L"[ch3:sock] failed to connnect to remote process";
static const wchar_t short_gen88[] = L"**ch3|sock|connrefused";
static const wchar_t long_gen88[]  = L"[ch3:sock] connection refused";
static const wchar_t short_gen89[] = L"**ch3|sock|connterm";
static const wchar_t long_gen89[]  = L"[ch3:sock] active connection unexpectedly terminated";
static const wchar_t short_gen90[] = L"**ch3|sock|failure";
static const wchar_t long_gen90[]  = L"[ch3:sock] unknown failure";
static const wchar_t short_gen91[] = L"**ch3|sock|handle_sock_event";
static const wchar_t long_gen91[]  = L"an error occurred while handling an event returned by MPIDU_Sock_Wait()";
static const wchar_t short_gen92[] = L"**ch3|sock|hostlookup";
static const wchar_t long_gen92[]  = L"[ch3:sock] hostname lookup failed";
static const wchar_t short_gen93[] = L"**ch3|sock|immedread";
static const wchar_t long_gen93[]  = L"immediate read operation failed";
static const wchar_t short_gen94[] = L"**ch3|sock|immedwrite";
static const wchar_t long_gen94[]  = L"immediate write operation failed";
static const wchar_t short_gen95[] = L"**ch3|sock|open_lrecv_data";
static const wchar_t long_gen95[]  = L"[ch3:sock] failed to handle open lrecv data packet";
static const wchar_t short_gen96[] = L"**ch3|sock|openlsend";
static const wchar_t long_gen96[]  = L"[ch3:sock] failed to handle open lsend packet";
static const wchar_t short_gen97[] = L"**ch3|sock|postconnect";
static const wchar_t long_gen97[]  = L"[ch3:sock] post connect failed";
static const wchar_t short_gen98[] = L"**ch3|sock|postread";
static const wchar_t long_gen98[]  = L"attempt to post a read operation failed";
static const wchar_t short_gen99[] = L"**ch3|sock|postwrite";
static const wchar_t long_gen99[]  = L"attempt to post a write operation failed";
static const wchar_t short_gen100[] = L"**ch3|sock|scconnaccept";
static const wchar_t long_gen100[]  = L"[ch3:sock] failed to handle connection accept packet";
static const wchar_t short_gen101[] = L"**ch3|sock|scopenresp";
static const wchar_t long_gen101[]  = L"[ch3:sock] failed to handle open response packet";
static const wchar_t short_gen102[] = L"**ch3|syncack";
static const wchar_t long_gen102[]  = L"failure occurred while attempting to send eager synchronization packet";
static const wchar_t short_gen103[] = L"**ch3|unhandled_connection_state";
static const wchar_t long_gen103[]  = L"encountered an unexpected connection state";
static const wchar_t short_gen104[] = L"**ch3|unknownpkt";
static const wchar_t long_gen104[]  = L"received unknown packet type";
static const wchar_t short_gen105[] = L"**closesocket";
static const wchar_t long_gen105[]  = L"closesocket failed";
static const wchar_t short_gen106[] = L"**comm";
static const wchar_t long_gen106[]  = L"Invalid communicator";
static const wchar_t short_gen107[] = L"**commnotinter";
static const wchar_t long_gen107[]  = L"An intercommunicator is required but an intracommunicator was provided.";
static const wchar_t short_gen108[] = L"**commnotintra";
static const wchar_t long_gen108[]  = L"An intracommunicator is required but an intercommunicator was provided.";
static const wchar_t short_gen109[] = L"**commnull";
static const wchar_t long_gen109[]  = L"Null communicator";
static const wchar_t short_gen110[] = L"**commperm";
static const wchar_t long_gen110[]  = L"Cannot free permanent communicator";
static const wchar_t short_gen111[] = L"**connfailed";
static const wchar_t long_gen111[]  = L"Failed to connect to remote process";
static const wchar_t short_gen112[] = L"**conversion";
static const wchar_t long_gen112[]  = L"An error occurred in a user-defined data conversion function";
static const wchar_t short_gen113[] = L"**count";
static const wchar_t long_gen113[]  = L"Invalid count";
static const wchar_t short_gen114[] = L"**countneg";
static const wchar_t long_gen114[]  = L"Negative count";
static const wchar_t short_gen115[] = L"**darrayblock";
static const wchar_t long_gen115[]  = L"Value of m must be positive for block(m) distribution";
static const wchar_t short_gen116[] = L"**darrayblock2";
static const wchar_t long_gen116[]  = L"m * nprocs is less than array_size and is not valid for block(m) distribution (optional arguments: {m*nprocs}, {array_size} (int))";
static const wchar_t short_gen117[] = L"**darraycyclic";
static const wchar_t long_gen117[]  = L"Value of m must be positive for a cyclic(m) distribution";
static const wchar_t short_gen118[] = L"**darraydist";
static const wchar_t long_gen118[]  = L"For MPI_DISTRIBUTE_NONE, the number of processes in that dimension of the grid must be 1";
static const wchar_t short_gen119[] = L"**darrayunknown";
static const wchar_t long_gen119[]  = L"Unknown distribution type ";
static const wchar_t short_gen120[] = L"**datarepunsupported";
static const wchar_t long_gen120[]  = L"Unsupported datarep passed to MPI_File_set_view ";
static const wchar_t short_gen121[] = L"**datarepused";
static const wchar_t long_gen121[]  = L"The requested datarep name has already been specified to MPI_REGISTER_DATAREP";
static const wchar_t short_gen122[] = L"**desc_len";
static const wchar_t long_gen122[]  = L"host description buffer too small";
static const wchar_t short_gen123[] = L"**dev|pg_create";
static const wchar_t long_gen123[]  = L"unable to create a new process group";
static const wchar_t short_gen124[] = L"**dev|pg_finalize|list_not_empty";
static const wchar_t long_gen124[]  = L"process group list was not empty";
static const wchar_t short_gen125[] = L"**dev|pg_init";
static const wchar_t long_gen125[]  = L"unable to initialize the process group management module";
static const wchar_t short_gen126[] = L"**dev|selfsenddeadlock";
static const wchar_t long_gen126[]  = L"DEADLOCK: attempting to send a message to the local process without a prior matching receive";
static const wchar_t short_gen127[] = L"**dev|vcrt_create";
static const wchar_t long_gen127[]  = L"failed to a create VCRT";
static const wchar_t short_gen128[] = L"**dev|vcrt_get_ptr";
static const wchar_t long_gen128[]  = L"failed to get a pointer to VCR table";
static const wchar_t short_gen129[] = L"**dims";
static const wchar_t long_gen129[]  = L"Invalid dimension argument";
static const wchar_t short_gen130[] = L"**dimsmany";
static const wchar_t long_gen130[]  = L"Number of dimensions is too large ";
static const wchar_t short_gen131[] = L"**dimspartition";
static const wchar_t long_gen131[]  = L"Cannot partition nodes as requested ";
static const wchar_t short_gen132[] = L"**dtype";
static const wchar_t long_gen132[]  = L"Invalid datatype";
static const wchar_t short_gen133[] = L"**dtypecommit";
static const wchar_t long_gen133[]  = L"Datatype has not been committed ";
static const wchar_t short_gen134[] = L"**dtypemismatch";
static const wchar_t long_gen134[]  = L"Receiving data with a datatype whose signature does not match that of the sending datatype.";
static const wchar_t short_gen135[] = L"**dtypenull";
static const wchar_t long_gen135[]  = L"Null datatype";
static const wchar_t short_gen136[] = L"**dtypeperm";
static const wchar_t long_gen136[]  = L"Cannot free permanent data type ";
static const wchar_t short_gen137[] = L"**duphandle";
static const wchar_t long_gen137[]  = L"unable to duplicate a handle";
static const wchar_t short_gen138[] = L"**edgeoutrange";
static const wchar_t long_gen138[]  = L"Edge index in graph topology is out of range";
static const wchar_t short_gen139[] = L"**errhandlernull";
static const wchar_t long_gen139[]  = L"Null errhandler ";
static const wchar_t short_gen140[] = L"**errhandnotfile";
static const wchar_t long_gen140[]  = L"Error handler is not a file error handler";
static const wchar_t short_gen141[] = L"**errhandnotwin";
static const wchar_t long_gen141[]  = L"Error handler is not a win error handler";
static const wchar_t short_gen142[] = L"**f90typetoomany";
static const wchar_t long_gen142[]  = L"Too many requests for unnamed, predefined f90 types";
static const wchar_t short_gen143[] = L"**fail";
static const wchar_t long_gen143[]  = L"";
static const wchar_t short_gen144[] = L"**file";
static const wchar_t long_gen144[]  = L"Invalid MPI_File";
static const wchar_t short_gen145[] = L"**fileaccess";
static const wchar_t long_gen145[]  = L"Access denied to file";
static const wchar_t short_gen146[] = L"**fileamode";
static const wchar_t long_gen146[]  = L"Invalid amode value in MPI_File_open ";
static const wchar_t short_gen147[] = L"**fileamodeone";
static const wchar_t long_gen147[]  = L"Exactly one of MPI_MODE_RDONLY, MPI_MODE_WRONLY, or MPI_MODE_RDWR must be specified";
static const wchar_t short_gen148[] = L"**fileamoderead";
static const wchar_t long_gen148[]  = L"Cannot use MPI_MODE_CREATE or MPI_MODE_EXCL with MPI_MODE_RDONLY ";
static const wchar_t short_gen149[] = L"**fileamodeseq";
static const wchar_t long_gen149[]  = L"Cannot specify MPI_MODE_SEQUENTIAL with MPI_MODE_RDWR";
static const wchar_t short_gen150[] = L"**fileexist";
static const wchar_t long_gen150[]  = L"File exists";
static const wchar_t short_gen151[] = L"**fileinuse";
static const wchar_t long_gen151[]  = L"File in use by some process";
static const wchar_t short_gen152[] = L"**filename";
static const wchar_t long_gen152[]  = L"Invalid file name";
static const wchar_t short_gen153[] = L"**filenoexist";
static const wchar_t long_gen153[]  = L"File does not exist";
static const wchar_t short_gen154[] = L"**filenospace";
static const wchar_t long_gen154[]  = L"Not enough space for file ";
static const wchar_t short_gen155[] = L"**filenull";
static const wchar_t long_gen155[]  = L"Null MPI_File ";
static const wchar_t short_gen156[] = L"**fileopunsupported";
static const wchar_t long_gen156[]  = L"Unsupported file operation ";
static const wchar_t short_gen157[] = L"**filequota";
static const wchar_t long_gen157[]  = L"Quota exceeded for files";
static const wchar_t short_gen158[] = L"**filerdonly";
static const wchar_t long_gen158[]  = L"Read-only file or filesystem name";
static const wchar_t short_gen159[] = L"**finalize_boot";
static const wchar_t long_gen159[]  = L"destroying the message queue failed";
static const wchar_t short_gen160[] = L"**finalize_progress_finalize";
static const wchar_t long_gen160[]  = L"Progress finalize failed";
static const wchar_t short_gen161[] = L"**finalize_release_mem";
static const wchar_t long_gen161[]  = L"Release shared memory failed";
static const wchar_t short_gen162[] = L"**finalized";
static const wchar_t long_gen162[]  = L"MPI has already called MPI_Finalize";
static const wchar_t short_gen163[] = L"**finish_qp";
static const wchar_t long_gen163[]  = L"unable to establish a queue pair connection";
static const wchar_t short_gen164[] = L"**ftok";
static const wchar_t long_gen164[]  = L"failed to create a sysv key from a file name";
static const wchar_t short_gen165[] = L"**ftruncate";
static const wchar_t long_gen165[]  = L"unable to resize the shared memory object";
static const wchar_t short_gen166[] = L"**get_guids";
static const wchar_t long_gen166[]  = L"unable to get the guids for the infiniband channel adapter";
static const wchar_t short_gen167[] = L"**getinfo";
static const wchar_t long_gen167[]  = L"GetAddrInfo failed";
static const wchar_t short_gen168[] = L"**graphnnodes";
static const wchar_t long_gen168[]  = L"Number of graph nodes exceeds size of communicator.";
static const wchar_t short_gen169[] = L"**group";
static const wchar_t long_gen169[]  = L"Invalid group";
static const wchar_t short_gen170[] = L"**groupnotincomm";
static const wchar_t long_gen170[]  = L"Specified group is not within the communicator";
static const wchar_t short_gen171[] = L"**groupnull";
static const wchar_t long_gen171[]  = L"Null group";
static const wchar_t short_gen172[] = L"**handle_sock_op";
static const wchar_t long_gen172[]  = L"handle_sock_op failed";
static const wchar_t short_gen173[] = L"**handle_written";
static const wchar_t long_gen173[]  = L"unable to handle written data";
static const wchar_t short_gen174[] = L"**ibu_op";
static const wchar_t long_gen174[]  = L"invalid infiniband operation";
static const wchar_t short_gen175[] = L"**ibu_wait";
static const wchar_t long_gen175[]  = L"ibu_wait failed";
static const wchar_t short_gen176[] = L"**ibwrite";
static const wchar_t long_gen176[]  = L"infiniband write failed";
static const wchar_t short_gen177[] = L"**ifnameinvalid";
static const wchar_t long_gen177[]  = L"Interface name was invalid in call to inet_pton";
static const wchar_t short_gen178[] = L"**indexneg";
static const wchar_t long_gen178[]  = L"Index value in graph topology must be nonnegative";
static const wchar_t short_gen179[] = L"**indexnonmonotone";
static const wchar_t long_gen179[]  = L"Index values in graph topology must be monotone nondecreasing";
static const wchar_t short_gen180[] = L"**info";
static const wchar_t long_gen180[]  = L"Invalid MPI_Info";
static const wchar_t short_gen181[] = L"**infokey";
static const wchar_t long_gen181[]  = L"Invalid key for MPI_Info ";
static const wchar_t short_gen182[] = L"**infokeyempty";
static const wchar_t long_gen182[]  = L"Empty or blank key ";
static const wchar_t short_gen183[] = L"**infokeylong";
static const wchar_t long_gen183[]  = L"Key is too long";
static const wchar_t short_gen184[] = L"**infokeynull";
static const wchar_t long_gen184[]  = L"Null key";
static const wchar_t short_gen185[] = L"**infonkey";
static const wchar_t long_gen185[]  = L"Requested nth key does not exist";
static const wchar_t short_gen186[] = L"**infonokey";
static const wchar_t long_gen186[]  = L"MPI_Info key is not defined ";
static const wchar_t short_gen187[] = L"**infonull";
static const wchar_t long_gen187[]  = L"Null MPI_Info ";
static const wchar_t short_gen188[] = L"**infoval";
static const wchar_t long_gen188[]  = L"Invalid MPI_Info value ";
static const wchar_t short_gen189[] = L"**infovallong";
static const wchar_t long_gen189[]  = L"Value is too long ";
static const wchar_t short_gen190[] = L"**infovalnull";
static const wchar_t long_gen190[]  = L"Null value";
static const wchar_t short_gen191[] = L"**init";
static const wchar_t long_gen191[]  = L"Initialization failed";
static const wchar_t short_gen192[] = L"**init_buscard";
static const wchar_t long_gen192[]  = L"failed to get my business card";
static const wchar_t short_gen193[] = L"**init_description";
static const wchar_t long_gen193[]  = L"unable to get the host description";
static const wchar_t short_gen194[] = L"**init_getptr";
static const wchar_t long_gen194[]  = L"failed to get the vcr";
static const wchar_t short_gen195[] = L"**init_ibu";
static const wchar_t long_gen195[]  = L"infiniband initialization failed";
static const wchar_t short_gen196[] = L"**init_ibu_set";
static const wchar_t long_gen196[]  = L"unable to create an infinband completion queue";
static const wchar_t short_gen197[] = L"**init_progress";
static const wchar_t long_gen197[]  = L"progress_init failed";
static const wchar_t short_gen198[] = L"**init_rwproc";
static const wchar_t long_gen198[]  = L"Unable to initialize a process for reading and writing directly to that process's memory";
static const wchar_t short_gen199[] = L"**init_vcrt";
static const wchar_t long_gen199[]  = L"failed to create VCRT";
static const wchar_t short_gen200[] = L"**initialized";
static const wchar_t long_gen200[]  = L"MPI not initialized. Call MPI_Init or MPI_Init_thread first";
static const wchar_t short_gen201[] = L"**inittwice";
static const wchar_t long_gen201[]  = L"Cannot call MPI_INIT or MPI_INIT_THREAD more than once";
static const wchar_t short_gen202[] = L"**inpending";
static const wchar_t long_gen202[]  = L"Pending request (no error)";
static const wchar_t short_gen203[] = L"**instatus";
static const wchar_t long_gen203[]  = L"See the MPI_ERROR field in MPI_Status for the error code";
static const wchar_t short_gen204[] = L"**intern";
static const wchar_t long_gen204[]  = L"Internal MPI error!";
static const wchar_t short_gen205[] = L"**inttoosmall";
static const wchar_t long_gen205[]  = L"An address does not fit into a Fortran INTEGER.  Use MPI_Get_address instead";
static const wchar_t short_gen206[] = L"**invalid_handle";
static const wchar_t long_gen206[]  = L"invalid handle";
static const wchar_t short_gen207[] = L"**invalid_refcount";
static const wchar_t long_gen207[]  = L"invalid reference count";
static const wchar_t short_gen208[] = L"**io";
static const wchar_t long_gen208[]  = L"Other I/O error ";
static const wchar_t short_gen209[] = L"**ioagnomatch";
static const wchar_t long_gen209[]  = L"No aggregators match";
static const wchar_t short_gen210[] = L"**ioamodeseq";
static const wchar_t long_gen210[]  = L"Cannot use this function when the file is opened with amode MPI_MODE_SEQUENTIAL ";
static const wchar_t short_gen211[] = L"**ioasyncwaiting";
static const wchar_t long_gen211[]  = L"There are outstanding nonblocking I/O operations on this file";
static const wchar_t short_gen212[] = L"**iobaddisp";
static const wchar_t long_gen212[]  = L"Invalid displacement argument";
static const wchar_t short_gen213[] = L"**iobadfh";
static const wchar_t long_gen213[]  = L"Invalid file handle";
static const wchar_t short_gen214[] = L"**iobadoffset";
static const wchar_t long_gen214[]  = L"Invalid offset argument";
static const wchar_t short_gen215[] = L"**iobadsize";
static const wchar_t long_gen215[]  = L"Invalid size argument";
static const wchar_t short_gen216[] = L"**iobadwhence";
static const wchar_t long_gen216[]  = L"Invalid whence argument";
static const wchar_t short_gen217[] = L"**iocp";
static const wchar_t long_gen217[]  = L"unable to create an I/O completion port";
static const wchar_t short_gen218[] = L"**iodispifseq";
static const wchar_t long_gen218[]  = L"disp must be set to MPI_DISPLACEMENT_CURRENT since file was opened with MPI_MODE_SEQUENTIAL";
static const wchar_t short_gen219[] = L"**ioetype";
static const wchar_t long_gen219[]  = L"Only an integral number of etypes can be accessed";
static const wchar_t short_gen220[] = L"**iofiletype";
static const wchar_t long_gen220[]  = L"Filetype must be constructed out of one or more etypes";
static const wchar_t short_gen221[] = L"**iofstypeunsupported";
static const wchar_t long_gen221[]  = L"Specified filesystem is not available";
static const wchar_t short_gen222[] = L"**ionegoffset";
static const wchar_t long_gen222[]  = L"Negative offset argument";
static const wchar_t short_gen223[] = L"**iopreallocrdwr";
static const wchar_t long_gen223[]  = L"Must open file with MPI_MODE_RDWR to preallocate disk space";
static const wchar_t short_gen224[] = L"**iordonly";
static const wchar_t long_gen224[]  = L"Cannot write to a file opened with amode MPI_MODE_RDONLY";
static const wchar_t short_gen225[] = L"**iosequnsupported";
static const wchar_t long_gen225[]  = L"MPI_MODE_SEQUENTIAL not supported on this file system";
static const wchar_t short_gen226[] = L"**iosharedfailed";
static const wchar_t long_gen226[]  = L"Could not access shared file pointer";
static const wchar_t short_gen227[] = L"**iosharedunsupported";
static const wchar_t long_gen227[]  = L"Shared file pointers not supported";
static const wchar_t short_gen228[] = L"**iosplitcoll";
static const wchar_t long_gen228[]  = L"Only one active split collective I/O operation is allowed per file handle";
static const wchar_t short_gen229[] = L"**iosplitcollnone";
static const wchar_t long_gen229[]  = L"No split collective I/O operation is active";
static const wchar_t short_gen230[] = L"**iov_offset";
static const wchar_t long_gen230[]  = L"invalid iov offset";
static const wchar_t short_gen231[] = L"**iowronly";
static const wchar_t long_gen231[]  = L"Cannot read from a file opened with amode MPI_MODE_WRONLY";
static const wchar_t short_gen232[] = L"**join_portname";
static const wchar_t long_gen232[]  = L"local and remote port names are the same";
static const wchar_t short_gen233[] = L"**join_recv";
static const wchar_t long_gen233[]  = L"recv from the socket failed";
static const wchar_t short_gen234[] = L"**join_send";
static const wchar_t long_gen234[]  = L"send on the socket failed";
static const wchar_t short_gen235[] = L"**keyval";
static const wchar_t long_gen235[]  = L"Invalid keyval";
static const wchar_t short_gen236[] = L"**keyvalinvalid";
static const wchar_t long_gen236[]  = L"Attribute key was MPI_KEYVAL_INVALID";
static const wchar_t short_gen237[] = L"**keyvalobj";
static const wchar_t long_gen237[]  = L"Keyval was not defined for the supplied object";
static const wchar_t short_gen238[] = L"**listen";
static const wchar_t long_gen238[]  = L"listen failed";
static const wchar_t short_gen239[] = L"**locktype";
static const wchar_t long_gen239[]  = L"Invalid lock type";
static const wchar_t short_gen240[] = L"**mmap";
static const wchar_t long_gen240[]  = L"unable to map memory, mmap failed";
static const wchar_t short_gen241[] = L"**mpi_abort";
static const wchar_t long_gen241[]  = L"MPI_Abort failed";
static const wchar_t short_gen242[] = L"**mpi_accumulate";
static const wchar_t long_gen242[]  = L"MPI_Accumulate failed";
static const wchar_t short_gen243[] = L"**mpi_add_error_class";
static const wchar_t long_gen243[]  = L"MPI_Add_error_class failed";
static const wchar_t short_gen244[] = L"**mpi_add_error_code";
static const wchar_t long_gen244[]  = L"MPI_Add_error_code failed";
static const wchar_t short_gen245[] = L"**mpi_add_error_string";
static const wchar_t long_gen245[]  = L"MPI_Add_error_string failed";
static const wchar_t short_gen246[] = L"**mpi_address";
static const wchar_t long_gen246[]  = L"MPI_Address failed";
static const wchar_t short_gen247[] = L"**mpi_allgather";
static const wchar_t long_gen247[]  = L"MPI_Allgather failed";
static const wchar_t short_gen248[] = L"**mpi_allgatherv";
static const wchar_t long_gen248[]  = L"MPI_Allgatherv failed";
static const wchar_t short_gen249[] = L"**mpi_alloc_mem";
static const wchar_t long_gen249[]  = L"MPI_Alloc_mem failed";
static const wchar_t short_gen250[] = L"**mpi_allreduce";
static const wchar_t long_gen250[]  = L"MPI_Allreduce failed";
static const wchar_t short_gen251[] = L"**mpi_alltoall";
static const wchar_t long_gen251[]  = L"MPI_Alltoall failed";
static const wchar_t short_gen252[] = L"**mpi_alltoallv";
static const wchar_t long_gen252[]  = L"MPI_Alltoallv failed";
static const wchar_t short_gen253[] = L"**mpi_alltoallw";
static const wchar_t long_gen253[]  = L"MPI_Alltoallw failed";
static const wchar_t short_gen254[] = L"**mpi_attr_delete";
static const wchar_t long_gen254[]  = L"MPI_Attr_delete failed";
static const wchar_t short_gen255[] = L"**mpi_attr_get";
static const wchar_t long_gen255[]  = L"MPI_Attr_get failed";
static const wchar_t short_gen256[] = L"**mpi_attr_put";
static const wchar_t long_gen256[]  = L"MPI_Attr_put failed";
static const wchar_t short_gen257[] = L"**mpi_barrier";
static const wchar_t long_gen257[]  = L"MPI_Barrier failed";
static const wchar_t short_gen258[] = L"**mpi_bcast";
static const wchar_t long_gen258[]  = L"MPI_Bcast failed";
static const wchar_t short_gen259[] = L"**mpi_bsend";
static const wchar_t long_gen259[]  = L"MPI_Bsend failed";
static const wchar_t short_gen260[] = L"**mpi_bsend_init";
static const wchar_t long_gen260[]  = L"MPI_Bsend_init failed";
static const wchar_t short_gen261[] = L"**mpi_buffer_attach";
static const wchar_t long_gen261[]  = L"MPI_Buffer_attach failed";
static const wchar_t short_gen262[] = L"**mpi_buffer_detach";
static const wchar_t long_gen262[]  = L"MPI_Buffer_detach failed";
static const wchar_t short_gen263[] = L"**mpi_cancel";
static const wchar_t long_gen263[]  = L"MPI_Cancel failed";
static const wchar_t short_gen264[] = L"**mpi_cart_coords";
static const wchar_t long_gen264[]  = L"MPI_Cart_coords failed";
static const wchar_t short_gen265[] = L"**mpi_cart_create";
static const wchar_t long_gen265[]  = L"MPI_Cart_create failed";
static const wchar_t short_gen266[] = L"**mpi_cart_get";
static const wchar_t long_gen266[]  = L"MPI_Cart_get failed";
static const wchar_t short_gen267[] = L"**mpi_cart_map";
static const wchar_t long_gen267[]  = L"MPI_Cart_map failed";
static const wchar_t short_gen268[] = L"**mpi_cart_rank";
static const wchar_t long_gen268[]  = L"MPI_Cart_rank failed";
static const wchar_t short_gen269[] = L"**mpi_cart_shift";
static const wchar_t long_gen269[]  = L"MPI_Cart_shift failed";
static const wchar_t short_gen270[] = L"**mpi_cart_sub";
static const wchar_t long_gen270[]  = L"MPI_Cart_sub failed";
static const wchar_t short_gen271[] = L"**mpi_cartdim_get";
static const wchar_t long_gen271[]  = L"MPI_Cartdim_get failed";
static const wchar_t short_gen272[] = L"**mpi_close_port";
static const wchar_t long_gen272[]  = L"MPI_Close_port failed";
static const wchar_t short_gen273[] = L"**mpi_comm_accept";
static const wchar_t long_gen273[]  = L"MPI_Comm_accept failed";
static const wchar_t short_gen274[] = L"**mpi_comm_call_errhandler";
static const wchar_t long_gen274[]  = L"MPI_Comm_call_errhandler failed";
static const wchar_t short_gen275[] = L"**mpi_comm_compare";
static const wchar_t long_gen275[]  = L"MPI_Comm_compare failed";
static const wchar_t short_gen276[] = L"**mpi_comm_connect";
static const wchar_t long_gen276[]  = L"MPI_Comm_connect failed";
static const wchar_t short_gen277[] = L"**mpi_comm_create";
static const wchar_t long_gen277[]  = L"MPI_Comm_create failed";
static const wchar_t short_gen278[] = L"**mpi_comm_create_errhandler";
static const wchar_t long_gen278[]  = L"MPI_Comm_create_errhandler failed";
static const wchar_t short_gen279[] = L"**mpi_comm_create_keyval";
static const wchar_t long_gen279[]  = L"MPI_Comm_create_keyval failed";
static const wchar_t short_gen280[] = L"**mpi_comm_delete_attr";
static const wchar_t long_gen280[]  = L"MPI_Comm_delete_attr failed";
static const wchar_t short_gen281[] = L"**mpi_comm_disconnect";
static const wchar_t long_gen281[]  = L"MPI_Comm_disconnect failed";
static const wchar_t short_gen282[] = L"**mpi_comm_dup";
static const wchar_t long_gen282[]  = L"MPI_Comm_dup failed";
static const wchar_t short_gen283[] = L"**mpi_comm_free";
static const wchar_t long_gen283[]  = L"MPI_Comm_free failed";
static const wchar_t short_gen284[] = L"**mpi_comm_free_keyval";
static const wchar_t long_gen284[]  = L"MPI_Comm_free_keyval failed";
static const wchar_t short_gen285[] = L"**mpi_comm_get_attr";
static const wchar_t long_gen285[]  = L"MPI_Comm_get_attr failed";
static const wchar_t short_gen286[] = L"**mpi_comm_get_errhandler";
static const wchar_t long_gen286[]  = L"MPI_Comm_get_errhandler failed";
static const wchar_t short_gen287[] = L"**mpi_comm_get_name";
static const wchar_t long_gen287[]  = L"MPI_Comm_get_name failed";
static const wchar_t short_gen288[] = L"**mpi_comm_get_parent";
static const wchar_t long_gen288[]  = L"MPI_Comm_get_parent failed";
static const wchar_t short_gen289[] = L"**mpi_comm_group";
static const wchar_t long_gen289[]  = L"MPI_Comm_group failed";
static const wchar_t short_gen290[] = L"**mpi_comm_join";
static const wchar_t long_gen290[]  = L"MPI_Comm_join failed";
static const wchar_t short_gen291[] = L"**mpi_comm_rank";
static const wchar_t long_gen291[]  = L"MPI_Comm_rank failed";
static const wchar_t short_gen292[] = L"**mpi_comm_remote_group";
static const wchar_t long_gen292[]  = L"MPI_Comm_remote_group failed";
static const wchar_t short_gen293[] = L"**mpi_comm_remote_size";
static const wchar_t long_gen293[]  = L"MPI_Comm_remote_size failed";
static const wchar_t short_gen294[] = L"**mpi_comm_set_attr";
static const wchar_t long_gen294[]  = L"MPI_Comm_set_attr failed";
static const wchar_t short_gen295[] = L"**mpi_comm_set_errhandler";
static const wchar_t long_gen295[]  = L"MPI_Comm_set_errhandler failed";
static const wchar_t short_gen296[] = L"**mpi_comm_set_name";
static const wchar_t long_gen296[]  = L"MPI_Comm_set_name failed";
static const wchar_t short_gen297[] = L"**mpi_comm_size";
static const wchar_t long_gen297[]  = L"MPI_Comm_size failed";
static const wchar_t short_gen298[] = L"**mpi_comm_spawn";
static const wchar_t long_gen298[]  = L"MPI_Comm_spawn failed";
static const wchar_t short_gen299[] = L"**mpi_comm_spawn_multiple";
static const wchar_t long_gen299[]  = L"MPI_Comm_spawn_multiple failed";
static const wchar_t short_gen300[] = L"**mpi_comm_split";
static const wchar_t long_gen300[]  = L"MPI_Comm_split failed";
static const wchar_t short_gen301[] = L"**mpi_comm_test_inter";
static const wchar_t long_gen301[]  = L"MPI_Comm_test_inter failed";
static const wchar_t short_gen302[] = L"**mpi_dims_create";
static const wchar_t long_gen302[]  = L"MPI_Dims_create failed";
static const wchar_t short_gen303[] = L"**mpi_errhandler_create";
static const wchar_t long_gen303[]  = L"MPI_Errhandler_create failed";
static const wchar_t short_gen304[] = L"**mpi_errhandler_free";
static const wchar_t long_gen304[]  = L"MPI_Errhandler_free failed";
static const wchar_t short_gen305[] = L"**mpi_errhandler_get";
static const wchar_t long_gen305[]  = L"MPI_Errhandler_get failed";
static const wchar_t short_gen306[] = L"**mpi_errhandler_set";
static const wchar_t long_gen306[]  = L"MPI_Errhandler_set failed";
static const wchar_t short_gen307[] = L"**mpi_error_class";
static const wchar_t long_gen307[]  = L"MPI_Error_class failed";
static const wchar_t short_gen308[] = L"**mpi_error_string";
static const wchar_t long_gen308[]  = L"MPI_Error_string failed";
static const wchar_t short_gen309[] = L"**mpi_exscan";
static const wchar_t long_gen309[]  = L"MPI_Exscan failed";
static const wchar_t short_gen310[] = L"**mpi_file_call_errhandler";
static const wchar_t long_gen310[]  = L"MPI_File_call_errhandler failed";
static const wchar_t short_gen311[] = L"**mpi_file_close";
static const wchar_t long_gen311[]  = L"MPI_File_clise failed";
static const wchar_t short_gen312[] = L"**mpi_file_create_errhandler";
static const wchar_t long_gen312[]  = L"MPI_File_create_errhandler failed";
static const wchar_t short_gen313[] = L"**mpi_file_delete";
static const wchar_t long_gen313[]  = L"MPI_File_delete failed";
static const wchar_t short_gen314[] = L"**mpi_file_get_amode";
static const wchar_t long_gen314[]  = L"MPI_File_get_amode failed";
static const wchar_t short_gen315[] = L"**mpi_file_get_atomicity";
static const wchar_t long_gen315[]  = L"MPI_File_get_atomicity failed";
static const wchar_t short_gen316[] = L"**mpi_file_get_byte_offset";
static const wchar_t long_gen316[]  = L"MPI_File_get_byte_offset failed";
static const wchar_t short_gen317[] = L"**mpi_file_get_errhandler";
static const wchar_t long_gen317[]  = L"MPI_File_get_errhandler failed";
static const wchar_t short_gen318[] = L"**mpi_file_get_group";
static const wchar_t long_gen318[]  = L"MPI_File_get_group failed";
static const wchar_t short_gen319[] = L"**mpi_file_get_info";
static const wchar_t long_gen319[]  = L"MPI_File_get_info failed";
static const wchar_t short_gen320[] = L"**mpi_file_get_position";
static const wchar_t long_gen320[]  = L"MPI_File_get_position failed";
static const wchar_t short_gen321[] = L"**mpi_file_get_position_shared";
static const wchar_t long_gen321[]  = L"MPI_File_get_position_shared failed";
static const wchar_t short_gen322[] = L"**mpi_file_get_size";
static const wchar_t long_gen322[]  = L"MPI_File_get_size failed";
static const wchar_t short_gen323[] = L"**mpi_file_get_type_extent";
static const wchar_t long_gen323[]  = L"MPI_File_get_type_extent failed";
static const wchar_t short_gen324[] = L"**mpi_file_get_view";
static const wchar_t long_gen324[]  = L"MPI_File_get_view failed";
static const wchar_t short_gen325[] = L"**mpi_file_iread";
static const wchar_t long_gen325[]  = L"MPI_File_iread failed";
static const wchar_t short_gen326[] = L"**mpi_file_iread_at";
static const wchar_t long_gen326[]  = L"MPI_File_iread_at failed";
static const wchar_t short_gen327[] = L"**mpi_file_iread_shared";
static const wchar_t long_gen327[]  = L"MPI_File_iread_shared failed";
static const wchar_t short_gen328[] = L"**mpi_file_iwrite";
static const wchar_t long_gen328[]  = L"MPI_File_iwrite failed";
static const wchar_t short_gen329[] = L"**mpi_file_iwrite_at";
static const wchar_t long_gen329[]  = L"MPI_File_iwrite_at failed";
static const wchar_t short_gen330[] = L"**mpi_file_iwrite_shared";
static const wchar_t long_gen330[]  = L"MPI_File_iwrite_shared failed";
static const wchar_t short_gen331[] = L"**mpi_file_open";
static const wchar_t long_gen331[]  = L"MPI_File_open failed";
static const wchar_t short_gen332[] = L"**mpi_file_preallocate";
static const wchar_t long_gen332[]  = L"MPI_File_preallocate failed";
static const wchar_t short_gen333[] = L"**mpi_file_read";
static const wchar_t long_gen333[]  = L"MPI_File_read failed";
static const wchar_t short_gen334[] = L"**mpi_file_read_all";
static const wchar_t long_gen334[]  = L"MPI_File_read_all failed";
static const wchar_t short_gen335[] = L"**mpi_file_read_all_begin";
static const wchar_t long_gen335[]  = L"MPI_File_read_all_begin failed";
static const wchar_t short_gen336[] = L"**mpi_file_read_all_end";
static const wchar_t long_gen336[]  = L"MPI_File_read_all_end failed";
static const wchar_t short_gen337[] = L"**mpi_file_read_at";
static const wchar_t long_gen337[]  = L"MPI_File_read_at failed";
static const wchar_t short_gen338[] = L"**mpi_file_read_at_all";
static const wchar_t long_gen338[]  = L"MPI_File_read_at_all failed";
static const wchar_t short_gen339[] = L"**mpi_file_read_at_all_begin";
static const wchar_t long_gen339[]  = L"MPI_File_read_at_all_begin failed";
static const wchar_t short_gen340[] = L"**mpi_file_read_at_all_end";
static const wchar_t long_gen340[]  = L"MPI_File_read_at_all_end failed";
static const wchar_t short_gen341[] = L"**mpi_file_read_ordered";
static const wchar_t long_gen341[]  = L"MPI_File_read_ordered failed";
static const wchar_t short_gen342[] = L"**mpi_file_read_ordered_begin";
static const wchar_t long_gen342[]  = L"MPI_File_read_ordered_begin failed";
static const wchar_t short_gen343[] = L"**mpi_file_read_ordered_end";
static const wchar_t long_gen343[]  = L"MPI_File_read_ordered_end failed";
static const wchar_t short_gen344[] = L"**mpi_file_read_shared";
static const wchar_t long_gen344[]  = L"MPI_File_read_shared failed";
static const wchar_t short_gen345[] = L"**mpi_file_seek";
static const wchar_t long_gen345[]  = L"MPI_File_seek failed";
static const wchar_t short_gen346[] = L"**mpi_file_seek_shared";
static const wchar_t long_gen346[]  = L"MPI_File_seek_shared failed";
static const wchar_t short_gen347[] = L"**mpi_file_set_atomicity";
static const wchar_t long_gen347[]  = L"MPI_File_set_atomicity failed";
static const wchar_t short_gen348[] = L"**mpi_file_set_errhandler";
static const wchar_t long_gen348[]  = L"MPI_File_set_errhandler failed";
static const wchar_t short_gen349[] = L"**mpi_file_set_info";
static const wchar_t long_gen349[]  = L"MPI_File_set_info failed";
static const wchar_t short_gen350[] = L"**mpi_file_set_size";
static const wchar_t long_gen350[]  = L"MPI_File_set_size failed";
static const wchar_t short_gen351[] = L"**mpi_file_set_view";
static const wchar_t long_gen351[]  = L"MPI_File_set_view failed";
static const wchar_t short_gen352[] = L"**mpi_file_sync";
static const wchar_t long_gen352[]  = L"MPI_File_sync failed";
static const wchar_t short_gen353[] = L"**mpi_file_write";
static const wchar_t long_gen353[]  = L"MPI_File_write failed";
static const wchar_t short_gen354[] = L"**mpi_file_write_all";
static const wchar_t long_gen354[]  = L"MPI_File_write_all failed";
static const wchar_t short_gen355[] = L"**mpi_file_write_all_begin";
static const wchar_t long_gen355[]  = L"MPI_File_write_all_begin failed";
static const wchar_t short_gen356[] = L"**mpi_file_write_all_end";
static const wchar_t long_gen356[]  = L"MPI_File_write_all_end failed";
static const wchar_t short_gen357[] = L"**mpi_file_write_at";
static const wchar_t long_gen357[]  = L"MPI_File_write_at failed";
static const wchar_t short_gen358[] = L"**mpi_file_write_at_all";
static const wchar_t long_gen358[]  = L"MPI_File_write_at_all failed";
static const wchar_t short_gen359[] = L"**mpi_file_write_at_all_begin";
static const wchar_t long_gen359[]  = L"MPI_File_write_at_all_begin failed";
static const wchar_t short_gen360[] = L"**mpi_file_write_at_all_end";
static const wchar_t long_gen360[]  = L"MPI_File_write_at_all_end failed";
static const wchar_t short_gen361[] = L"**mpi_file_write_ordered";
static const wchar_t long_gen361[]  = L"MPI_File_write_ordered failed";
static const wchar_t short_gen362[] = L"**mpi_file_write_ordered_begin";
static const wchar_t long_gen362[]  = L"MPI_File_write_ordered_begin failed";
static const wchar_t short_gen363[] = L"**mpi_file_write_ordered_end";
static const wchar_t long_gen363[]  = L"MPI_File_write_ordered_end failed";
static const wchar_t short_gen364[] = L"**mpi_file_write_shared";
static const wchar_t long_gen364[]  = L"MPI_File_write_shared failed";
static const wchar_t short_gen365[] = L"**mpi_finalize";
static const wchar_t long_gen365[]  = L"MPI_Finalize failed";
static const wchar_t short_gen366[] = L"**mpi_finalized";
static const wchar_t long_gen366[]  = L"MPI_Finalized failed";
static const wchar_t short_gen367[] = L"**mpi_free_mem";
static const wchar_t long_gen367[]  = L"MPI_Free_mem failed";
static const wchar_t short_gen368[] = L"**mpi_gather";
static const wchar_t long_gen368[]  = L"MPI_Gather failed";
static const wchar_t short_gen369[] = L"**mpi_gatherv";
static const wchar_t long_gen369[]  = L"MPI_Gatherv failed";
static const wchar_t short_gen370[] = L"**mpi_get";
static const wchar_t long_gen370[]  = L"MPI_Get failed";
static const wchar_t short_gen371[] = L"**mpi_get_address";
static const wchar_t long_gen371[]  = L"MPI_Get_address failed";
static const wchar_t short_gen372[] = L"**mpi_get_count";
static const wchar_t long_gen372[]  = L"MPI_Get_count failed";
static const wchar_t short_gen373[] = L"**mpi_get_elements";
static const wchar_t long_gen373[]  = L"MPI_Get_elements failed";
static const wchar_t short_gen374[] = L"**mpi_get_processor_name";
static const wchar_t long_gen374[]  = L"MPI_Get_processor_name failed";
static const wchar_t short_gen375[] = L"**mpi_get_version";
static const wchar_t long_gen375[]  = L"MPI_Get_version failed";
static const wchar_t short_gen376[] = L"**mpi_graph_create";
static const wchar_t long_gen376[]  = L"MPI_Graph_create failed";
static const wchar_t short_gen377[] = L"**mpi_graph_get";
static const wchar_t long_gen377[]  = L"MPI_Graph_get failed";
static const wchar_t short_gen378[] = L"**mpi_graph_map";
static const wchar_t long_gen378[]  = L"MPI_Graph_map failed";
static const wchar_t short_gen379[] = L"**mpi_graph_neighbors";
static const wchar_t long_gen379[]  = L"MPI_Graph_neighbors failed";
static const wchar_t short_gen380[] = L"**mpi_graph_neighbors_count";
static const wchar_t long_gen380[]  = L"MPI_Graph_neighbors_count failed";
static const wchar_t short_gen381[] = L"**mpi_graphdims_get";
static const wchar_t long_gen381[]  = L"MPI_Graphdims_get failed";
static const wchar_t short_gen382[] = L"**mpi_grequest_complete";
static const wchar_t long_gen382[]  = L"MPI_Grequest_complete failed";
static const wchar_t short_gen383[] = L"**mpi_grequest_start";
static const wchar_t long_gen383[]  = L"MPI_Grequest_start failed";
static const wchar_t short_gen384[] = L"**mpi_group_compare";
static const wchar_t long_gen384[]  = L"MPI_Group_compare failed";
static const wchar_t short_gen385[] = L"**mpi_group_difference";
static const wchar_t long_gen385[]  = L"MPI_Group_difference failed";
static const wchar_t short_gen386[] = L"**mpi_group_excl";
static const wchar_t long_gen386[]  = L"MPI_Group_excl failed";
static const wchar_t short_gen387[] = L"**mpi_group_free";
static const wchar_t long_gen387[]  = L"MPI_Group_free failed";
static const wchar_t short_gen388[] = L"**mpi_group_incl";
static const wchar_t long_gen388[]  = L"MPI_Group_incl failed";
static const wchar_t short_gen389[] = L"**mpi_group_intersection";
static const wchar_t long_gen389[]  = L"MPI_Group_intersection failed";
static const wchar_t short_gen390[] = L"**mpi_group_range_excl";
static const wchar_t long_gen390[]  = L"MPI_Group_range_excl failed";
static const wchar_t short_gen391[] = L"**mpi_group_range_incl";
static const wchar_t long_gen391[]  = L"MPI_Group_range_incl failed";
static const wchar_t short_gen392[] = L"**mpi_group_rank";
static const wchar_t long_gen392[]  = L"MPI_Group_rank failed";
static const wchar_t short_gen393[] = L"**mpi_group_size";
static const wchar_t long_gen393[]  = L"MPI_Group_size failed";
static const wchar_t short_gen394[] = L"**mpi_group_translate_ranks";
static const wchar_t long_gen394[]  = L"MPI_Group_translate_ranks failed";
static const wchar_t short_gen395[] = L"**mpi_group_union";
static const wchar_t long_gen395[]  = L"MPI_Group_union failed";
static const wchar_t short_gen396[] = L"**mpi_ibsend";
static const wchar_t long_gen396[]  = L"MPI_Ibsend failed";
static const wchar_t short_gen397[] = L"**mpi_info_create";
static const wchar_t long_gen397[]  = L"MPI_Info_create failed";
static const wchar_t short_gen398[] = L"**mpi_info_delete";
static const wchar_t long_gen398[]  = L"MPI_Info_delete failed";
static const wchar_t short_gen399[] = L"**mpi_info_dup";
static const wchar_t long_gen399[]  = L"MPI_Info_dup failed";
static const wchar_t short_gen400[] = L"**mpi_info_free";
static const wchar_t long_gen400[]  = L"MPI_Info_free failed";
static const wchar_t short_gen401[] = L"**mpi_info_get";
static const wchar_t long_gen401[]  = L"MPI_Info_get failed";
static const wchar_t short_gen402[] = L"**mpi_info_get_nkeys";
static const wchar_t long_gen402[]  = L"MPI_Info_get_nkeys failed";
static const wchar_t short_gen403[] = L"**mpi_info_get_nthkey";
static const wchar_t long_gen403[]  = L"MPI_Info_get_nthkey failed";
static const wchar_t short_gen404[] = L"**mpi_info_get_valuelen";
static const wchar_t long_gen404[]  = L"MPI_Info_get_valuelen failed";
static const wchar_t short_gen405[] = L"**mpi_info_set";
static const wchar_t long_gen405[]  = L"MPI_Info_set failed";
static const wchar_t short_gen406[] = L"**mpi_init";
static const wchar_t long_gen406[]  = L"MPI_Init failed";
static const wchar_t short_gen407[] = L"**mpi_init_thread";
static const wchar_t long_gen407[]  = L"MPI_Init_thread failed";
static const wchar_t short_gen408[] = L"**mpi_initialized";
static const wchar_t long_gen408[]  = L"MPI_Initialized failed";
static const wchar_t short_gen409[] = L"**mpi_intercomm_create";
static const wchar_t long_gen409[]  = L"MPI_Intercomm_create failed";
static const wchar_t short_gen410[] = L"**mpi_intercomm_merge";
static const wchar_t long_gen410[]  = L"MPI_Intercomm_merge failed";
static const wchar_t short_gen411[] = L"**mpi_iprobe";
static const wchar_t long_gen411[]  = L"MPI_Iprobe failed";
static const wchar_t short_gen412[] = L"**mpi_irecv";
static const wchar_t long_gen412[]  = L"MPI_Irecv failed";
static const wchar_t short_gen413[] = L"**mpi_irsend";
static const wchar_t long_gen413[]  = L"MPI_Irsend failed";
static const wchar_t short_gen414[] = L"**mpi_is_thread_main";
static const wchar_t long_gen414[]  = L"MPI_Is_thread_main failed";
static const wchar_t short_gen415[] = L"**mpi_isend";
static const wchar_t long_gen415[]  = L"MPI_Isend failed";
static const wchar_t short_gen416[] = L"**mpi_issend";
static const wchar_t long_gen416[]  = L"MPI_Issend failed";
static const wchar_t short_gen417[] = L"**mpi_keyval_create";
static const wchar_t long_gen417[]  = L"MPI_Keyval_create failed";
static const wchar_t short_gen418[] = L"**mpi_keyval_free";
static const wchar_t long_gen418[]  = L"MPI_Keyval_free failed";
static const wchar_t short_gen419[] = L"**mpi_lookup_name";
static const wchar_t long_gen419[]  = L"MPI_Lookup_name failed";
static const wchar_t short_gen420[] = L"**mpi_op_create";
static const wchar_t long_gen420[]  = L"MPI_Op_create failed";
static const wchar_t short_gen421[] = L"**mpi_op_free";
static const wchar_t long_gen421[]  = L"MPI_Op_free failed";
static const wchar_t short_gen422[] = L"**mpi_open_port";
static const wchar_t long_gen422[]  = L"MPI_Open_port failed";
static const wchar_t short_gen423[] = L"**mpi_pack";
static const wchar_t long_gen423[]  = L"MPI_Pack failed";
static const wchar_t short_gen424[] = L"**mpi_pack_external";
static const wchar_t long_gen424[]  = L"MPI_Pack_external failed";
static const wchar_t short_gen425[] = L"**mpi_pack_external_size";
static const wchar_t long_gen425[]  = L"MPI_Pack_external_size failed";
static const wchar_t short_gen426[] = L"**mpi_pack_size";
static const wchar_t long_gen426[]  = L"MPI_Pack_size failed";
static const wchar_t short_gen427[] = L"**mpi_probe";
static const wchar_t long_gen427[]  = L"MPI_Probe failed";
static const wchar_t short_gen428[] = L"**mpi_publish_name";
static const wchar_t long_gen428[]  = L"MPI_Publish_name failed";
static const wchar_t short_gen429[] = L"**mpi_put";
static const wchar_t long_gen429[]  = L"MPI_Put failed";
static const wchar_t short_gen430[] = L"**mpi_query_thread";
static const wchar_t long_gen430[]  = L"MPI_Query_thread failed";
static const wchar_t short_gen431[] = L"**mpi_recv";
static const wchar_t long_gen431[]  = L"MPI_Recv failed";
static const wchar_t short_gen432[] = L"**mpi_recv_init";
static const wchar_t long_gen432[]  = L"MPI_Recv_init failed";
static const wchar_t short_gen433[] = L"**mpi_reduce";
static const wchar_t long_gen433[]  = L"MPI_Reduce failed";
static const wchar_t short_gen434[] = L"**mpi_reduce_scatter";
static const wchar_t long_gen434[]  = L"MPI_Reduce_scatter failed";
static const wchar_t short_gen435[] = L"**mpi_register_datarep";
static const wchar_t long_gen435[]  = L"MPI_Register_datarep failed";
static const wchar_t short_gen436[] = L"**mpi_request_free";
static const wchar_t long_gen436[]  = L"MPI_Request_free failed";
static const wchar_t short_gen437[] = L"**mpi_request_get_status";
static const wchar_t long_gen437[]  = L"MPI_Request_get_status failed";
static const wchar_t short_gen438[] = L"**mpi_rsend";
static const wchar_t long_gen438[]  = L"MPI_Rsend failed";
static const wchar_t short_gen439[] = L"**mpi_rsend_init";
static const wchar_t long_gen439[]  = L"MPI_Rsend_init failed";
static const wchar_t short_gen440[] = L"**mpi_scan";
static const wchar_t long_gen440[]  = L"MPI_Scan failed";
static const wchar_t short_gen441[] = L"**mpi_scatter";
static const wchar_t long_gen441[]  = L"MPI_Scatter failed";
static const wchar_t short_gen442[] = L"**mpi_scatterv";
static const wchar_t long_gen442[]  = L"MPI_Scatterv failed";
static const wchar_t short_gen443[] = L"**mpi_send";
static const wchar_t long_gen443[]  = L"MPI_Send failed";
static const wchar_t short_gen444[] = L"**mpi_send_init";
static const wchar_t long_gen444[]  = L"MPI_Send_init failed";
static const wchar_t short_gen445[] = L"**mpi_sendrecv";
static const wchar_t long_gen445[]  = L"MPI_Sendrecv failed";
static const wchar_t short_gen446[] = L"**mpi_sendrecv_replace";
static const wchar_t long_gen446[]  = L"MPI_Sendrecv_replace failed";
static const wchar_t short_gen447[] = L"**mpi_ssend";
static const wchar_t long_gen447[]  = L"MPI_Ssend failed";
static const wchar_t short_gen448[] = L"**mpi_ssend_init";
static const wchar_t long_gen448[]  = L"MPI_Ssend_init failed";
static const wchar_t short_gen449[] = L"**mpi_start";
static const wchar_t long_gen449[]  = L"MPI_Start failed";
static const wchar_t short_gen450[] = L"**mpi_startall";
static const wchar_t long_gen450[]  = L"MPI_Start_all failed";
static const wchar_t short_gen451[] = L"**mpi_status_set_cancelled";
static const wchar_t long_gen451[]  = L"MPI_Status_set_cancelled failed";
static const wchar_t short_gen452[] = L"**mpi_status_set_elements";
static const wchar_t long_gen452[]  = L"MPI_Status_set_elements failed";
static const wchar_t short_gen453[] = L"**mpi_test";
static const wchar_t long_gen453[]  = L"MPI_Test failed";
static const wchar_t short_gen454[] = L"**mpi_test_cancelled";
static const wchar_t long_gen454[]  = L"MPI_Test_cancelled failed";
static const wchar_t short_gen455[] = L"**mpi_testall";
static const wchar_t long_gen455[]  = L"MPI_Testall failed";
static const wchar_t short_gen456[] = L"**mpi_testany";
static const wchar_t long_gen456[]  = L"MPI_Testany failed";
static const wchar_t short_gen457[] = L"**mpi_testsome";
static const wchar_t long_gen457[]  = L"MPI_Testsome failed";
static const wchar_t short_gen458[] = L"**mpi_topo_test";
static const wchar_t long_gen458[]  = L"MPI_Topo_test failed";
static const wchar_t short_gen459[] = L"**mpi_type_commit";
static const wchar_t long_gen459[]  = L"MPI_Type_commit failed";
static const wchar_t short_gen460[] = L"**mpi_type_contiguous";
static const wchar_t long_gen460[]  = L"MPI_Type_continuous failed";
static const wchar_t short_gen461[] = L"**mpi_type_create_darray";
static const wchar_t long_gen461[]  = L"MPI_Type_create_darray failed";
static const wchar_t short_gen462[] = L"**mpi_type_create_hindexed";
static const wchar_t long_gen462[]  = L"MPI_Type_create_hindexed failed";
static const wchar_t short_gen463[] = L"**mpi_type_create_hvector";
static const wchar_t long_gen463[]  = L"MPI_Type_create_hvector failed";
static const wchar_t short_gen464[] = L"**mpi_type_create_indexed_block";
static const wchar_t long_gen464[]  = L"MPI_Type_create_indexed_block failed";
static const wchar_t short_gen465[] = L"**mpi_type_create_keyval";
static const wchar_t long_gen465[]  = L"MPI_Type_create_keyval failed";
static const wchar_t short_gen466[] = L"**mpi_type_create_resized";
static const wchar_t long_gen466[]  = L"MPI_Type_create_resized failed";
static const wchar_t short_gen467[] = L"**mpi_type_create_struct";
static const wchar_t long_gen467[]  = L"MPI_Type_create_struct failed";
static const wchar_t short_gen468[] = L"**mpi_type_create_subarray";
static const wchar_t long_gen468[]  = L"MPI_Type_create_subarray failed";
static const wchar_t short_gen469[] = L"**mpi_type_delete_attr";
static const wchar_t long_gen469[]  = L"MPI_Type_delete_attr failed";
static const wchar_t short_gen470[] = L"**mpi_type_dup";
static const wchar_t long_gen470[]  = L"MPI_Type_dup failed";
static const wchar_t short_gen471[] = L"**mpi_type_extent";
static const wchar_t long_gen471[]  = L"MPI_Type_extent failed";
static const wchar_t short_gen472[] = L"**mpi_type_free";
static const wchar_t long_gen472[]  = L"MPI_Type_free failed";
static const wchar_t short_gen473[] = L"**mpi_type_free_keyval";
static const wchar_t long_gen473[]  = L"MPI_Type_free_keyval failed";
static const wchar_t short_gen474[] = L"**mpi_type_get_attr";
static const wchar_t long_gen474[]  = L"MPI_Type_get_attr failed";
static const wchar_t short_gen475[] = L"**mpi_type_get_contents";
static const wchar_t long_gen475[]  = L"MPI_Type_get_contents failed";
static const wchar_t short_gen476[] = L"**mpi_type_get_envelope";
static const wchar_t long_gen476[]  = L"MPI_Type_get_envelope failed";
static const wchar_t short_gen477[] = L"**mpi_type_get_extent";
static const wchar_t long_gen477[]  = L"MPI_Type_get_extent failed";
static const wchar_t short_gen478[] = L"**mpi_type_get_name";
static const wchar_t long_gen478[]  = L"MPI_Type_get_name failed";
static const wchar_t short_gen479[] = L"**mpi_type_get_true_extent";
static const wchar_t long_gen479[]  = L"MPI_Type_get_true_extent failed";
static const wchar_t short_gen480[] = L"**mpi_type_hindexed";
static const wchar_t long_gen480[]  = L"MPI_Type_hindexed failed";
static const wchar_t short_gen481[] = L"**mpi_type_hvector";
static const wchar_t long_gen481[]  = L"MPI_Type_hvector failed";
static const wchar_t short_gen482[] = L"**mpi_type_indexed";
static const wchar_t long_gen482[]  = L"MPI_Type_indexed failed";
static const wchar_t short_gen483[] = L"**mpi_type_lb";
static const wchar_t long_gen483[]  = L"MPI_Type_lb failed";
static const wchar_t short_gen484[] = L"**mpi_type_match_size";
static const wchar_t long_gen484[]  = L"MPI_Type_match_size failed";
static const wchar_t short_gen485[] = L"**mpi_type_set_attr";
static const wchar_t long_gen485[]  = L"MPI_Type_set_attr failed";
static const wchar_t short_gen486[] = L"**mpi_type_set_name";
static const wchar_t long_gen486[]  = L"MPI_Type_set_name failed";
static const wchar_t short_gen487[] = L"**mpi_type_size";
static const wchar_t long_gen487[]  = L"MPI_Type_size failed";
static const wchar_t short_gen488[] = L"**mpi_type_struct";
static const wchar_t long_gen488[]  = L"MPI_Type_struct failed";
static const wchar_t short_gen489[] = L"**mpi_type_ub";
static const wchar_t long_gen489[]  = L"MPI_Type_ub failed";
static const wchar_t short_gen490[] = L"**mpi_type_vector";
static const wchar_t long_gen490[]  = L"MPI_Type_vector failed";
static const wchar_t short_gen491[] = L"**mpi_unpack";
static const wchar_t long_gen491[]  = L"MPI_Unpack failed";
static const wchar_t short_gen492[] = L"**mpi_unpack_external";
static const wchar_t long_gen492[]  = L"MPI_Unpack_external failed";
static const wchar_t short_gen493[] = L"**mpi_unpublish_name";
static const wchar_t long_gen493[]  = L"MPI_Unpublish_name failed";
static const wchar_t short_gen494[] = L"**mpi_wait";
static const wchar_t long_gen494[]  = L"MPI_Wait failed";
static const wchar_t short_gen495[] = L"**mpi_waitall";
static const wchar_t long_gen495[]  = L"MPI_Waitall failed";
static const wchar_t short_gen496[] = L"**mpi_waitany";
static const wchar_t long_gen496[]  = L"MPI_Waitany failed";
static const wchar_t short_gen497[] = L"**mpi_waitsome";
static const wchar_t long_gen497[]  = L"MPI_Waitsome failed";
static const wchar_t short_gen498[] = L"**mpi_win_call_errhandler";
static const wchar_t long_gen498[]  = L"MPI_Win_call_errhandler failed";
static const wchar_t short_gen499[] = L"**mpi_win_complete";
static const wchar_t long_gen499[]  = L"MPI_Win_complete failed";
static const wchar_t short_gen500[] = L"**mpi_win_create";
static const wchar_t long_gen500[]  = L"MPI_Win_create failed";
static const wchar_t short_gen501[] = L"**mpi_win_create_errhandler";
static const wchar_t long_gen501[]  = L"MPI_Win_create_errhandler failed";
static const wchar_t short_gen502[] = L"**mpi_win_create_keyval";
static const wchar_t long_gen502[]  = L"MPI_Win_create_keyval failed";
static const wchar_t short_gen503[] = L"**mpi_win_delete_attr";
static const wchar_t long_gen503[]  = L"MPI_Win_delete_attr failed";
static const wchar_t short_gen504[] = L"**mpi_win_fence";
static const wchar_t long_gen504[]  = L"MPI_Win_fence failed";
static const wchar_t short_gen505[] = L"**mpi_win_free";
static const wchar_t long_gen505[]  = L"MPI_Win_free failed";
static const wchar_t short_gen506[] = L"**mpi_win_free_keyval";
static const wchar_t long_gen506[]  = L"MPI_Win_free_keyval failed";
static const wchar_t short_gen507[] = L"**mpi_win_get_attr";
static const wchar_t long_gen507[]  = L"MPI_Win_get_attr failed";
static const wchar_t short_gen508[] = L"**mpi_win_get_errhandler";
static const wchar_t long_gen508[]  = L"MPI_Win_get_errhandler failed";
static const wchar_t short_gen509[] = L"**mpi_win_get_group";
static const wchar_t long_gen509[]  = L"MPI_Win_get_group failed";
static const wchar_t short_gen510[] = L"**mpi_win_get_name";
static const wchar_t long_gen510[]  = L"MPI_Win_get_name failed";
static const wchar_t short_gen511[] = L"**mpi_win_lock";
static const wchar_t long_gen511[]  = L"MPI_Win_lock failed";
static const wchar_t short_gen512[] = L"**mpi_win_post";
static const wchar_t long_gen512[]  = L"MPI_Win_post failed";
static const wchar_t short_gen513[] = L"**mpi_win_set_attr";
static const wchar_t long_gen513[]  = L"MPI_Win_set_attr failed";
static const wchar_t short_gen514[] = L"**mpi_win_set_errhandler";
static const wchar_t long_gen514[]  = L"MPI_Win_set_errhandler failed";
static const wchar_t short_gen515[] = L"**mpi_win_set_name";
static const wchar_t long_gen515[]  = L"MPI_Win_set_name failed";
static const wchar_t short_gen516[] = L"**mpi_win_start";
static const wchar_t long_gen516[]  = L"MPI_Win_start failed";
static const wchar_t short_gen517[] = L"**mpi_win_test";
static const wchar_t long_gen517[]  = L"MPI_Win_test failed";
static const wchar_t short_gen518[] = L"**mpi_win_unlock";
static const wchar_t long_gen518[]  = L"MPI_Win_unlock failed";
static const wchar_t short_gen519[] = L"**mpi_win_wait";
static const wchar_t long_gen519[]  = L"MPI_Win_wait failed";
static const wchar_t short_gen520[] = L"**mpioi_file_iread";
static const wchar_t long_gen520[]  = L"MPIOI_File_iread failed";
static const wchar_t short_gen521[] = L"**mpioi_file_iwrite";
static const wchar_t long_gen521[]  = L"MPIOI_File_iwrite failed";
static const wchar_t short_gen522[] = L"**mpioi_file_read";
static const wchar_t long_gen522[]  = L"MPIOI_File_read failed";
static const wchar_t short_gen523[] = L"**mpioi_file_read_all";
static const wchar_t long_gen523[]  = L"MPIOI_File_read_all failed";
static const wchar_t short_gen524[] = L"**mpioi_file_read_all_begin";
static const wchar_t long_gen524[]  = L"MPIOI_File_read_all_begin failed";
static const wchar_t short_gen525[] = L"**mpioi_file_read_all_end";
static const wchar_t long_gen525[]  = L"MPIOI_File_read_all_end failed";
static const wchar_t short_gen526[] = L"**mpioi_file_write";
static const wchar_t long_gen526[]  = L"MPIOI_File_write failed";
static const wchar_t short_gen527[] = L"**mpioi_file_write_all";
static const wchar_t long_gen527[]  = L"MPIOI_File_write_all failed";
static const wchar_t short_gen528[] = L"**mpioi_file_write_all_begin";
static const wchar_t long_gen528[]  = L"MPIOI_File_write_all_begin failed";
static const wchar_t short_gen529[] = L"**mpioi_file_write_all_end";
static const wchar_t long_gen529[]  = L"MPIOI_File_write_all_end failed";
static const wchar_t short_gen530[] = L"**mq_close";
static const wchar_t long_gen530[]  = L"failed to close a posix message queue";
static const wchar_t short_gen531[] = L"**mq_open";
static const wchar_t long_gen531[]  = L"failed to open a posix message queue";
static const wchar_t short_gen532[] = L"**mq_receive";
static const wchar_t long_gen532[]  = L"failed to receive a posix message queue message";
static const wchar_t short_gen533[] = L"**mq_send";
static const wchar_t long_gen533[]  = L"failed to send a posix message queue message";
static const wchar_t short_gen534[] = L"**mqp_failure";
static const wchar_t long_gen534[]  = L"failed to make progress on the shared memory bootstrap message queue";
static const wchar_t short_gen535[] = L"**mqshm_create";
static const wchar_t long_gen535[]  = L"failed to create a shared memory message queue";
static const wchar_t short_gen536[] = L"**mqshm_receive";
static const wchar_t long_gen536[]  = L"failed to receive a bootstrap message";
static const wchar_t short_gen537[] = L"**mqshm_send";
static const wchar_t long_gen537[]  = L"failed to send a bootstrap message";
static const wchar_t short_gen538[] = L"**mqshm_unlink";
static const wchar_t long_gen538[]  = L"unable to unlink the shared memory message queue";
static const wchar_t short_gen539[] = L"**msgctl";
static const wchar_t long_gen539[]  = L"msgctl failed";
static const wchar_t short_gen540[] = L"**msgget";
static const wchar_t long_gen540[]  = L"msgget failed";
static const wchar_t short_gen541[] = L"**msgrcv";
static const wchar_t long_gen541[]  = L"msgrcv failed";
static const wchar_t short_gen542[] = L"**msgsnd";
static const wchar_t long_gen542[]  = L"msgsnd failed";
static const wchar_t short_gen543[] = L"**namepubfile";
static const wchar_t long_gen543[]  = L"Unable to publish service name";
static const wchar_t short_gen544[] = L"**namepubnotfound";
static const wchar_t long_gen544[]  = L"Lookup failed for service name";
static const wchar_t short_gen545[] = L"**namepubnotpub";
static const wchar_t long_gen545[]  = L"Lookup failed for service name ";
static const wchar_t short_gen546[] = L"**namepubnotunpub";
static const wchar_t long_gen546[]  = L"Failed to unpublish service name";
static const wchar_t short_gen547[] = L"**nameservice";
static const wchar_t long_gen547[]  = L"Invalid service name (see MPI_Publish_name)";
static const wchar_t short_gen548[] = L"**nextbootmsg";
static const wchar_t long_gen548[]  = L"failed to get the next bootstrap message";
static const wchar_t short_gen549[] = L"**noConnInfoToString";
static const wchar_t long_gen549[]  = L"No ConnInfoToString routine defined for this process group";
static const wchar_t short_gen550[] = L"**noca";
static const wchar_t long_gen550[]  = L"unable to find an active infiniband channel adapter";
static const wchar_t short_gen551[] = L"**node_root_rank";
static const wchar_t long_gen551[]  = L"Unable to get the node root rank";
static const wchar_t short_gen552[] = L"**noerrclasses";
static const wchar_t long_gen552[]  = L"No more user-defined error classes";
static const wchar_t short_gen553[] = L"**noerrcodes";
static const wchar_t long_gen553[]  = L"No more user-defined error codes";
static const wchar_t short_gen554[] = L"**nomem";
static const wchar_t long_gen554[]  = L"Out of memory";
static const wchar_t short_gen555[] = L"**nomem2";
static const wchar_t long_gen555[]  = L"Unable to allocate memory (probably out of memory)";
static const wchar_t short_gen556[] = L"**nomemreq";
static const wchar_t long_gen556[]  = L"failure occurred while allocating memory for a request object";
static const wchar_t short_gen557[] = L"**nonamepub";
static const wchar_t long_gen557[]  = L"No name publishing service available";
static const wchar_t short_gen558[] = L"**notcarttopo";
static const wchar_t long_gen558[]  = L"No Cartesian topology associated with this communicator";
static const wchar_t short_gen559[] = L"**notcstatignore";
static const wchar_t long_gen559[]  = L"MPI_STATUS_IGNORE cannot be passed to MPI_Status_c2f()";
static const wchar_t short_gen560[] = L"**notfstatignore";
static const wchar_t long_gen560[]  = L"MPI_STATUS_IGNORE cannot be passed to MPI_Status_f2c()";
static const wchar_t short_gen561[] = L"**notgenreq";
static const wchar_t long_gen561[]  = L"Attempt to complete a request with MPI_GREQUEST_COMPLETE that was not started with MPI_GREQUEST_START";
static const wchar_t short_gen562[] = L"**notgraphtopo";
static const wchar_t long_gen562[]  = L"No Graph topology associated with this communicator";
static const wchar_t short_gen563[] = L"**notimpl";
static const wchar_t long_gen563[]  = L"Function not implemented";
static const wchar_t short_gen564[] = L"**notopology";
static const wchar_t long_gen564[]  = L"No topology associated with this communicator";
static const wchar_t short_gen565[] = L"**notsame";
static const wchar_t long_gen565[]  = L"Inconsistent arguments to collective routine ";
static const wchar_t short_gen566[] = L"**nulledge";
static const wchar_t long_gen566[]  = L"Edge detected from a node to the same node";
static const wchar_t short_gen567[] = L"**nullptr";
static const wchar_t long_gen567[]  = L"Null pointer";
static const wchar_t short_gen568[] = L"**nullptrtype";
static const wchar_t long_gen568[]  = L"Null pointer";
static const wchar_t short_gen569[] = L"**op";
static const wchar_t long_gen569[]  = L"Invalid MPI_Op";
static const wchar_t short_gen570[] = L"**open";
static const wchar_t long_gen570[]  = L"open failed";
static const wchar_t short_gen571[] = L"**openportfailed";
static const wchar_t long_gen571[]  = L"Unable to establish a port";
static const wchar_t short_gen572[] = L"**opnotpredefined";
static const wchar_t long_gen572[]  = L"only predefined ops are valid";
static const wchar_t short_gen573[] = L"**opnull";
static const wchar_t long_gen573[]  = L"Null MPI_Op";
static const wchar_t short_gen574[] = L"**opundefined";
static const wchar_t long_gen574[]  = L"MPI_Op operation not defined for this datatype ";
static const wchar_t short_gen575[] = L"**oremote_fail";
static const wchar_t long_gen575[]  = L"open failed on a remote node";
static const wchar_t short_gen576[] = L"**other";
static const wchar_t long_gen576[]  = L"";
static const wchar_t short_gen577[] = L"**pctwice";
static const wchar_t long_gen577[]  = L"post close called twice";
static const wchar_t short_gen578[] = L"**pd_alloc";
static const wchar_t long_gen578[]  = L"unable to allocate a protection domain";
static const wchar_t short_gen579[] = L"**permattr";
static const wchar_t long_gen579[]  = L"Cannot set permanent attribute";
static const wchar_t short_gen580[] = L"**permop";
static const wchar_t long_gen580[]  = L"Cannot free permanent MPI_Op ";
static const wchar_t short_gen581[] = L"**pglookup";
static const wchar_t long_gen581[]  = L"unable to find the process group structure";
static const wchar_t short_gen582[] = L"**pkt_ptr";
static const wchar_t long_gen582[]  = L"invalid shm queue packet pointer";
static const wchar_t short_gen583[] = L"**pmi_barrier";
static const wchar_t long_gen583[]  = L"PMI_Barrier failed";
static const wchar_t short_gen584[] = L"**pmi_get_appnum";
static const wchar_t long_gen584[]  = L"PMI_Get_appnum failed";
static const wchar_t short_gen585[] = L"**pmi_get_clique_ranks";
static const wchar_t long_gen585[]  = L"PMI_Get_clique_ranks failed";
static const wchar_t short_gen586[] = L"**pmi_get_clique_size";
static const wchar_t long_gen586[]  = L"PMI_Get_clique_size failed";
static const wchar_t short_gen587[] = L"**pmi_get_id";
static const wchar_t long_gen587[]  = L"PMI_Get_id failed";
static const wchar_t short_gen588[] = L"**pmi_get_id_length_max";
static const wchar_t long_gen588[]  = L"PMI_Get_id_length_max failed";
static const wchar_t short_gen589[] = L"**pmi_get_rank";
static const wchar_t long_gen589[]  = L"PMI_Get_rank failed";
static const wchar_t short_gen590[] = L"**pmi_get_size";
static const wchar_t long_gen590[]  = L"PMI_Get_size failed";
static const wchar_t short_gen591[] = L"**pmi_get_universe_size";
static const wchar_t long_gen591[]  = L"PMI_Get_universe_size failed";
static const wchar_t short_gen592[] = L"**pmi_init";
static const wchar_t long_gen592[]  = L"PMI_Init failed";
static const wchar_t short_gen593[] = L"**pmi_invalid_clique_size";
static const wchar_t long_gen593[]  = L"PMI_Get_clique_ranks returned an invalid size";
static const wchar_t short_gen594[] = L"**pmi_kvs_commit";
static const wchar_t long_gen594[]  = L"PMI_KVS_Commit failed";
static const wchar_t short_gen595[] = L"**pmi_kvs_destroy";
static const wchar_t long_gen595[]  = L"PMI_KVS_Destroy failed";
static const wchar_t short_gen596[] = L"**pmi_kvs_get";
static const wchar_t long_gen596[]  = L"PMI_KVS_Get failed";
static const wchar_t short_gen597[] = L"**pmi_kvs_get_key_length_max";
static const wchar_t long_gen597[]  = L"PMI_KVS_Get_key_length_max failed";
static const wchar_t short_gen598[] = L"**pmi_kvs_get_my_name";
static const wchar_t long_gen598[]  = L"PMI_KVS_Get_my_name failed";
static const wchar_t short_gen599[] = L"**pmi_kvs_get_name_length_max";
static const wchar_t long_gen599[]  = L"PMI_KVS_Get_name_length_max failed";
static const wchar_t short_gen600[] = L"**pmi_kvs_get_value_length_max";
static const wchar_t long_gen600[]  = L"PMI_KVS_Get_value_length_max failed";
static const wchar_t short_gen601[] = L"**pmi_kvs_put";
static const wchar_t long_gen601[]  = L"PMI_KVS_Put failed";
static const wchar_t short_gen602[] = L"**pmi_spawn_multiple";
static const wchar_t long_gen602[]  = L"PMI_Spawn_multiple failed";
static const wchar_t short_gen603[] = L"**port";
static const wchar_t long_gen603[]  = L"Invalid port";
static const wchar_t short_gen604[] = L"**post_accept";
static const wchar_t long_gen604[]  = L"post accept failed";
static const wchar_t short_gen605[] = L"**post_connect";
static const wchar_t long_gen605[]  = L"failed to post a connection";
static const wchar_t short_gen606[] = L"**progress";
static const wchar_t long_gen606[]  = L"progress engine failure";
static const wchar_t short_gen607[] = L"**progress_handle_sock_op";
static const wchar_t long_gen607[]  = L"handle_sock_op failed";
static const wchar_t short_gen608[] = L"**progress_init";
static const wchar_t long_gen608[]  = L"unable to initialize the progress engine";
static const wchar_t short_gen609[] = L"**progress_sock_wait";
static const wchar_t long_gen609[]  = L"sock_wait failed";
static const wchar_t short_gen610[] = L"**progress_test";
static const wchar_t long_gen610[]  = L"progress_test engine failure";
static const wchar_t short_gen611[] = L"**rangedup";
static const wchar_t long_gen611[]  = L"The range array specifies duplicate entries";
static const wchar_t short_gen612[] = L"**rangeendinvalid";
static const wchar_t long_gen612[]  = L"Some element of a range array is either negative or too large";
static const wchar_t short_gen613[] = L"**rangestartinvalid";
static const wchar_t long_gen613[]  = L"Some element of a range array is either negative or too large";
static const wchar_t short_gen614[] = L"**rank";
static const wchar_t long_gen614[]  = L"Invalid rank";
static const wchar_t short_gen615[] = L"**rankarray";
static const wchar_t long_gen615[]  = L"Invalid rank in rank array";
static const wchar_t short_gen616[] = L"**rankdup";
static const wchar_t long_gen616[]  = L"Duplicate ranks in rank array ";
static const wchar_t short_gen617[] = L"**recvbuf_inplace";
static const wchar_t long_gen617[]  = L"recvbuf cannot be MPI_IN_PLACE";
static const wchar_t short_gen618[] = L"**request";
static const wchar_t long_gen618[]  = L"Invalid MPI_Request";
static const wchar_t short_gen619[] = L"**request_invalid_kind";
static const wchar_t long_gen619[]  = L"The supplied request was invalid";
static const wchar_t short_gen620[] = L"**requestnotpersist";
static const wchar_t long_gen620[]  = L"Request is not persistent in MPI_Start or MPI_Startall.";
static const wchar_t short_gen621[] = L"**requestnull";
static const wchar_t long_gen621[]  = L"Null MPI_Request ";
static const wchar_t short_gen622[] = L"**requestpersistactive";
static const wchar_t long_gen622[]  = L"Persistent request passed to MPI_Start or MPI_Startall is already active.";
static const wchar_t short_gen623[] = L"**rmaconflict";
static const wchar_t long_gen623[]  = L"Conflicting accesses to window ";
static const wchar_t short_gen624[] = L"**rmadisp";
static const wchar_t long_gen624[]  = L"Invalid displacement argument in RMA call ";
static const wchar_t short_gen625[] = L"**rmasize";
static const wchar_t long_gen625[]  = L"Invalid size argument in RMA call";
static const wchar_t short_gen626[] = L"**rmasync";
static const wchar_t long_gen626[]  = L"Wrong synchronization of RMA calls ";
static const wchar_t short_gen627[] = L"**root";
static const wchar_t long_gen627[]  = L"Invalid root";
static const wchar_t short_gen628[] = L"**rsendnomatch";
static const wchar_t long_gen628[]  = L"Ready send had no matching receive ";
static const wchar_t short_gen629[] = L"**sendbuf_inplace";
static const wchar_t long_gen629[]  = L"sendbuf cannot be MPI_IN_PLACE";
static const wchar_t short_gen630[] = L"**servicename";
static const wchar_t long_gen630[]  = L"Attempt to lookup an unknown service name ";
static const wchar_t short_gen631[] = L"**setup_connections";
static const wchar_t long_gen631[]  = L"MPIDI_CH3I_Setup_connections failed";
static const wchar_t short_gen632[] = L"**shm_op";
static const wchar_t long_gen632[]  = L"invalid shm operation";
static const wchar_t short_gen633[] = L"**shm_open";
static const wchar_t long_gen633[]  = L"unable to open a shared memory object";
static const wchar_t short_gen634[] = L"**shm_read_progress";
static const wchar_t long_gen634[]  = L"shared memory read progress failed";
static const wchar_t short_gen635[] = L"**shm_unlink";
static const wchar_t long_gen635[]  = L"failed to unlink shared memory";
static const wchar_t short_gen636[] = L"**shm_wait";
static const wchar_t long_gen636[]  = L"wait function failed";
static const wchar_t short_gen637[] = L"**shmat";
static const wchar_t long_gen637[]  = L"shmat failed";
static const wchar_t short_gen638[] = L"**shmconnect_getmem";
static const wchar_t long_gen638[]  = L"failed to allocate shared memory for a write queue";
static const wchar_t short_gen639[] = L"**shmctl";
static const wchar_t long_gen639[]  = L"failed to mark the sysv segment for removal";
static const wchar_t short_gen640[] = L"**shmget";
static const wchar_t long_gen640[]  = L"shmget failed";
static const wchar_t short_gen641[] = L"**shmgetmem";
static const wchar_t long_gen641[]  = L"Unable to allocate shared memory";
static const wchar_t short_gen642[] = L"**shmhost";
static const wchar_t long_gen642[]  = L"process not on the same host";
static const wchar_t short_gen643[] = L"**shmq_index";
static const wchar_t long_gen643[]  = L"invalid shm queue index";
static const wchar_t short_gen644[] = L"**shmsize";
static const wchar_t long_gen644[]  = L"Shared memory subsystem unable to allocate a block of the requested size";
static const wchar_t short_gen645[] = L"**shmwrite";
static const wchar_t long_gen645[]  = L"shared memory write failed";
static const wchar_t short_gen646[] = L"**shutdown";
static const wchar_t long_gen646[]  = L"shutdown failed";
static const wchar_t short_gen647[] = L"**sock_connect";
static const wchar_t long_gen647[]  = L"connect failed";
static const wchar_t short_gen648[] = L"**sock_create";
static const wchar_t long_gen648[]  = L"unable to create a socket";
static const wchar_t short_gen649[] = L"**sock_gethost";
static const wchar_t long_gen649[]  = L"gethostname failed";
static const wchar_t short_gen650[] = L"**sock_init";
static const wchar_t long_gen650[]  = L"unable to initialize the sock library";
static const wchar_t short_gen651[] = L"**sock_nop_accept";
static const wchar_t long_gen651[]  = L"accept called without having received an op_accept";
static const wchar_t short_gen652[] = L"**sock_post_close";
static const wchar_t long_gen652[]  = L"posting a close of the socket failed";
static const wchar_t short_gen653[] = L"**socket";
static const wchar_t long_gen653[]  = L"WSASocket failed";
static const wchar_t short_gen654[] = L"**spawn";
static const wchar_t long_gen654[]  = L"Error in spawn call";
static const wchar_t short_gen655[] = L"**ssmwrite";
static const wchar_t long_gen655[]  = L"sock/shared memory write failed";
static const wchar_t short_gen656[] = L"**ssmwritev";
static const wchar_t long_gen656[]  = L"sock/shared memory writev failed";
static const wchar_t short_gen657[] = L"**stride";
static const wchar_t long_gen657[]  = L"Range does not terminate";
static const wchar_t short_gen658[] = L"**stridezero";
static const wchar_t long_gen658[]  = L"Zero stride is invalid";
static const wchar_t short_gen659[] = L"**success";
static const wchar_t long_gen659[]  = L"No MPI error";
static const wchar_t short_gen660[] = L"**tag";
static const wchar_t long_gen660[]  = L"Invalid tag";
static const wchar_t short_gen661[] = L"**test_sock_wait";
static const wchar_t long_gen661[]  = L"sock_wait failed";
static const wchar_t short_gen662[] = L"**toomanycomm";
static const wchar_t long_gen662[]  = L"Too many communicators";
static const wchar_t short_gen663[] = L"**topology";
static const wchar_t long_gen663[]  = L"Invalid topology";
static const wchar_t short_gen664[] = L"**topotoolarge";
static const wchar_t long_gen664[]  = L"Topology size is greater than communicator size";
static const wchar_t short_gen665[] = L"**truncate";
static const wchar_t long_gen665[]  = L"Message truncated";
static const wchar_t short_gen666[] = L"**typematchnoclass";
static const wchar_t long_gen666[]  = L"The value of typeclass is not one of MPI_TYPECLASS_REAL, MPI_TYPECLASS_INTEGER, or MPI_TYPECLASS_COMPLEX";
static const wchar_t short_gen667[] = L"**typematchsize";
static const wchar_t long_gen667[]  = L"No MPI datatype available for the given typeclass and size";
static const wchar_t short_gen668[] = L"**typenamelen";
static const wchar_t long_gen668[]  = L"Specified datatype name is too long";
static const wchar_t short_gen669[] = L"**unknown";
static const wchar_t long_gen669[]  = L"Unknown error.  Please file a bug report.";
static const wchar_t short_gen670[] = L"**unsupporteddatarep";
static const wchar_t long_gen670[]  = L"Only native data representation currently supported";
static const wchar_t short_gen671[] = L"**user";
static const wchar_t long_gen671[]  = L"user defined function returned an error code";
static const wchar_t short_gen672[] = L"**vc_state";
static const wchar_t long_gen672[]  = L"invalid vc state";
static const wchar_t short_gen673[] = L"**wcsncpy";
static const wchar_t long_gen673[]  = L"wide string copy failed";
static const wchar_t short_gen674[] = L"**win";
static const wchar_t long_gen674[]  = L"Invalid MPI_Win";
static const wchar_t short_gen675[] = L"**winnull";
static const wchar_t long_gen675[]  = L"Null MPI_Win";
static const wchar_t short_gen676[] = L"**winunlockrank";
static const wchar_t long_gen676[]  = L"Invalid rank argument";
static const wchar_t short_gen677[] = L"**winwait";
static const wchar_t long_gen677[]  = L"WaitForSingleObject failed";
static const wchar_t short_gen678[] = L"**wsasock";
static const wchar_t long_gen678[]  = L"WSAStartup failed";

static const int generic_msgs_len = 679;
static const msgpair generic_err_msgs[] = {
{ 0xacebad03, short_gen0, long_gen0, 0xcb0bfa11 },
{ 0xacebad03, short_gen1, long_gen1, 0xcb0bfa11 },
{ 0xacebad03, short_gen2, long_gen2, 0xcb0bfa11 },
{ 0xacebad03, short_gen3, long_gen3, 0xcb0bfa11 },
{ 0xacebad03, short_gen4, long_gen4, 0xcb0bfa11 },
{ 0xacebad03, short_gen5, long_gen5, 0xcb0bfa11 },
{ 0xacebad03, short_gen6, long_gen6, 0xcb0bfa11 },
{ 0xacebad03, short_gen7, long_gen7, 0xcb0bfa11 },
{ 0xacebad03, short_gen8, long_gen8, 0xcb0bfa11 },
{ 0xacebad03, short_gen9, long_gen9, 0xcb0bfa11 },
{ 0xacebad03, short_gen10, long_gen10, 0xcb0bfa11 },
{ 0xacebad03, short_gen11, long_gen11, 0xcb0bfa11 },
{ 0xacebad03, short_gen12, long_gen12, 0xcb0bfa11 },
{ 0xacebad03, short_gen13, long_gen13, 0xcb0bfa11 },
{ 0xacebad03, short_gen14, long_gen14, 0xcb0bfa11 },
{ 0xacebad03, short_gen15, long_gen15, 0xcb0bfa11 },
{ 0xacebad03, short_gen16, long_gen16, 0xcb0bfa11 },
{ 0xacebad03, short_gen17, long_gen17, 0xcb0bfa11 },
{ 0xacebad03, short_gen18, long_gen18, 0xcb0bfa11 },
{ 0xacebad03, short_gen19, long_gen19, 0xcb0bfa11 },
{ 0xacebad03, short_gen20, long_gen20, 0xcb0bfa11 },
{ 0xacebad03, short_gen21, long_gen21, 0xcb0bfa11 },
{ 0xacebad03, short_gen22, long_gen22, 0xcb0bfa11 },
{ 0xacebad03, short_gen23, long_gen23, 0xcb0bfa11 },
{ 0xacebad03, short_gen24, long_gen24, 0xcb0bfa11 },
{ 0xacebad03, short_gen25, long_gen25, 0xcb0bfa11 },
{ 0xacebad03, short_gen26, long_gen26, 0xcb0bfa11 },
{ 0xacebad03, short_gen27, long_gen27, 0xcb0bfa11 },
{ 0xacebad03, short_gen28, long_gen28, 0xcb0bfa11 },
{ 0xacebad03, short_gen29, long_gen29, 0xcb0bfa11 },
{ 0xacebad03, short_gen30, long_gen30, 0xcb0bfa11 },
{ 0xacebad03, short_gen31, long_gen31, 0xcb0bfa11 },
{ 0xacebad03, short_gen32, long_gen32, 0xcb0bfa11 },
{ 0xacebad03, short_gen33, long_gen33, 0xcb0bfa11 },
{ 0xacebad03, short_gen34, long_gen34, 0xcb0bfa11 },
{ 0xacebad03, short_gen35, long_gen35, 0xcb0bfa11 },
{ 0xacebad03, short_gen36, long_gen36, 0xcb0bfa11 },
{ 0xacebad03, short_gen37, long_gen37, 0xcb0bfa11 },
{ 0xacebad03, short_gen38, long_gen38, 0xcb0bfa11 },
{ 0xacebad03, short_gen39, long_gen39, 0xcb0bfa11 },
{ 0xacebad03, short_gen40, long_gen40, 0xcb0bfa11 },
{ 0xacebad03, short_gen41, long_gen41, 0xcb0bfa11 },
{ 0xacebad03, short_gen42, long_gen42, 0xcb0bfa11 },
{ 0xacebad03, short_gen43, long_gen43, 0xcb0bfa11 },
{ 0xacebad03, short_gen44, long_gen44, 0xcb0bfa11 },
{ 0xacebad03, short_gen45, long_gen45, 0xcb0bfa11 },
{ 0xacebad03, short_gen46, long_gen46, 0xcb0bfa11 },
{ 0xacebad03, short_gen47, long_gen47, 0xcb0bfa11 },
{ 0xacebad03, short_gen48, long_gen48, 0xcb0bfa11 },
{ 0xacebad03, short_gen49, long_gen49, 0xcb0bfa11 },
{ 0xacebad03, short_gen50, long_gen50, 0xcb0bfa11 },
{ 0xacebad03, short_gen51, long_gen51, 0xcb0bfa11 },
{ 0xacebad03, short_gen52, long_gen52, 0xcb0bfa11 },
{ 0xacebad03, short_gen53, long_gen53, 0xcb0bfa11 },
{ 0xacebad03, short_gen54, long_gen54, 0xcb0bfa11 },
{ 0xacebad03, short_gen55, long_gen55, 0xcb0bfa11 },
{ 0xacebad03, short_gen56, long_gen56, 0xcb0bfa11 },
{ 0xacebad03, short_gen57, long_gen57, 0xcb0bfa11 },
{ 0xacebad03, short_gen58, long_gen58, 0xcb0bfa11 },
{ 0xacebad03, short_gen59, long_gen59, 0xcb0bfa11 },
{ 0xacebad03, short_gen60, long_gen60, 0xcb0bfa11 },
{ 0xacebad03, short_gen61, long_gen61, 0xcb0bfa11 },
{ 0xacebad03, short_gen62, long_gen62, 0xcb0bfa11 },
{ 0xacebad03, short_gen63, long_gen63, 0xcb0bfa11 },
{ 0xacebad03, short_gen64, long_gen64, 0xcb0bfa11 },
{ 0xacebad03, short_gen65, long_gen65, 0xcb0bfa11 },
{ 0xacebad03, short_gen66, long_gen66, 0xcb0bfa11 },
{ 0xacebad03, short_gen67, long_gen67, 0xcb0bfa11 },
{ 0xacebad03, short_gen68, long_gen68, 0xcb0bfa11 },
{ 0xacebad03, short_gen69, long_gen69, 0xcb0bfa11 },
{ 0xacebad03, short_gen70, long_gen70, 0xcb0bfa11 },
{ 0xacebad03, short_gen71, long_gen71, 0xcb0bfa11 },
{ 0xacebad03, short_gen72, long_gen72, 0xcb0bfa11 },
{ 0xacebad03, short_gen73, long_gen73, 0xcb0bfa11 },
{ 0xacebad03, short_gen74, long_gen74, 0xcb0bfa11 },
{ 0xacebad03, short_gen75, long_gen75, 0xcb0bfa11 },
{ 0xacebad03, short_gen76, long_gen76, 0xcb0bfa11 },
{ 0xacebad03, short_gen77, long_gen77, 0xcb0bfa11 },
{ 0xacebad03, short_gen78, long_gen78, 0xcb0bfa11 },
{ 0xacebad03, short_gen79, long_gen79, 0xcb0bfa11 },
{ 0xacebad03, short_gen80, long_gen80, 0xcb0bfa11 },
{ 0xacebad03, short_gen81, long_gen81, 0xcb0bfa11 },
{ 0xacebad03, short_gen82, long_gen82, 0xcb0bfa11 },
{ 0xacebad03, short_gen83, long_gen83, 0xcb0bfa11 },
{ 0xacebad03, short_gen84, long_gen84, 0xcb0bfa11 },
{ 0xacebad03, short_gen85, long_gen85, 0xcb0bfa11 },
{ 0xacebad03, short_gen86, long_gen86, 0xcb0bfa11 },
{ 0xacebad03, short_gen87, long_gen87, 0xcb0bfa11 },
{ 0xacebad03, short_gen88, long_gen88, 0xcb0bfa11 },
{ 0xacebad03, short_gen89, long_gen89, 0xcb0bfa11 },
{ 0xacebad03, short_gen90, long_gen90, 0xcb0bfa11 },
{ 0xacebad03, short_gen91, long_gen91, 0xcb0bfa11 },
{ 0xacebad03, short_gen92, long_gen92, 0xcb0bfa11 },
{ 0xacebad03, short_gen93, long_gen93, 0xcb0bfa11 },
{ 0xacebad03, short_gen94, long_gen94, 0xcb0bfa11 },
{ 0xacebad03, short_gen95, long_gen95, 0xcb0bfa11 },
{ 0xacebad03, short_gen96, long_gen96, 0xcb0bfa11 },
{ 0xacebad03, short_gen97, long_gen97, 0xcb0bfa11 },
{ 0xacebad03, short_gen98, long_gen98, 0xcb0bfa11 },
{ 0xacebad03, short_gen99, long_gen99, 0xcb0bfa11 },
{ 0xacebad03, short_gen100, long_gen100, 0xcb0bfa11 },
{ 0xacebad03, short_gen101, long_gen101, 0xcb0bfa11 },
{ 0xacebad03, short_gen102, long_gen102, 0xcb0bfa11 },
{ 0xacebad03, short_gen103, long_gen103, 0xcb0bfa11 },
{ 0xacebad03, short_gen104, long_gen104, 0xcb0bfa11 },
{ 0xacebad03, short_gen105, long_gen105, 0xcb0bfa11 },
{ 0xacebad03, short_gen106, long_gen106, 0xcb0bfa11 },
{ 0xacebad03, short_gen107, long_gen107, 0xcb0bfa11 },
{ 0xacebad03, short_gen108, long_gen108, 0xcb0bfa11 },
{ 0xacebad03, short_gen109, long_gen109, 0xcb0bfa11 },
{ 0xacebad03, short_gen110, long_gen110, 0xcb0bfa11 },
{ 0xacebad03, short_gen111, long_gen111, 0xcb0bfa11 },
{ 0xacebad03, short_gen112, long_gen112, 0xcb0bfa11 },
{ 0xacebad03, short_gen113, long_gen113, 0xcb0bfa11 },
{ 0xacebad03, short_gen114, long_gen114, 0xcb0bfa11 },
{ 0xacebad03, short_gen115, long_gen115, 0xcb0bfa11 },
{ 0xacebad03, short_gen116, long_gen116, 0xcb0bfa11 },
{ 0xacebad03, short_gen117, long_gen117, 0xcb0bfa11 },
{ 0xacebad03, short_gen118, long_gen118, 0xcb0bfa11 },
{ 0xacebad03, short_gen119, long_gen119, 0xcb0bfa11 },
{ 0xacebad03, short_gen120, long_gen120, 0xcb0bfa11 },
{ 0xacebad03, short_gen121, long_gen121, 0xcb0bfa11 },
{ 0xacebad03, short_gen122, long_gen122, 0xcb0bfa11 },
{ 0xacebad03, short_gen123, long_gen123, 0xcb0bfa11 },
{ 0xacebad03, short_gen124, long_gen124, 0xcb0bfa11 },
{ 0xacebad03, short_gen125, long_gen125, 0xcb0bfa11 },
{ 0xacebad03, short_gen126, long_gen126, 0xcb0bfa11 },
{ 0xacebad03, short_gen127, long_gen127, 0xcb0bfa11 },
{ 0xacebad03, short_gen128, long_gen128, 0xcb0bfa11 },
{ 0xacebad03, short_gen129, long_gen129, 0xcb0bfa11 },
{ 0xacebad03, short_gen130, long_gen130, 0xcb0bfa11 },
{ 0xacebad03, short_gen131, long_gen131, 0xcb0bfa11 },
{ 0xacebad03, short_gen132, long_gen132, 0xcb0bfa11 },
{ 0xacebad03, short_gen133, long_gen133, 0xcb0bfa11 },
{ 0xacebad03, short_gen134, long_gen134, 0xcb0bfa11 },
{ 0xacebad03, short_gen135, long_gen135, 0xcb0bfa11 },
{ 0xacebad03, short_gen136, long_gen136, 0xcb0bfa11 },
{ 0xacebad03, short_gen137, long_gen137, 0xcb0bfa11 },
{ 0xacebad03, short_gen138, long_gen138, 0xcb0bfa11 },
{ 0xacebad03, short_gen139, long_gen139, 0xcb0bfa11 },
{ 0xacebad03, short_gen140, long_gen140, 0xcb0bfa11 },
{ 0xacebad03, short_gen141, long_gen141, 0xcb0bfa11 },
{ 0xacebad03, short_gen142, long_gen142, 0xcb0bfa11 },
{ 0xacebad03, short_gen143, long_gen143, 0xcb0bfa11 },
{ 0xacebad03, short_gen144, long_gen144, 0xcb0bfa11 },
{ 0xacebad03, short_gen145, long_gen145, 0xcb0bfa11 },
{ 0xacebad03, short_gen146, long_gen146, 0xcb0bfa11 },
{ 0xacebad03, short_gen147, long_gen147, 0xcb0bfa11 },
{ 0xacebad03, short_gen148, long_gen148, 0xcb0bfa11 },
{ 0xacebad03, short_gen149, long_gen149, 0xcb0bfa11 },
{ 0xacebad03, short_gen150, long_gen150, 0xcb0bfa11 },
{ 0xacebad03, short_gen151, long_gen151, 0xcb0bfa11 },
{ 0xacebad03, short_gen152, long_gen152, 0xcb0bfa11 },
{ 0xacebad03, short_gen153, long_gen153, 0xcb0bfa11 },
{ 0xacebad03, short_gen154, long_gen154, 0xcb0bfa11 },
{ 0xacebad03, short_gen155, long_gen155, 0xcb0bfa11 },
{ 0xacebad03, short_gen156, long_gen156, 0xcb0bfa11 },
{ 0xacebad03, short_gen157, long_gen157, 0xcb0bfa11 },
{ 0xacebad03, short_gen158, long_gen158, 0xcb0bfa11 },
{ 0xacebad03, short_gen159, long_gen159, 0xcb0bfa11 },
{ 0xacebad03, short_gen160, long_gen160, 0xcb0bfa11 },
{ 0xacebad03, short_gen161, long_gen161, 0xcb0bfa11 },
{ 0xacebad03, short_gen162, long_gen162, 0xcb0bfa11 },
{ 0xacebad03, short_gen163, long_gen163, 0xcb0bfa11 },
{ 0xacebad03, short_gen164, long_gen164, 0xcb0bfa11 },
{ 0xacebad03, short_gen165, long_gen165, 0xcb0bfa11 },
{ 0xacebad03, short_gen166, long_gen166, 0xcb0bfa11 },
{ 0xacebad03, short_gen167, long_gen167, 0xcb0bfa11 },
{ 0xacebad03, short_gen168, long_gen168, 0xcb0bfa11 },
{ 0xacebad03, short_gen169, long_gen169, 0xcb0bfa11 },
{ 0xacebad03, short_gen170, long_gen170, 0xcb0bfa11 },
{ 0xacebad03, short_gen171, long_gen171, 0xcb0bfa11 },
{ 0xacebad03, short_gen172, long_gen172, 0xcb0bfa11 },
{ 0xacebad03, short_gen173, long_gen173, 0xcb0bfa11 },
{ 0xacebad03, short_gen174, long_gen174, 0xcb0bfa11 },
{ 0xacebad03, short_gen175, long_gen175, 0xcb0bfa11 },
{ 0xacebad03, short_gen176, long_gen176, 0xcb0bfa11 },
{ 0xacebad03, short_gen177, long_gen177, 0xcb0bfa11 },
{ 0xacebad03, short_gen178, long_gen178, 0xcb0bfa11 },
{ 0xacebad03, short_gen179, long_gen179, 0xcb0bfa11 },
{ 0xacebad03, short_gen180, long_gen180, 0xcb0bfa11 },
{ 0xacebad03, short_gen181, long_gen181, 0xcb0bfa11 },
{ 0xacebad03, short_gen182, long_gen182, 0xcb0bfa11 },
{ 0xacebad03, short_gen183, long_gen183, 0xcb0bfa11 },
{ 0xacebad03, short_gen184, long_gen184, 0xcb0bfa11 },
{ 0xacebad03, short_gen185, long_gen185, 0xcb0bfa11 },
{ 0xacebad03, short_gen186, long_gen186, 0xcb0bfa11 },
{ 0xacebad03, short_gen187, long_gen187, 0xcb0bfa11 },
{ 0xacebad03, short_gen188, long_gen188, 0xcb0bfa11 },
{ 0xacebad03, short_gen189, long_gen189, 0xcb0bfa11 },
{ 0xacebad03, short_gen190, long_gen190, 0xcb0bfa11 },
{ 0xacebad03, short_gen191, long_gen191, 0xcb0bfa11 },
{ 0xacebad03, short_gen192, long_gen192, 0xcb0bfa11 },
{ 0xacebad03, short_gen193, long_gen193, 0xcb0bfa11 },
{ 0xacebad03, short_gen194, long_gen194, 0xcb0bfa11 },
{ 0xacebad03, short_gen195, long_gen195, 0xcb0bfa11 },
{ 0xacebad03, short_gen196, long_gen196, 0xcb0bfa11 },
{ 0xacebad03, short_gen197, long_gen197, 0xcb0bfa11 },
{ 0xacebad03, short_gen198, long_gen198, 0xcb0bfa11 },
{ 0xacebad03, short_gen199, long_gen199, 0xcb0bfa11 },
{ 0xacebad03, short_gen200, long_gen200, 0xcb0bfa11 },
{ 0xacebad03, short_gen201, long_gen201, 0xcb0bfa11 },
{ 0xacebad03, short_gen202, long_gen202, 0xcb0bfa11 },
{ 0xacebad03, short_gen203, long_gen203, 0xcb0bfa11 },
{ 0xacebad03, short_gen204, long_gen204, 0xcb0bfa11 },
{ 0xacebad03, short_gen205, long_gen205, 0xcb0bfa11 },
{ 0xacebad03, short_gen206, long_gen206, 0xcb0bfa11 },
{ 0xacebad03, short_gen207, long_gen207, 0xcb0bfa11 },
{ 0xacebad03, short_gen208, long_gen208, 0xcb0bfa11 },
{ 0xacebad03, short_gen209, long_gen209, 0xcb0bfa11 },
{ 0xacebad03, short_gen210, long_gen210, 0xcb0bfa11 },
{ 0xacebad03, short_gen211, long_gen211, 0xcb0bfa11 },
{ 0xacebad03, short_gen212, long_gen212, 0xcb0bfa11 },
{ 0xacebad03, short_gen213, long_gen213, 0xcb0bfa11 },
{ 0xacebad03, short_gen214, long_gen214, 0xcb0bfa11 },
{ 0xacebad03, short_gen215, long_gen215, 0xcb0bfa11 },
{ 0xacebad03, short_gen216, long_gen216, 0xcb0bfa11 },
{ 0xacebad03, short_gen217, long_gen217, 0xcb0bfa11 },
{ 0xacebad03, short_gen218, long_gen218, 0xcb0bfa11 },
{ 0xacebad03, short_gen219, long_gen219, 0xcb0bfa11 },
{ 0xacebad03, short_gen220, long_gen220, 0xcb0bfa11 },
{ 0xacebad03, short_gen221, long_gen221, 0xcb0bfa11 },
{ 0xacebad03, short_gen222, long_gen222, 0xcb0bfa11 },
{ 0xacebad03, short_gen223, long_gen223, 0xcb0bfa11 },
{ 0xacebad03, short_gen224, long_gen224, 0xcb0bfa11 },
{ 0xacebad03, short_gen225, long_gen225, 0xcb0bfa11 },
{ 0xacebad03, short_gen226, long_gen226, 0xcb0bfa11 },
{ 0xacebad03, short_gen227, long_gen227, 0xcb0bfa11 },
{ 0xacebad03, short_gen228, long_gen228, 0xcb0bfa11 },
{ 0xacebad03, short_gen229, long_gen229, 0xcb0bfa11 },
{ 0xacebad03, short_gen230, long_gen230, 0xcb0bfa11 },
{ 0xacebad03, short_gen231, long_gen231, 0xcb0bfa11 },
{ 0xacebad03, short_gen232, long_gen232, 0xcb0bfa11 },
{ 0xacebad03, short_gen233, long_gen233, 0xcb0bfa11 },
{ 0xacebad03, short_gen234, long_gen234, 0xcb0bfa11 },
{ 0xacebad03, short_gen235, long_gen235, 0xcb0bfa11 },
{ 0xacebad03, short_gen236, long_gen236, 0xcb0bfa11 },
{ 0xacebad03, short_gen237, long_gen237, 0xcb0bfa11 },
{ 0xacebad03, short_gen238, long_gen238, 0xcb0bfa11 },
{ 0xacebad03, short_gen239, long_gen239, 0xcb0bfa11 },
{ 0xacebad03, short_gen240, long_gen240, 0xcb0bfa11 },
{ 0xacebad03, short_gen241, long_gen241, 0xcb0bfa11 },
{ 0xacebad03, short_gen242, long_gen242, 0xcb0bfa11 },
{ 0xacebad03, short_gen243, long_gen243, 0xcb0bfa11 },
{ 0xacebad03, short_gen244, long_gen244, 0xcb0bfa11 },
{ 0xacebad03, short_gen245, long_gen245, 0xcb0bfa11 },
{ 0xacebad03, short_gen246, long_gen246, 0xcb0bfa11 },
{ 0xacebad03, short_gen247, long_gen247, 0xcb0bfa11 },
{ 0xacebad03, short_gen248, long_gen248, 0xcb0bfa11 },
{ 0xacebad03, short_gen249, long_gen249, 0xcb0bfa11 },
{ 0xacebad03, short_gen250, long_gen250, 0xcb0bfa11 },
{ 0xacebad03, short_gen251, long_gen251, 0xcb0bfa11 },
{ 0xacebad03, short_gen252, long_gen252, 0xcb0bfa11 },
{ 0xacebad03, short_gen253, long_gen253, 0xcb0bfa11 },
{ 0xacebad03, short_gen254, long_gen254, 0xcb0bfa11 },
{ 0xacebad03, short_gen255, long_gen255, 0xcb0bfa11 },
{ 0xacebad03, short_gen256, long_gen256, 0xcb0bfa11 },
{ 0xacebad03, short_gen257, long_gen257, 0xcb0bfa11 },
{ 0xacebad03, short_gen258, long_gen258, 0xcb0bfa11 },
{ 0xacebad03, short_gen259, long_gen259, 0xcb0bfa11 },
{ 0xacebad03, short_gen260, long_gen260, 0xcb0bfa11 },
{ 0xacebad03, short_gen261, long_gen261, 0xcb0bfa11 },
{ 0xacebad03, short_gen262, long_gen262, 0xcb0bfa11 },
{ 0xacebad03, short_gen263, long_gen263, 0xcb0bfa11 },
{ 0xacebad03, short_gen264, long_gen264, 0xcb0bfa11 },
{ 0xacebad03, short_gen265, long_gen265, 0xcb0bfa11 },
{ 0xacebad03, short_gen266, long_gen266, 0xcb0bfa11 },
{ 0xacebad03, short_gen267, long_gen267, 0xcb0bfa11 },
{ 0xacebad03, short_gen268, long_gen268, 0xcb0bfa11 },
{ 0xacebad03, short_gen269, long_gen269, 0xcb0bfa11 },
{ 0xacebad03, short_gen270, long_gen270, 0xcb0bfa11 },
{ 0xacebad03, short_gen271, long_gen271, 0xcb0bfa11 },
{ 0xacebad03, short_gen272, long_gen272, 0xcb0bfa11 },
{ 0xacebad03, short_gen273, long_gen273, 0xcb0bfa11 },
{ 0xacebad03, short_gen274, long_gen274, 0xcb0bfa11 },
{ 0xacebad03, short_gen275, long_gen275, 0xcb0bfa11 },
{ 0xacebad03, short_gen276, long_gen276, 0xcb0bfa11 },
{ 0xacebad03, short_gen277, long_gen277, 0xcb0bfa11 },
{ 0xacebad03, short_gen278, long_gen278, 0xcb0bfa11 },
{ 0xacebad03, short_gen279, long_gen279, 0xcb0bfa11 },
{ 0xacebad03, short_gen280, long_gen280, 0xcb0bfa11 },
{ 0xacebad03, short_gen281, long_gen281, 0xcb0bfa11 },
{ 0xacebad03, short_gen282, long_gen282, 0xcb0bfa11 },
{ 0xacebad03, short_gen283, long_gen283, 0xcb0bfa11 },
{ 0xacebad03, short_gen284, long_gen284, 0xcb0bfa11 },
{ 0xacebad03, short_gen285, long_gen285, 0xcb0bfa11 },
{ 0xacebad03, short_gen286, long_gen286, 0xcb0bfa11 },
{ 0xacebad03, short_gen287, long_gen287, 0xcb0bfa11 },
{ 0xacebad03, short_gen288, long_gen288, 0xcb0bfa11 },
{ 0xacebad03, short_gen289, long_gen289, 0xcb0bfa11 },
{ 0xacebad03, short_gen290, long_gen290, 0xcb0bfa11 },
{ 0xacebad03, short_gen291, long_gen291, 0xcb0bfa11 },
{ 0xacebad03, short_gen292, long_gen292, 0xcb0bfa11 },
{ 0xacebad03, short_gen293, long_gen293, 0xcb0bfa11 },
{ 0xacebad03, short_gen294, long_gen294, 0xcb0bfa11 },
{ 0xacebad03, short_gen295, long_gen295, 0xcb0bfa11 },
{ 0xacebad03, short_gen296, long_gen296, 0xcb0bfa11 },
{ 0xacebad03, short_gen297, long_gen297, 0xcb0bfa11 },
{ 0xacebad03, short_gen298, long_gen298, 0xcb0bfa11 },
{ 0xacebad03, short_gen299, long_gen299, 0xcb0bfa11 },
{ 0xacebad03, short_gen300, long_gen300, 0xcb0bfa11 },
{ 0xacebad03, short_gen301, long_gen301, 0xcb0bfa11 },
{ 0xacebad03, short_gen302, long_gen302, 0xcb0bfa11 },
{ 0xacebad03, short_gen303, long_gen303, 0xcb0bfa11 },
{ 0xacebad03, short_gen304, long_gen304, 0xcb0bfa11 },
{ 0xacebad03, short_gen305, long_gen305, 0xcb0bfa11 },
{ 0xacebad03, short_gen306, long_gen306, 0xcb0bfa11 },
{ 0xacebad03, short_gen307, long_gen307, 0xcb0bfa11 },
{ 0xacebad03, short_gen308, long_gen308, 0xcb0bfa11 },
{ 0xacebad03, short_gen309, long_gen309, 0xcb0bfa11 },
{ 0xacebad03, short_gen310, long_gen310, 0xcb0bfa11 },
{ 0xacebad03, short_gen311, long_gen311, 0xcb0bfa11 },
{ 0xacebad03, short_gen312, long_gen312, 0xcb0bfa11 },
{ 0xacebad03, short_gen313, long_gen313, 0xcb0bfa11 },
{ 0xacebad03, short_gen314, long_gen314, 0xcb0bfa11 },
{ 0xacebad03, short_gen315, long_gen315, 0xcb0bfa11 },
{ 0xacebad03, short_gen316, long_gen316, 0xcb0bfa11 },
{ 0xacebad03, short_gen317, long_gen317, 0xcb0bfa11 },
{ 0xacebad03, short_gen318, long_gen318, 0xcb0bfa11 },
{ 0xacebad03, short_gen319, long_gen319, 0xcb0bfa11 },
{ 0xacebad03, short_gen320, long_gen320, 0xcb0bfa11 },
{ 0xacebad03, short_gen321, long_gen321, 0xcb0bfa11 },
{ 0xacebad03, short_gen322, long_gen322, 0xcb0bfa11 },
{ 0xacebad03, short_gen323, long_gen323, 0xcb0bfa11 },
{ 0xacebad03, short_gen324, long_gen324, 0xcb0bfa11 },
{ 0xacebad03, short_gen325, long_gen325, 0xcb0bfa11 },
{ 0xacebad03, short_gen326, long_gen326, 0xcb0bfa11 },
{ 0xacebad03, short_gen327, long_gen327, 0xcb0bfa11 },
{ 0xacebad03, short_gen328, long_gen328, 0xcb0bfa11 },
{ 0xacebad03, short_gen329, long_gen329, 0xcb0bfa11 },
{ 0xacebad03, short_gen330, long_gen330, 0xcb0bfa11 },
{ 0xacebad03, short_gen331, long_gen331, 0xcb0bfa11 },
{ 0xacebad03, short_gen332, long_gen332, 0xcb0bfa11 },
{ 0xacebad03, short_gen333, long_gen333, 0xcb0bfa11 },
{ 0xacebad03, short_gen334, long_gen334, 0xcb0bfa11 },
{ 0xacebad03, short_gen335, long_gen335, 0xcb0bfa11 },
{ 0xacebad03, short_gen336, long_gen336, 0xcb0bfa11 },
{ 0xacebad03, short_gen337, long_gen337, 0xcb0bfa11 },
{ 0xacebad03, short_gen338, long_gen338, 0xcb0bfa11 },
{ 0xacebad03, short_gen339, long_gen339, 0xcb0bfa11 },
{ 0xacebad03, short_gen340, long_gen340, 0xcb0bfa11 },
{ 0xacebad03, short_gen341, long_gen341, 0xcb0bfa11 },
{ 0xacebad03, short_gen342, long_gen342, 0xcb0bfa11 },
{ 0xacebad03, short_gen343, long_gen343, 0xcb0bfa11 },
{ 0xacebad03, short_gen344, long_gen344, 0xcb0bfa11 },
{ 0xacebad03, short_gen345, long_gen345, 0xcb0bfa11 },
{ 0xacebad03, short_gen346, long_gen346, 0xcb0bfa11 },
{ 0xacebad03, short_gen347, long_gen347, 0xcb0bfa11 },
{ 0xacebad03, short_gen348, long_gen348, 0xcb0bfa11 },
{ 0xacebad03, short_gen349, long_gen349, 0xcb0bfa11 },
{ 0xacebad03, short_gen350, long_gen350, 0xcb0bfa11 },
{ 0xacebad03, short_gen351, long_gen351, 0xcb0bfa11 },
{ 0xacebad03, short_gen352, long_gen352, 0xcb0bfa11 },
{ 0xacebad03, short_gen353, long_gen353, 0xcb0bfa11 },
{ 0xacebad03, short_gen354, long_gen354, 0xcb0bfa11 },
{ 0xacebad03, short_gen355, long_gen355, 0xcb0bfa11 },
{ 0xacebad03, short_gen356, long_gen356, 0xcb0bfa11 },
{ 0xacebad03, short_gen357, long_gen357, 0xcb0bfa11 },
{ 0xacebad03, short_gen358, long_gen358, 0xcb0bfa11 },
{ 0xacebad03, short_gen359, long_gen359, 0xcb0bfa11 },
{ 0xacebad03, short_gen360, long_gen360, 0xcb0bfa11 },
{ 0xacebad03, short_gen361, long_gen361, 0xcb0bfa11 },
{ 0xacebad03, short_gen362, long_gen362, 0xcb0bfa11 },
{ 0xacebad03, short_gen363, long_gen363, 0xcb0bfa11 },
{ 0xacebad03, short_gen364, long_gen364, 0xcb0bfa11 },
{ 0xacebad03, short_gen365, long_gen365, 0xcb0bfa11 },
{ 0xacebad03, short_gen366, long_gen366, 0xcb0bfa11 },
{ 0xacebad03, short_gen367, long_gen367, 0xcb0bfa11 },
{ 0xacebad03, short_gen368, long_gen368, 0xcb0bfa11 },
{ 0xacebad03, short_gen369, long_gen369, 0xcb0bfa11 },
{ 0xacebad03, short_gen370, long_gen370, 0xcb0bfa11 },
{ 0xacebad03, short_gen371, long_gen371, 0xcb0bfa11 },
{ 0xacebad03, short_gen372, long_gen372, 0xcb0bfa11 },
{ 0xacebad03, short_gen373, long_gen373, 0xcb0bfa11 },
{ 0xacebad03, short_gen374, long_gen374, 0xcb0bfa11 },
{ 0xacebad03, short_gen375, long_gen375, 0xcb0bfa11 },
{ 0xacebad03, short_gen376, long_gen376, 0xcb0bfa11 },
{ 0xacebad03, short_gen377, long_gen377, 0xcb0bfa11 },
{ 0xacebad03, short_gen378, long_gen378, 0xcb0bfa11 },
{ 0xacebad03, short_gen379, long_gen379, 0xcb0bfa11 },
{ 0xacebad03, short_gen380, long_gen380, 0xcb0bfa11 },
{ 0xacebad03, short_gen381, long_gen381, 0xcb0bfa11 },
{ 0xacebad03, short_gen382, long_gen382, 0xcb0bfa11 },
{ 0xacebad03, short_gen383, long_gen383, 0xcb0bfa11 },
{ 0xacebad03, short_gen384, long_gen384, 0xcb0bfa11 },
{ 0xacebad03, short_gen385, long_gen385, 0xcb0bfa11 },
{ 0xacebad03, short_gen386, long_gen386, 0xcb0bfa11 },
{ 0xacebad03, short_gen387, long_gen387, 0xcb0bfa11 },
{ 0xacebad03, short_gen388, long_gen388, 0xcb0bfa11 },
{ 0xacebad03, short_gen389, long_gen389, 0xcb0bfa11 },
{ 0xacebad03, short_gen390, long_gen390, 0xcb0bfa11 },
{ 0xacebad03, short_gen391, long_gen391, 0xcb0bfa11 },
{ 0xacebad03, short_gen392, long_gen392, 0xcb0bfa11 },
{ 0xacebad03, short_gen393, long_gen393, 0xcb0bfa11 },
{ 0xacebad03, short_gen394, long_gen394, 0xcb0bfa11 },
{ 0xacebad03, short_gen395, long_gen395, 0xcb0bfa11 },
{ 0xacebad03, short_gen396, long_gen396, 0xcb0bfa11 },
{ 0xacebad03, short_gen397, long_gen397, 0xcb0bfa11 },
{ 0xacebad03, short_gen398, long_gen398, 0xcb0bfa11 },
{ 0xacebad03, short_gen399, long_gen399, 0xcb0bfa11 },
{ 0xacebad03, short_gen400, long_gen400, 0xcb0bfa11 },
{ 0xacebad03, short_gen401, long_gen401, 0xcb0bfa11 },
{ 0xacebad03, short_gen402, long_gen402, 0xcb0bfa11 },
{ 0xacebad03, short_gen403, long_gen403, 0xcb0bfa11 },
{ 0xacebad03, short_gen404, long_gen404, 0xcb0bfa11 },
{ 0xacebad03, short_gen405, long_gen405, 0xcb0bfa11 },
{ 0xacebad03, short_gen406, long_gen406, 0xcb0bfa11 },
{ 0xacebad03, short_gen407, long_gen407, 0xcb0bfa11 },
{ 0xacebad03, short_gen408, long_gen408, 0xcb0bfa11 },
{ 0xacebad03, short_gen409, long_gen409, 0xcb0bfa11 },
{ 0xacebad03, short_gen410, long_gen410, 0xcb0bfa11 },
{ 0xacebad03, short_gen411, long_gen411, 0xcb0bfa11 },
{ 0xacebad03, short_gen412, long_gen412, 0xcb0bfa11 },
{ 0xacebad03, short_gen413, long_gen413, 0xcb0bfa11 },
{ 0xacebad03, short_gen414, long_gen414, 0xcb0bfa11 },
{ 0xacebad03, short_gen415, long_gen415, 0xcb0bfa11 },
{ 0xacebad03, short_gen416, long_gen416, 0xcb0bfa11 },
{ 0xacebad03, short_gen417, long_gen417, 0xcb0bfa11 },
{ 0xacebad03, short_gen418, long_gen418, 0xcb0bfa11 },
{ 0xacebad03, short_gen419, long_gen419, 0xcb0bfa11 },
{ 0xacebad03, short_gen420, long_gen420, 0xcb0bfa11 },
{ 0xacebad03, short_gen421, long_gen421, 0xcb0bfa11 },
{ 0xacebad03, short_gen422, long_gen422, 0xcb0bfa11 },
{ 0xacebad03, short_gen423, long_gen423, 0xcb0bfa11 },
{ 0xacebad03, short_gen424, long_gen424, 0xcb0bfa11 },
{ 0xacebad03, short_gen425, long_gen425, 0xcb0bfa11 },
{ 0xacebad03, short_gen426, long_gen426, 0xcb0bfa11 },
{ 0xacebad03, short_gen427, long_gen427, 0xcb0bfa11 },
{ 0xacebad03, short_gen428, long_gen428, 0xcb0bfa11 },
{ 0xacebad03, short_gen429, long_gen429, 0xcb0bfa11 },
{ 0xacebad03, short_gen430, long_gen430, 0xcb0bfa11 },
{ 0xacebad03, short_gen431, long_gen431, 0xcb0bfa11 },
{ 0xacebad03, short_gen432, long_gen432, 0xcb0bfa11 },
{ 0xacebad03, short_gen433, long_gen433, 0xcb0bfa11 },
{ 0xacebad03, short_gen434, long_gen434, 0xcb0bfa11 },
{ 0xacebad03, short_gen435, long_gen435, 0xcb0bfa11 },
{ 0xacebad03, short_gen436, long_gen436, 0xcb0bfa11 },
{ 0xacebad03, short_gen437, long_gen437, 0xcb0bfa11 },
{ 0xacebad03, short_gen438, long_gen438, 0xcb0bfa11 },
{ 0xacebad03, short_gen439, long_gen439, 0xcb0bfa11 },
{ 0xacebad03, short_gen440, long_gen440, 0xcb0bfa11 },
{ 0xacebad03, short_gen441, long_gen441, 0xcb0bfa11 },
{ 0xacebad03, short_gen442, long_gen442, 0xcb0bfa11 },
{ 0xacebad03, short_gen443, long_gen443, 0xcb0bfa11 },
{ 0xacebad03, short_gen444, long_gen444, 0xcb0bfa11 },
{ 0xacebad03, short_gen445, long_gen445, 0xcb0bfa11 },
{ 0xacebad03, short_gen446, long_gen446, 0xcb0bfa11 },
{ 0xacebad03, short_gen447, long_gen447, 0xcb0bfa11 },
{ 0xacebad03, short_gen448, long_gen448, 0xcb0bfa11 },
{ 0xacebad03, short_gen449, long_gen449, 0xcb0bfa11 },
{ 0xacebad03, short_gen450, long_gen450, 0xcb0bfa11 },
{ 0xacebad03, short_gen451, long_gen451, 0xcb0bfa11 },
{ 0xacebad03, short_gen452, long_gen452, 0xcb0bfa11 },
{ 0xacebad03, short_gen453, long_gen453, 0xcb0bfa11 },
{ 0xacebad03, short_gen454, long_gen454, 0xcb0bfa11 },
{ 0xacebad03, short_gen455, long_gen455, 0xcb0bfa11 },
{ 0xacebad03, short_gen456, long_gen456, 0xcb0bfa11 },
{ 0xacebad03, short_gen457, long_gen457, 0xcb0bfa11 },
{ 0xacebad03, short_gen458, long_gen458, 0xcb0bfa11 },
{ 0xacebad03, short_gen459, long_gen459, 0xcb0bfa11 },
{ 0xacebad03, short_gen460, long_gen460, 0xcb0bfa11 },
{ 0xacebad03, short_gen461, long_gen461, 0xcb0bfa11 },
{ 0xacebad03, short_gen462, long_gen462, 0xcb0bfa11 },
{ 0xacebad03, short_gen463, long_gen463, 0xcb0bfa11 },
{ 0xacebad03, short_gen464, long_gen464, 0xcb0bfa11 },
{ 0xacebad03, short_gen465, long_gen465, 0xcb0bfa11 },
{ 0xacebad03, short_gen466, long_gen466, 0xcb0bfa11 },
{ 0xacebad03, short_gen467, long_gen467, 0xcb0bfa11 },
{ 0xacebad03, short_gen468, long_gen468, 0xcb0bfa11 },
{ 0xacebad03, short_gen469, long_gen469, 0xcb0bfa11 },
{ 0xacebad03, short_gen470, long_gen470, 0xcb0bfa11 },
{ 0xacebad03, short_gen471, long_gen471, 0xcb0bfa11 },
{ 0xacebad03, short_gen472, long_gen472, 0xcb0bfa11 },
{ 0xacebad03, short_gen473, long_gen473, 0xcb0bfa11 },
{ 0xacebad03, short_gen474, long_gen474, 0xcb0bfa11 },
{ 0xacebad03, short_gen475, long_gen475, 0xcb0bfa11 },
{ 0xacebad03, short_gen476, long_gen476, 0xcb0bfa11 },
{ 0xacebad03, short_gen477, long_gen477, 0xcb0bfa11 },
{ 0xacebad03, short_gen478, long_gen478, 0xcb0bfa11 },
{ 0xacebad03, short_gen479, long_gen479, 0xcb0bfa11 },
{ 0xacebad03, short_gen480, long_gen480, 0xcb0bfa11 },
{ 0xacebad03, short_gen481, long_gen481, 0xcb0bfa11 },
{ 0xacebad03, short_gen482, long_gen482, 0xcb0bfa11 },
{ 0xacebad03, short_gen483, long_gen483, 0xcb0bfa11 },
{ 0xacebad03, short_gen484, long_gen484, 0xcb0bfa11 },
{ 0xacebad03, short_gen485, long_gen485, 0xcb0bfa11 },
{ 0xacebad03, short_gen486, long_gen486, 0xcb0bfa11 },
{ 0xacebad03, short_gen487, long_gen487, 0xcb0bfa11 },
{ 0xacebad03, short_gen488, long_gen488, 0xcb0bfa11 },
{ 0xacebad03, short_gen489, long_gen489, 0xcb0bfa11 },
{ 0xacebad03, short_gen490, long_gen490, 0xcb0bfa11 },
{ 0xacebad03, short_gen491, long_gen491, 0xcb0bfa11 },
{ 0xacebad03, short_gen492, long_gen492, 0xcb0bfa11 },
{ 0xacebad03, short_gen493, long_gen493, 0xcb0bfa11 },
{ 0xacebad03, short_gen494, long_gen494, 0xcb0bfa11 },
{ 0xacebad03, short_gen495, long_gen495, 0xcb0bfa11 },
{ 0xacebad03, short_gen496, long_gen496, 0xcb0bfa11 },
{ 0xacebad03, short_gen497, long_gen497, 0xcb0bfa11 },
{ 0xacebad03, short_gen498, long_gen498, 0xcb0bfa11 },
{ 0xacebad03, short_gen499, long_gen499, 0xcb0bfa11 },
{ 0xacebad03, short_gen500, long_gen500, 0xcb0bfa11 },
{ 0xacebad03, short_gen501, long_gen501, 0xcb0bfa11 },
{ 0xacebad03, short_gen502, long_gen502, 0xcb0bfa11 },
{ 0xacebad03, short_gen503, long_gen503, 0xcb0bfa11 },
{ 0xacebad03, short_gen504, long_gen504, 0xcb0bfa11 },
{ 0xacebad03, short_gen505, long_gen505, 0xcb0bfa11 },
{ 0xacebad03, short_gen506, long_gen506, 0xcb0bfa11 },
{ 0xacebad03, short_gen507, long_gen507, 0xcb0bfa11 },
{ 0xacebad03, short_gen508, long_gen508, 0xcb0bfa11 },
{ 0xacebad03, short_gen509, long_gen509, 0xcb0bfa11 },
{ 0xacebad03, short_gen510, long_gen510, 0xcb0bfa11 },
{ 0xacebad03, short_gen511, long_gen511, 0xcb0bfa11 },
{ 0xacebad03, short_gen512, long_gen512, 0xcb0bfa11 },
{ 0xacebad03, short_gen513, long_gen513, 0xcb0bfa11 },
{ 0xacebad03, short_gen514, long_gen514, 0xcb0bfa11 },
{ 0xacebad03, short_gen515, long_gen515, 0xcb0bfa11 },
{ 0xacebad03, short_gen516, long_gen516, 0xcb0bfa11 },
{ 0xacebad03, short_gen517, long_gen517, 0xcb0bfa11 },
{ 0xacebad03, short_gen518, long_gen518, 0xcb0bfa11 },
{ 0xacebad03, short_gen519, long_gen519, 0xcb0bfa11 },
{ 0xacebad03, short_gen520, long_gen520, 0xcb0bfa11 },
{ 0xacebad03, short_gen521, long_gen521, 0xcb0bfa11 },
{ 0xacebad03, short_gen522, long_gen522, 0xcb0bfa11 },
{ 0xacebad03, short_gen523, long_gen523, 0xcb0bfa11 },
{ 0xacebad03, short_gen524, long_gen524, 0xcb0bfa11 },
{ 0xacebad03, short_gen525, long_gen525, 0xcb0bfa11 },
{ 0xacebad03, short_gen526, long_gen526, 0xcb0bfa11 },
{ 0xacebad03, short_gen527, long_gen527, 0xcb0bfa11 },
{ 0xacebad03, short_gen528, long_gen528, 0xcb0bfa11 },
{ 0xacebad03, short_gen529, long_gen529, 0xcb0bfa11 },
{ 0xacebad03, short_gen530, long_gen530, 0xcb0bfa11 },
{ 0xacebad03, short_gen531, long_gen531, 0xcb0bfa11 },
{ 0xacebad03, short_gen532, long_gen532, 0xcb0bfa11 },
{ 0xacebad03, short_gen533, long_gen533, 0xcb0bfa11 },
{ 0xacebad03, short_gen534, long_gen534, 0xcb0bfa11 },
{ 0xacebad03, short_gen535, long_gen535, 0xcb0bfa11 },
{ 0xacebad03, short_gen536, long_gen536, 0xcb0bfa11 },
{ 0xacebad03, short_gen537, long_gen537, 0xcb0bfa11 },
{ 0xacebad03, short_gen538, long_gen538, 0xcb0bfa11 },
{ 0xacebad03, short_gen539, long_gen539, 0xcb0bfa11 },
{ 0xacebad03, short_gen540, long_gen540, 0xcb0bfa11 },
{ 0xacebad03, short_gen541, long_gen541, 0xcb0bfa11 },
{ 0xacebad03, short_gen542, long_gen542, 0xcb0bfa11 },
{ 0xacebad03, short_gen543, long_gen543, 0xcb0bfa11 },
{ 0xacebad03, short_gen544, long_gen544, 0xcb0bfa11 },
{ 0xacebad03, short_gen545, long_gen545, 0xcb0bfa11 },
{ 0xacebad03, short_gen546, long_gen546, 0xcb0bfa11 },
{ 0xacebad03, short_gen547, long_gen547, 0xcb0bfa11 },
{ 0xacebad03, short_gen548, long_gen548, 0xcb0bfa11 },
{ 0xacebad03, short_gen549, long_gen549, 0xcb0bfa11 },
{ 0xacebad03, short_gen550, long_gen550, 0xcb0bfa11 },
{ 0xacebad03, short_gen551, long_gen551, 0xcb0bfa11 },
{ 0xacebad03, short_gen552, long_gen552, 0xcb0bfa11 },
{ 0xacebad03, short_gen553, long_gen553, 0xcb0bfa11 },
{ 0xacebad03, short_gen554, long_gen554, 0xcb0bfa11 },
{ 0xacebad03, short_gen555, long_gen555, 0xcb0bfa11 },
{ 0xacebad03, short_gen556, long_gen556, 0xcb0bfa11 },
{ 0xacebad03, short_gen557, long_gen557, 0xcb0bfa11 },
{ 0xacebad03, short_gen558, long_gen558, 0xcb0bfa11 },
{ 0xacebad03, short_gen559, long_gen559, 0xcb0bfa11 },
{ 0xacebad03, short_gen560, long_gen560, 0xcb0bfa11 },
{ 0xacebad03, short_gen561, long_gen561, 0xcb0bfa11 },
{ 0xacebad03, short_gen562, long_gen562, 0xcb0bfa11 },
{ 0xacebad03, short_gen563, long_gen563, 0xcb0bfa11 },
{ 0xacebad03, short_gen564, long_gen564, 0xcb0bfa11 },
{ 0xacebad03, short_gen565, long_gen565, 0xcb0bfa11 },
{ 0xacebad03, short_gen566, long_gen566, 0xcb0bfa11 },
{ 0xacebad03, short_gen567, long_gen567, 0xcb0bfa11 },
{ 0xacebad03, short_gen568, long_gen568, 0xcb0bfa11 },
{ 0xacebad03, short_gen569, long_gen569, 0xcb0bfa11 },
{ 0xacebad03, short_gen570, long_gen570, 0xcb0bfa11 },
{ 0xacebad03, short_gen571, long_gen571, 0xcb0bfa11 },
{ 0xacebad03, short_gen572, long_gen572, 0xcb0bfa11 },
{ 0xacebad03, short_gen573, long_gen573, 0xcb0bfa11 },
{ 0xacebad03, short_gen574, long_gen574, 0xcb0bfa11 },
{ 0xacebad03, short_gen575, long_gen575, 0xcb0bfa11 },
{ 0xacebad03, short_gen576, long_gen576, 0xcb0bfa11 },
{ 0xacebad03, short_gen577, long_gen577, 0xcb0bfa11 },
{ 0xacebad03, short_gen578, long_gen578, 0xcb0bfa11 },
{ 0xacebad03, short_gen579, long_gen579, 0xcb0bfa11 },
{ 0xacebad03, short_gen580, long_gen580, 0xcb0bfa11 },
{ 0xacebad03, short_gen581, long_gen581, 0xcb0bfa11 },
{ 0xacebad03, short_gen582, long_gen582, 0xcb0bfa11 },
{ 0xacebad03, short_gen583, long_gen583, 0xcb0bfa11 },
{ 0xacebad03, short_gen584, long_gen584, 0xcb0bfa11 },
{ 0xacebad03, short_gen585, long_gen585, 0xcb0bfa11 },
{ 0xacebad03, short_gen586, long_gen586, 0xcb0bfa11 },
{ 0xacebad03, short_gen587, long_gen587, 0xcb0bfa11 },
{ 0xacebad03, short_gen588, long_gen588, 0xcb0bfa11 },
{ 0xacebad03, short_gen589, long_gen589, 0xcb0bfa11 },
{ 0xacebad03, short_gen590, long_gen590, 0xcb0bfa11 },
{ 0xacebad03, short_gen591, long_gen591, 0xcb0bfa11 },
{ 0xacebad03, short_gen592, long_gen592, 0xcb0bfa11 },
{ 0xacebad03, short_gen593, long_gen593, 0xcb0bfa11 },
{ 0xacebad03, short_gen594, long_gen594, 0xcb0bfa11 },
{ 0xacebad03, short_gen595, long_gen595, 0xcb0bfa11 },
{ 0xacebad03, short_gen596, long_gen596, 0xcb0bfa11 },
{ 0xacebad03, short_gen597, long_gen597, 0xcb0bfa11 },
{ 0xacebad03, short_gen598, long_gen598, 0xcb0bfa11 },
{ 0xacebad03, short_gen599, long_gen599, 0xcb0bfa11 },
{ 0xacebad03, short_gen600, long_gen600, 0xcb0bfa11 },
{ 0xacebad03, short_gen601, long_gen601, 0xcb0bfa11 },
{ 0xacebad03, short_gen602, long_gen602, 0xcb0bfa11 },
{ 0xacebad03, short_gen603, long_gen603, 0xcb0bfa11 },
{ 0xacebad03, short_gen604, long_gen604, 0xcb0bfa11 },
{ 0xacebad03, short_gen605, long_gen605, 0xcb0bfa11 },
{ 0xacebad03, short_gen606, long_gen606, 0xcb0bfa11 },
{ 0xacebad03, short_gen607, long_gen607, 0xcb0bfa11 },
{ 0xacebad03, short_gen608, long_gen608, 0xcb0bfa11 },
{ 0xacebad03, short_gen609, long_gen609, 0xcb0bfa11 },
{ 0xacebad03, short_gen610, long_gen610, 0xcb0bfa11 },
{ 0xacebad03, short_gen611, long_gen611, 0xcb0bfa11 },
{ 0xacebad03, short_gen612, long_gen612, 0xcb0bfa11 },
{ 0xacebad03, short_gen613, long_gen613, 0xcb0bfa11 },
{ 0xacebad03, short_gen614, long_gen614, 0xcb0bfa11 },
{ 0xacebad03, short_gen615, long_gen615, 0xcb0bfa11 },
{ 0xacebad03, short_gen616, long_gen616, 0xcb0bfa11 },
{ 0xacebad03, short_gen617, long_gen617, 0xcb0bfa11 },
{ 0xacebad03, short_gen618, long_gen618, 0xcb0bfa11 },
{ 0xacebad03, short_gen619, long_gen619, 0xcb0bfa11 },
{ 0xacebad03, short_gen620, long_gen620, 0xcb0bfa11 },
{ 0xacebad03, short_gen621, long_gen621, 0xcb0bfa11 },
{ 0xacebad03, short_gen622, long_gen622, 0xcb0bfa11 },
{ 0xacebad03, short_gen623, long_gen623, 0xcb0bfa11 },
{ 0xacebad03, short_gen624, long_gen624, 0xcb0bfa11 },
{ 0xacebad03, short_gen625, long_gen625, 0xcb0bfa11 },
{ 0xacebad03, short_gen626, long_gen626, 0xcb0bfa11 },
{ 0xacebad03, short_gen627, long_gen627, 0xcb0bfa11 },
{ 0xacebad03, short_gen628, long_gen628, 0xcb0bfa11 },
{ 0xacebad03, short_gen629, long_gen629, 0xcb0bfa11 },
{ 0xacebad03, short_gen630, long_gen630, 0xcb0bfa11 },
{ 0xacebad03, short_gen631, long_gen631, 0xcb0bfa11 },
{ 0xacebad03, short_gen632, long_gen632, 0xcb0bfa11 },
{ 0xacebad03, short_gen633, long_gen633, 0xcb0bfa11 },
{ 0xacebad03, short_gen634, long_gen634, 0xcb0bfa11 },
{ 0xacebad03, short_gen635, long_gen635, 0xcb0bfa11 },
{ 0xacebad03, short_gen636, long_gen636, 0xcb0bfa11 },
{ 0xacebad03, short_gen637, long_gen637, 0xcb0bfa11 },
{ 0xacebad03, short_gen638, long_gen638, 0xcb0bfa11 },
{ 0xacebad03, short_gen639, long_gen639, 0xcb0bfa11 },
{ 0xacebad03, short_gen640, long_gen640, 0xcb0bfa11 },
{ 0xacebad03, short_gen641, long_gen641, 0xcb0bfa11 },
{ 0xacebad03, short_gen642, long_gen642, 0xcb0bfa11 },
{ 0xacebad03, short_gen643, long_gen643, 0xcb0bfa11 },
{ 0xacebad03, short_gen644, long_gen644, 0xcb0bfa11 },
{ 0xacebad03, short_gen645, long_gen645, 0xcb0bfa11 },
{ 0xacebad03, short_gen646, long_gen646, 0xcb0bfa11 },
{ 0xacebad03, short_gen647, long_gen647, 0xcb0bfa11 },
{ 0xacebad03, short_gen648, long_gen648, 0xcb0bfa11 },
{ 0xacebad03, short_gen649, long_gen649, 0xcb0bfa11 },
{ 0xacebad03, short_gen650, long_gen650, 0xcb0bfa11 },
{ 0xacebad03, short_gen651, long_gen651, 0xcb0bfa11 },
{ 0xacebad03, short_gen652, long_gen652, 0xcb0bfa11 },
{ 0xacebad03, short_gen653, long_gen653, 0xcb0bfa11 },
{ 0xacebad03, short_gen654, long_gen654, 0xcb0bfa11 },
{ 0xacebad03, short_gen655, long_gen655, 0xcb0bfa11 },
{ 0xacebad03, short_gen656, long_gen656, 0xcb0bfa11 },
{ 0xacebad03, short_gen657, long_gen657, 0xcb0bfa11 },
{ 0xacebad03, short_gen658, long_gen658, 0xcb0bfa11 },
{ 0xacebad03, short_gen659, long_gen659, 0xcb0bfa11 },
{ 0xacebad03, short_gen660, long_gen660, 0xcb0bfa11 },
{ 0xacebad03, short_gen661, long_gen661, 0xcb0bfa11 },
{ 0xacebad03, short_gen662, long_gen662, 0xcb0bfa11 },
{ 0xacebad03, short_gen663, long_gen663, 0xcb0bfa11 },
{ 0xacebad03, short_gen664, long_gen664, 0xcb0bfa11 },
{ 0xacebad03, short_gen665, long_gen665, 0xcb0bfa11 },
{ 0xacebad03, short_gen666, long_gen666, 0xcb0bfa11 },
{ 0xacebad03, short_gen667, long_gen667, 0xcb0bfa11 },
{ 0xacebad03, short_gen668, long_gen668, 0xcb0bfa11 },
{ 0xacebad03, short_gen669, long_gen669, 0xcb0bfa11 },
{ 0xacebad03, short_gen670, long_gen670, 0xcb0bfa11 },
{ 0xacebad03, short_gen671, long_gen671, 0xcb0bfa11 },
{ 0xacebad03, short_gen672, long_gen672, 0xcb0bfa11 },
{ 0xacebad03, short_gen673, long_gen673, 0xcb0bfa11 },
{ 0xacebad03, short_gen674, long_gen674, 0xcb0bfa11 },
{ 0xacebad03, short_gen675, long_gen675, 0xcb0bfa11 },
{ 0xacebad03, short_gen676, long_gen676, 0xcb0bfa11 },
{ 0xacebad03, short_gen677, long_gen677, 0xcb0bfa11 },
{ 0xacebad03, short_gen678, long_gen678, 0xcb0bfa11 }
};
#endif

#if MPICH_ERROR_MSG_LEVEL > MPICH_ERROR_MSG_GENERIC
static const wchar_t short_spc0[] = L"**CreateFileMapping %d";
static const wchar_t long_spc0[]  = L"CreateFileMapping failed, error %d";
static const wchar_t short_spc1[] = L"**CreateThread %d";
static const wchar_t long_spc1[]  = L"CreateThread failed, error %d";
static const wchar_t short_spc2[] = L"**FindWindowEx %d";
static const wchar_t long_spc2[]  = L"FindWindowEx failed, error %d";
static const wchar_t short_spc3[] = L"**MPIDI_CH3I_SHM_Attach_to_mem %d";
static const wchar_t long_spc3[]  = L"MPIDI_CH3I_SHM_Attach_to_mem failed, error %d";
static const wchar_t short_spc4[] = L"**MapViewOfFileEx %d";
static const wchar_t long_spc4[]  = L"MapViewOfFileEx failed, error %d";
static const wchar_t short_spc5[] = L"**OpenProcess %d";
static const wchar_t long_spc5[]  = L"OpenProcess failed, error %d";
static const wchar_t short_spc6[] = L"**OpenProcess %d %d";
static const wchar_t long_spc6[]  = L"OpenProcess failed for process %d, error %d";
static const wchar_t short_spc7[] = L"**_snwprintf %d";
static const wchar_t long_spc7[]  = L"wide string printf failed (snwprintf returned: %d)";
static const wchar_t short_spc8[] = L"**arg %s";
static const wchar_t long_spc8[]  = L"Invalid argument %s";
static const wchar_t short_spc9[] = L"**argarray %s %d %p";
static const wchar_t long_spc9[]  = L"Invalid value in %s[%d] = %p";
static const wchar_t short_spc10[] = L"**argarrayneg %s %d %d";
static const wchar_t long_spc10[]  = L"Negative value in array %s[%d] (value is %d)";
static const wchar_t short_spc11[] = L"**argerrcode %d";
static const wchar_t long_spc11[]  = L"Invalid error code %d";
static const wchar_t short_spc12[] = L"**argneg %s %d";
static const wchar_t long_spc12[]  = L"Invalid value for %s, must be non-negative but is %d";
static const wchar_t short_spc13[] = L"**argnonpos %s %d";
static const wchar_t long_spc13[]  = L"Invalid value for %s; must be positive but is %d";
static const wchar_t short_spc14[] = L"**argrange %s %d %d";
static const wchar_t long_spc14[]  = L"Argument %s has value %d but must be within [0,%d]";
static const wchar_t short_spc15[] = L"**attach_to_mem %d";
static const wchar_t long_spc15[]  = L"attach to shared memory returned error %d";
static const wchar_t short_spc16[] = L"**badcase %d";
static const wchar_t long_spc16[]  = L"INTERNAL ERROR: unexpected value in case statement (value=%d)";
static const wchar_t short_spc17[] = L"**bootqmsg %d";
static const wchar_t long_spc17[]  = L"invalid bootstrap queue message size (%d bytes)";
static const wchar_t short_spc18[] = L"**bsendbufsmall %d %d";
static const wchar_t long_spc18[]  = L"Buffer size of %d is smaller than MPI_BSEND_OVERHEAD (%d)";
static const wchar_t short_spc19[] = L"**bufbsend %d %d";
static const wchar_t long_spc19[]  = L"Insufficient space in Bsend buffer; requested %d; total buffer size is %d";
static const wchar_t short_spc20[] = L"**business_card %s";
static const wchar_t long_spc20[]  = L"Invalid business card (%s)";
static const wchar_t short_spc21[] = L"**ca_guids %s";
static const wchar_t long_spc21[]  = L"unable to get the infiniband guids - %s";
static const wchar_t short_spc22[] = L"**cartcoordinvalid %d %d %d";
static const wchar_t long_spc22[]  = L"Cartesian coordinate for the %d coordinate is %d but must be between 0 and %d";
static const wchar_t short_spc23[] = L"**cartdim %d %d";
static const wchar_t long_spc23[]  = L"Size of the communicator (%d) is smaller than the size of the Cartesian topology (%d)";
static const wchar_t short_spc24[] = L"**ch3|badca %d";
static const wchar_t long_spc24[]  = L"specified completion action in not known (%d)";
static const wchar_t short_spc25[] = L"**ch3|badmsgtype %d";
static const wchar_t long_spc25[]  = L"request contained an invalid message type (%d)";
static const wchar_t short_spc26[] = L"**ch3|badreqtype %d";
static const wchar_t long_spc26[]  = L"request contained an invalid request type (%d)";
static const wchar_t short_spc27[] = L"**ch3|conn_parent %s";
static const wchar_t long_spc27[]  = L"spawned process group was unable to connect back to the parent on port <%s>";
static const wchar_t short_spc28[] = L"**ch3|loadrecviov %s";
static const wchar_t long_spc28[]  = L"failure occurred while loading the receive I/O vector (%s)";
static const wchar_t short_spc29[] = L"**ch3|postrecv %s";
static const wchar_t long_spc29[]  = L"failure occurred while posting a receive for message data (%s)";
static const wchar_t short_spc30[] = L"**ch3|sock|badhost %s %d %s";
static const wchar_t long_spc30[]  = L"[ch3:sock] invalid host description, %s:%d (%s)";
static const wchar_t short_spc31[] = L"**ch3|sock|badpacket %d";
static const wchar_t long_spc31[]  = L"[ch3:sock] received packet of unknown type (%d)";
static const wchar_t short_spc32[] = L"**ch3|sock|connfailed %s %d";
static const wchar_t long_spc32[]  = L"[ch3:sock] failed to connnect to remote process %s:%d";
static const wchar_t short_spc33[] = L"**ch3|sock|connrefused %s %d %s";
static const wchar_t long_spc33[]  = L"[ch3:sock] failed to connect to process %s:%d (%s)";
static const wchar_t short_spc34[] = L"**ch3|sock|failure %d";
static const wchar_t long_spc34[]  = L"[ch3:sock] unknown failure, sock_errno=%d";
static const wchar_t short_spc35[] = L"**ch3|sock|postconnect %d %d %s";
static const wchar_t long_spc35[]  = L"[ch3:sock] rank %d unable to connect to rank %d using business card <%s>";
static const wchar_t short_spc36[] = L"**ch3|unhandled_connection_state %p %d";
static const wchar_t long_spc36[]  = L"encountered an unexpected connection state (vc=%p, state=%d)";
static const wchar_t short_spc37[] = L"**ch3|unknownpkt %d";
static const wchar_t long_spc37[]  = L"received unknown packet type (type=%d)";
static const wchar_t short_spc38[] = L"**closesocket %s %d";
static const wchar_t long_spc38[]  = L"closesocket failed, %s (errno %d)";
static const wchar_t short_spc39[] = L"**commperm %s";
static const wchar_t long_spc39[]  = L"Cannot free permanent communicator %s";
static const wchar_t short_spc40[] = L"**countneg %d";
static const wchar_t long_spc40[]  = L"Negative count, value is %d";
static const wchar_t short_spc41[] = L"**darrayblock %d";
static const wchar_t long_spc41[]  = L"Value of m in block(m) distribution is %d must must be positive";
static const wchar_t short_spc42[] = L"**darrayblock2 %d %d";
static const wchar_t long_spc42[]  = L"m * nprocs is %d but must equal the array size %d and is not valid for block(m) distribution";
static const wchar_t short_spc43[] = L"**darraycyclic %d";
static const wchar_t long_spc43[]  = L"Value of m is %d but must be positive for a cyclic(m) distribution";
static const wchar_t short_spc44[] = L"**darraydist %d %d";
static const wchar_t long_spc44[]  = L"For MPI_DISTRIBUTE_NONE, the value of array_of_psizes[%d] is %d but must have value 1";
static const wchar_t short_spc45[] = L"**dev|vcrt_create %s";
static const wchar_t long_spc45[]  = L"failed to create VCRT for %s";
static const wchar_t short_spc46[] = L"**dims %d";
static const wchar_t long_spc46[]  = L"Invalid dimension argument (value is %d)";
static const wchar_t short_spc47[] = L"**dimsmany %d %d";
static const wchar_t long_spc47[]  = L"Number of dimensions %d is too large (maximum is %d)";
static const wchar_t short_spc48[] = L"**dtype %d";
static const wchar_t long_spc48[]  = L"Invalid datatype (value = 0x%x)";
static const wchar_t short_spc49[] = L"**dtypenull %s";
static const wchar_t long_spc49[]  = L"Datatype for argument %s is a null datatype";
static const wchar_t short_spc50[] = L"**duphandle %s %d";
static const wchar_t long_spc50[]  = L"unable to duplicate a handle, %s (errno %d)";
static const wchar_t short_spc51[] = L"**edgeoutrange %d %d %d";
static const wchar_t long_spc51[]  = L"Edge index edges[%d] is %d but must be nonnegative and less than %d";
static const wchar_t short_spc52[] = L"**f90typetoomany %s %d";
static const wchar_t long_spc52[]  = L"Too many requests for unnamed, predefined f90 %s types; no more than %d allowed.";
static const wchar_t short_spc53[] = L"**fail %d";
static const wchar_t long_spc53[]  = L"generic failure with errno = %d";
static const wchar_t short_spc54[] = L"**fail %s";
static const wchar_t long_spc54[]  = L"%s";
static const wchar_t short_spc55[] = L"**fail %s %d";
static const wchar_t long_spc55[]  = L"%s (errno %d)";
static const wchar_t short_spc56[] = L"**filename %s";
static const wchar_t long_spc56[]  = L"Invalid file name %s";
static const wchar_t short_spc57[] = L"**ftok %s %d %d";
static const wchar_t long_spc57[]  = L"failed to create a sysv key from the file '%s' and id %d, error %d";
static const wchar_t short_spc58[] = L"**ftruncate %s %d %d";
static const wchar_t long_spc58[]  = L"unable to resize the shared memory object %s to size %d (errno %d)";
static const wchar_t short_spc59[] = L"**getinfo %s %d";
static const wchar_t long_spc59[]  = L"getinfo failed, %s (errno %d)";
static const wchar_t short_spc60[] = L"**groupnotincomm %d";
static const wchar_t long_spc60[]  = L"Rank %d of the specified group is not a member of this communicator";
static const wchar_t short_spc61[] = L"**ibu_op %d";
static const wchar_t long_spc61[]  = L"invalid infiniband operation (%d)";
static const wchar_t short_spc62[] = L"**ibu_wait %d";
static const wchar_t long_spc62[]  = L"ibu_wait failed (errno %d)";
static const wchar_t short_spc63[] = L"**indexneg %d %d";
static const wchar_t long_spc63[]  = L"Index value for index[%d] is %d but must be nonnegative";
static const wchar_t short_spc64[] = L"**indexnonmonotone %d %d %d";
static const wchar_t long_spc64[]  = L"Index values in graph topology must be monotone nondecreasing but index[%d] is %d but the next index value is %d";
static const wchar_t short_spc65[] = L"**infonkey %d %d";
static const wchar_t long_spc65[]  = L"Requested key %d but this MPI_Info only has %d keys";
static const wchar_t short_spc66[] = L"**infonokey %s";
static const wchar_t long_spc66[]  = L"MPI_Info key %s is not defined ";
static const wchar_t short_spc67[] = L"**init_rwproc %d";
static const wchar_t long_spc67[]  = L"Unable to initialize the process rank %d for reading and writing directly to that process's memory";
static const wchar_t short_spc68[] = L"**invalid_handle %d %p";
static const wchar_t long_spc68[]  = L"invalid handle (handle=%d, object=%p)";
static const wchar_t short_spc69[] = L"**invalid_refcount %d %p %d";
static const wchar_t long_spc69[]  = L"invalid reference count (handle=%d, object=%p, count=%d)";
static const wchar_t short_spc70[] = L"**io %s";
static const wchar_t long_spc70[]  = L"Other I/O error %s";
static const wchar_t short_spc71[] = L"**iocp %s %d";
static const wchar_t long_spc71[]  = L"unable to create an I/O copmletion port, %s (erron %d)";
static const wchar_t short_spc72[] = L"**iov_offset %d %d";
static const wchar_t long_spc72[]  = L"invalid iov offset (%d > %d)";
static const wchar_t short_spc73[] = L"**join_portname %s %s";
static const wchar_t long_spc73[]  = L"local %s, remote %s";
static const wchar_t short_spc74[] = L"**join_recv %d";
static const wchar_t long_spc74[]  = L"recv from the socket failed (errno %d)";
static const wchar_t short_spc75[] = L"**join_send %d";
static const wchar_t long_spc75[]  = L"send on the socket failed (errno %d)";
static const wchar_t short_spc76[] = L"**keyvalobj %s";
static const wchar_t long_spc76[]  = L"Keyval was not defined for %s objects";
static const wchar_t short_spc77[] = L"**listen %s %d";
static const wchar_t long_spc77[]  = L"listen failed, %s (errno %d)";
static const wchar_t short_spc78[] = L"**mmap %d";
static const wchar_t long_spc78[]  = L"unable to map memory, mmap failed (errno %d)";
static const wchar_t short_spc79[] = L"**mpi_abort %C %d";
static const wchar_t long_spc79[]  = L"MPI_Abort(%C, errorcode=%d) failed";
static const wchar_t short_spc80[] = L"**mpi_accumulate %p %d %D %d %d %d %D %O %W";
static const wchar_t long_spc80[]  = L"MPI_Accumulate(origin_addr=%p, origin_count=%d, %D, target_rank=%d, target_disp=%d, target_count=%d, %D, %O, %W) failed";
static const wchar_t short_spc81[] = L"**mpi_add_error_class %p";
static const wchar_t long_spc81[]  = L"MPI_Add_error_class(errorclass=%p) failed";
static const wchar_t short_spc82[] = L"**mpi_add_error_code %d %p";
static const wchar_t long_spc82[]  = L"MPI_Add_error_code(errorclass=%d, errorcode=%p) failed";
static const wchar_t short_spc83[] = L"**mpi_add_error_string %d %s";
static const wchar_t long_spc83[]  = L"MPI_Add_error_string(code=%d, str=\"%s\") failed";
static const wchar_t short_spc84[] = L"**mpi_address %p %p";
static const wchar_t long_spc84[]  = L"MPI_Address(location=%p, address=%p) failed";
static const wchar_t short_spc85[] = L"**mpi_allgather %p %d %D %p %d %D %C";
static const wchar_t long_spc85[]  = L"MPI_Allgather(sbuf=%p, scount=%d, %D, rbuf=%p, rcount=%d, %D, %C) failed";
static const wchar_t short_spc86[] = L"**mpi_allgatherv %p %d %D %p %p %p %D %C";
static const wchar_t long_spc86[]  = L"MPI_Allgatherv(sbuf=%p, scount=%d, %D, rbuf=%p, rcounts=%p, displs=%p, %D, %C) failed";
static const wchar_t short_spc87[] = L"**mpi_alloc_mem %d %I %p";
static const wchar_t long_spc87[]  = L"MPI_Alloc_mem(size=%d, %I, baseptr=%p) failed";
static const wchar_t short_spc88[] = L"**mpi_allreduce %p %p %d %D %O %C";
static const wchar_t long_spc88[]  = L"MPI_Allreduce(sbuf=%p, rbuf=%p, count=%d, %D, %O, %C) failed";
static const wchar_t short_spc89[] = L"**mpi_alltoall %p %d %D %p %d %D %C";
static const wchar_t long_spc89[]  = L"MPI_Alltoall(sbuf=%p, scount=%d, %D, rbuf=%p, rcount=%d, %D, %C) failed";
static const wchar_t short_spc90[] = L"**mpi_alltoallv %p %p %p %D %p %p %p %D %C";
static const wchar_t long_spc90[]  = L"MPI_Alltoallv(sbuf=%p, scnts=%p, sdispls=%p, %D, rbuf=%p, rcnts=%p, rdispls=%p, %D, %C) failed";
static const wchar_t short_spc91[] = L"**mpi_alltoallw %p %p %p %p %p %p %p %p %C";
static const wchar_t long_spc91[]  = L"MPI_Alltoallw(sbuf=%p, scnts=%p, sdispls=%p, stypes=%p, rbuf=%p, rcnts=%p, rdispls=%p, rtypes=%p, %C) failed";
static const wchar_t short_spc92[] = L"**mpi_attr_delete %C %d";
static const wchar_t long_spc92[]  = L"MPI_Attr_delete(%C, keyval=%d) failed";
static const wchar_t short_spc93[] = L"**mpi_attr_get %C %d %p %p";
static const wchar_t long_spc93[]  = L"MPI_Attr_get(%C, keyval=%d, attr_value=%p, flag=%p) failed";
static const wchar_t short_spc94[] = L"**mpi_attr_put %C %d %p";
static const wchar_t long_spc94[]  = L"MPI_Attr_put(%C, keyval=%d, attr_value=%p) failed";
static const wchar_t short_spc95[] = L"**mpi_barrier %C";
static const wchar_t long_spc95[]  = L"MPI_Barrier(%C) failed";
static const wchar_t short_spc96[] = L"**mpi_bcast %p %d %D %d %C";
static const wchar_t long_spc96[]  = L"MPI_Bcast(buf=%p, count=%d, %D, root=%d, %C) failed";
static const wchar_t short_spc97[] = L"**mpi_bsend %p %d %D %i %t %C";
static const wchar_t long_spc97[]  = L"MPI_Bsend(buf=%p, count=%d, %D, dest=%i, tag=%t, %C) failed";
static const wchar_t short_spc98[] = L"**mpi_bsend_init %p %d %D %i %t %C %p";
static const wchar_t long_spc98[]  = L"MPI_Bsend_init(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc99[] = L"**mpi_buffer_attach %p %d";
static const wchar_t long_spc99[]  = L"MPI_Buffer_attach(buf=%p, size=%d) failed";
static const wchar_t short_spc100[] = L"**mpi_buffer_detach %p %p";
static const wchar_t long_spc100[]  = L"MPI_Buffer_detach(buf=%p, size=%p) failed";
static const wchar_t short_spc101[] = L"**mpi_cancel %p";
static const wchar_t long_spc101[]  = L"MPI_Cancel(request=%p) failed";
static const wchar_t short_spc102[] = L"**mpi_cart_coords %C %d %d %p";
static const wchar_t long_spc102[]  = L"MPI_Cart_coords(%C, rank=%d, maxdims=%d, coords=%p) failed";
static const wchar_t short_spc103[] = L"**mpi_cart_create %C %d %p %p %d %p";
static const wchar_t long_spc103[]  = L"MPI_Cart_create(%C, ndims=%d, dims=%p, periods=%p, reorder=%d, comm_cart=%p) failed";
static const wchar_t short_spc104[] = L"**mpi_cart_get %C %d %p %p %p";
static const wchar_t long_spc104[]  = L"MPI_Cart_get(%C, maxdims=%d, dims=%p, periods=%p, coords=%p) failed";
static const wchar_t short_spc105[] = L"**mpi_cart_map %C %d %p %p %p";
static const wchar_t long_spc105[]  = L"MPI_Cart_map(%C, ndims=%d, dims=%p, periods=%p, newrank=%p) failed";
static const wchar_t short_spc106[] = L"**mpi_cart_rank %C %p %p";
static const wchar_t long_spc106[]  = L"MPI_Cart_rank(%C, coords=%p, rank=%p) failed";
static const wchar_t short_spc107[] = L"**mpi_cart_shift %C %d %d %p %p";
static const wchar_t long_spc107[]  = L"MPI_Cart_shift(%C, direction=%d, displ=%d, source=%p, dest=%p) failed";
static const wchar_t short_spc108[] = L"**mpi_cart_sub %C %p %p";
static const wchar_t long_spc108[]  = L"MPI_Cart_sub(%C, remain_dims=%p, comm_new=%p) failed";
static const wchar_t short_spc109[] = L"**mpi_cartdim_get %C %p";
static const wchar_t long_spc109[]  = L"MPI_Cartdim_get(%C, ndims=%p) failed";
static const wchar_t short_spc110[] = L"**mpi_close_port %s";
static const wchar_t long_spc110[]  = L"MPI_Close_port(port=\"%s\") failed";
static const wchar_t short_spc111[] = L"**mpi_comm_accept %s %I %d %C %p";
static const wchar_t long_spc111[]  = L"MPI_Comm_accept(port=\"%s\", %I, root=%d, %C, newcomm=%p) failed";
static const wchar_t short_spc112[] = L"**mpi_comm_call_errhandler %C %d";
static const wchar_t long_spc112[]  = L"MPI_Comm_call_errhandler(%C, errorcode=%d) failed";
static const wchar_t short_spc113[] = L"**mpi_comm_compare %C %C %p";
static const wchar_t long_spc113[]  = L"MPI_Comm_compare(%C, %C, result=%p) failed";
static const wchar_t short_spc114[] = L"**mpi_comm_connect %s %I %d %C %p";
static const wchar_t long_spc114[]  = L"MPI_Comm_connect(port=\"%s\", %I, root=%d, %C, newcomm=%p) failed";
static const wchar_t short_spc115[] = L"**mpi_comm_create %C %G %p";
static const wchar_t long_spc115[]  = L"MPI_Comm_create(%C, %G, new_comm=%p) failed";
static const wchar_t short_spc116[] = L"**mpi_comm_create_errhandler %p %p";
static const wchar_t long_spc116[]  = L"MPI_Comm_create_errhandler(function=%p, errhandler=%p) failed";
static const wchar_t short_spc117[] = L"**mpi_comm_create_keyval %p %p %p %p";
static const wchar_t long_spc117[]  = L"MPI_Comm_create_keyval(comm_copy_attr_fn=%p, comm_delete_attr_fn=%p, comm_keyval=%p, extra_state=%p) failed";
static const wchar_t short_spc118[] = L"**mpi_comm_delete_attr %C %d";
static const wchar_t long_spc118[]  = L"MPI_Comm_delete_attr(%C, comm_keyval=%d) failed";
static const wchar_t short_spc119[] = L"**mpi_comm_disconnect %C";
static const wchar_t long_spc119[]  = L"MPI_Comm_disconnect(comm=%C) failed";
static const wchar_t short_spc120[] = L"**mpi_comm_dup %C %p";
static const wchar_t long_spc120[]  = L"MPI_Comm_dup(%C, new_comm=%p) failed";
static const wchar_t short_spc121[] = L"**mpi_comm_free %p";
static const wchar_t long_spc121[]  = L"MPI_Comm_free(comm=%p) failed";
static const wchar_t short_spc122[] = L"**mpi_comm_free_keyval %p";
static const wchar_t long_spc122[]  = L"MPI_Comm_free_keyval(comm_keyval=%p) failed";
static const wchar_t short_spc123[] = L"**mpi_comm_get_attr %C %d %p %p";
static const wchar_t long_spc123[]  = L"MPI_Comm_get_attr(%C, comm_keyval=%d, attribute_val=%p, flag=%p) failed";
static const wchar_t short_spc124[] = L"**mpi_comm_get_errhandler %C %p";
static const wchar_t long_spc124[]  = L"MPI_Comm_get_errhandler(%C, errhandler=%p) failed";
static const wchar_t short_spc125[] = L"**mpi_comm_get_name %C %p %p";
static const wchar_t long_spc125[]  = L"MPI_Comm_get_name(%C, comm_name=%p, resultlen=%p) failed";
static const wchar_t short_spc126[] = L"**mpi_comm_get_parent %p";
static const wchar_t long_spc126[]  = L"MPI_Comm_get_parent(comm=%p) failed";
static const wchar_t short_spc127[] = L"**mpi_comm_group %C %p";
static const wchar_t long_spc127[]  = L"MPI_Comm_group(%C, group=%p) failed";
static const wchar_t short_spc128[] = L"**mpi_comm_join %d %p";
static const wchar_t long_spc128[]  = L"MPI_Comm_join(fd=%d, intercomm=%p) failed";
static const wchar_t short_spc129[] = L"**mpi_comm_rank %C %p";
static const wchar_t long_spc129[]  = L"MPI_Comm_rank(%C, rank=%p) failed";
static const wchar_t short_spc130[] = L"**mpi_comm_remote_group %C %p";
static const wchar_t long_spc130[]  = L"MPI_Comm_remote_group(%C, group=%p) failed";
static const wchar_t short_spc131[] = L"**mpi_comm_remote_size %C %p";
static const wchar_t long_spc131[]  = L"MPI_Comm_remote_size(%C, size=%p) failed";
static const wchar_t short_spc132[] = L"**mpi_comm_set_attr %C %d %p";
static const wchar_t long_spc132[]  = L"MPI_Comm_set_attr(%C, comm_keyval=%d, attribute_val=%p) failed";
static const wchar_t short_spc133[] = L"**mpi_comm_set_errhandler %C %E";
static const wchar_t long_spc133[]  = L"MPI_Comm_set_errhandler(%C, %E) failed";
static const wchar_t short_spc134[] = L"**mpi_comm_set_name %C %s";
static const wchar_t long_spc134[]  = L"MPI_Comm_set_name(%C, comm_name=%s) failed";
static const wchar_t short_spc135[] = L"**mpi_comm_size %C %p";
static const wchar_t long_spc135[]  = L"MPI_Comm_size(%C, size=%p) failed";
static const wchar_t short_spc136[] = L"**mpi_comm_spawn %s %p %d %I %d %C %p %p";
static const wchar_t long_spc136[]  = L"MPI_Comm_spawn(cmd=\"%s\", argv=%p, maxprocs=%d, %I, root=%d, %C, intercomm=%p, errors=%p) failed";
static const wchar_t short_spc137[] = L"**mpi_comm_spawn_multiple %d %p %p %p %p %d %C %p %p";
static const wchar_t long_spc137[]  = L"MPI_Comm_spawn_multiple(count=%d, cmds=%p, argvs=%p, maxprocs=%p, infos=%p, root=%d, %C, intercomm=%p, errors=%p) failed";
static const wchar_t short_spc138[] = L"**mpi_comm_split %C %d %d %p";
static const wchar_t long_spc138[]  = L"MPI_Comm_split(%C, color=%d, key=%d, new_comm=%p) failed";
static const wchar_t short_spc139[] = L"**mpi_comm_test_inter %C %p";
static const wchar_t long_spc139[]  = L"MPI_Comm_test_inter(%C, flag=%p) failed";
static const wchar_t short_spc140[] = L"**mpi_dims_create %d %d %p";
static const wchar_t long_spc140[]  = L"MPI_Dims_create(nnodes=%d, ndims=%d, dims=%p) failed";
static const wchar_t short_spc141[] = L"**mpi_errhandler_create %p %p";
static const wchar_t long_spc141[]  = L"MPI_Errhandler_create(function=%p, errhandler=%p) failed";
static const wchar_t short_spc142[] = L"**mpi_errhandler_free %p";
static const wchar_t long_spc142[]  = L"MPI_Errhandler_free(errhandler=%p) failed";
static const wchar_t short_spc143[] = L"**mpi_errhandler_get %C %p";
static const wchar_t long_spc143[]  = L"MPI_Errhandler_get(%C, errhandler=%p) failed";
static const wchar_t short_spc144[] = L"**mpi_errhandler_set %C %E";
static const wchar_t long_spc144[]  = L"MPI_Errhandler_set(%C, %E) failed";
static const wchar_t short_spc145[] = L"**mpi_error_class %d %p";
static const wchar_t long_spc145[]  = L"MPI_Error_class(errorcode=%d, errorclass=%p) failed";
static const wchar_t short_spc146[] = L"**mpi_error_string %d %s %p";
static const wchar_t long_spc146[]  = L"MPI_Error_string(errorcode=%d, string=%s, resultlen=%p) failed";
static const wchar_t short_spc147[] = L"**mpi_exscan %p %p %d %D %O %C";
static const wchar_t long_spc147[]  = L"MPI_Exscan(sbuf=%p, rbuf=%p, count=%d, %D, %O, %C) failed";
static const wchar_t short_spc148[] = L"**mpi_file_call_errhandler %F %d";
static const wchar_t long_spc148[]  = L"MPI_File_call_errhandler(%F, errorcode=%d) failed";
static const wchar_t short_spc149[] = L"**mpi_file_close %p";
static const wchar_t long_spc149[]  = L"MPI_File_close(file_p=%p) failed";
static const wchar_t short_spc150[] = L"**mpi_file_create_errhandler %p %p";
static const wchar_t long_spc150[]  = L"MPI_File_create_errhandler(function=%p, errhandler=%p) failed";
static const wchar_t short_spc151[] = L"**mpi_file_delete %s %I";
static const wchar_t long_spc151[]  = L"MPI_File_delete(filename=\"%s\", %I) failed";
static const wchar_t short_spc152[] = L"**mpi_file_get_amode %F %p";
static const wchar_t long_spc152[]  = L"MPI_File_get_amode(%F, amode=%p) failed";
static const wchar_t short_spc153[] = L"**mpi_file_get_atomicity %F %p";
static const wchar_t long_spc153[]  = L"MPI_File_get_atomicity(%F, flag=%p) failed";
static const wchar_t short_spc154[] = L"**mpi_file_get_byte_offset %F %o %p";
static const wchar_t long_spc154[]  = L"MPI_File_get_byte_offset(%F, offset=%o, disp=%p) failed";
static const wchar_t short_spc155[] = L"**mpi_file_get_errhandler %F %p";
static const wchar_t long_spc155[]  = L"MPI_File_get_errhandler(%F, errhandler=%p) failed";
static const wchar_t short_spc156[] = L"**mpi_file_get_group %F %p";
static const wchar_t long_spc156[]  = L"MPI_File_get_group(%F, group=%p) failed";
static const wchar_t short_spc157[] = L"**mpi_file_get_info %F %p";
static const wchar_t long_spc157[]  = L"MPI_File_get_info(%F, info_used=%p) failed";
static const wchar_t short_spc158[] = L"**mpi_file_get_position %F %p";
static const wchar_t long_spc158[]  = L"MPI_File_get_position(%F, offset=%p) failed";
static const wchar_t short_spc159[] = L"**mpi_file_get_position_shared %F %p";
static const wchar_t long_spc159[]  = L"MPI_File_get_position_shared(%F, offset=%p) failed";
static const wchar_t short_spc160[] = L"**mpi_file_get_size %F %p";
static const wchar_t long_spc160[]  = L"MPI_File_get_size(%F, size=%p) failed";
static const wchar_t short_spc161[] = L"**mpi_file_get_type_extent %F %D %p";
static const wchar_t long_spc161[]  = L"MPI_File_get_type_extent(%F, %D, extent=%p) failed";
static const wchar_t short_spc162[] = L"**mpi_file_get_view %F %p %p %p %s";
static const wchar_t long_spc162[]  = L"MPI_File_get_view(%F, disp=%p, etype=%p, filetype=%p, datarep=\"%s\") failed";
static const wchar_t short_spc163[] = L"**mpi_file_iread %F %p %d %D %p";
static const wchar_t long_spc163[]  = L"MPI_File_iread(%F, buf=%p, count=%d, %D, request=%p) failed ";
static const wchar_t short_spc164[] = L"**mpi_file_iread_at %F %o %p %d %D %p";
static const wchar_t long_spc164[]  = L"MPI_File_iread_at(%F, offset=%o, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc165[] = L"**mpi_file_iread_shared %F %p %d %D %p";
static const wchar_t long_spc165[]  = L"MPI_File_iread_shared(%F, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc166[] = L"**mpi_file_iwrite %F %p %d %D %p";
static const wchar_t long_spc166[]  = L"MPI_File_iwrite(%F, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc167[] = L"**mpi_file_iwrite_at %F %o %p %d %D %p";
static const wchar_t long_spc167[]  = L"MPI_File_iwrite_at(%F, offset=%o, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc168[] = L"**mpi_file_iwrite_shared %F %p %d %D %p";
static const wchar_t long_spc168[]  = L"MPI_File_iwrite_shared(%F, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc169[] = L"**mpi_file_open %C %s %M %I %p";
static const wchar_t long_spc169[]  = L"MPI_File_open(%C, filename=\"%s\", %M, %I, fh=%p) failed";
static const wchar_t short_spc170[] = L"**mpi_file_preallocate %F %d";
static const wchar_t long_spc170[]  = L"MPI_File_preallocate(%F, size=%d) failed";
static const wchar_t short_spc171[] = L"**mpi_file_read %F %p %d %D %p";
static const wchar_t long_spc171[]  = L"MPI_File_read(%F, buf=%p, count=%d, %D, status=%p) failed ";
static const wchar_t short_spc172[] = L"**mpi_file_read_all %F %p %d %D %p";
static const wchar_t long_spc172[]  = L"MPI_File_read_all(%F, buf=%p, count=%d, %D, status=%p) failed ";
static const wchar_t short_spc173[] = L"**mpi_file_read_all_begin %F %p %d %D";
static const wchar_t long_spc173[]  = L"MPI_File_read_all_begin(%F, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc174[] = L"**mpi_file_read_all_end %F %p %p";
static const wchar_t long_spc174[]  = L"MPI_File_read_all_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc175[] = L"**mpi_file_read_at %F %o %p %d %D %p";
static const wchar_t long_spc175[]  = L"MPI_File_read_at(%F, offset=%o, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc176[] = L"**mpi_file_read_at_all %F %o %p %d %D %p";
static const wchar_t long_spc176[]  = L"MPI_File_read_at_all(%F, offset=%o, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc177[] = L"**mpi_file_read_at_all_begin %F %o %p %d %D";
static const wchar_t long_spc177[]  = L"MPI_File_read_at_all_begin(%F, offset=%o, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc178[] = L"**mpi_file_read_at_all_end %F %p %p";
static const wchar_t long_spc178[]  = L"MPI_File_read_at_all_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc179[] = L"**mpi_file_read_ordered %F %p %d %D %p";
static const wchar_t long_spc179[]  = L"MPI_File_read_ordered(%F, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc180[] = L"**mpi_file_read_ordered_begin %F %p %d %D";
static const wchar_t long_spc180[]  = L"MPI_File_read_ordered_begin(%F, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc181[] = L"**mpi_file_read_ordered_end %F %p %p";
static const wchar_t long_spc181[]  = L"MPI_File_read_ordered_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc182[] = L"**mpi_file_read_shared %F %p %d %D %p";
static const wchar_t long_spc182[]  = L"MPI_File_read_shared(%F, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc183[] = L"**mpi_file_seek %F %o %d";
static const wchar_t long_spc183[]  = L"MPI_File_seek(%F, offset=%o, whence=%d) failed";
static const wchar_t short_spc184[] = L"**mpi_file_seek_shared %F %o %d";
static const wchar_t long_spc184[]  = L"MPI_File_seek_shared(%F, offset=%o, whence=%d) failed";
static const wchar_t short_spc185[] = L"**mpi_file_set_atomicity %F %d";
static const wchar_t long_spc185[]  = L"MPI_File_set_atomicity(%F, flag=%d) failed";
static const wchar_t short_spc186[] = L"**mpi_file_set_errhandler %F %E";
static const wchar_t long_spc186[]  = L"MPI_File_set_errhandler(%F, %E) failed";
static const wchar_t short_spc187[] = L"**mpi_file_set_info %F %I";
static const wchar_t long_spc187[]  = L"MPI_File_set_info(%F, %I) failed";
static const wchar_t short_spc188[] = L"**mpi_file_set_size %F %d";
static const wchar_t long_spc188[]  = L"MPI_File_set_size(%F, size=%d) failed";
static const wchar_t short_spc189[] = L"**mpi_file_set_view %F %d %D %D %s %I";
static const wchar_t long_spc189[]  = L"MPI_File_set_view(%F, disp=%d, %D, %D, filetype=\"%s\", %I) failed";
static const wchar_t short_spc190[] = L"**mpi_file_sync %F";
static const wchar_t long_spc190[]  = L"MPI_File_sync(%F) failed";
static const wchar_t short_spc191[] = L"**mpi_file_write %F %p %d %D %p";
static const wchar_t long_spc191[]  = L"MPI_File_write(%F, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc192[] = L"**mpi_file_write_all %F %p %d %D %p";
static const wchar_t long_spc192[]  = L"MPI_File_write_all(%F, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc193[] = L"**mpi_file_write_all_begin %F %p %d %D";
static const wchar_t long_spc193[]  = L"MPI_File_write_all_begin(%F, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc194[] = L"**mpi_file_write_all_end %F %p %p";
static const wchar_t long_spc194[]  = L"MPI_File_write_all_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc195[] = L"**mpi_file_write_at %F %o %p %d %D %p";
static const wchar_t long_spc195[]  = L"MPI_File_write_at(%F, offset=%o, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc196[] = L"**mpi_file_write_at_all %F %o %p %d %D %p";
static const wchar_t long_spc196[]  = L"MPI_File_write_at_all(%F, offset=%o, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc197[] = L"**mpi_file_write_at_all_begin %F %o %p %d %D";
static const wchar_t long_spc197[]  = L"MPI_File_write_at_all_begin(%F, offset=%o, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc198[] = L"**mpi_file_write_at_all_end %F %p %p";
static const wchar_t long_spc198[]  = L"MPI_File_write_at_all_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc199[] = L"**mpi_file_write_ordered %F %p %d %D %p";
static const wchar_t long_spc199[]  = L"MPI_File_write_ordered(%F, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc200[] = L"**mpi_file_write_ordered_begin %F %p %d %D";
static const wchar_t long_spc200[]  = L"MPI_File_write_ordered_begin(%F, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc201[] = L"**mpi_file_write_ordered_end %F %p %p";
static const wchar_t long_spc201[]  = L"MPI_File_write_ordered_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc202[] = L"**mpi_file_write_shared %F %p %d %D %p";
static const wchar_t long_spc202[]  = L"MPI_File_write_shared(%F, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc203[] = L"**mpi_finalized %p";
static const wchar_t long_spc203[]  = L"MPI_Finalized(flag=%p) failed";
static const wchar_t short_spc204[] = L"**mpi_free_mem %p";
static const wchar_t long_spc204[]  = L"MPI_Free_mem(base=%p) failed";
static const wchar_t short_spc205[] = L"**mpi_gather %p %d %D %p %d %D %d %C";
static const wchar_t long_spc205[]  = L"MPI_Gather(sbuf=%p, scount=%d, %D, rbuf=%p, rcount=%d, %D, root=%d, %C) failed";
static const wchar_t short_spc206[] = L"**mpi_gatherv %p %d %D %p %p %p %D %d %C";
static const wchar_t long_spc206[]  = L"MPI_Gatherv failed(sbuf=%p, scount=%d, %D, rbuf=%p, rcnts=%p, displs=%p, %D, root=%d, %C) failed";
static const wchar_t short_spc207[] = L"**mpi_get %p %d %D %d %d %d %D %W";
static const wchar_t long_spc207[]  = L"MPI_Get(origin_addr=%p, origin_count=%d, %D, target_rank=%d, target_disp=%d, target_count=%d, %D, %W) failed";
static const wchar_t short_spc208[] = L"**mpi_get_address %p %p";
static const wchar_t long_spc208[]  = L"MPI_Get_address(location=%p, address=%p) failed";
static const wchar_t short_spc209[] = L"**mpi_get_count %p %D %p";
static const wchar_t long_spc209[]  = L"MPI_Get_count(status=%p, %D, count=%p) failed";
static const wchar_t short_spc210[] = L"**mpi_get_elements %p %D %p";
static const wchar_t long_spc210[]  = L"MPI_Get_elements(status=%p, %D, elements=%p) failed";
static const wchar_t short_spc211[] = L"**mpi_get_processor_name %p %p";
static const wchar_t long_spc211[]  = L"MPI_Get_processor_name(name=%p, resultlen=%p) failed";
static const wchar_t short_spc212[] = L"**mpi_get_version %p %p";
static const wchar_t long_spc212[]  = L"MPI_Get_version(version=%p, subversion=%p) failed";
static const wchar_t short_spc213[] = L"**mpi_graph_create %C %d %p %p %d %p";
static const wchar_t long_spc213[]  = L"MPI_Graph_create(%C, nnodes=%d, index=%p, edges=%p, reorder=%d, comm_graph=%p) failed";
static const wchar_t short_spc214[] = L"**mpi_graph_get %C %d %d %p %p";
static const wchar_t long_spc214[]  = L"MPI_Graph_get(%C, maxindex=%d, maxedges=%d, index=%p, edges=%p) failed";
static const wchar_t short_spc215[] = L"**mpi_graph_map %C %d %p %p %p";
static const wchar_t long_spc215[]  = L"MPI_Graph_map(%C, nnodes=%d, index=%p, edges=%p, newrank=%p) failed";
static const wchar_t short_spc216[] = L"**mpi_graph_neighbors %C %d %d %p";
static const wchar_t long_spc216[]  = L"MPI_Graph_neighbors(%C, rank=%d, maxneighbors=%d, neighbors=%p) failed";
static const wchar_t short_spc217[] = L"**mpi_graph_neighbors_count %C %d %p";
static const wchar_t long_spc217[]  = L"MPI_Graph_neighbors_count(%C, rank=%d, nneighbors=%p) failed";
static const wchar_t short_spc218[] = L"**mpi_graphdims_get %C %p %p";
static const wchar_t long_spc218[]  = L"MPI_Graphdims_get(%C, nnodes=%p, nedges=%p) failed";
static const wchar_t short_spc219[] = L"**mpi_grequest_complete %R";
static const wchar_t long_spc219[]  = L"MPI_Grequest_complete(%R) failed";
static const wchar_t short_spc220[] = L"**mpi_grequest_start %p %p %p %p %p";
static const wchar_t long_spc220[]  = L"MPI_Grequest_start(query_fn=%p, free_fn=%p, cancel_fn=%p, extra_state=%p, request=%p) failed";
static const wchar_t short_spc221[] = L"**mpi_group_compare %G %G %p";
static const wchar_t long_spc221[]  = L"MPI_Group_compare(%G, %G, result=%p) failed";
static const wchar_t short_spc222[] = L"**mpi_group_difference %G %G %p";
static const wchar_t long_spc222[]  = L"MPI_Group_difference(%G, %G, new_group=%p) failed";
static const wchar_t short_spc223[] = L"**mpi_group_excl %G %d %p %p";
static const wchar_t long_spc223[]  = L"MPI_Group_excl(%G, n=%d, ranks=%p, new_group=%p) failed";
static const wchar_t short_spc224[] = L"**mpi_group_free %p";
static const wchar_t long_spc224[]  = L"MPI_Group_free(group=%p) failed";
static const wchar_t short_spc225[] = L"**mpi_group_incl %G %d %p %p";
static const wchar_t long_spc225[]  = L"MPI_Group_incl(%G, n=%d, ranks=%p, new_group=%p) failed";
static const wchar_t short_spc226[] = L"**mpi_group_intersection %G %G %p";
static const wchar_t long_spc226[]  = L"MPI_Group_intersection(%G, %G, new_group=%p) failed";
static const wchar_t short_spc227[] = L"**mpi_group_range_excl %G %d %p %p";
static const wchar_t long_spc227[]  = L"MPI_Group_range_excl(%G, n=%d, ranges=%p, new_group=%p) failed";
static const wchar_t short_spc228[] = L"**mpi_group_range_incl %G %d %p %p";
static const wchar_t long_spc228[]  = L"MPI_Group_range_incl(%G, n=%d, ranges=%p, new_group=%p) failed";
static const wchar_t short_spc229[] = L"**mpi_group_rank %G %p";
static const wchar_t long_spc229[]  = L"MPI_Group_rank(%G, rank=%p) failed";
static const wchar_t short_spc230[] = L"**mpi_group_size %G %p";
static const wchar_t long_spc230[]  = L"MPI_Group_size(%G, size=%p) failed";
static const wchar_t short_spc231[] = L"**mpi_group_translate_ranks %G %d %p %G %p";
static const wchar_t long_spc231[]  = L"MPI_Group_translate_ranks(%G, n=%d, ranks1=%p, %G, ranks2=%p) failed";
static const wchar_t short_spc232[] = L"**mpi_group_union %G %G %p";
static const wchar_t long_spc232[]  = L"MPI_Group_union(%G, %G, new_group=%p) failed";
static const wchar_t short_spc233[] = L"**mpi_ibsend %p %d %D %i %t %C %p";
static const wchar_t long_spc233[]  = L"MPI_Ibsend(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc234[] = L"**mpi_info_create %p";
static const wchar_t long_spc234[]  = L"MPI_Info_create(info=%p) failed";
static const wchar_t short_spc235[] = L"**mpi_info_delete %I %s";
static const wchar_t long_spc235[]  = L"MPI_Info_delete(%I, key=%s) failed";
static const wchar_t short_spc236[] = L"**mpi_info_dup %I %p";
static const wchar_t long_spc236[]  = L"MPI_Info_dup(%I, newinfo=%p) failed";
static const wchar_t short_spc237[] = L"**mpi_info_free %p";
static const wchar_t long_spc237[]  = L"MPI_Info_free(info=%p) failed";
static const wchar_t short_spc238[] = L"**mpi_info_get %I %s %d %p %p";
static const wchar_t long_spc238[]  = L"MPI_Info_get(%I, key=%s, valuelen=%d, value=%p, flag=%p) failed";
static const wchar_t short_spc239[] = L"**mpi_info_get_nkeys %I %p";
static const wchar_t long_spc239[]  = L"MPI_Info_get_nkeys(%I, nkeys=%p) failed";
static const wchar_t short_spc240[] = L"**mpi_info_get_nthkey %I %d %p";
static const wchar_t long_spc240[]  = L"MPI_Info_get_nthkey(%I, n=%d, key=%p) failed";
static const wchar_t short_spc241[] = L"**mpi_info_get_valuelen %I %s %p %p";
static const wchar_t long_spc241[]  = L"MPI_Info_get_valuelen(%I, key=%s, valuelen=%p, flag=%p) failed";
static const wchar_t short_spc242[] = L"**mpi_info_set %I %s %s";
static const wchar_t long_spc242[]  = L"MPI_Info_set(%I, key=%s, value=%s) failed";
static const wchar_t short_spc243[] = L"**mpi_init %p %p";
static const wchar_t long_spc243[]  = L"MPI_Init(argc_p=%p, argv_p=%p) failed";
static const wchar_t short_spc244[] = L"**mpi_init_thread %p %p %d %p";
static const wchar_t long_spc244[]  = L"MPI_Init_thread(argc_p=%p, argv_p=%p, required=%d, provided=%p)";
static const wchar_t short_spc245[] = L"**mpi_initialized %p";
static const wchar_t long_spc245[]  = L"MPI_Initialized(flag=%p) failed";
static const wchar_t short_spc246[] = L"**mpi_intercomm_create %C %d %C %d %d %p";
static const wchar_t long_spc246[]  = L"MPI_Intercomm_create(%C, local_leader=%d, %C, remote_leader=%d, tag=%d, newintercomm=%p) failed";
static const wchar_t short_spc247[] = L"**mpi_intercomm_merge %C %d %p";
static const wchar_t long_spc247[]  = L"MPI_Intercomm_merge(%C, high=%d, newintracomm=%p) failed";
static const wchar_t short_spc248[] = L"**mpi_iprobe %i %t %C %p %p";
static const wchar_t long_spc248[]  = L"MPI_Iprobe(src=%i, tag=%t, %C, flag=%p, status=%p) failed";
static const wchar_t short_spc249[] = L"**mpi_irecv %p %d %D %i %t %C %p";
static const wchar_t long_spc249[]  = L"MPI_Irecv(buf=%p, count=%d, %D, src=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc250[] = L"**mpi_irsend %p %d %D %i %t %C %p";
static const wchar_t long_spc250[]  = L"MPI_Irsend(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc251[] = L"**mpi_is_thread_main %p";
static const wchar_t long_spc251[]  = L"MPI_Is_thread_main(flag=%p) failed";
static const wchar_t short_spc252[] = L"**mpi_isend %p %d %D %i %t %C %p";
static const wchar_t long_spc252[]  = L"MPI_Isend(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc253[] = L"**mpi_issend %p %d %D %i %t %C %p";
static const wchar_t long_spc253[]  = L"MPI_Issend(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc254[] = L"**mpi_keyval_create %p %p %p %p";
static const wchar_t long_spc254[]  = L"MPI_Keyval_create(copy_fn=%p, del_fn=%p, keyval=%p, extra=%p) failed";
static const wchar_t short_spc255[] = L"**mpi_keyval_free %p";
static const wchar_t long_spc255[]  = L"MPI_Keyval_free(keyval=%p) failed";
static const wchar_t short_spc256[] = L"**mpi_lookup_name %s %I %p";
static const wchar_t long_spc256[]  = L"MPI_Lookup_name(service=\"%s\", %I, port=%p) failed";
static const wchar_t short_spc257[] = L"**mpi_op_create %p %d %p";
static const wchar_t long_spc257[]  = L"MPI_Op_create(fn=%p, commute=%d, op=%p) failed";
static const wchar_t short_spc258[] = L"**mpi_op_free %p";
static const wchar_t long_spc258[]  = L"MPI_Op_free(op=%p) failed";
static const wchar_t short_spc259[] = L"**mpi_open_port %I %p";
static const wchar_t long_spc259[]  = L"MPI_Open_port(%I, port=%p) failed";
static const wchar_t short_spc260[] = L"**mpi_pack %p %d %D %p %d %p %C";
static const wchar_t long_spc260[]  = L"MPI_Pack(inbuf=%p, incount=%d, %D, outbuf=%p, outcount=%d, position=%p, %C) failed";
static const wchar_t short_spc261[] = L"**mpi_pack_external %s %p %d %D %p %d %p";
static const wchar_t long_spc261[]  = L"MPI_Pack_external(datarep=%s, inbuf=%p, incount=%d, %D, outbuf=%p, outcount=%d, position=%p) failed";
static const wchar_t short_spc262[] = L"**mpi_pack_external_size %s %d %D %p";
static const wchar_t long_spc262[]  = L"MPI_Pack_external_size(datarep=%s, incount=%d, %D, size=%p) failed";
static const wchar_t short_spc263[] = L"**mpi_pack_size %d %D %C %p";
static const wchar_t long_spc263[]  = L"MPI_Pack_size(count=%d, %D, %C, size=%p) failed";
static const wchar_t short_spc264[] = L"**mpi_probe %i %t %C %p";
static const wchar_t long_spc264[]  = L"MPI_Probe(src=%i, tag=%t, %C, status=%p) failed";
static const wchar_t short_spc265[] = L"**mpi_publish_name %s %I %s";
static const wchar_t long_spc265[]  = L"MPI_Publish_name(service=\"%s\", %I, port=\"%s\") failed";
static const wchar_t short_spc266[] = L"**mpi_put %p %d %D %d %d %d %D %W";
static const wchar_t long_spc266[]  = L"MPI_Put(origin_addr=%p, origin_count=%d, %D, target_rank=%d, target_disp=%d, target_count=%d, %D, %W) failed";
static const wchar_t short_spc267[] = L"**mpi_query_thread %p";
static const wchar_t long_spc267[]  = L"MPI_Query_thread(provided=%p) failed";
static const wchar_t short_spc268[] = L"**mpi_recv %p %d %D %i %t %C %p";
static const wchar_t long_spc268[]  = L"MPI_Recv(buf=%p, count=%d, %D, src=%i, tag=%t, %C, status=%p) failed";
static const wchar_t short_spc269[] = L"**mpi_recv_init %p %d %D %i %t %C %p";
static const wchar_t long_spc269[]  = L"MPI_Recv_init(buf=%p, count=%d, %D, src=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc270[] = L"**mpi_reduce %p %p %d %D %O %d %C";
static const wchar_t long_spc270[]  = L"MPI_Reduce(sbuf=%p, rbuf=%p, count=%d, %D, %O, root=%d, %C) failed";
static const wchar_t short_spc271[] = L"**mpi_reduce_scatter %p %p %p %D %O %C";
static const wchar_t long_spc271[]  = L"MPI_Reduce_scatter(sbuf=%p, rbuf=%p, rcnts=%p, %D, %O, %C) failed";
static const wchar_t short_spc272[] = L"**mpi_register_datarep %s %p %p %p %p";
static const wchar_t long_spc272[]  = L"MPI_Register_datarep(datarep=%s, read_conversion_fn=%p, write_conversion_fn=%p, dtype_file_extent_fn=%p, extra_state=%p) failed";
static const wchar_t short_spc273[] = L"**mpi_request_free %p";
static const wchar_t long_spc273[]  = L"MPI_Request_free(request=%p) failed";
static const wchar_t short_spc274[] = L"**mpi_request_get_status %R %p %p";
static const wchar_t long_spc274[]  = L"MPI_Request_get_status(%R, flag=%p, status=%p) failed";
static const wchar_t short_spc275[] = L"**mpi_rsend %p %d %D %i %t %C";
static const wchar_t long_spc275[]  = L"MPI_Rsend(buf=%p, count=%d, %D, src=%i, tag=%t, %C) failed";
static const wchar_t short_spc276[] = L"**mpi_rsend_init %p %d %D %i %t %C %p";
static const wchar_t long_spc276[]  = L"MPI_Rsend_init(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc277[] = L"**mpi_scan %p %p %d %D %O %C";
static const wchar_t long_spc277[]  = L"MPI_Scan(sbuf=%p, rbuf=%p, count=%d, %D, %O, %C) failed";
static const wchar_t short_spc278[] = L"**mpi_scatter %p %d %D %p %d %D %d %C";
static const wchar_t long_spc278[]  = L"MPI_Scatter(sbuf=%p, scount=%d, %D, rbuf=%p, rcount=%d, %D, root=%d, %C) failed";
static const wchar_t short_spc279[] = L"**mpi_scatterv %p %p %p %D %p %d %D %d %C";
static const wchar_t long_spc279[]  = L"MPI_Scatterv(sbuf=%p, scnts=%p, displs=%p, %D, rbuf=%p, rcount=%d, %D, root=%d, %C) failed";
static const wchar_t short_spc280[] = L"**mpi_send %p %d %D %i %t %C";
static const wchar_t long_spc280[]  = L"MPI_Send(buf=%p, count=%d, %D, dest=%i, tag=%t, %C) failed";
static const wchar_t short_spc281[] = L"**mpi_send_init %p %d %D %i %t %C %p";
static const wchar_t long_spc281[]  = L"MPI_Send_init(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc282[] = L"**mpi_sendrecv %p %d %D %i %t %p %d %D %i %t %C %p";
static const wchar_t long_spc282[]  = L"MPI_Sendrecv(sbuf=%p, scount=%d, %D, dest=%i, stag=%t, rbuf=%p, rcount=%d, %D, src=%i, rtag=%t, %C, status=%p) failed";
static const wchar_t short_spc283[] = L"**mpi_sendrecv_replace %p %d %D %i %t %i %t %C %p";
static const wchar_t long_spc283[]  = L"MPI_Sendrecv_replace(buf=%p, count=%d, %D, dest=%i, stag=%t, src=%i, rtag=%t, %C, status=%p) failed";
static const wchar_t short_spc284[] = L"**mpi_ssend %p %d %D %i %t %C";
static const wchar_t long_spc284[]  = L"MPI_Ssend(buf=%p, count=%d, %D, dest=%i, tag=%t, %C) failed";
static const wchar_t short_spc285[] = L"**mpi_ssend_init %p %d %D %i %t %C %p";
static const wchar_t long_spc285[]  = L"MPI_Ssend_init(buf=%p, count=%d, %D, dest=%i, tag=%t, %C, request=%p) failed";
static const wchar_t short_spc286[] = L"**mpi_start %p";
static const wchar_t long_spc286[]  = L"MPI_Start(request=%p) failed";
static const wchar_t short_spc287[] = L"**mpi_startall %d %p";
static const wchar_t long_spc287[]  = L"MPI_Startall(count=%d, req_array=%p) failed";
static const wchar_t short_spc288[] = L"**mpi_status_set_cancelled %p %d";
static const wchar_t long_spc288[]  = L"MPI_Status_set_cancelled(status=%p, flag=%d) failed";
static const wchar_t short_spc289[] = L"**mpi_status_set_elements %p %D %d";
static const wchar_t long_spc289[]  = L"MPI_Status_set_elements(status=%p, %D, count=%d) failed";
static const wchar_t short_spc290[] = L"**mpi_test %p %p %p";
static const wchar_t long_spc290[]  = L"MPI_Test(request=%p, flag=%p, status=%p) failed";
static const wchar_t short_spc291[] = L"**mpi_test_cancelled %p %p";
static const wchar_t long_spc291[]  = L"MPI_Test_cancelled(status=%p, flag=%p) failed";
static const wchar_t short_spc292[] = L"**mpi_testall %d %p %p %p";
static const wchar_t long_spc292[]  = L"MPI_Testall(count=%d, req_array=%p, flag=%p, status_array=%p) failed";
static const wchar_t short_spc293[] = L"**mpi_testany %d %p %p %p %p";
static const wchar_t long_spc293[]  = L"MPI_Testany(count=%d, req_array=%p, index=%p, flag=%p, status=%p) failed";
static const wchar_t short_spc294[] = L"**mpi_testsome %d %p %p %p %p";
static const wchar_t long_spc294[]  = L"MPI_Testsome(count=%d, req_array=%p, out_count=%p, indices=%p, status_array=%p) failed";
static const wchar_t short_spc295[] = L"**mpi_topo_test %C %p";
static const wchar_t long_spc295[]  = L"MPI_Topo_test(%C, topo_type=%p) failed";
static const wchar_t short_spc296[] = L"**mpi_type_commit %p";
static const wchar_t long_spc296[]  = L"MPI_Type_commit(datatype_p=%p) failed";
static const wchar_t short_spc297[] = L"**mpi_type_contiguous %d %D %p";
static const wchar_t long_spc297[]  = L"MPI_Type_contiguous(count=%d, %D, new_type_p=%p) failed";
static const wchar_t short_spc298[] = L"**mpi_type_create_darray %d %d %d %p %p %p %p %d %D %p";
static const wchar_t long_spc298[]  = L"MPI_Type_create_darray(size=%d, rank=%d, ndims=%d, array_of_gsizes=%p, array_of_distribs=%p, array_of_dargs=%p, array_of_psizes=%p, order=%d, %D, newtype=%p) failed";
static const wchar_t short_spc299[] = L"**mpi_type_create_hindexed %d %p %p %D %p";
static const wchar_t long_spc299[]  = L"MPI_Type_create_hindexed(count=%d, array_of_blocklengths=%p, array_of_displacements=%p, %D, newtype=%p) failed";
static const wchar_t short_spc300[] = L"**mpi_type_create_hvector %d %d %d %D %p";
static const wchar_t long_spc300[]  = L"MPI_Type_create_hvector(count=%d, blocklength=%d, stride=%d, %D, newtype=%p) failed";
static const wchar_t short_spc301[] = L"**mpi_type_create_indexed_block %d %d %p %D %p";
static const wchar_t long_spc301[]  = L"MPI_Type_create_indexed_block(count=%d, blocklength=%d, array_of_displacements=%p, %D, newtype=%p) failed";
static const wchar_t short_spc302[] = L"**mpi_type_create_keyval %p %p %p %p";
static const wchar_t long_spc302[]  = L"MPI_Type_create_keyval(type_copy_attr_fn=%p, type_delete_attr_fn=%p, type_keyval=%p, extra_state=%p) failed";
static const wchar_t short_spc303[] = L"**mpi_type_create_resized %D %d %d %p";
static const wchar_t long_spc303[]  = L"MPI_Type_create_resized(%D, lb=%d, extent=%d, newtype=%p) failed";
static const wchar_t short_spc304[] = L"**mpi_type_create_struct %d %p %p %p %p";
static const wchar_t long_spc304[]  = L"MPI_Type_create_struct(count=%d, array_of_blocklengths=%p, array_of_displacements=%p, array_of_types=%p, newtype=%p) failed";
static const wchar_t short_spc305[] = L"**mpi_type_create_subarray %d %p %p %p %d %D %p";
static const wchar_t long_spc305[]  = L"MPI_Type_create_subarray(ndims=%d, array_of_sizes=%p, array_of_subsizes=%p, array_of_starts=%p, order=%d, %D, newtype=%p) failed";
static const wchar_t short_spc306[] = L"**mpi_type_delete_attr %D %d";
static const wchar_t long_spc306[]  = L"MPI_Type_delete_attr(%D, type_keyval=%d) failed";
static const wchar_t short_spc307[] = L"**mpi_type_dup %D %p";
static const wchar_t long_spc307[]  = L"MPI_Type_dup(%D, newtype=%p) failed";
static const wchar_t short_spc308[] = L"**mpi_type_extent %D %p";
static const wchar_t long_spc308[]  = L"MPI_Type_extent(%D, extent=%p) failed";
static const wchar_t short_spc309[] = L"**mpi_type_free %p";
static const wchar_t long_spc309[]  = L"MPI_Type_free(datatype_p=%p) failed";
static const wchar_t short_spc310[] = L"**mpi_type_free_keyval %p";
static const wchar_t long_spc310[]  = L"MPI_Type_free_keyval(type_keyval=%p) failed";
static const wchar_t short_spc311[] = L"**mpi_type_get_attr %D %d %p %p";
static const wchar_t long_spc311[]  = L"MPI_Type_get_attr(%D, type_keyval=%d, attribute_val=%p, flag=%p) failed";
static const wchar_t short_spc312[] = L"**mpi_type_get_contents %D %d %d %d %p %p %p";
static const wchar_t long_spc312[]  = L"MPI_Type_get_contents(%D, max_integers=%d, max_addresses=%d, max_datatypes=%d, array_of_integers=%p, array_of_addresses=%p, array_of_datatypes=%p) failed";
static const wchar_t short_spc313[] = L"**mpi_type_get_envelope %D %p %p %p %p";
static const wchar_t long_spc313[]  = L"MPI_Type_get_envelope(%D, num_integers=%p, num_addresses=%p, num_datatypes=%p, combiner=%p) failed";
static const wchar_t short_spc314[] = L"**mpi_type_get_extent %D %p %p";
static const wchar_t long_spc314[]  = L"MPI_Type_get_extent(%D, lb=%p, extent=%p) failed";
static const wchar_t short_spc315[] = L"**mpi_type_get_name %D %p %p";
static const wchar_t long_spc315[]  = L"MPI_Type_get_name(%D, type_name=%p, resultlen=%p) failed";
static const wchar_t short_spc316[] = L"**mpi_type_get_true_extent %D %p %p";
static const wchar_t long_spc316[]  = L"MPI_Type_get_true_extent(%D, lb=%p, true_extent=%p) failed";
static const wchar_t short_spc317[] = L"**mpi_type_hindexed %d %p %p %D %p";
static const wchar_t long_spc317[]  = L"MPI_Type_hindexed(count=%d, blocklens=%p, indices=%p, %D, new_type_p=%p) failed";
static const wchar_t short_spc318[] = L"**mpi_type_hvector %d %d %d %D %p";
static const wchar_t long_spc318[]  = L"MPI_Type_hvector(count=%d, blocklen=%d, stride=%d, %D, new_type_p=%p) failed";
static const wchar_t short_spc319[] = L"**mpi_type_indexed %d %p %p %D %p";
static const wchar_t long_spc319[]  = L"MPI_Type_indexed(count=%d, blocklens=%p, indices=%p, %D, new_type_p=%p) failed";
static const wchar_t short_spc320[] = L"**mpi_type_lb %D %p";
static const wchar_t long_spc320[]  = L"MPI_Type_lb(%D, displacement=%p) failed";
static const wchar_t short_spc321[] = L"**mpi_type_match_size %d %d %p";
static const wchar_t long_spc321[]  = L"MPI_Type_match_size(typeclass=%d, size=%d, datatype=%p) failed";
static const wchar_t short_spc322[] = L"**mpi_type_set_attr %D %d %p";
static const wchar_t long_spc322[]  = L"MPI_Type_set_attr(%D, type_keyval=%d, attribute_val=%p) failed";
static const wchar_t short_spc323[] = L"**mpi_type_set_name %D %s";
static const wchar_t long_spc323[]  = L"MPI_Type_set_name(%D, type_name=%s) failed";
static const wchar_t short_spc324[] = L"**mpi_type_size %D %p";
static const wchar_t long_spc324[]  = L"MPI_Type_size(%D) failed";
static const wchar_t short_spc325[] = L"**mpi_type_struct %d %p %p %p %p";
static const wchar_t long_spc325[]  = L"MPI_Type_struct(count=%d, blocklens=%p, indices=%p, old_types=%p, new_type_p=%p) failed";
static const wchar_t short_spc326[] = L"**mpi_type_ub %D %p";
static const wchar_t long_spc326[]  = L"MPI_Type_ub(%D, displacement=%p) failed";
static const wchar_t short_spc327[] = L"**mpi_type_vector %d %d %d %D %p";
static const wchar_t long_spc327[]  = L"MPI_Type_vector(count=%d, blocklength=%d, stride=%d, %D, new_type_p=%p) failed";
static const wchar_t short_spc328[] = L"**mpi_unpack %p %d %p %p %d %D %C";
static const wchar_t long_spc328[]  = L"MPI_Unpack(inbuf=%p, insize=%d, position=%p, outbuf=%p, outcount=%d, %D, %C) failed";
static const wchar_t short_spc329[] = L"**mpi_unpack_external %s %p %d %p %p %d %D";
static const wchar_t long_spc329[]  = L"MPI_Unpack_external(datarep=%s, inbuf=%p, insize=%d, position=%p, outbuf=%p, outcount=%d, %D) failed";
static const wchar_t short_spc330[] = L"**mpi_unpublish_name %s %I %s";
static const wchar_t long_spc330[]  = L"MPI_Unpublish_name(service=\"%s\", %I, port=\"%s\") failed";
static const wchar_t short_spc331[] = L"**mpi_wait %p %p";
static const wchar_t long_spc331[]  = L"MPI_Wait(request=%p, status%p) failed";
static const wchar_t short_spc332[] = L"**mpi_waitall %d %p %p";
static const wchar_t long_spc332[]  = L"MPI_Waitall(count=%d, req_array=%p, status_array=%p) failed";
static const wchar_t short_spc333[] = L"**mpi_waitany %d %p %p %p";
static const wchar_t long_spc333[]  = L"MPI_Waitany(count=%d, req_array=%p, index=%p, status=%p) failed";
static const wchar_t short_spc334[] = L"**mpi_waitsome %d %p %p %p %p";
static const wchar_t long_spc334[]  = L"MPI_Waitsome(count=%d, req_array=%p, out_count=%p, indices=%p, status_array=%p) failed";
static const wchar_t short_spc335[] = L"**mpi_win_call_errhandler %W %d";
static const wchar_t long_spc335[]  = L"MPI_Win_call_errhandler(%W, errorcode=%d) failed";
static const wchar_t short_spc336[] = L"**mpi_win_complete %W";
static const wchar_t long_spc336[]  = L"MPI_Win_complete(%W) failed";
static const wchar_t short_spc337[] = L"**mpi_win_create %p %d %d %I %C %p";
static const wchar_t long_spc337[]  = L"MPI_Win_create(base=%p, size=%d, disp_unit=%d, %I, %C, win=%p) failed";
static const wchar_t short_spc338[] = L"**mpi_win_create_errhandler %p %p";
static const wchar_t long_spc338[]  = L"MPI_Win_create_errhandler(function=%p, errhandler=%p) failed";
static const wchar_t short_spc339[] = L"**mpi_win_create_keyval %p %p %p %p";
static const wchar_t long_spc339[]  = L"MPI_Win_create_keyval(win_copy_attr_fn=%p, win_delete_attr_fn=%p, win_keyval=%p, extra_state=%p) failed";
static const wchar_t short_spc340[] = L"**mpi_win_delete_attr %W %d";
static const wchar_t long_spc340[]  = L"MPI_Win_delete_attr(%W, win_keyval=%d) failed";
static const wchar_t short_spc341[] = L"**mpi_win_fence %A %W";
static const wchar_t long_spc341[]  = L"MPI_Win_fence(%A, %W) failed";
static const wchar_t short_spc342[] = L"**mpi_win_free %p";
static const wchar_t long_spc342[]  = L"MPI_Win_free(win=%p) failed";
static const wchar_t short_spc343[] = L"**mpi_win_free_keyval %p";
static const wchar_t long_spc343[]  = L"MPI_Win_free_keyval(win_keyval=%p) failed";
static const wchar_t short_spc344[] = L"**mpi_win_get_attr %W %d %p %p";
static const wchar_t long_spc344[]  = L"MPI_Win_get_attr(%W, win_keyval=%d, attribute_val=%p, flag=%p) failed";
static const wchar_t short_spc345[] = L"**mpi_win_get_errhandler %W %p";
static const wchar_t long_spc345[]  = L"MPI_Win_get_errhandler(%W, errhandler=%p) failed";
static const wchar_t short_spc346[] = L"**mpi_win_get_group %W %p";
static const wchar_t long_spc346[]  = L"MPI_Win_get_group(%W, group=%p) failed";
static const wchar_t short_spc347[] = L"**mpi_win_get_name %W %p %p";
static const wchar_t long_spc347[]  = L"MPI_Win_get_name(%W, win_name=%p, resultlen=%p) failed";
static const wchar_t short_spc348[] = L"**mpi_win_lock %d %d %A %W";
static const wchar_t long_spc348[]  = L"MPI_Win_lock(lock_type=%d, rank=%d, %A, %W) failed";
static const wchar_t short_spc349[] = L"**mpi_win_post %G %A %W";
static const wchar_t long_spc349[]  = L"MPI_Win_post(%G, %A, %W) failed";
static const wchar_t short_spc350[] = L"**mpi_win_set_attr %W %d %p";
static const wchar_t long_spc350[]  = L"MPI_Win_set_attr(%W, win_keyval=%d, attribute_val=%p) failed";
static const wchar_t short_spc351[] = L"**mpi_win_set_errhandler %W %E";
static const wchar_t long_spc351[]  = L"MPI_Win_set_errhandler(%W, %E) failed";
static const wchar_t short_spc352[] = L"**mpi_win_set_name %W %s";
static const wchar_t long_spc352[]  = L"MPI_Win_set_name(%W, win_name=%s) failed";
static const wchar_t short_spc353[] = L"**mpi_win_start %G %A %W";
static const wchar_t long_spc353[]  = L"MPI_Win_start(%G, %A, %W) failed";
static const wchar_t short_spc354[] = L"**mpi_win_test %W %p";
static const wchar_t long_spc354[]  = L"MPI_Win_test(%W, flag=%p) failed";
static const wchar_t short_spc355[] = L"**mpi_win_unlock %d %W";
static const wchar_t long_spc355[]  = L"MPI_Win_unlock(rank=%d, %W) failed";
static const wchar_t short_spc356[] = L"**mpi_win_wait %W";
static const wchar_t long_spc356[]  = L"MPI_Win_wait(%W) failed";
static const wchar_t short_spc357[] = L"**mpioi_file_iread %F %o %d %p %d %D %p";
static const wchar_t long_spc357[]  = L"MPIOI_File_iread(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc358[] = L"**mpioi_file_iwrite %F %o %d %p %d %D %p";
static const wchar_t long_spc358[]  = L"MPIOI_File_iwrite(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D, request=%p) failed";
static const wchar_t short_spc359[] = L"**mpioi_file_read %F %o %d %p %d %D %p";
static const wchar_t long_spc359[]  = L"MPIOI_File_read(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc360[] = L"**mpioi_file_read_all %F %o %d %p %d %D %p";
static const wchar_t long_spc360[]  = L"MPIOI_File_read_all(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc361[] = L"**mpioi_file_read_all_begin %F %o %d %p %d %D";
static const wchar_t long_spc361[]  = L"MPIOI_File_read_all_begin(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc362[] = L"**mpioi_file_read_all_end %F %p %p";
static const wchar_t long_spc362[]  = L"MPIOI_File_read_all_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc363[] = L"**mpioi_file_write %F %o %d %p %d %D %p";
static const wchar_t long_spc363[]  = L"MPIOI_File_write(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc364[] = L"**mpioi_file_write_all %F %o %d %p %d %D %p";
static const wchar_t long_spc364[]  = L"MPIOI_File_write_all(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D, status=%p) failed";
static const wchar_t short_spc365[] = L"**mpioi_file_write_all_begin %F %o %d %p %d %D";
static const wchar_t long_spc365[]  = L"MPIOI_File_write_all_begin(%F, offset=%o, file_ptr_type=%d, buf=%p, count=%d, %D) failed";
static const wchar_t short_spc366[] = L"**mpioi_file_write_all_end %F %p %p";
static const wchar_t long_spc366[]  = L"MPIOI_File_write_all_end(%F, buf=%p, status=%p) failed";
static const wchar_t short_spc367[] = L"**mq_close %d";
static const wchar_t long_spc367[]  = L"failed to close a posix message queue, error %d";
static const wchar_t short_spc368[] = L"**mq_open %d";
static const wchar_t long_spc368[]  = L"failed to open a posix message queue, error %d";
static const wchar_t short_spc369[] = L"**mq_receive %d";
static const wchar_t long_spc369[]  = L"failed to receive a posix message queue message, error %d";
static const wchar_t short_spc370[] = L"**mq_send %d";
static const wchar_t long_spc370[]  = L"failed to send a posix message queue message, error %d";
static const wchar_t short_spc371[] = L"**msgctl %d";
static const wchar_t long_spc371[]  = L"msgctl returned %d";
static const wchar_t short_spc372[] = L"**msgget %d";
static const wchar_t long_spc372[]  = L"msgget returned %d";
static const wchar_t short_spc373[] = L"**msgrcv %d";
static const wchar_t long_spc373[]  = L"msgrcv returned %d";
static const wchar_t short_spc374[] = L"**msgsnd %d";
static const wchar_t long_spc374[]  = L"msgsnd returned %d";
static const wchar_t short_spc375[] = L"**namepubfile %s %s %s";
static const wchar_t long_spc375[]  = L"Unable to publish service name %s using file %s for reason %s";
static const wchar_t short_spc376[] = L"**namepubnotfound %s";
static const wchar_t long_spc376[]  = L"Lookup failed for service name %s";
static const wchar_t short_spc377[] = L"**namepubnotpub %s";
static const wchar_t long_spc377[]  = L"Lookup failed for service name %s";
static const wchar_t short_spc378[] = L"**namepubnotunpub %s";
static const wchar_t long_spc378[]  = L"Failed to unpublish service name %s";
static const wchar_t short_spc379[] = L"**nomem %d";
static const wchar_t long_spc379[]  = L"Out of memory (unable to allocate %d bytes)";
static const wchar_t short_spc380[] = L"**nomem %s";
static const wchar_t long_spc380[]  = L"Out of memory (unable to allocate a '%s')";
static const wchar_t short_spc381[] = L"**nomem %s %d";
static const wchar_t long_spc381[]  = L"Out of memory (unable to allocate a '%s' of size %d)";
static const wchar_t short_spc382[] = L"**nomem2 %d %s";
static const wchar_t long_spc382[]  = L"Unable to allocate %d bytes of memory for %s (probably out of memory)";
static const wchar_t short_spc383[] = L"**notsame %s %s";
static const wchar_t long_spc383[]  = L"Inconsistent arguments %s to collective routine %s";
static const wchar_t short_spc384[] = L"**nulledge %d %d";
static const wchar_t long_spc384[]  = L"Edge for node %d (entry edges[%d]) is to itself";
static const wchar_t short_spc385[] = L"**nullptr %s";
static const wchar_t long_spc385[]  = L"Null pointer in parameter %s";
static const wchar_t short_spc386[] = L"**nullptrtype %s";
static const wchar_t long_spc386[]  = L"Null %s pointer";
static const wchar_t short_spc387[] = L"**open %s %d %d";
static const wchar_t long_spc387[]  = L"open(%s) failed for process %d, error %d";
static const wchar_t short_spc388[] = L"**opnotpredefined %d";
static const wchar_t long_spc388[]  = L"only predefined ops are valid (op = %d)";
static const wchar_t short_spc389[] = L"**opundefined %s";
static const wchar_t long_spc389[]  = L"MPI_Op %s operation not defined for this datatype ";
static const wchar_t short_spc390[] = L"**pd_alloc %s";
static const wchar_t long_spc390[]  = L"unable to allocate a protection domain - %s";
static const wchar_t short_spc391[] = L"**pglookup %s";
static const wchar_t long_spc391[]  = L"unable to find the process group structure with id <%s>";
static const wchar_t short_spc392[] = L"**pkt_ptr %p %p";
static const wchar_t long_spc392[]  = L"invalid shm queue packet pointer (%p != %p)";
static const wchar_t short_spc393[] = L"**pmi_barrier %d";
static const wchar_t long_spc393[]  = L"PMI_Barrier returned %d";
static const wchar_t short_spc394[] = L"**pmi_barrier %d %s";
static const wchar_t long_spc394[]  = L"PMI_Barrier returned %d, %s";
static const wchar_t short_spc395[] = L"**pmi_get_appnum %d %s";
static const wchar_t long_spc395[]  = L"PMI_Get_appnum returned %d, %s";
static const wchar_t short_spc396[] = L"**pmi_get_clique_ranks %d %s";
static const wchar_t long_spc396[]  = L"PMI_Get_clique_ranks returned %d, %s";
static const wchar_t short_spc397[] = L"**pmi_get_clique_size %d %s";
static const wchar_t long_spc397[]  = L"PMI_Get_clique_size returned %d, %s";
static const wchar_t short_spc398[] = L"**pmi_get_id %d %s";
static const wchar_t long_spc398[]  = L"PMI_Get_id returned %d, %s";
static const wchar_t short_spc399[] = L"**pmi_get_id_length_max %d %s";
static const wchar_t long_spc399[]  = L"PMI_Get_id_length_max returned %d, %s";
static const wchar_t short_spc400[] = L"**pmi_get_rank %d %s";
static const wchar_t long_spc400[]  = L"PMI_Get_rank returned %d, %s";
static const wchar_t short_spc401[] = L"**pmi_get_size %d";
static const wchar_t long_spc401[]  = L"PMI_Get_size returned %d";
static const wchar_t short_spc402[] = L"**pmi_get_size %d %s";
static const wchar_t long_spc402[]  = L"PMI_Get_size returned %d, %s";
static const wchar_t short_spc403[] = L"**pmi_get_universe_size %d %s";
static const wchar_t long_spc403[]  = L"PMI_Get_universe_size returned %d, %s";
static const wchar_t short_spc404[] = L"**pmi_init %d %s";
static const wchar_t long_spc404[]  = L"PMI_Init returned %d, %s";
static const wchar_t short_spc405[] = L"**pmi_invalid_clique_size %d";
static const wchar_t long_spc405[]  = L"PMI_Get_clique_ranks returned an invalid size %d";
static const wchar_t short_spc406[] = L"**pmi_kvs_commit %d";
static const wchar_t long_spc406[]  = L"PMI_KVS_Commit returned %d";
static const wchar_t short_spc407[] = L"**pmi_kvs_commit %d %s";
static const wchar_t long_spc407[]  = L"PMI_KVS_Commit returned %d, %s";
static const wchar_t short_spc408[] = L"**pmi_kvs_get %d";
static const wchar_t long_spc408[]  = L"PMI_KVS_Get returned %d";
static const wchar_t short_spc409[] = L"**pmi_kvs_get %d %s";
static const wchar_t long_spc409[]  = L"PMI_KVS_Get returned %d, %s";
static const wchar_t short_spc410[] = L"**pmi_kvs_get_key_length_max %d %s";
static const wchar_t long_spc410[]  = L"PMI_KVS_Get_key_length_max returned %d, %s";
static const wchar_t short_spc411[] = L"**pmi_kvs_get_my_name %d %s";
static const wchar_t long_spc411[]  = L"PMI_KVS_Get_my_name returned %d, %s";
static const wchar_t short_spc412[] = L"**pmi_kvs_get_name_length_max %d %s";
static const wchar_t long_spc412[]  = L"PMI_KVS_Get_name_length_max returned %d, %s";
static const wchar_t short_spc413[] = L"**pmi_kvs_get_value_length_max %d %s";
static const wchar_t long_spc413[]  = L"PMI_KVS_Get_value_length_max returned %d, %s";
static const wchar_t short_spc414[] = L"**pmi_kvs_put %d";
static const wchar_t long_spc414[]  = L"PMI_KVS_Put returned %d";
static const wchar_t short_spc415[] = L"**pmi_kvs_put %d %s";
static const wchar_t long_spc415[]  = L"PMI_KVS_Put returned %d, %s";
static const wchar_t short_spc416[] = L"**pmi_spawn_multiple %d %s";
static const wchar_t long_spc416[]  = L"PMI_Spawn_multiple returned %d, %s";
static const wchar_t short_spc417[] = L"**post_connect %s";
static const wchar_t long_spc417[]  = L"%s failed in VC_post_connect";
static const wchar_t short_spc418[] = L"**rangedup %d %d %d";
static const wchar_t long_spc418[]  = L"The range array specifies duplicate entries; process %d specified in range array %d was previously specified in range array %d";
static const wchar_t short_spc419[] = L"**rangeendinvalid %d %d %d";
static const wchar_t long_spc419[]  = L"The %dth element of a range array ends at %d but must be nonnegative and less than %d";
static const wchar_t short_spc420[] = L"**rangestartinvalid %d %d %d";
static const wchar_t long_spc420[]  = L"The %dth element of a range array starts at %d but must be nonnegative and less than %d";
static const wchar_t short_spc421[] = L"**rank %d %d";
static const wchar_t long_spc421[]  = L"Invalid rank has value %d but must be nonnegative and less than %d";
static const wchar_t short_spc422[] = L"**rankarray %d %d %d";
static const wchar_t long_spc422[]  = L"Invalid rank in rank array at index %d; value is %d but must be in the range 0 to %d";
static const wchar_t short_spc423[] = L"**rankdup %d %d %d";
static const wchar_t long_spc423[]  = L"Duplicate ranks in rank array at index %d, has value %d which is also the value at index %d";
static const wchar_t short_spc424[] = L"**request_invalid_kind %d";
static const wchar_t long_spc424[]  = L"The supplied request was invalid (kind=%d)";
static const wchar_t short_spc425[] = L"**rmasize %d";
static const wchar_t long_spc425[]  = L"Invalid size argument in RMA call (value is %d)";
static const wchar_t short_spc426[] = L"**root %d";
static const wchar_t long_spc426[]  = L"Invalid root (value given was %d)";
static const wchar_t short_spc427[] = L"**rsendnomatch %d %d";
static const wchar_t long_spc427[]  = L"Ready send from source %d and with tag %d had no matching receive";
static const wchar_t short_spc428[] = L"**shm_op %d";
static const wchar_t long_spc428[]  = L"invalid shm operation (%d)";
static const wchar_t short_spc429[] = L"**shm_open %s %d";
static const wchar_t long_spc429[]  = L"unable to open shared memory object %s (errno %d)";
static const wchar_t short_spc430[] = L"**shm_unlink %s %d";
static const wchar_t long_spc430[]  = L"failed to unlink shared memory object %s, error %d";
static const wchar_t short_spc431[] = L"**shmat %d";
static const wchar_t long_spc431[]  = L"shmat failed, error %d";
static const wchar_t short_spc432[] = L"**shmctl %d %d";
static const wchar_t long_spc432[]  = L"failed to mark the sysv segment %d for removal, error %d";
static const wchar_t short_spc433[] = L"**shmget %d";
static const wchar_t long_spc433[]  = L"shmget failed, error %d";
static const wchar_t short_spc434[] = L"**shmhost %s %s";
static const wchar_t long_spc434[]  = L"process not on the same host (%s != %s)";
static const wchar_t short_spc435[] = L"**shmq_index %d %d";
static const wchar_t long_spc435[]  = L"invalid shm queue index (%d > %d)";
static const wchar_t short_spc436[] = L"**shmsize %d";
static const wchar_t long_spc436[]  = L"Shared memory subsystem unable to allocate a block of the requested size, %d bytes";
static const wchar_t short_spc437[] = L"**shutdown %s %d";
static const wchar_t long_spc437[]  = L"shutdown failed, %s (errno %d)";
static const wchar_t short_spc438[] = L"**sock_connect %s %d %s %d";
static const wchar_t long_spc438[]  = L"unable to connect to %s on port %d, %s (errno %d)";
static const wchar_t short_spc439[] = L"**sock_gethost %s %d";
static const wchar_t long_spc439[]  = L"gethostname failed, %s (errno %d)";
static const wchar_t short_spc440[] = L"**socket %s %d";
static const wchar_t long_spc440[]  = L"WSASocket failed, %s (errno %d)";
static const wchar_t short_spc441[] = L"**stride %d %d %d";
static const wchar_t long_spc441[]  = L"Range (start = %d, end = %d, stride = %d) does not terminate";
static const wchar_t short_spc442[] = L"**tag %d";
static const wchar_t long_spc442[]  = L"Invalid tag, value is %d";
static const wchar_t short_spc443[] = L"**topotoolarge %d %d";
static const wchar_t long_spc443[]  = L"Topology size %d is larger than communicator size (%d)";
static const wchar_t short_spc444[] = L"**truncate %d %d";
static const wchar_t long_spc444[]  = L"Message truncated; %d bytes received but buffer size is %d";
static const wchar_t short_spc445[] = L"**truncate %d %d %d %d";
static const wchar_t long_spc445[]  = L"Message from rank %d and tag %d truncated; %d bytes received but buffer size is %d";
static const wchar_t short_spc446[] = L"**typematchsize %s %d";
static const wchar_t long_spc446[]  = L"No MPI datatype available for typeclass %s and size %d";
static const wchar_t short_spc447[] = L"**typenamelen %d";
static const wchar_t long_spc447[]  = L"Specified datatype name is too long (%d characters)";
static const wchar_t short_spc448[] = L"**usercancel %d";
static const wchar_t long_spc448[]  = L"user request cancel function returned error code %d";
static const wchar_t short_spc449[] = L"**usercopy %d";
static const wchar_t long_spc449[]  = L"user copy function returned error code %d";
static const wchar_t short_spc450[] = L"**userdel %d";
static const wchar_t long_spc450[]  = L"user delete function returned error code %d";
static const wchar_t short_spc451[] = L"**userfree %d";
static const wchar_t long_spc451[]  = L"user request free function returned error code %d";
static const wchar_t short_spc452[] = L"**userquery %d";
static const wchar_t long_spc452[]  = L"user request query function returned error code %d";
static const wchar_t short_spc453[] = L"**vc_state %d";
static const wchar_t long_spc453[]  = L"invalid vc state (%d)";
static const wchar_t short_spc454[] = L"**winunlockrank %d %d";
static const wchar_t long_spc454[]  = L"Invalid rank argument %d, should be %d";
static const wchar_t short_spc455[] = L"**wsasock %s %d";
static const wchar_t long_spc455[]  = L"WSAStartup failed, %s (errno %d)";

static const int specific_msgs_len = 456;
static const msgpair specific_err_msgs[] = {
{ 0xacebad03, short_spc0, long_spc0, 0xcb0bfa11 },
{ 0xacebad03, short_spc1, long_spc1, 0xcb0bfa11 },
{ 0xacebad03, short_spc2, long_spc2, 0xcb0bfa11 },
{ 0xacebad03, short_spc3, long_spc3, 0xcb0bfa11 },
{ 0xacebad03, short_spc4, long_spc4, 0xcb0bfa11 },
{ 0xacebad03, short_spc5, long_spc5, 0xcb0bfa11 },
{ 0xacebad03, short_spc6, long_spc6, 0xcb0bfa11 },
{ 0xacebad03, short_spc7, long_spc7, 0xcb0bfa11 },
{ 0xacebad03, short_spc8, long_spc8, 0xcb0bfa11 },
{ 0xacebad03, short_spc9, long_spc9, 0xcb0bfa11 },
{ 0xacebad03, short_spc10, long_spc10, 0xcb0bfa11 },
{ 0xacebad03, short_spc11, long_spc11, 0xcb0bfa11 },
{ 0xacebad03, short_spc12, long_spc12, 0xcb0bfa11 },
{ 0xacebad03, short_spc13, long_spc13, 0xcb0bfa11 },
{ 0xacebad03, short_spc14, long_spc14, 0xcb0bfa11 },
{ 0xacebad03, short_spc15, long_spc15, 0xcb0bfa11 },
{ 0xacebad03, short_spc16, long_spc16, 0xcb0bfa11 },
{ 0xacebad03, short_spc17, long_spc17, 0xcb0bfa11 },
{ 0xacebad03, short_spc18, long_spc18, 0xcb0bfa11 },
{ 0xacebad03, short_spc19, long_spc19, 0xcb0bfa11 },
{ 0xacebad03, short_spc20, long_spc20, 0xcb0bfa11 },
{ 0xacebad03, short_spc21, long_spc21, 0xcb0bfa11 },
{ 0xacebad03, short_spc22, long_spc22, 0xcb0bfa11 },
{ 0xacebad03, short_spc23, long_spc23, 0xcb0bfa11 },
{ 0xacebad03, short_spc24, long_spc24, 0xcb0bfa11 },
{ 0xacebad03, short_spc25, long_spc25, 0xcb0bfa11 },
{ 0xacebad03, short_spc26, long_spc26, 0xcb0bfa11 },
{ 0xacebad03, short_spc27, long_spc27, 0xcb0bfa11 },
{ 0xacebad03, short_spc28, long_spc28, 0xcb0bfa11 },
{ 0xacebad03, short_spc29, long_spc29, 0xcb0bfa11 },
{ 0xacebad03, short_spc30, long_spc30, 0xcb0bfa11 },
{ 0xacebad03, short_spc31, long_spc31, 0xcb0bfa11 },
{ 0xacebad03, short_spc32, long_spc32, 0xcb0bfa11 },
{ 0xacebad03, short_spc33, long_spc33, 0xcb0bfa11 },
{ 0xacebad03, short_spc34, long_spc34, 0xcb0bfa11 },
{ 0xacebad03, short_spc35, long_spc35, 0xcb0bfa11 },
{ 0xacebad03, short_spc36, long_spc36, 0xcb0bfa11 },
{ 0xacebad03, short_spc37, long_spc37, 0xcb0bfa11 },
{ 0xacebad03, short_spc38, long_spc38, 0xcb0bfa11 },
{ 0xacebad03, short_spc39, long_spc39, 0xcb0bfa11 },
{ 0xacebad03, short_spc40, long_spc40, 0xcb0bfa11 },
{ 0xacebad03, short_spc41, long_spc41, 0xcb0bfa11 },
{ 0xacebad03, short_spc42, long_spc42, 0xcb0bfa11 },
{ 0xacebad03, short_spc43, long_spc43, 0xcb0bfa11 },
{ 0xacebad03, short_spc44, long_spc44, 0xcb0bfa11 },
{ 0xacebad03, short_spc45, long_spc45, 0xcb0bfa11 },
{ 0xacebad03, short_spc46, long_spc46, 0xcb0bfa11 },
{ 0xacebad03, short_spc47, long_spc47, 0xcb0bfa11 },
{ 0xacebad03, short_spc48, long_spc48, 0xcb0bfa11 },
{ 0xacebad03, short_spc49, long_spc49, 0xcb0bfa11 },
{ 0xacebad03, short_spc50, long_spc50, 0xcb0bfa11 },
{ 0xacebad03, short_spc51, long_spc51, 0xcb0bfa11 },
{ 0xacebad03, short_spc52, long_spc52, 0xcb0bfa11 },
{ 0xacebad03, short_spc53, long_spc53, 0xcb0bfa11 },
{ 0xacebad03, short_spc54, long_spc54, 0xcb0bfa11 },
{ 0xacebad03, short_spc55, long_spc55, 0xcb0bfa11 },
{ 0xacebad03, short_spc56, long_spc56, 0xcb0bfa11 },
{ 0xacebad03, short_spc57, long_spc57, 0xcb0bfa11 },
{ 0xacebad03, short_spc58, long_spc58, 0xcb0bfa11 },
{ 0xacebad03, short_spc59, long_spc59, 0xcb0bfa11 },
{ 0xacebad03, short_spc60, long_spc60, 0xcb0bfa11 },
{ 0xacebad03, short_spc61, long_spc61, 0xcb0bfa11 },
{ 0xacebad03, short_spc62, long_spc62, 0xcb0bfa11 },
{ 0xacebad03, short_spc63, long_spc63, 0xcb0bfa11 },
{ 0xacebad03, short_spc64, long_spc64, 0xcb0bfa11 },
{ 0xacebad03, short_spc65, long_spc65, 0xcb0bfa11 },
{ 0xacebad03, short_spc66, long_spc66, 0xcb0bfa11 },
{ 0xacebad03, short_spc67, long_spc67, 0xcb0bfa11 },
{ 0xacebad03, short_spc68, long_spc68, 0xcb0bfa11 },
{ 0xacebad03, short_spc69, long_spc69, 0xcb0bfa11 },
{ 0xacebad03, short_spc70, long_spc70, 0xcb0bfa11 },
{ 0xacebad03, short_spc71, long_spc71, 0xcb0bfa11 },
{ 0xacebad03, short_spc72, long_spc72, 0xcb0bfa11 },
{ 0xacebad03, short_spc73, long_spc73, 0xcb0bfa11 },
{ 0xacebad03, short_spc74, long_spc74, 0xcb0bfa11 },
{ 0xacebad03, short_spc75, long_spc75, 0xcb0bfa11 },
{ 0xacebad03, short_spc76, long_spc76, 0xcb0bfa11 },
{ 0xacebad03, short_spc77, long_spc77, 0xcb0bfa11 },
{ 0xacebad03, short_spc78, long_spc78, 0xcb0bfa11 },
{ 0xacebad03, short_spc79, long_spc79, 0xcb0bfa11 },
{ 0xacebad03, short_spc80, long_spc80, 0xcb0bfa11 },
{ 0xacebad03, short_spc81, long_spc81, 0xcb0bfa11 },
{ 0xacebad03, short_spc82, long_spc82, 0xcb0bfa11 },
{ 0xacebad03, short_spc83, long_spc83, 0xcb0bfa11 },
{ 0xacebad03, short_spc84, long_spc84, 0xcb0bfa11 },
{ 0xacebad03, short_spc85, long_spc85, 0xcb0bfa11 },
{ 0xacebad03, short_spc86, long_spc86, 0xcb0bfa11 },
{ 0xacebad03, short_spc87, long_spc87, 0xcb0bfa11 },
{ 0xacebad03, short_spc88, long_spc88, 0xcb0bfa11 },
{ 0xacebad03, short_spc89, long_spc89, 0xcb0bfa11 },
{ 0xacebad03, short_spc90, long_spc90, 0xcb0bfa11 },
{ 0xacebad03, short_spc91, long_spc91, 0xcb0bfa11 },
{ 0xacebad03, short_spc92, long_spc92, 0xcb0bfa11 },
{ 0xacebad03, short_spc93, long_spc93, 0xcb0bfa11 },
{ 0xacebad03, short_spc94, long_spc94, 0xcb0bfa11 },
{ 0xacebad03, short_spc95, long_spc95, 0xcb0bfa11 },
{ 0xacebad03, short_spc96, long_spc96, 0xcb0bfa11 },
{ 0xacebad03, short_spc97, long_spc97, 0xcb0bfa11 },
{ 0xacebad03, short_spc98, long_spc98, 0xcb0bfa11 },
{ 0xacebad03, short_spc99, long_spc99, 0xcb0bfa11 },
{ 0xacebad03, short_spc100, long_spc100, 0xcb0bfa11 },
{ 0xacebad03, short_spc101, long_spc101, 0xcb0bfa11 },
{ 0xacebad03, short_spc102, long_spc102, 0xcb0bfa11 },
{ 0xacebad03, short_spc103, long_spc103, 0xcb0bfa11 },
{ 0xacebad03, short_spc104, long_spc104, 0xcb0bfa11 },
{ 0xacebad03, short_spc105, long_spc105, 0xcb0bfa11 },
{ 0xacebad03, short_spc106, long_spc106, 0xcb0bfa11 },
{ 0xacebad03, short_spc107, long_spc107, 0xcb0bfa11 },
{ 0xacebad03, short_spc108, long_spc108, 0xcb0bfa11 },
{ 0xacebad03, short_spc109, long_spc109, 0xcb0bfa11 },
{ 0xacebad03, short_spc110, long_spc110, 0xcb0bfa11 },
{ 0xacebad03, short_spc111, long_spc111, 0xcb0bfa11 },
{ 0xacebad03, short_spc112, long_spc112, 0xcb0bfa11 },
{ 0xacebad03, short_spc113, long_spc113, 0xcb0bfa11 },
{ 0xacebad03, short_spc114, long_spc114, 0xcb0bfa11 },
{ 0xacebad03, short_spc115, long_spc115, 0xcb0bfa11 },
{ 0xacebad03, short_spc116, long_spc116, 0xcb0bfa11 },
{ 0xacebad03, short_spc117, long_spc117, 0xcb0bfa11 },
{ 0xacebad03, short_spc118, long_spc118, 0xcb0bfa11 },
{ 0xacebad03, short_spc119, long_spc119, 0xcb0bfa11 },
{ 0xacebad03, short_spc120, long_spc120, 0xcb0bfa11 },
{ 0xacebad03, short_spc121, long_spc121, 0xcb0bfa11 },
{ 0xacebad03, short_spc122, long_spc122, 0xcb0bfa11 },
{ 0xacebad03, short_spc123, long_spc123, 0xcb0bfa11 },
{ 0xacebad03, short_spc124, long_spc124, 0xcb0bfa11 },
{ 0xacebad03, short_spc125, long_spc125, 0xcb0bfa11 },
{ 0xacebad03, short_spc126, long_spc126, 0xcb0bfa11 },
{ 0xacebad03, short_spc127, long_spc127, 0xcb0bfa11 },
{ 0xacebad03, short_spc128, long_spc128, 0xcb0bfa11 },
{ 0xacebad03, short_spc129, long_spc129, 0xcb0bfa11 },
{ 0xacebad03, short_spc130, long_spc130, 0xcb0bfa11 },
{ 0xacebad03, short_spc131, long_spc131, 0xcb0bfa11 },
{ 0xacebad03, short_spc132, long_spc132, 0xcb0bfa11 },
{ 0xacebad03, short_spc133, long_spc133, 0xcb0bfa11 },
{ 0xacebad03, short_spc134, long_spc134, 0xcb0bfa11 },
{ 0xacebad03, short_spc135, long_spc135, 0xcb0bfa11 },
{ 0xacebad03, short_spc136, long_spc136, 0xcb0bfa11 },
{ 0xacebad03, short_spc137, long_spc137, 0xcb0bfa11 },
{ 0xacebad03, short_spc138, long_spc138, 0xcb0bfa11 },
{ 0xacebad03, short_spc139, long_spc139, 0xcb0bfa11 },
{ 0xacebad03, short_spc140, long_spc140, 0xcb0bfa11 },
{ 0xacebad03, short_spc141, long_spc141, 0xcb0bfa11 },
{ 0xacebad03, short_spc142, long_spc142, 0xcb0bfa11 },
{ 0xacebad03, short_spc143, long_spc143, 0xcb0bfa11 },
{ 0xacebad03, short_spc144, long_spc144, 0xcb0bfa11 },
{ 0xacebad03, short_spc145, long_spc145, 0xcb0bfa11 },
{ 0xacebad03, short_spc146, long_spc146, 0xcb0bfa11 },
{ 0xacebad03, short_spc147, long_spc147, 0xcb0bfa11 },
{ 0xacebad03, short_spc148, long_spc148, 0xcb0bfa11 },
{ 0xacebad03, short_spc149, long_spc149, 0xcb0bfa11 },
{ 0xacebad03, short_spc150, long_spc150, 0xcb0bfa11 },
{ 0xacebad03, short_spc151, long_spc151, 0xcb0bfa11 },
{ 0xacebad03, short_spc152, long_spc152, 0xcb0bfa11 },
{ 0xacebad03, short_spc153, long_spc153, 0xcb0bfa11 },
{ 0xacebad03, short_spc154, long_spc154, 0xcb0bfa11 },
{ 0xacebad03, short_spc155, long_spc155, 0xcb0bfa11 },
{ 0xacebad03, short_spc156, long_spc156, 0xcb0bfa11 },
{ 0xacebad03, short_spc157, long_spc157, 0xcb0bfa11 },
{ 0xacebad03, short_spc158, long_spc158, 0xcb0bfa11 },
{ 0xacebad03, short_spc159, long_spc159, 0xcb0bfa11 },
{ 0xacebad03, short_spc160, long_spc160, 0xcb0bfa11 },
{ 0xacebad03, short_spc161, long_spc161, 0xcb0bfa11 },
{ 0xacebad03, short_spc162, long_spc162, 0xcb0bfa11 },
{ 0xacebad03, short_spc163, long_spc163, 0xcb0bfa11 },
{ 0xacebad03, short_spc164, long_spc164, 0xcb0bfa11 },
{ 0xacebad03, short_spc165, long_spc165, 0xcb0bfa11 },
{ 0xacebad03, short_spc166, long_spc166, 0xcb0bfa11 },
{ 0xacebad03, short_spc167, long_spc167, 0xcb0bfa11 },
{ 0xacebad03, short_spc168, long_spc168, 0xcb0bfa11 },
{ 0xacebad03, short_spc169, long_spc169, 0xcb0bfa11 },
{ 0xacebad03, short_spc170, long_spc170, 0xcb0bfa11 },
{ 0xacebad03, short_spc171, long_spc171, 0xcb0bfa11 },
{ 0xacebad03, short_spc172, long_spc172, 0xcb0bfa11 },
{ 0xacebad03, short_spc173, long_spc173, 0xcb0bfa11 },
{ 0xacebad03, short_spc174, long_spc174, 0xcb0bfa11 },
{ 0xacebad03, short_spc175, long_spc175, 0xcb0bfa11 },
{ 0xacebad03, short_spc176, long_spc176, 0xcb0bfa11 },
{ 0xacebad03, short_spc177, long_spc177, 0xcb0bfa11 },
{ 0xacebad03, short_spc178, long_spc178, 0xcb0bfa11 },
{ 0xacebad03, short_spc179, long_spc179, 0xcb0bfa11 },
{ 0xacebad03, short_spc180, long_spc180, 0xcb0bfa11 },
{ 0xacebad03, short_spc181, long_spc181, 0xcb0bfa11 },
{ 0xacebad03, short_spc182, long_spc182, 0xcb0bfa11 },
{ 0xacebad03, short_spc183, long_spc183, 0xcb0bfa11 },
{ 0xacebad03, short_spc184, long_spc184, 0xcb0bfa11 },
{ 0xacebad03, short_spc185, long_spc185, 0xcb0bfa11 },
{ 0xacebad03, short_spc186, long_spc186, 0xcb0bfa11 },
{ 0xacebad03, short_spc187, long_spc187, 0xcb0bfa11 },
{ 0xacebad03, short_spc188, long_spc188, 0xcb0bfa11 },
{ 0xacebad03, short_spc189, long_spc189, 0xcb0bfa11 },
{ 0xacebad03, short_spc190, long_spc190, 0xcb0bfa11 },
{ 0xacebad03, short_spc191, long_spc191, 0xcb0bfa11 },
{ 0xacebad03, short_spc192, long_spc192, 0xcb0bfa11 },
{ 0xacebad03, short_spc193, long_spc193, 0xcb0bfa11 },
{ 0xacebad03, short_spc194, long_spc194, 0xcb0bfa11 },
{ 0xacebad03, short_spc195, long_spc195, 0xcb0bfa11 },
{ 0xacebad03, short_spc196, long_spc196, 0xcb0bfa11 },
{ 0xacebad03, short_spc197, long_spc197, 0xcb0bfa11 },
{ 0xacebad03, short_spc198, long_spc198, 0xcb0bfa11 },
{ 0xacebad03, short_spc199, long_spc199, 0xcb0bfa11 },
{ 0xacebad03, short_spc200, long_spc200, 0xcb0bfa11 },
{ 0xacebad03, short_spc201, long_spc201, 0xcb0bfa11 },
{ 0xacebad03, short_spc202, long_spc202, 0xcb0bfa11 },
{ 0xacebad03, short_spc203, long_spc203, 0xcb0bfa11 },
{ 0xacebad03, short_spc204, long_spc204, 0xcb0bfa11 },
{ 0xacebad03, short_spc205, long_spc205, 0xcb0bfa11 },
{ 0xacebad03, short_spc206, long_spc206, 0xcb0bfa11 },
{ 0xacebad03, short_spc207, long_spc207, 0xcb0bfa11 },
{ 0xacebad03, short_spc208, long_spc208, 0xcb0bfa11 },
{ 0xacebad03, short_spc209, long_spc209, 0xcb0bfa11 },
{ 0xacebad03, short_spc210, long_spc210, 0xcb0bfa11 },
{ 0xacebad03, short_spc211, long_spc211, 0xcb0bfa11 },
{ 0xacebad03, short_spc212, long_spc212, 0xcb0bfa11 },
{ 0xacebad03, short_spc213, long_spc213, 0xcb0bfa11 },
{ 0xacebad03, short_spc214, long_spc214, 0xcb0bfa11 },
{ 0xacebad03, short_spc215, long_spc215, 0xcb0bfa11 },
{ 0xacebad03, short_spc216, long_spc216, 0xcb0bfa11 },
{ 0xacebad03, short_spc217, long_spc217, 0xcb0bfa11 },
{ 0xacebad03, short_spc218, long_spc218, 0xcb0bfa11 },
{ 0xacebad03, short_spc219, long_spc219, 0xcb0bfa11 },
{ 0xacebad03, short_spc220, long_spc220, 0xcb0bfa11 },
{ 0xacebad03, short_spc221, long_spc221, 0xcb0bfa11 },
{ 0xacebad03, short_spc222, long_spc222, 0xcb0bfa11 },
{ 0xacebad03, short_spc223, long_spc223, 0xcb0bfa11 },
{ 0xacebad03, short_spc224, long_spc224, 0xcb0bfa11 },
{ 0xacebad03, short_spc225, long_spc225, 0xcb0bfa11 },
{ 0xacebad03, short_spc226, long_spc226, 0xcb0bfa11 },
{ 0xacebad03, short_spc227, long_spc227, 0xcb0bfa11 },
{ 0xacebad03, short_spc228, long_spc228, 0xcb0bfa11 },
{ 0xacebad03, short_spc229, long_spc229, 0xcb0bfa11 },
{ 0xacebad03, short_spc230, long_spc230, 0xcb0bfa11 },
{ 0xacebad03, short_spc231, long_spc231, 0xcb0bfa11 },
{ 0xacebad03, short_spc232, long_spc232, 0xcb0bfa11 },
{ 0xacebad03, short_spc233, long_spc233, 0xcb0bfa11 },
{ 0xacebad03, short_spc234, long_spc234, 0xcb0bfa11 },
{ 0xacebad03, short_spc235, long_spc235, 0xcb0bfa11 },
{ 0xacebad03, short_spc236, long_spc236, 0xcb0bfa11 },
{ 0xacebad03, short_spc237, long_spc237, 0xcb0bfa11 },
{ 0xacebad03, short_spc238, long_spc238, 0xcb0bfa11 },
{ 0xacebad03, short_spc239, long_spc239, 0xcb0bfa11 },
{ 0xacebad03, short_spc240, long_spc240, 0xcb0bfa11 },
{ 0xacebad03, short_spc241, long_spc241, 0xcb0bfa11 },
{ 0xacebad03, short_spc242, long_spc242, 0xcb0bfa11 },
{ 0xacebad03, short_spc243, long_spc243, 0xcb0bfa11 },
{ 0xacebad03, short_spc244, long_spc244, 0xcb0bfa11 },
{ 0xacebad03, short_spc245, long_spc245, 0xcb0bfa11 },
{ 0xacebad03, short_spc246, long_spc246, 0xcb0bfa11 },
{ 0xacebad03, short_spc247, long_spc247, 0xcb0bfa11 },
{ 0xacebad03, short_spc248, long_spc248, 0xcb0bfa11 },
{ 0xacebad03, short_spc249, long_spc249, 0xcb0bfa11 },
{ 0xacebad03, short_spc250, long_spc250, 0xcb0bfa11 },
{ 0xacebad03, short_spc251, long_spc251, 0xcb0bfa11 },
{ 0xacebad03, short_spc252, long_spc252, 0xcb0bfa11 },
{ 0xacebad03, short_spc253, long_spc253, 0xcb0bfa11 },
{ 0xacebad03, short_spc254, long_spc254, 0xcb0bfa11 },
{ 0xacebad03, short_spc255, long_spc255, 0xcb0bfa11 },
{ 0xacebad03, short_spc256, long_spc256, 0xcb0bfa11 },
{ 0xacebad03, short_spc257, long_spc257, 0xcb0bfa11 },
{ 0xacebad03, short_spc258, long_spc258, 0xcb0bfa11 },
{ 0xacebad03, short_spc259, long_spc259, 0xcb0bfa11 },
{ 0xacebad03, short_spc260, long_spc260, 0xcb0bfa11 },
{ 0xacebad03, short_spc261, long_spc261, 0xcb0bfa11 },
{ 0xacebad03, short_spc262, long_spc262, 0xcb0bfa11 },
{ 0xacebad03, short_spc263, long_spc263, 0xcb0bfa11 },
{ 0xacebad03, short_spc264, long_spc264, 0xcb0bfa11 },
{ 0xacebad03, short_spc265, long_spc265, 0xcb0bfa11 },
{ 0xacebad03, short_spc266, long_spc266, 0xcb0bfa11 },
{ 0xacebad03, short_spc267, long_spc267, 0xcb0bfa11 },
{ 0xacebad03, short_spc268, long_spc268, 0xcb0bfa11 },
{ 0xacebad03, short_spc269, long_spc269, 0xcb0bfa11 },
{ 0xacebad03, short_spc270, long_spc270, 0xcb0bfa11 },
{ 0xacebad03, short_spc271, long_spc271, 0xcb0bfa11 },
{ 0xacebad03, short_spc272, long_spc272, 0xcb0bfa11 },
{ 0xacebad03, short_spc273, long_spc273, 0xcb0bfa11 },
{ 0xacebad03, short_spc274, long_spc274, 0xcb0bfa11 },
{ 0xacebad03, short_spc275, long_spc275, 0xcb0bfa11 },
{ 0xacebad03, short_spc276, long_spc276, 0xcb0bfa11 },
{ 0xacebad03, short_spc277, long_spc277, 0xcb0bfa11 },
{ 0xacebad03, short_spc278, long_spc278, 0xcb0bfa11 },
{ 0xacebad03, short_spc279, long_spc279, 0xcb0bfa11 },
{ 0xacebad03, short_spc280, long_spc280, 0xcb0bfa11 },
{ 0xacebad03, short_spc281, long_spc281, 0xcb0bfa11 },
{ 0xacebad03, short_spc282, long_spc282, 0xcb0bfa11 },
{ 0xacebad03, short_spc283, long_spc283, 0xcb0bfa11 },
{ 0xacebad03, short_spc284, long_spc284, 0xcb0bfa11 },
{ 0xacebad03, short_spc285, long_spc285, 0xcb0bfa11 },
{ 0xacebad03, short_spc286, long_spc286, 0xcb0bfa11 },
{ 0xacebad03, short_spc287, long_spc287, 0xcb0bfa11 },
{ 0xacebad03, short_spc288, long_spc288, 0xcb0bfa11 },
{ 0xacebad03, short_spc289, long_spc289, 0xcb0bfa11 },
{ 0xacebad03, short_spc290, long_spc290, 0xcb0bfa11 },
{ 0xacebad03, short_spc291, long_spc291, 0xcb0bfa11 },
{ 0xacebad03, short_spc292, long_spc292, 0xcb0bfa11 },
{ 0xacebad03, short_spc293, long_spc293, 0xcb0bfa11 },
{ 0xacebad03, short_spc294, long_spc294, 0xcb0bfa11 },
{ 0xacebad03, short_spc295, long_spc295, 0xcb0bfa11 },
{ 0xacebad03, short_spc296, long_spc296, 0xcb0bfa11 },
{ 0xacebad03, short_spc297, long_spc297, 0xcb0bfa11 },
{ 0xacebad03, short_spc298, long_spc298, 0xcb0bfa11 },
{ 0xacebad03, short_spc299, long_spc299, 0xcb0bfa11 },
{ 0xacebad03, short_spc300, long_spc300, 0xcb0bfa11 },
{ 0xacebad03, short_spc301, long_spc301, 0xcb0bfa11 },
{ 0xacebad03, short_spc302, long_spc302, 0xcb0bfa11 },
{ 0xacebad03, short_spc303, long_spc303, 0xcb0bfa11 },
{ 0xacebad03, short_spc304, long_spc304, 0xcb0bfa11 },
{ 0xacebad03, short_spc305, long_spc305, 0xcb0bfa11 },
{ 0xacebad03, short_spc306, long_spc306, 0xcb0bfa11 },
{ 0xacebad03, short_spc307, long_spc307, 0xcb0bfa11 },
{ 0xacebad03, short_spc308, long_spc308, 0xcb0bfa11 },
{ 0xacebad03, short_spc309, long_spc309, 0xcb0bfa11 },
{ 0xacebad03, short_spc310, long_spc310, 0xcb0bfa11 },
{ 0xacebad03, short_spc311, long_spc311, 0xcb0bfa11 },
{ 0xacebad03, short_spc312, long_spc312, 0xcb0bfa11 },
{ 0xacebad03, short_spc313, long_spc313, 0xcb0bfa11 },
{ 0xacebad03, short_spc314, long_spc314, 0xcb0bfa11 },
{ 0xacebad03, short_spc315, long_spc315, 0xcb0bfa11 },
{ 0xacebad03, short_spc316, long_spc316, 0xcb0bfa11 },
{ 0xacebad03, short_spc317, long_spc317, 0xcb0bfa11 },
{ 0xacebad03, short_spc318, long_spc318, 0xcb0bfa11 },
{ 0xacebad03, short_spc319, long_spc319, 0xcb0bfa11 },
{ 0xacebad03, short_spc320, long_spc320, 0xcb0bfa11 },
{ 0xacebad03, short_spc321, long_spc321, 0xcb0bfa11 },
{ 0xacebad03, short_spc322, long_spc322, 0xcb0bfa11 },
{ 0xacebad03, short_spc323, long_spc323, 0xcb0bfa11 },
{ 0xacebad03, short_spc324, long_spc324, 0xcb0bfa11 },
{ 0xacebad03, short_spc325, long_spc325, 0xcb0bfa11 },
{ 0xacebad03, short_spc326, long_spc326, 0xcb0bfa11 },
{ 0xacebad03, short_spc327, long_spc327, 0xcb0bfa11 },
{ 0xacebad03, short_spc328, long_spc328, 0xcb0bfa11 },
{ 0xacebad03, short_spc329, long_spc329, 0xcb0bfa11 },
{ 0xacebad03, short_spc330, long_spc330, 0xcb0bfa11 },
{ 0xacebad03, short_spc331, long_spc331, 0xcb0bfa11 },
{ 0xacebad03, short_spc332, long_spc332, 0xcb0bfa11 },
{ 0xacebad03, short_spc333, long_spc333, 0xcb0bfa11 },
{ 0xacebad03, short_spc334, long_spc334, 0xcb0bfa11 },
{ 0xacebad03, short_spc335, long_spc335, 0xcb0bfa11 },
{ 0xacebad03, short_spc336, long_spc336, 0xcb0bfa11 },
{ 0xacebad03, short_spc337, long_spc337, 0xcb0bfa11 },
{ 0xacebad03, short_spc338, long_spc338, 0xcb0bfa11 },
{ 0xacebad03, short_spc339, long_spc339, 0xcb0bfa11 },
{ 0xacebad03, short_spc340, long_spc340, 0xcb0bfa11 },
{ 0xacebad03, short_spc341, long_spc341, 0xcb0bfa11 },
{ 0xacebad03, short_spc342, long_spc342, 0xcb0bfa11 },
{ 0xacebad03, short_spc343, long_spc343, 0xcb0bfa11 },
{ 0xacebad03, short_spc344, long_spc344, 0xcb0bfa11 },
{ 0xacebad03, short_spc345, long_spc345, 0xcb0bfa11 },
{ 0xacebad03, short_spc346, long_spc346, 0xcb0bfa11 },
{ 0xacebad03, short_spc347, long_spc347, 0xcb0bfa11 },
{ 0xacebad03, short_spc348, long_spc348, 0xcb0bfa11 },
{ 0xacebad03, short_spc349, long_spc349, 0xcb0bfa11 },
{ 0xacebad03, short_spc350, long_spc350, 0xcb0bfa11 },
{ 0xacebad03, short_spc351, long_spc351, 0xcb0bfa11 },
{ 0xacebad03, short_spc352, long_spc352, 0xcb0bfa11 },
{ 0xacebad03, short_spc353, long_spc353, 0xcb0bfa11 },
{ 0xacebad03, short_spc354, long_spc354, 0xcb0bfa11 },
{ 0xacebad03, short_spc355, long_spc355, 0xcb0bfa11 },
{ 0xacebad03, short_spc356, long_spc356, 0xcb0bfa11 },
{ 0xacebad03, short_spc357, long_spc357, 0xcb0bfa11 },
{ 0xacebad03, short_spc358, long_spc358, 0xcb0bfa11 },
{ 0xacebad03, short_spc359, long_spc359, 0xcb0bfa11 },
{ 0xacebad03, short_spc360, long_spc360, 0xcb0bfa11 },
{ 0xacebad03, short_spc361, long_spc361, 0xcb0bfa11 },
{ 0xacebad03, short_spc362, long_spc362, 0xcb0bfa11 },
{ 0xacebad03, short_spc363, long_spc363, 0xcb0bfa11 },
{ 0xacebad03, short_spc364, long_spc364, 0xcb0bfa11 },
{ 0xacebad03, short_spc365, long_spc365, 0xcb0bfa11 },
{ 0xacebad03, short_spc366, long_spc366, 0xcb0bfa11 },
{ 0xacebad03, short_spc367, long_spc367, 0xcb0bfa11 },
{ 0xacebad03, short_spc368, long_spc368, 0xcb0bfa11 },
{ 0xacebad03, short_spc369, long_spc369, 0xcb0bfa11 },
{ 0xacebad03, short_spc370, long_spc370, 0xcb0bfa11 },
{ 0xacebad03, short_spc371, long_spc371, 0xcb0bfa11 },
{ 0xacebad03, short_spc372, long_spc372, 0xcb0bfa11 },
{ 0xacebad03, short_spc373, long_spc373, 0xcb0bfa11 },
{ 0xacebad03, short_spc374, long_spc374, 0xcb0bfa11 },
{ 0xacebad03, short_spc375, long_spc375, 0xcb0bfa11 },
{ 0xacebad03, short_spc376, long_spc376, 0xcb0bfa11 },
{ 0xacebad03, short_spc377, long_spc377, 0xcb0bfa11 },
{ 0xacebad03, short_spc378, long_spc378, 0xcb0bfa11 },
{ 0xacebad03, short_spc379, long_spc379, 0xcb0bfa11 },
{ 0xacebad03, short_spc380, long_spc380, 0xcb0bfa11 },
{ 0xacebad03, short_spc381, long_spc381, 0xcb0bfa11 },
{ 0xacebad03, short_spc382, long_spc382, 0xcb0bfa11 },
{ 0xacebad03, short_spc383, long_spc383, 0xcb0bfa11 },
{ 0xacebad03, short_spc384, long_spc384, 0xcb0bfa11 },
{ 0xacebad03, short_spc385, long_spc385, 0xcb0bfa11 },
{ 0xacebad03, short_spc386, long_spc386, 0xcb0bfa11 },
{ 0xacebad03, short_spc387, long_spc387, 0xcb0bfa11 },
{ 0xacebad03, short_spc388, long_spc388, 0xcb0bfa11 },
{ 0xacebad03, short_spc389, long_spc389, 0xcb0bfa11 },
{ 0xacebad03, short_spc390, long_spc390, 0xcb0bfa11 },
{ 0xacebad03, short_spc391, long_spc391, 0xcb0bfa11 },
{ 0xacebad03, short_spc392, long_spc392, 0xcb0bfa11 },
{ 0xacebad03, short_spc393, long_spc393, 0xcb0bfa11 },
{ 0xacebad03, short_spc394, long_spc394, 0xcb0bfa11 },
{ 0xacebad03, short_spc395, long_spc395, 0xcb0bfa11 },
{ 0xacebad03, short_spc396, long_spc396, 0xcb0bfa11 },
{ 0xacebad03, short_spc397, long_spc397, 0xcb0bfa11 },
{ 0xacebad03, short_spc398, long_spc398, 0xcb0bfa11 },
{ 0xacebad03, short_spc399, long_spc399, 0xcb0bfa11 },
{ 0xacebad03, short_spc400, long_spc400, 0xcb0bfa11 },
{ 0xacebad03, short_spc401, long_spc401, 0xcb0bfa11 },
{ 0xacebad03, short_spc402, long_spc402, 0xcb0bfa11 },
{ 0xacebad03, short_spc403, long_spc403, 0xcb0bfa11 },
{ 0xacebad03, short_spc404, long_spc404, 0xcb0bfa11 },
{ 0xacebad03, short_spc405, long_spc405, 0xcb0bfa11 },
{ 0xacebad03, short_spc406, long_spc406, 0xcb0bfa11 },
{ 0xacebad03, short_spc407, long_spc407, 0xcb0bfa11 },
{ 0xacebad03, short_spc408, long_spc408, 0xcb0bfa11 },
{ 0xacebad03, short_spc409, long_spc409, 0xcb0bfa11 },
{ 0xacebad03, short_spc410, long_spc410, 0xcb0bfa11 },
{ 0xacebad03, short_spc411, long_spc411, 0xcb0bfa11 },
{ 0xacebad03, short_spc412, long_spc412, 0xcb0bfa11 },
{ 0xacebad03, short_spc413, long_spc413, 0xcb0bfa11 },
{ 0xacebad03, short_spc414, long_spc414, 0xcb0bfa11 },
{ 0xacebad03, short_spc415, long_spc415, 0xcb0bfa11 },
{ 0xacebad03, short_spc416, long_spc416, 0xcb0bfa11 },
{ 0xacebad03, short_spc417, long_spc417, 0xcb0bfa11 },
{ 0xacebad03, short_spc418, long_spc418, 0xcb0bfa11 },
{ 0xacebad03, short_spc419, long_spc419, 0xcb0bfa11 },
{ 0xacebad03, short_spc420, long_spc420, 0xcb0bfa11 },
{ 0xacebad03, short_spc421, long_spc421, 0xcb0bfa11 },
{ 0xacebad03, short_spc422, long_spc422, 0xcb0bfa11 },
{ 0xacebad03, short_spc423, long_spc423, 0xcb0bfa11 },
{ 0xacebad03, short_spc424, long_spc424, 0xcb0bfa11 },
{ 0xacebad03, short_spc425, long_spc425, 0xcb0bfa11 },
{ 0xacebad03, short_spc426, long_spc426, 0xcb0bfa11 },
{ 0xacebad03, short_spc427, long_spc427, 0xcb0bfa11 },
{ 0xacebad03, short_spc428, long_spc428, 0xcb0bfa11 },
{ 0xacebad03, short_spc429, long_spc429, 0xcb0bfa11 },
{ 0xacebad03, short_spc430, long_spc430, 0xcb0bfa11 },
{ 0xacebad03, short_spc431, long_spc431, 0xcb0bfa11 },
{ 0xacebad03, short_spc432, long_spc432, 0xcb0bfa11 },
{ 0xacebad03, short_spc433, long_spc433, 0xcb0bfa11 },
{ 0xacebad03, short_spc434, long_spc434, 0xcb0bfa11 },
{ 0xacebad03, short_spc435, long_spc435, 0xcb0bfa11 },
{ 0xacebad03, short_spc436, long_spc436, 0xcb0bfa11 },
{ 0xacebad03, short_spc437, long_spc437, 0xcb0bfa11 },
{ 0xacebad03, short_spc438, long_spc438, 0xcb0bfa11 },
{ 0xacebad03, short_spc439, long_spc439, 0xcb0bfa11 },
{ 0xacebad03, short_spc440, long_spc440, 0xcb0bfa11 },
{ 0xacebad03, short_spc441, long_spc441, 0xcb0bfa11 },
{ 0xacebad03, short_spc442, long_spc442, 0xcb0bfa11 },
{ 0xacebad03, short_spc443, long_spc443, 0xcb0bfa11 },
{ 0xacebad03, short_spc444, long_spc444, 0xcb0bfa11 },
{ 0xacebad03, short_spc445, long_spc445, 0xcb0bfa11 },
{ 0xacebad03, short_spc446, long_spc446, 0xcb0bfa11 },
{ 0xacebad03, short_spc447, long_spc447, 0xcb0bfa11 },
{ 0xacebad03, short_spc448, long_spc448, 0xcb0bfa11 },
{ 0xacebad03, short_spc449, long_spc449, 0xcb0bfa11 },
{ 0xacebad03, short_spc450, long_spc450, 0xcb0bfa11 },
{ 0xacebad03, short_spc451, long_spc451, 0xcb0bfa11 },
{ 0xacebad03, short_spc452, long_spc452, 0xcb0bfa11 },
{ 0xacebad03, short_spc453, long_spc453, 0xcb0bfa11 },
{ 0xacebad03, short_spc454, long_spc454, 0xcb0bfa11 },
{ 0xacebad03, short_spc455, long_spc455, 0xcb0bfa11 }
};
#endif

#if MPICH_ERROR_MSG_LEVEL > MPICH_ERROR_MSG_NONE
#define MPIR_MAX_ERROR_CLASS_INDEX 54
static int class_to_index[] = {
659,47,113,132,660,106,614,627,169,569,
663,129,11,669,665,576,204,203,202,618,
145,146,152,112,121,150,151,144,180,181,
188,186,208,547,10,565,154,153,603,157,
158,630,654,120,156,674,34,239,235,623,
626,625,624,26};
#endif
